/*********************************************************************************/
/*                                                                               */
/*                      UTS : Ulysse Train System                                */
/*                                                                               */
/*     Logiciel de pilotage d'un reseau ferroviaire  avec a la carte UTS         */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*  Historique:                                                                  */
/*                                                                               */
/*  05 avril   2005 : Ulysse Delmas-Begue: commencer version gra^hique v 1.0     */
/*  27 juillet 2003 : Ulysse Delmas-Begue: pauffinages pour livraison v 0.4      */
/*  31 mars    2004 : correction pb inter 0                                      */
/*                      (il y avait un pb lors du relachement de la souris)      */
/*                    correction du no aig dans les itineraires 0-31 et non 1-32 */
/*                    correction pb se rafraichisement surtout sur l'ecran RS232 */
/*                      (SendMessage remplace par PostMessge)                    */
/*        juin 2004 : 4 cartes max, nouvelle gestion des trains, garages         */
/*            reste : plaques tournantes, progressivitee en automatique          */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*  Notes:                                                                       */
/*                                                                               */
/*                                                                               */
/*                                                                               */
/*********************************************************************************/


//#define TITRE   "UTS - Ulysse Train System - v0.4 Dev 27jul2003"
//#define TITRE   "UTS - Ulysse Train System - v0.5 Dev 31mar2004"
//#define TITRE   "UTS - Ulysse Train System - v1.0 Dev 20jun2004"
//#define TITRE   "UTS - Ulysse Train System - v2.0 Dev 20apr2005"
#define TITRE   "UTS - Ulysse Train System - v2.0 Dev 25juin2005"
#define STR_AIDE "Voir le manuel sur le site web:\nhttp://www.chez.com/udelmas"
#define STR_NO_CONFIG_FILE "Le fichier de configuration est introuvable \n\n UTS a besoin d'un fichier de configuration\n config.txt dans le meme repertoire que l'executable\n\n(si vous voulez juste deboguer la carte alors creez un fichier vide)\n\nFin de UTS"
#define SZ_INFO_OPEN_CONFIG "UTS va ouvrir le fichier de config avec l'editeur par defaut\n\nSi ca ne marche pas, editez le fichier config.txt dans le repertoire UTS\n\nN'oubliez pas de le sauver en fin de modification\n\nPour prendre en compte les modifs\n- vous pouvez recharger le fichier si la section est rechargeable\n- autrement il faudra relancer UTS"
#define SZ_INFO_RELOAD_CONFIG "UTS va prendre en compte les modifications du fichier de configuration\n\nSeules les sections qui peuvent etre rechargees le seront (voir liste dans le fichier)\n\nPour les autres relancer UTS"

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"

HINSTANCE ghinstance;
HWND hwnd;               /* This is the handle for our window */ 
HDC hdc;
HFONT la_fonte;
HFONT cells_font;
int x_mouse,y_mouse,touche,touche_char,x_mouse_move,y_mouse_move;


#define DEBUG_PAINT        0
#define DEBUG_TOTAL_PAINT  1
#define DEBUG_MOUSE        2
#define DEBUG_KEY          3
#define DEBUG_MOUSE_RIGHT  4
#define DEBUG_TICK         5
#define DEBUG_MOUSE_UP     6
#define DEBUG_MOUSE_RIGHT_UP 7

#define MD_SCREEN_TCO0      0
#define MD_SCREEN_TCO1      1
#define MD_SCREEN_TCO2      2
#define MD_SCREEN_TCO3      3
#define MD_SCREEN_TCO4      4
#define MD_SCREEN_TCO5      5
#define MD_SCREEN_TCO6      6
#define MD_SCREEN_TCO7      7
#define MD_SCREEN_HORO      8
#define MD_SCREEN_SERIAL    9
#define MD_SCREEN_AIG      10
#define MD_SCREEN_ITI      11
#define MD_SCREEN_SELECTIF 12
#define MD_SCREEN_AUTO     13
#define MD_SCREEN_TRAIN    14
#define MD_SCREEN_CANTON   15
#define MD_SCREEN_VIB      16
#define MD_SCREEN_SPARE0   17
#define MD_SCREEN_SPARE1   18
#define MD_SCREEN_SPARE2   19
#define MD_SCREEN_SPARE3   20
#define MD_SCREEN_END      20
char* TabSzScreenMode[]= { "tco0", "tco1", "tco2", "tco3", "tco4", "tco5", "tco6", "tco7",
                          "horloge", "rs232", "aig", "iti", "selectif", "depl", "regu", "cantons", "vib",
                          "spare1", "spare2", "spare3", "spare4" };

int screen_mode=MD_SCREEN_TCO0;

int horo_j=0,horo_j_dep=0;    //global    //0-6    //por depart: 7=week 8=weekend
int horo_h=5,horo_h_dep=5;    //global    //0-23
int horo_m=0,horo_m_dep=0;    //global    //0-59
int horo_tic_on=0;            //global
int horo_blocked=0;           //global


/* variables  */

// 1. variables des cartes (utilisees par serial)
int vio_can[4][5];
int vio_in[4][36];
int vio_det[4][16];
int vio_canton_vit[4][16];      //UU: n'en garder qu'un et mettre en debug total
//int vio_canton_sens[4][16];   //UU: n'en garder qu'un et mettre en debug total
int vio_out[4][40];
int vio_led[4][48];
int vio_led_cli[4][48];
int vio_led_phase[4][48];
int vio_srv[4][2];
int cfg_enable_leds[4]={ 1,1,1,1};
int cfg_enable_servos[4][2]={ {0,0},{0,0},{0,0},{0,0} };
int cfg_show_cards_found=0;
int cfg_canton_inv[4][16]={{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};
int cfg_can_inv[4][5]={{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}};
int rs232_debug_link[4][16]={{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,},{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,},{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,},{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,}};


// 2. variables de debug des cartes
int serial_debug_select_canton_vit[4][16];
int serial_debug_canton_vit[4][16];
int serial_debug_select_out[4][40];
int serial_debug_out[4][40];
int serial_debug_select_led[4][48];
int serial_debug_led[4][48];
int serial_debug_led_cli[4][48];
int serial_debug_led_phase[4][48];
int serial_debug_select_srv[4][2];
int serial_debug_srv[4][2];

int vio_srv_cmd[4][2];
int vio_srv_res[4][2];





//autres
int vio_reg_pot[5];      //-64,+64
int vio_reg_val[5];      //-64,+64
int vio_reg_pot_vir[5];  //0,+255
int vio_reg_pot_vir_selected[5];

int vio_pot_virtual_step[5]={0,0,0,0,0}; //UU_NEW
int vio_pot_virtual_conf[5][3]={ {0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0} };

int vio_aig_cmd[64];
int vio_aig_pos0[64];
int vio_aig_pos1[64];
int vio_aig_res[64];

int vio_garage_lock_cmd[64];
int vio_garage_lock_status[64];
int vio_garage_lock_res[64];

int vio_canton_fixe[16];
int vio_canton_simu_pot[16];
int vio_canton_reg[16];
int vio_canton_auto[16];
int vio_canton_selectif[16];
int vio_canton_prog[16];
int vio_canton_vit_max[16];
#define MD_RIEN     0
#define MD_FIXE     1
#define MD_POT      2
#define MD_REG      3
#define MD_AUTO     4
#define MD_SELECTIF 5
#define MD_MIXTE    6
#define MD_MIXTEA   7
#define MD_MIXTES   8
#define MD_PROG     9    //new
int vio_canton_mode[16];
int vio_canton_mode_no[16];
int vio_canton_res[16];
int vio_selectif_new_pot=-1;
int vio_selectif_new_reg=-1;

// config
//int cfg_disable_led=0;

//ITI
#define NB_ITI 50
#define NB_ITI_AIG          8
#define NB_ITI_EXIST        0
#define NB_ITI_TYPE         1
#define NB_ITI_VAR_START    2
#define NB_ITI_VAR_STOP     3
#define NB_ITI_VAR_STEP     4
#define NB_ITI_TEMPO        5
#define NB_ITI_VAR_WAIT     6
#define NB_ITI_VAR_OK       7
#define NB_ITI_CANT_START   8
#define NB_ITI_CANT_STOP    9
#define NB_ITI_AIG_NO      10
#define NB_ITI_AIG_POS     11
#define NB_ITI_DIRECT       0
#define NB_ITI_ONOFF        1
#define NB_ITI_STEP_IDLE          0
#define NB_ITI_STEP_WAIT_CANT_DEP 1
#define NB_ITI_STEP_WAIT_RES      2
#define NB_ITI_STEP_WAIT_VER      3
#define NB_ITI_STEP_WAIT_CANT_FIN 4
#define NB_ITI_STEP_WAIT_WAIT     5
#define NB_ITI_STEP_WAIT_STOP     6
#define NB_ITI_STEP_RELEASE       7
int iti_tab[NB_ITI][10+2*NB_ITI_AIG];

#define DEPL_TAB_NB                   100
#define DEPL_TAB_IND_CANT_0_NO          0
#define DEPL_TAB_IND_CANT_0_VIT         1
#define DEPL_TAB_IND_AIG_0_NO          16
#define DEPL_TAB_IND_AIG_0_POS         17
#define DEPL_TAB_IND_FIN_0_VAR         32
#define DEPL_TAB_IND_FIN_0_VAL         33
#define DEPL_TAB_IND_FIN_1_VAR         34
#define DEPL_TAB_IND_FIN_1_VAL         35
#define DEPL_TAB_IND_TAF               36
#define DEPL_TAB_IND_TSF               37
#define DEPL_TAB_IND_START_RUN         38
#define DEPL_TAB_IND_STOP              39
#define DEPL_TAB_IND_STEP              40
#define DEPL_TAB_IND_TEMPO             41
#define DEPL_TAB_IND_ACTION_OP         42
#define DEPL_TAB_IND_ACTION_VAR        43
#define DEPL_TAB_IND_TR_NUM_SAVE       50
#define DEPL_TAB_IND_TR_NUM_ONLY       51
#define DEPL_TAB_IND_CANT_START        52
#define DEPL_TAB_IND_CANT_START2       53
#define DEPL_TAB_IND_CANT_STOP         54
#define DEPL_TAB_IND_END_GARAGE_LOCKED 55
#define DEPL_TAB_IND_CONS              56
#define DEPL_TAB_IND_VIT               57
#define DEPL_TAB_IND_SRV_NO            58
#define DEPL_TAB_IND_SRV_VAL           59
#define DEPL_TAB_IND_NB                60
int depl_tab[DEPL_TAB_NB][DEPL_TAB_IND_NB];

int vib_on=0;      //dans pio
int vib_state=0;   //dans pio
int vib_var=-1;
int vib_var_inv=0;
int vib_pwm_no=-1;
int vib_pwm_vit=-1;
int vib_time_before=8;
int vib_time_after=8;
int vib_dec_before=0;
int vib_dec_after=0;

/* recopie les variables menbres de canton car classe en dessous de TCO*/
int  copy_res_auto[4][16];
int  copy_master_selectif[4][16];
int  copy_update_selectif[4][16];
int  copy_num_train[4][16];
char copy_train_name[16][10];
int  copy_allowed_sens[4][16];
int  canton_pb_capt[4][16];
int  train_pb_capt[16];
int  copy_garage_num_train[16];
int  copy_garage_ass_canton[16];


/*****************************************************************************/
/* GENERAL                                                                   */
/*****************************************************************************/
char gszErr[1024];

void log(char* sz)
{
    FILE* pf;
    static int start=1;

    if(start) pf=fopen("log.txt","wt");  // erase file before first log
    else      pf=fopen("log.txt","at");  // apend text to next log
    if(pf) { fprintf(pf,sz); fclose(pf); }
    start=0;
}
// ex: sprintf(gszErr,"g=%d c=%d canton.num_train=%d selected_train=%d",g,c,canton.num_train[c/100][c%100],selected_train); log(gszErr);




char szdebug[200];
//  sprintf(szerror," ");
//  MessageBox(NULL,szdebug,"Error",MB_OK|MB_ICONERROR);
//sprintf(szdebug,"s_led_d=%d s_led_cli=%d s_led_phase=%d sel=%d",serial_led_debug[0],serial_led_cli_debug[0],serial_led_phase_debug[0],serial_led_debug_select[0]);
//TextOut(hdc,10,550,szdebug,strlen(szdebug));

int moins_char_normal=1;   // 1: - est un caractere normal (comme 0)  0: - est un separateur (comme +)

int get_line(FILE* pf, char ch_tab[][100], int* ch_nb)
{
    int i;
    char c;
    char ch[100];
    int ch_ind;
    int ch_ok;

    *ch_nb=0; ch_ind=0; ch_ok=0;

    for(i=0;i<50;i++) ch_tab[i][0]='\0';

    do
    {
        /* 1. read char */
        if(fscanf(pf,"%c",&c)==EOF) return 0;

        /* 2. normal char */
        if( (c>='a' && c<='z') || (c>='A' && c<='Z') || (c>='0' && c<='9') || c=='_' || (c=='-' && moins_char_normal) )
        {
            ch_tab[*ch_nb][ch_ind]=c;
            ch_ind++;
            ch_ok=1;
        }

        /* 3. control char */
        else
        {
            /* 3.1 normal character before */
            if(ch_ok)
            {
                ch_tab[*ch_nb][ch_ind]='\0';
                *ch_nb=(*ch_nb)+1;
                ch_ind=0;
                ch_ok=0;
            }

            /* 3.2 add printable control char */
            if(c!=' ' && c!='\t' && c!='\n')
            {
                ch_tab[*ch_nb][0]=c;
                ch_tab[*ch_nb][1]='\0';
                *ch_nb=(*ch_nb)+1;
                ch_ind=0;
                ch_ok=0;
            }
        }

    }
    while(c!='\n' && c!=';');

    if( (*ch_nb)==1 && ch_tab[0][0]==']') return 0;
    return 1;
}

/*
    convertit la valeur can 0-255 en consigne de vitesse -64...0...+64 et frein -99
    utilise un profile standard

    +vmax                  /--
                         /
    +vmin              /
                      |
    0            |----|
                 |
    -vmin       /
              /
    -vmax --/
          0    127   128   255
*/
int can_to_cons(int can, int vmin, int vmax, int enbreak)
{
    char sign='+';
    int can_plus;   // 0...127
    int ret;

    if(can>=128) { sign='+'; can_plus=can-128; }
    else         { sign='-'; can_plus=127-can; }

    if(can_plus>122) if(enbreak) return -99;

    if(can_plus>112) ret=vmax;

    if(can_plus<16) ret=0;

    if(can_plus>=16 && can_plus<=112) ret=vmin+((vmax-vmin)*(can_plus-16))/(112-16);

    if(sign=='-') ret=-ret;

    return ret;
}

int virtualstep_to_cons(int pot_virtual_step,int vmin,int vmax)
{
    switch(pot_virtual_step)
    {
        case  0: return 0;
        case  1: return vmin;
        case  2: return vmin+(1*(vmax-vmin))/2;
        case  3: return vmax;
        case -1: return -vmin;
        case -2: return -(vmin+(1*(vmax-vmin))/2);
        case -3: return -vmax;
        default: return 0;
    }

}



void EasyTextOut(int x, int y, char* sz)
{
    TextOut(hdc,x,y,sz,strlen(sz));
}

void EasyLine(int x1, int y1, int x2, int y2)
{
    MoveToEx(hdc,x1,y1,NULL); LineTo(hdc,x2,y2);
}

void init_fonte_pen_brush(void)
{
    la_fonte=CreateFont(15,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier");
    cells_font=CreateFont(10,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier New");
}

/*****************************************************************************/
/* FIN GENERAL                                                               */
/*****************************************************************************/








/*****************************************************************************/
/* PIO                                                                       */
/*****************************************************************************/


/* PIO */
#define NB_VAR  512
int pio_var[NB_VAR];

#define NB_TDV  50
int pio_tdv_on_off[NB_TDV];
int pio_tdv_ind[NB_TDV];

#define NB_EXE 100
int pio_exe[NB_EXE];
char aszExe[NB_EXE][200];

#define NB_PULSE 32
int pio_pulse_cmd[NB_PULSE];

#define NB_TAB  20000
int pio_tab[NB_TAB];
int pio_var_add_indice=0; //remplacer var par tab

/* define tab */   // nonutilise pour l'instant
#define PIO_DEFINE_ENTRY_NB   200
#define PIO_DEFINE_CHAR_NB   5000
char pio_define_string_tab[PIO_DEFINE_CHAR_NB];
int  pio_define_index[PIO_DEFINE_ENTRY_NB][2];
int  pio_define_next_ind=0;
int  pio_define_next_entry=0;

void pio_define_init_clear()
{
    int i;

    for(i=0;i<PIO_DEFINE_ENTRY_NB;i++) pio_define_index[i][0]=pio_define_index[i][1]=0;
    pio_define_next_ind=0;
    pio_define_next_entry=0;
}

int pio_define_add(char ch_user[],char ch_syst[])
{
    if((strlen(ch_user)+strlen(ch_syst)+2+pio_define_next_ind)>PIO_DEFINE_CHAR_NB) return 0;
    if(pio_define_next_entry==(PIO_DEFINE_ENTRY_NB-1)) return 0;
    pio_define_index[pio_define_next_entry][0]=pio_define_next_ind;
    strcpy(&pio_define_string_tab[pio_define_next_ind],ch_user);
    pio_define_next_ind+=strlen(ch_user)+1;
    pio_define_index[pio_define_next_entry][1]=pio_define_next_ind;
    strcpy(&pio_define_string_tab[pio_define_next_ind],ch_syst);
    pio_define_next_ind+=strlen(ch_syst)+1;
    pio_define_next_entry++;
    return 1;
}

int pio_define_convert(char ch_user[],char ch_syst[])
{
    int i;

    for(i=0;i<pio_define_next_entry;i++)
    {
        if(!strcmp(ch_user,&pio_define_string_tab[pio_define_index[i][0]]))
        {
            strcpy(ch_syst,&pio_define_string_tab[pio_define_index[i][1]]);
            return 1;
        }
    }
    return 0;
}

void pio_define_list(void)
{
    FILE* pf;
    int i;

    pf=fopen("debug_define","wt");

    for(i=0;i<pio_define_next_entry;i++)
        fprintf(pf,"\n%d: %s --> %s",i,&pio_define_string_tab[pio_define_index[i][0]],&pio_define_string_tab[pio_define_index[i][1]]);

    fclose(pf);
}

/* general */

#define PIO_BASE_AIG_CMD  5000
#define PIO_BASE_AIG_POS0 5100
#define PIO_BASE_AIG_POS1 5200
#define PIO_BASE_AIG_RES  5000
// permet representer une variable par un nombre (plus facile a manipuler qu'une chaine)
//attention a l'ordre des comparaisons ex: led_cli_ puis led_ ...
char* pio_var_ch[]=
{
    "det_"               ,"4x16"  ,"0"   ,
    "can_"               ,"4x5"   ,"800" ,
    "in_"                ,"4x36"  ,"400" ,
    "out_"               ,"4x40"  ,"1200",
    "led_cli_"           ,"4x48"  ,"2000",
    "led_phase_"         ,"4x48"  ,"2400",
    "led_"               ,"4x48"  ,"1600",

//  "srv_cmd_"           ,"4x2"   ,"8000",
//  "srv_pos"            ,"4x2"   ,"2800",

    "aig_cmd_"           ,"64"    ,"5000",
    "pos0_aig_"          ,"64"    ,"5100",
    "pos1_aig_"          ,"64"    ,"5200",

    "var_"               ,"512"   ,"5400",

    "iti_start_"         ,"50"    ,"6000",
    "iti_stop_"          ,"50"    ,"6100",
    "iti_wait_"          ,"50"    ,"6200",
    "iti_ok_"            ,"50"    ,"6300",
//  "iti_step_"          ,"50"    ,"6400",

    "depl_start_run_"    ,"100"   ,"6500",
    "depl_stop_"         ,"100"   ,"6600",
//  "depl_step_"         ,"100"   ,"6700",

    "garage_lock_cmd_"   ,"64"    ,"6800",
    "garage_lock_status_","64"    ,"6900",

    "vib_on_"            ,"1"     ,"7000",
    "vib_state_"         ,"1"     ,"7002",

//  "screen_mode"        ,"1"     ,"7003",
    "exe_"               ,"100"   ,"8400",
    "pulse_cmd_"         ,"32"    ,"8500",

    "pb_capt_c_"         ,"4x16"  ,"8600",
    "pb_capt_t_"         ,"16"    ,"9000",

    "EOL",
};

int pio_var_int2ch(int num,char szVarName[])
{
    int ind=0,min,max;

    while(strcmp(pio_var_ch[ind],"EOL"))
    {
        min=atoi(pio_var_ch[ind+2]);
        if(pio_var_ch[ind+1][1]=='x') max=min+100*(atoi(pio_var_ch[ind+1])-1)+atoi(&pio_var_ch[ind+1][2])-1;
        else                          max=min+atoi(pio_var_ch[ind+1])-1;

        if(num>=min && num<=max)
        {
            sprintf(szVarName,"%s%d",pio_var_ch[ind],num-min);
            return 1;
        }

        ind=ind+3;
    }

    sprintf(szVarName,"invalid");
    sprintf(gszErr,"\n-ERR-0000- pio_var_int2ch - unknown num var %d",num); log(gszErr);
    return 0;
}

#define STR_SAME 0==
#define STR_DIFF 0!=
#define PIO_VAR_NAME  pio_var_ch[3*i]
#define PIO_VAR_NB    pio_var_ch[3*i+1]
#define PIO_VAR_BASE  pio_var_ch[3*i+2]

int pio_var_ch2int_(char szVarName[])
{
    int i,l1,l2;
    char ch[100];

    // 1. si le nom de la variable est definie par l'utilisateur alors la remplacer par son non system
    if(pio_define_convert(szVarName,ch)==0) strcpy(ch,szVarName);

    // 2. chercher le numero de la variable en fonction de son nom
    i=0;
    while(STR_DIFF stricmp(PIO_VAR_NAME,"EOL"))
    {
        if(STR_SAME strnicmp( ch,PIO_VAR_NAME,strlen(PIO_VAR_NAME) ) )
        {
            if(atoi(PIO_VAR_NB)==1) return atoi(PIO_VAR_BASE);

            else if(PIO_VAR_NB[0]=='4' && PIO_VAR_NB[1]=='x')
            {
                l1=atoi(&ch[strlen(PIO_VAR_NAME)]);
                l2=atoi(&PIO_VAR_NB[2]);  //skip 4x
                if((l1%100)<l2) return atoi(PIO_VAR_BASE)+l1;
            }

            else
            {
                l1=atoi(&ch[strlen(PIO_VAR_NAME)]);
                l2=atoi(PIO_VAR_NB);
                if(l1<l2) return atoi(PIO_VAR_BASE)+l1;
            }
        }
        i++;
    }
    sprintf(gszErr,"\n-ERR-0000- pio_var_ch2int - unknown var %s",ch); log(gszErr);
    return -1;
}

int pio_var_ch2int(char szVarName[])
{
    int ret;

    ret=pio_var_ch2int_(szVarName);
    //sprintf(gszErr,"\n-DBG-0000- adr: %s = %d",szVarName,ret); log(gszErr);

    return ret;
}


// pas besoin de verifier que l'interval existe (ex: 25: vio_det_25)
// car la fonction pio_var_ch2int aura deja signalee l'errer
int pio_get_val_(int no_var)
{
    int base;

    base=0   ; if(no_var>=base && no_var<=(base+400-1)) return vio_det         [(no_var-base)/100][(no_var-base)%100];
    base=400 ; if(no_var>=base && no_var<=(base+400-1)) return vio_in          [(no_var-base)/100][(no_var-base)%100];
    base=800 ; if(no_var>=base && no_var<=(base+400-1)) return vio_can         [(no_var-base)/100][(no_var-base)%100];
    base=1200; if(no_var>=base && no_var<=(base+400-1)) return vio_out         [(no_var-base)/100][(no_var-base)%100];
    base=1600; if(no_var>=base && no_var<=(base+400-1)) return vio_led         [(no_var-base)/100][(no_var-base)%100];
    base=2000; if(no_var>=base && no_var<=(base+400-1)) return vio_led_cli     [(no_var-base)/100][(no_var-base)%100];
    base=2400; if(no_var>=base && no_var<=(base+400-1)) return vio_led_phase   [(no_var-base)/100][(no_var-base)%100];
    base=2800; if(no_var>=base && no_var<=(base+400-1)) return vio_srv         [(no_var-base)/100][(no_var-base)%100];
    base=8000; if(no_var>=base && no_var<=(base+400-1)) return vio_srv_cmd     [(no_var-base)/100][(no_var-base)%100];

    base=5000; if(no_var>=base && no_var<=(base+100-1)) return vio_aig_cmd     [no_var-base];
    base=5100; if(no_var>=base && no_var<=(base+100-1)) return vio_aig_pos0    [no_var-base];
    base=5200; if(no_var>=base && no_var<=(base+100-1)) return vio_aig_pos1    [no_var-base];
    base=5400; if(no_var>=base && no_var<=(base+600-1)) return pio_var         [no_var-base];

    base=6200; if(no_var>=base && no_var<=(base+100-1)) return iti_tab[no_var-base][NB_ITI_VAR_WAIT];
    base=6300; if(no_var>=base && no_var<=(base+100-1)) return iti_tab[no_var-base][NB_ITI_VAR_OK];
    base=6400; if(no_var>=base && no_var<=(base+100-1)) return iti_tab[no_var-base][NB_ITI_VAR_STEP];
    base=6500; if(no_var>=base && no_var<=(base+100-1)) return depl_tab[no_var-base][DEPL_TAB_IND_START_RUN];
    base=6700; if(no_var>=base && no_var<=(base+100-1)) return depl_tab[no_var-base][DEPL_TAB_IND_STEP];
    base=6800; if(no_var>=base && no_var<=(base+100-1)) return vio_garage_lock_cmd[no_var-base];
    base=6800; if(no_var>=base && no_var<=(base+100-1)) return vio_garage_lock_status[no_var-base];

    base=8500; if(no_var>=base && no_var<=(base+100-1)) return pio_pulse_cmd[no_var-base];
    base=8400; if(no_var>=base && no_var<=(base+100-1)) return pio_exe[no_var-base];

    if(no_var==7000) return vib_on;
    if(no_var==7002) return vib_state;
    if(no_var==7003) return screen_mode;

    base=8600; if(no_var>=base && no_var<=(base+400-1)) return canton_pb_capt[(no_var-base)/100][(no_var-base)%100];
    base=9000; if(no_var>=base && no_var<=(base+100-1)) return train_pb_capt[no_var-base];

    sprintf(gszErr,"\n-ERR-0000- pio_get_var - unknown var %d",no_var); log(gszErr);
    return -1;
}

int pio_get_val(int no_var)
{
    int ret;

    ret=pio_get_val_(no_var);

    //sprintf(gszErr,"\n-DBG-0001- getadr: %d = %d",no_var,ret); log(gszErr);
    return ret;
}

int pio_set_val(int no_var,int val_var)
{
    int base;

    //sprintf(gszErr,"\n-DBG-0002- setadr: %d = %d",no_var,val_var); log(gszErr);

    base=1200; if(no_var>=base && no_var<=(base+400-1)) { vio_out[(no_var-base)/100][(no_var-base)%100]=val_var; return 0; }
    base=1600; if(no_var>=base && no_var<=(base+400-1)) { vio_led[(no_var-base)/100][(no_var-base)%100]=val_var; return 0; }
    base=2000; if(no_var>=base && no_var<=(base+400-1)) { vio_led_cli[(no_var-base)/100][(no_var-base)%100]=val_var; return 0; }
    base=2400; if(no_var>=base && no_var<=(base+400-1)) { vio_led_phase[(no_var-base)/100][(no_var-base)%100]=val_var; return 0; }
    base=8000; if(no_var>=base && no_var<=(base+400-1))
               if(vio_srv_res[(no_var-base)/100][(no_var-base)%100]==0) { vio_srv_cmd[(no_var-base)/100][(no_var-base)%100]=val_var; return 0; }

    base=5000; if(no_var>=base && no_var<=(base+100-1))
               if(vio_aig_res[no_var-base]==0)          { vio_aig_cmd[no_var-base]=val_var; return 0; }  // if(vio_aig_mode[no_var-1000]=='p') ... else return -2;
    base=5400; if(no_var>=base && no_var<=(base+600-1)) { pio_var[no_var-base]=val_var; return 0; }
    base=6000; if(no_var>=base && no_var<=(base+100-1)) { iti_tab[no_var-base][NB_ITI_VAR_START]=val_var; return 0; }
    base=6100; if(no_var>=base && no_var<=(base+100-1)) { iti_tab[no_var-base][NB_ITI_VAR_STOP]=val_var; return 0; }
    base=6500; if(no_var>=base && no_var<=(base+100-1)) { depl_tab[no_var-base][DEPL_TAB_IND_START_RUN]=val_var; return 0; }
    base=6600; if(no_var>=base && no_var<=(base+100-1)) { depl_tab[no_var-base][DEPL_TAB_IND_STOP]=val_var; return 0; }

    base=6800; if(no_var>=base && no_var<=(base+100-1))
               if(vio_garage_lock_res[no_var-base]==0)  {vio_garage_lock_cmd[no_var-base]=val_var; return 0; }

    base=8400; if(no_var>=base && no_var<(base+100)) { pio_exe[no_var-base]=val_var; return 0; }
    base=8500; if(no_var>=base && no_var<(base+100)) { pio_pulse_cmd[no_var-base]=val_var; return 0; }

    if(no_var==7000) {vib_on     =val_var; return 0;}
    if(no_var==7002) {vib_state  =val_var; return 0;}
    if(no_var==7003) {screen_mode=val_var; return 0;}

    sprintf(gszErr,"\n-ERR-0000- pio_set_var - unknown var %d",no_var); log(gszErr);
    return -1;
}

void pio_init(void)
{
    int j,i;

    // 1. variables des cartes (en sortie)
    for(j=0;j<4;j++) for(i=0;i<16;i++) { vio_canton_vit[j][i]=0;
                                         serial_debug_select_canton_vit[j][i]=0;
                                         serial_debug_canton_vit[j][i]=0;
                                       }
    for(j=0;j<4;j++) for(i=0;i<40;i++) { vio_out[j][i]=0;
                                         serial_debug_select_out[j][i]=0;
                                         serial_debug_out[j][i]=0;
                                       }
    for(j=0;j<4;j++) for(i=0;i<48;i++) { vio_led[j][i]=vio_led_cli[j][i]=vio_led_phase[j][i]=0;
                                         serial_debug_select_led[j][i]=0;
                                         serial_debug_led[j][i]=serial_debug_led_cli[j][i]=serial_debug_led_phase[j][i]=0;
                                       }
    for(j=0;j<4;j++) for(i=0;i<2;i++)  { vio_srv[j][i]=20;
                                         serial_debug_select_srv[j][i]=0;
                                         serial_debug_srv[j][i]=20;
                                         vio_srv_cmd[j][i]=20; /*20 : exit from extremity*/
                                       }
    for(i=0;i<512;i++)                   pio_var[i]=0;

    for(j=0;j<4;j++)                     cfg_enable_leds[j]=1;
    for(j=0;j<4;j++) for(i=0;i<2;i++)    cfg_enable_servos[j][i]=0;

    for(i=0;i<64;i++)                  { vio_aig_cmd[i]=0; vio_aig_pos0[i]=0; vio_aig_pos1[i]=0; }

    // 2. variables des cartes (en entree)
    for(j=0;j<4;j++) for(i=0;i<5;i++)    vio_can[j][i]=0;
    for(j=0;j<4;j++) for(i=0;i<36;i++)   vio_in[j][i]=0;
    for(j=0;j<4;j++) for(i=0;i<48;i++)   vio_det[j][i]=0;

    // 3. variables internes
    for(i=0;i<64;i++) vio_aig_res[i]=0;
    for(i=0;i<64;i++) vio_garage_lock_cmd[i]=0;
    for(i=0;i<64;i++) vio_garage_lock_status[i]=0;
    for(i=0;i<64;i++) vio_garage_lock_res[i]=0;
    for(j=0;j<4;j++) for(i=0;i<2;i++) vio_srv_res[j][i]=0;

}

void pio_maj(void)
{
}


/*****************************************************************************/
/* FIN PIO                                                                   */
/*****************************************************************************/




/*****************************************************************************/
/* EXE                                                                       */
/*****************************************************************************/

// en global
//#define NB_EXE 100
//int pio_exe[NB_EXE];
//char aszExe[NB_EXE][200];

class cExe
{
    public:

         cExe(void);
    void init(char filename[]);
    void save_conf();
    void tick(void);
};

cExe::cExe(void)
{

}

void cExe::init(char filename[])
{
    FILE* pf;
    int no;
    int i;
    char ch[200];
    char c;
    char* pt;

    for(i=0;i<NB_EXE;i++) { strcpy(aszExe[i],""); pio_exe[i]=0; }

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des executions","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#exe"))
        {
            fscanf(pf," %s",ch); //remove [

            while(1)
            {
                  if(fscanf(pf," %c",&c)==EOF) break;

                  if(c=='@')
                  {
                      do{ if(fscanf(pf,"%c",&c)==EOF) break; } while(c!='\n');
                      continue;
                  }
                  if(c==']') break;

                  ch[0]=c;ch[1]='\0';
                  if(c=='e')
                  {
                      fscanf(pf," %s",&ch[1]);
                      strlwr(ch);
                      if(ch[0]=='e' && ch[1]=='x' && ch[2]=='e') sscanf(&ch[3]," %d",&no);
                  }

                  if(c=='\"')
                  {
                      pt=ch;
                      while(1)
                      {
                           if(fscanf(pf,"%c",&c)==EOF) break;
                           if(c=='\"') break;
                           *pt++=c;
                      }
                      *pt='\0';
                      strcpy(aszExe[no],ch);
                  }
            } //fin while 1
        }     //fin #exe
    }         //fin fscanf

    fclose(pf);
}
    
void cExe::save_conf(void)
{
    FILE* pf;
    int i;

    if((pf=fopen("debug_exe.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_exe.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(i=0;i<NB_EXE;i++) fprintf(pf,"%3d: \"%s\"",i,aszExe[i]);

    fclose(pf);
}

void cExe::tick(void)
{
    int i;

    for(i=0;i<NB_EXE;i++) if(aszExe[i][0]!='\0') if(pio_exe[i]==1)
    {
        //ShellExecute(NULL,"open",aszExe[i], NULL, NULL, SW_SHOWNORMAL);
        ShellExecute(NULL,"open",aszExe[i], NULL, NULL, SW_SHOWNA);
        pio_exe[i]=0;
    }
}

cExe ThisExe;

/*****************************************************************************/
/* FIN EXE                                                                   */
/*****************************************************************************/


/*****************************************************************************/
/* TDV                                                                       */
/*****************************************************************************/


/* ex:
#tdv
[
    tdv:   0 
    on:    1
    in:    det_0 det_1
    init:  clear out_0  clear out_1 clear out_2  #0:r 1:j 2:v
    eq:    1 X   set out_0
    eq:    0 1   set out_1
    eq:    0 0   set out_2

    tdv:   1
    on:    1
    in:    det_0 det_1 out_0  clear io_out_1 clear io_out_2  #0:r 1:j 2:v
    eq:    1     X     1            0              0
    eq:    0     1     0            1              0
    eq:    0     0     0            0              1

    pulse0:4-10-4-10-0

    eq: l[n] v a|o|x[n] =|=set|=clr v
    l|a|o|x[n]tst v ==|<=|>=|<|>|<>  v|cst

    l can_0<20 a det_0 = out_3 = tco=5
    l det_0 = led_0
    l in_0 = aig_cmd_0

    ...
]
*/


#define NB_PULSE 32
int pulse_tab[NB_PULSE][10]; // on w1 a1 w2 a2 w3 out1 out2 (phase tempo)
int pulse_no;



class cTdv
{
    public:

         cTdv(void);
    void init(char filename[]);
    void save_conf();
    void tick(void);
};

cTdv::cTdv(void)
{

}

#define TDV_START 0
#define TDV_IN    1
#define TDV_INIT  2
#define TDV_EQ    3
#define TDV_OUT   4
#define TDV_PULSE 5
#define TDV_EQU   6

#define TDV_CLR   0
#define TDV_SET   1

#define EQ_BASE      30100
#define EQ_L         0
#define EQ_A         10
#define EQ_O         20
#define EQ_X         30
#define EQ_EGA       40
#define EQ_EGASET    50
#define EQ_EGACLR    60
#define EQ_EGANUM    70

#define EQ_TSTNO     0
#define EQ_TSTEGA    1
#define EQ_TSTDIFF   2
#define EQ_TSTSUP    3
#define EQ_TSTSUPEGA 4
#define EQ_TSTINF    5
#define EQ_TSTINFEGA 6

#define EQ_INV       100
void cTdv::init(char filename[])
{
    FILE* pf;
    char ch[100];
    char c;
    int no,on=1;
    int phase;
    int nb_in;
    int nb_out;
    int i;
    int val=-1;
    int t;
    char* pt;
    int num;

    no=-1;
    for(i=0;i<NB_TDV;i++) pio_tdv_ind[i]=-1;
    for(i=0;i<NB_TDV;i++) pio_tdv_on_off[i]=0;
    pulse_no=-1;
    for(i=0;i<NB_PULSE;i++) { pulse_tab[i][0]=0; pulse_tab[i][6]=-1; pulse_tab[i][7]=-1; pulse_tab[i][8]=0; }


    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des tables de verites","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    pio_tab[pio_var_add_indice++]=30000+0;

    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#tdv"))
        {
            fscanf(pf," %s",ch); //remove [

            while(1)
            {
                  if(fscanf(pf," %s",ch)==EOF) break;

                  if(ch[0]=='@')
                  {
                      do{ if(fscanf(pf,"%c",&c)==EOF) break; } while(c!='\n');
                      continue;
                  }
                  if(ch[0]==']') break;
                  strlwr(ch);

                  //MessageBox(NULL,ch,"Chaine",MB_OK|MB_ICONERROR);
                  //if(phase==TDV_EQU) MessageBox(NULL,ch,"TDV Chaine",MB_OK|MB_ICONERROR);

                  if(!strcmp(ch,"tdv:"))
                  {
                      no++;
                      //fscanf(pf," %d",&no);
                      pio_tdv_ind[no]=pio_var_add_indice;
                      pio_tdv_on_off[no]=1;
                      phase=TDV_START;
                  }
                  else if(!strcmp(ch,"equ:")) phase=TDV_EQU;
                  else if(!strcmp(ch,"on:"))
                  {
                      fscanf(pf," %d",&on);
                      pio_tdv_on_off[no]=on;
                  }
                  else if(!strcmp(ch,"in:"))
                  {
                      pio_tab[pio_var_add_indice++]=30000+1;
                      phase=TDV_IN;
                      //nb_in=0;
                  }
                  else if(!strcmp(ch,"out:"))
                  {
                      pio_tab[pio_var_add_indice++]=30000+5;
                      phase=TDV_OUT;
                      //nb_out=0;
                  }
                  else if(!strcmp(ch,"init:"))
                  {
                      phase=TDV_INIT;
                      pio_tab[pio_var_add_indice++]=30000+2;
                  }
                  else if(!strcmp(ch,"eq:"))
                  {
                      phase=TDV_EQ;
                      pio_tab[pio_var_add_indice++]=30000+3;
                  }
                  else if( (!strcmp(ch,"clear")) || (!strcmp(ch,"clr")) )
                  {
                      val=TDV_CLR;
                  }
                  else if(!strcmp(ch,"set"))
                  {
                      val=TDV_SET;
                  }
                  else if(!strcmp(ch,"0"))
                  {
                      pio_tab[pio_var_add_indice++]=0;
                  }
                  else if(!strcmp(ch,"1"))
                  {
                      pio_tab[pio_var_add_indice++]=1;
                  }
                  else if(!strcmp(ch,"x"))
                  {
                      if(phase==TDV_EQU) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_X;
                      else               pio_tab[pio_var_add_indice++]='x';
                  }
                  else if(!strcmp(ch,"|"))
                  {
                  }
                  else if(!strncmp(ch,"pulse",5))
                  {
                      pt=&ch[5];
                      pulse_no=atoi(pt); pulse_tab[pulse_no][0]=1; pt=pt+2;  if(pulse_no>=10) pt++;  if(pulse_no>=100) pt++;  if(pulse_no>=1000) pt++;
                      t=atoi(pt);        pulse_tab[pulse_no][1]=t; pt=pt+2;  if(t>=10) pt++;  if(t>=100) pt++;  if(t>=1000) pt++;
                      t=atoi(pt);        pulse_tab[pulse_no][2]=t; pt=pt+2;  if(t>=10) pt++;  if(t>=100) pt++;  if(t>=1000) pt++;
                      t=atoi(pt);        pulse_tab[pulse_no][3]=t; pt=pt+2;  if(t>=10) pt++;  if(t>=100) pt++;  if(t>=1000) pt++;
                      t=atoi(pt);        pulse_tab[pulse_no][4]=t; pt=pt+2;  if(t>=10) pt++;  if(t>=100) pt++;  if(t>=1000) pt++;
                      t=atoi(pt);        pulse_tab[pulse_no][5]=t;

                      phase=TDV_PULSE;
                  }
                  else if(!strcmp(ch,"l")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_L;
                  else if(!strcmp(ch,"a")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_A;
                  else if(!strcmp(ch,"o")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_O;
                  //else if(!strcmp(ch,"x")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_X; //reporte dans x
                  else if(!strcmp(ch,"ln")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_L+EQ_INV;
                  else if(!strcmp(ch,"an")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_A+EQ_INV;
                  else if(!strcmp(ch,"on")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_O+EQ_INV;
                  else if(!strcmp(ch,"xn")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_X+EQ_INV;
                  else if(!strcmp(ch,"=")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_EGA;
                  else if(!strcmp(ch,"=set")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_EGASET;
                  else if(!strcmp(ch,"=clr")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_EGACLR;
                  else if(!strcmp(ch,"=num")) pio_tab[pio_var_add_indice++]=EQ_BASE+EQ_EGANUM;

                  else if(pt=strstr(ch,"=="))
                  {
                      num=atoi(pt+2);  // num contient la valeur numerique
                      pt='\0';         // ch contient le nom
                      pio_var_add_indice--; //modify order
                      pio_tab[pio_var_add_indice++]|=EQ_TSTEGA;
                      pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      pio_tab[pio_var_add_indice++]=num;
                  }
                  else if(pt=strstr(ch,"<>"))
                  {
                      num=atoi(pt+2);  // num contient la valeur numerique
                      pt='\0';         // ch contient le nom
                      pio_var_add_indice--; //modify order
                      pio_tab[pio_var_add_indice++]|=EQ_TSTDIFF;
                      pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      pio_tab[pio_var_add_indice++]=num;
                  }
                  else if(pt=strstr(ch,"<="))
                  {
                      num=atoi(pt+2);  // num contient la valeur numerique
                      pt='\0';         // ch contient le nom
                      pio_var_add_indice--; //modify order
                      pio_tab[pio_var_add_indice++]|=EQ_TSTINFEGA;
                      pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      pio_tab[pio_var_add_indice++]=num;
                  }
                  else if(pt=strstr(ch,">="))
                  {
                      num=atoi(pt+2);  // num contient la valeur numerique
                      pt='\0';         // ch contient le nom
                      pio_var_add_indice--; //modify order
                      pio_tab[pio_var_add_indice++]|=EQ_TSTSUPEGA;
                      pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      pio_tab[pio_var_add_indice++]=num;
                  }
                  else if(pt=strstr(ch,"<"))
                  {
                      num=atoi(pt+1);  // num contient la valeur numerique
                      pt='\0';         // ch contient le nom
                      pio_var_add_indice--; //modify order
                      pio_tab[pio_var_add_indice++]|=EQ_TSTINF;
                      pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      pio_tab[pio_var_add_indice++]=num;
                  }
                  else if(pt=strstr(ch,">"))
                  {
                      num=atoi(pt+1);  // num contient la valeur numerique
                      pt='\0';         // ch contient le nom
                      pio_var_add_indice--; //modify order
                      pio_tab[pio_var_add_indice++]|=EQ_TSTSUP;
                      pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      pio_tab[pio_var_add_indice++]=num;
                  }
                  //variable sans set ni clear
                  else
                  {
                      if( phase==TDV_PULSE)
                      {
                         //MessageBox(NULL,ch,"debug",MB_OK);
                               if(pulse_tab[pulse_no][6]==-1) { pulse_tab[pulse_no][6]=pio_var_ch2int(ch); }
                          else if(pulse_tab[pulse_no][7]==-1) { pulse_tab[pulse_no][7]=pio_var_ch2int(ch); }
                      }
                      else if(phase==TDV_EQU)
                      {
                          pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                      }
                      else
                      {
                          if(val==-1 && phase==TDV_EQ)   val=TDV_SET;
                          if(val==-1 && phase==TDV_INIT) val=TDV_CLR;
                          if(phase==TDV_EQ || phase==TDV_INIT)
                          {
                              if(val==TDV_SET) pio_tab[pio_var_add_indice++]='s';
                              else             pio_tab[pio_var_add_indice++]='c';
                          }
                          pio_tab[pio_var_add_indice++]=pio_var_ch2int(ch);
                          val=-1;
                      }
                  }

            } //fin while 1
        }     //fin #tdv
    }         //fin ch
    pio_tab[pio_var_add_indice++]=30000+4;

    fclose(pf);

}
    
void cTdv::save_conf(void)
{
    FILE* pf;
    int i,j;

    if((pf=fopen("debug_prog.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_prog.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    fprintf(pf,"\n\nPIO_VAR\n");
    for(i=0;i<pio_var_add_indice;i++) fprintf(pf,"\n%4d: %4d  %c",i,pio_tab[i],pio_tab[i]);

    fprintf(pf,"\n\nPIO_ON_OFF\n");
    for(i=0;i<NB_TDV;i++) fprintf(pf,"\n%4d: %4d",i,pio_tdv_on_off[i]);

    fprintf(pf,"\n\nPIO_IND\n");
    for(i=0;i<NB_TDV;i++) fprintf(pf,"\n%4d: %4d",i,pio_tdv_ind[i]);

    for(i=0;i<NB_PULSE;i++) { fprintf(pf,"\n%2d:",i); for(j=0;j<8;j++) fprintf(pf," %4d",pulse_tab[i][j]); }

    fclose(pf);
}

void cTdv::tick(void)
{
    int i,j;
    int nb_in,nb_out;
    int ind;
    int tab_in[10];
    int tab_out[10];
    int sens,val,ok;
    int test,test2;

    for(i=0;i<NB_PULSE;i++) if(pulse_tab[i][0]==1)
    {

        if(pulse_tab[i][8]==0) if(pio_pulse_cmd[i]==1) // non declenche
        {
            pio_pulse_cmd[i]=0;
            pulse_tab[i][8]=1;
            pulse_tab[i][9]=pulse_tab[i][1];
        }

        if(pulse_tab[i][8]==1) // attente 1
        {
            if(pulse_tab[i][9]==0)
            {
                pulse_tab[i][8]=2; pulse_tab[i][9]=pulse_tab[i][2];
                if(pulse_tab[i][2])
                {
                    val=pulse_tab[i][6]; if(val!=-1) pio_set_val(val,1);
                    val=pulse_tab[i][7]; if(val!=-1) pio_set_val(val,1);
                }
            }
            else pulse_tab[i][9]--;
        }

        if(pulse_tab[i][8]==2) // actif 1
        {
            if(pulse_tab[i][9]==0)
            {
                pulse_tab[i][8]=3; pulse_tab[i][9]=pulse_tab[i][3];
                if(pulse_tab[i][2])
                {
                    val=pulse_tab[i][6]; if(val!=-1) pio_set_val(val,0);
                    val=pulse_tab[i][7]; if(val!=-1) pio_set_val(val,0);
                }
            }
            else pulse_tab[i][9]--;
        }

        if(pulse_tab[i][8]==3) // attente 2
        {
            if(pulse_tab[i][9]==0)
            {
                pulse_tab[i][8]=4; pulse_tab[i][9]=pulse_tab[i][4];
                if(pulse_tab[i][4])
                {
                    val=pulse_tab[i][6]; if(val!=-1) pio_set_val(val,1);
                    val=pulse_tab[i][7]; if(val!=-1) pio_set_val(val,1);
                }
            }
            else pulse_tab[i][9]--;
        }

        if(pulse_tab[i][8]==4) // actif 2
        {
            if(pulse_tab[i][9]==0)
            {
                pulse_tab[i][8]=5; pulse_tab[i][9]=pulse_tab[i][5];
                if(pulse_tab[i][4])
                {
                    val=pulse_tab[i][6]; if(val!=-1) pio_set_val(val,0);
                    val=pulse_tab[i][7]; if(val!=-1) pio_set_val(val,0);
                }
            }
            else pulse_tab[i][9]--;
        }

        if(pulse_tab[i][8]==5) // attente 3
        {
            if(pulse_tab[i][9]==0)  { pulse_tab[i][8]=0; }
            else pulse_tab[i][9]--;
        }
    }

    for(i=0;i<NB_TDV;i++) if(pio_tdv_ind[i]!=-1) if(pio_tdv_on_off[i])
    {
        ind=pio_tdv_ind[i];

        while((val=pio_tab[ind++])!=30004)
        {

            if(val==30001) /*IN*/
            {
                nb_in=0; nb_out=0;
                while((val=pio_tab[ind])<30000)
                {
                    tab_in[nb_in++]=pio_get_val(val);
                    ind++;
                }
            }
            else if(val==30005) /*OUT*/
            {
                nb_out=0;
                while((val=pio_tab[ind])<30000)
                {
                    tab_out[nb_out++]=val;
                    ind++;
                }
            }
            else if(val==30002) /*INIT*/
            {
                nb_in=nb_out=0;
                while((sens=pio_tab[ind])<30000)
                {
                    ind++;
                    val=pio_tab[ind];
                    if(sens=='s') pio_set_val(val,1); else pio_set_val(val,0);
                    ind++;
                }
            }
            else if(val==30003) /*EQ*/
            {
                ok=1;
                for(j=0;j<nb_in;j++) if(pio_tab[ind+j]=='x' || pio_tab[ind+j]==tab_in[j]) ok=ok; else ok=0;
                ind+=nb_in;

                if(ok)
                for(j=0;j<nb_out;j++)
                {
                    if(pio_tab[ind+j]==0) pio_set_val(tab_out[j],0);
                    if(pio_tab[ind+j]==1) pio_set_val(tab_out[j],1);
                }
                ind+=nb_out;

                while((sens=pio_tab[ind])<30000)
                {
                    ind++;
                    val=pio_tab[ind];
                    if(ok) { if(sens=='s') pio_set_val(val,1); else pio_set_val(val,0); }
                    ind++;
                }
            }

        } //fin while

    } //fin each tdv & on

    ind=0;
    while((val=pio_tab[ind++])!=30004)
    {
        if(val==(EQ_BASE+EQ_L))            { test=0;  if(pio_get_val(pio_tab[ind++])>0) test=1; }
        else if(val==(EQ_BASE+EQ_O))       { test2=0; if(pio_get_val(pio_tab[ind++])>0) test2=1; test=test|test2; }
        else if(val==(EQ_BASE+EQ_A))       { test2=0; if(pio_get_val(pio_tab[ind++])>0) test2=1; test=test&test2; }
        else if(val==(EQ_BASE+EQ_X))       { test2=0; if(pio_get_val(pio_tab[ind++])>0) test2=1; test=test^test2; }
        else if(val==(EQ_BASE+EQ_L+EQ_INV)){ test=0;  if(pio_get_val(pio_tab[ind++])==0) test=1; }
        else if(val==(EQ_BASE+EQ_O+EQ_INV)){ test2=0; if(pio_get_val(pio_tab[ind++])>0) test2=1; test=test|(test2^1); }
        else if(val==(EQ_BASE+EQ_A+EQ_INV)){ test2=0; if(pio_get_val(pio_tab[ind++])>0) test2=1; test=test&(test2^1); }
        else if(val==(EQ_BASE+EQ_X+EQ_INV)){ test2=0; if(pio_get_val(pio_tab[ind++])>0) test2=1; test=test^(test2^1); }
        else if(val==(EQ_BASE+EQ_EGA))     { pio_set_val(pio_tab[ind++],test); }
        else if(val==(EQ_BASE+EQ_EGASET))  { if(test) pio_set_val(pio_tab[ind++],1); }
        else if(val==(EQ_BASE+EQ_EGACLR))  { if(test) pio_set_val(pio_tab[ind++],0); }
        else if(val==(EQ_BASE+EQ_EGANUM))  { pio_set_val(pio_tab[ind],pio_tab[ind+1]); ind+=2; }
    }

}


/*****************************************************************************/
/* FIN TDV                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* BMP VOY                                                                       */
/*****************************************************************************/


HDC       bmp_hdc_mem;
HDC       bmp_hdc_fond_0;
HDC       bmp_hdc_fond_1;
HDC       bmp_hdc_fond_2;
HDC       bmp_hdc_fond_3;
HFONT     bmp_fonte;
HBRUSH    bmp_pinceau_noir;
HBRUSH    bmp_pinceau_bleu;
HBRUSH    bmp_pinceau_vert;
HBRUSH    bmp_pinceau_cyan;
HBRUSH    bmp_pinceau_rouge;
HBRUSH    bmp_pinceau_violet;
HBRUSH    bmp_pinceau_jaune;
HBRUSH    bmp_pinceau_blanc;
HBRUSH    bmp_pinceau_gris;
HBRUSH    bmp_pinceau_rose;
HBRUSH    bmp_pinceau_orange;
HBRUSH    bmp_pinceau_marron;
HBRUSH    bmp_pinceau_kaki;
HBRUSH    bmp_pinceau_bordeau;
HBRUSH    bmp_pinceau_grisvert;
HBRUSH    bmp_pinceau_vertfonce;
HPEN      bmp_stylo_noir;
HPEN      bmp_stylo_bleu;
HPEN      bmp_stylo_vert;
HPEN      bmp_stylo_cyan;
HPEN      bmp_stylo_rouge;
HPEN      bmp_stylo_violet;
HPEN      bmp_stylo_jaune;
HPEN      bmp_stylo_blanc;
HPEN      bmp_stylo_gris;
HPEN      bmp_stylo_rose;
HPEN      bmp_stylo_orange;
HPEN      bmp_stylo_marron;
HPEN      bmp_stylo_kaki;
HPEN      bmp_stylo_bordeau;
HPEN      bmp_stylo_grisvert;
HPEN      bmp_stylo_vertfonce;

/*
int       bmp_cli=0;
int       bmp_rgb_color[9][3]={ {  0,  0,  0}, {  0,  0,255}, {  0,255,  0},
                                {  0,255,255}, {255,  0,  0}, {255,  0,255},
                                {255,255,  0}, {255,255,255}, {192,192,192} };
unsigned long  bmp_rgb[9]={ RGB(  0,  0,  0), RGB(  0,  0,255), RGB(  0,255,  0),
                            RGB(  0,255,255), RGB(255,  0,  0), RGB(255,  0,255),
                            RGB(255,255,  0), RGB(255,255,255), RGB(192,192,192) };
*/

#define BMP_TAB_TYPE_NB        50
#define BMP_TAB_TYPE_IND_NB    11
#define BMP_TAB_TYPE_IND_TYPE   0
#define BMP_TAB_TYPE_IND_DX     1
#define BMP_TAB_TYPE_IND_DY     2
#define BMP_TAB_TYPE_IND_X0     3
#define BMP_TAB_TYPE_IND_Y0     4
#define BMP_TAB_TYPE_IND_X1     5
#define BMP_TAB_TYPE_IND_Y1     6
#define BMP_TAB_TYPE_IND_X2     7
#define BMP_TAB_TYPE_IND_Y2     8
#define BMP_TAB_TYPE_IND_X3     9
#define BMP_TAB_TYPE_IND_Y3    10
#define BMP_TAB_TYPE_IND_C0     3
#define BMP_TAB_TYPE_IND_C1     4
#define BMP_TAB_TYPE_IND_C2     5
#define BMP_TAB_TYPE_IND_C3     6
#define BMP_TAB_TYPE_IND_DIGIT  7
#define BMP_TAB_TYPE_IND_FORMAT 8
#define BMP_TAB_TYPE_IND_MIN    7
#define BMP_TAB_TYPE_IND_MAX    8
#define BMP_TAB_TYPE_IND_DX2    9
#define BMP_TAB_TYPE_IND_DY2   10
#define BMP_TAB_TYPE_IND_HORI   6


#define BMP_CST_COLOR_NOIR       0
#define BMP_CST_COLOR_BLEU       1
#define BMP_CST_COLOR_VERT       2
#define BMP_CST_COLOR_CYAN       3
#define BMP_CST_COLOR_ROUGE      4
#define BMP_CST_COLOR_VIOLET     5
#define BMP_CST_COLOR_JAUNE      6
#define BMP_CST_COLOR_BLANC      7
#define BMP_CST_COLOR_GRIS       8
#define BMP_CST_COLOR_ROSE       9
#define BMP_CST_COLOR_ORANGE    10
#define BMP_CST_COLOR_MARRON    11
#define BMP_CST_COLOR_KAKI      12
#define BMP_CST_COLOR_BORDEAU   13
#define BMP_CST_COLOR_GRISVERT  14
#define BMP_CST_COLOR_VERTFONCE 15

void bmp_move(int x, int y, int xo, int yo, int l, int h)
{
    SelectObject(hdc,bmp_pinceau_blanc);
    BitBlt(hdc,x,y,l,h,bmp_hdc_mem,xo,yo,MERGECOPY);
}

void bmp_select_brush(int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc,bmp_pinceau_noir     ); break;
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc,bmp_pinceau_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc,bmp_pinceau_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc,bmp_pinceau_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc,bmp_pinceau_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc,bmp_pinceau_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc,bmp_pinceau_jaune    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc,bmp_pinceau_gris     ); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc,bmp_pinceau_blanc    ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc,bmp_pinceau_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc,bmp_pinceau_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc,bmp_pinceau_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc,bmp_pinceau_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc,bmp_pinceau_vertfonce); break;
         default:                      SelectObject(hdc,bmp_pinceau_blanc    ); break;
     }
}

void bmp_select_pen(int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc,bmp_stylo_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc,bmp_stylo_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc,bmp_stylo_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc,bmp_stylo_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc,bmp_stylo_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc,bmp_stylo_jaune    ); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc,bmp_stylo_blanc    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc,bmp_stylo_gris     ); break;
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc,bmp_stylo_noir     ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc,bmp_stylo_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc,bmp_stylo_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc,bmp_stylo_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc,bmp_stylo_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc,bmp_stylo_vertfonce); break;
         default:                      SelectObject(hdc,bmp_stylo_noir     ); break;
     }
}

void bmp_select_brush(HDC hdc_,int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc_,bmp_pinceau_noir     ); break;
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc_,bmp_pinceau_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc_,bmp_pinceau_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc_,bmp_pinceau_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc_,bmp_pinceau_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc_,bmp_pinceau_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc_,bmp_pinceau_jaune    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc_,bmp_pinceau_gris     ); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc_,bmp_pinceau_blanc    ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc_,bmp_pinceau_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc_,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc_,bmp_pinceau_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc_,bmp_pinceau_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc_,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc_,bmp_pinceau_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc_,bmp_pinceau_vertfonce); break;
         default:                      SelectObject(hdc_,bmp_pinceau_blanc    ); break;
     }
}

void bmp_select_pen(HDC hdc_,int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc_,bmp_stylo_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc_,bmp_stylo_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc_,bmp_stylo_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc_,bmp_stylo_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc_,bmp_stylo_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc_,bmp_stylo_jaune    ); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc_,bmp_stylo_blanc    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc_,bmp_stylo_gris     ); break;
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc_,bmp_stylo_noir     ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc_,bmp_stylo_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc_,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc_,bmp_stylo_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc_,bmp_stylo_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc_,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc_,bmp_stylo_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc_,bmp_stylo_vertfonce); break;
         default:                      SelectObject(hdc_,bmp_stylo_noir     ); break;
     }
}

void bmp_SetTextColor(HDC hdc_,int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_BLEU     : SetTextColor(hdc_,RGB(  0,128,255)); break;
         case BMP_CST_COLOR_VERT     : SetTextColor(hdc_,RGB(  0,255,  0)); break;
         case BMP_CST_COLOR_CYAN     : SetTextColor(hdc_,RGB(  0,255,255)); break;
         case BMP_CST_COLOR_ROUGE    : SetTextColor(hdc_,RGB(255,  0,  0)); break;
         case BMP_CST_COLOR_VIOLET   : SetTextColor(hdc_,RGB(128,  0,255)); break;
         case BMP_CST_COLOR_JAUNE    : SetTextColor(hdc_,RGB(255,255,  0)); break;
         case BMP_CST_COLOR_BLANC    : SetTextColor(hdc_,RGB(255,255,255)); break;
         case BMP_CST_COLOR_GRIS     : SetTextColor(hdc_,RGB(192,192,192)); break;
         case BMP_CST_COLOR_NOIR     : SetTextColor(hdc_,RGB(  0,  0,  0)); break;
         case BMP_CST_COLOR_ROSE     : SetTextColor(hdc_,RGB(128,128,255)); break;
         case BMP_CST_COLOR_ORANGE   : SetTextColor(hdc_,RGB(255,128,  0)); break;
         case BMP_CST_COLOR_MARRON   : SetTextColor(hdc_,RGB(128, 64,  0)); break;
         case BMP_CST_COLOR_KAKI     : SetTextColor(hdc_,RGB(128,128,  0)); break;
         case BMP_CST_COLOR_BORDEAU  : SetTextColor(hdc_,RGB(128,  0, 64)); break;
         case BMP_CST_COLOR_GRISVERT : SetTextColor(hdc_,RGB( 64,128,128)); break;
         case BMP_CST_COLOR_VERTFONCE: SetTextColor(hdc_,RGB(  0,128,  0)); break;
         default:                      SetTextColor(hdc_,RGB(  0,  0,  0)); break;
     }
}

void bmp_SetTextColor(int no_color)
{
    bmp_SetTextColor(hdc,no_color);
}

void font_pinceau_stylo_init(void)
{
    bmp_fonte=CreateFont(15,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier");

    bmp_pinceau_noir      = CreateSolidBrush(RGB(  0,  0,  0));
    bmp_pinceau_bleu      = CreateSolidBrush(RGB(  0,128,255));
    bmp_pinceau_vert      = CreateSolidBrush(RGB(  0,255,  0));
    bmp_pinceau_cyan      = CreateSolidBrush(RGB(  0,255,255));
    bmp_pinceau_rouge     = CreateSolidBrush(RGB(255,  0,  0));
    bmp_pinceau_violet    = CreateSolidBrush(RGB(128,  0,255));
    bmp_pinceau_jaune     = CreateSolidBrush(RGB(255,255,  0));
    bmp_pinceau_blanc     = CreateSolidBrush(RGB(255,255,255));
    bmp_pinceau_gris      = CreateSolidBrush(RGB(192,192,192));
    bmp_pinceau_rose      = CreateSolidBrush(RGB(128,128,255));
    bmp_pinceau_orange    = CreateSolidBrush(RGB(255,128,  0));
    bmp_pinceau_marron    = CreateSolidBrush(RGB(128, 64,  0));
    bmp_pinceau_kaki      = CreateSolidBrush(RGB(128,128,  0));
    bmp_pinceau_bordeau   = CreateSolidBrush(RGB(128,  0, 64));
    bmp_pinceau_grisvert  = CreateSolidBrush(RGB( 64,128,128));
    bmp_pinceau_vertfonce = CreateSolidBrush(RGB(  0,128,  0));

    bmp_stylo_noir        = CreatePen(PS_SOLID,1,RGB(0  ,0  ,0  ));
    bmp_stylo_bleu        = CreatePen(PS_SOLID,1,RGB(  0,128,255));
    bmp_stylo_vert        = CreatePen(PS_SOLID,1,RGB(  0,255,  0));
    bmp_stylo_cyan        = CreatePen(PS_SOLID,1,RGB(  0,255,255));
    bmp_stylo_rouge       = CreatePen(PS_SOLID,1,RGB(255,  0,  0));
    bmp_stylo_violet      = CreatePen(PS_SOLID,1,RGB(128,  0,255));
    bmp_stylo_jaune       = CreatePen(PS_SOLID,1,RGB(255,255,  0));
    bmp_stylo_blanc       = CreatePen(PS_SOLID,1,RGB(255,255,255));
    bmp_stylo_gris        = CreatePen(PS_SOLID,1,RGB(192,192,192));
    bmp_stylo_rose        = CreatePen(PS_SOLID,1,RGB(255,128,255));
    bmp_stylo_orange      = CreatePen(PS_SOLID,1,RGB(255,128,  0));
    bmp_stylo_marron      = CreatePen(PS_SOLID,1,RGB(128, 64,  0));
    bmp_stylo_kaki        = CreatePen(PS_SOLID,1,RGB(128,128,  0));
    bmp_stylo_bordeau     = CreatePen(PS_SOLID,1,RGB(128,  0, 64));
    bmp_stylo_grisvert    = CreatePen(PS_SOLID,1,RGB( 64,128,128));
    bmp_stylo_vertfonce   = CreatePen(PS_SOLID,1,RGB(  0,128,  0));
}

void bmp_fond_default(void)
{
    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_blanc);
    Rectangle(hdc,0,0,1600,1200);
    //SelectObject(hdc,bmp_pinceau_blanc);  Rectangle(hdc,200,0,1600,1200);
}

/*****************************************************************************/
/* END BMP VOY                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* TCO                                                                       */
/*****************************************************************************/
#define CELLS_TCO_NB   8
#define CELLS_X_NB    32
#define CELLS_Y_NB    25
#define CELLS_SIZE    40

#define CELLS_ENR_NB  15

#define CELLS_TYPE     0
#define CELLS_SUBTYPE  1
#define CELLS_CANT     2
#define CELLS_N1       3
#define CELLS_N2       4
#define CELLS_V1       5
#define CELLS_V2       6
#define CELLS_V3       7
#define CELLS_V4       8
#define CELLS_C1       9
#define CELLS_C2      10
#define CELLS_C3      11
#define CELLS_C4      12
#define CELLS_OPT     13
#define CELLS_SENS    14

#define CELLS_SZ_LEN  41

#define CELLS_TYPE_RIEN   -1
#define CELLS_TYPE_LINK   0
#define CELLS_TYPE_AIG    1
#define CELLS_TYPE_CMDVOY 2
#define CELLS_TYPE_SPE    3

#define CELLS_SUBTYPE_LINK_H    0
#define CELLS_SUBTYPE_LINK_V    1
#define CELLS_SUBTYPE_LINK_SONE 2
#define CELLS_SUBTYPE_LINK_NOSE 3
#define CELLS_SUBTYPE_LINK_SE   4
#define CELLS_SUBTYPE_LINK_OS   5
#define CELLS_SUBTYPE_LINK_NE   6
#define CELLS_SUBTYPE_LINK_ON   7
#define CELLS_SUBTYPE_LINK_SOE  8
#define CELLS_SUBTYPE_LINK_OSE  9
#define CELLS_SUBTYPE_LINK_NOE 10
#define CELLS_SUBTYPE_LINK_ONE 11
#define CELLS_SUBTYPE_LINK_BALA 12

#define CELLS_SUBTYPE_AIG_CH    0
#define CELLS_SUBTYPE_AIG_CB    1
#define CELLS_SUBTYPE_AIG_CHB   2
#define CELLS_SUBTYPE_AIG_HC    3
#define CELLS_SUBTYPE_AIG_BC    4
#define CELLS_SUBTYPE_AIG_HBC   5

#define CELLS_SUBTYPE_CMDVOY_POUSS 0
#define CELLS_SUBTYPE_CMDVOY_INT   1
#define CELLS_SUBTYPE_CMDVOY_ITI   2
#define CELLS_SUBTYPE_CMDVOY_VOY4  3
#define CELLS_SUBTYPE_CMDVOY_LABEL 4
#define CELLS_SUBTYPE_CMDVOY_VOY2  5
#define CELLS_SUBTYPE_CMDVOY_VOY1  6
#define CELLS_SUBTYPE_CMDVOY_GO    7

#define CELLS_SUBTYPE_SPE_VOY   0
#define CELLS_SUBTYPE_SPE_DETEL 1
#define CELLS_SUBTYPE_SPE_CANT  2
#define CELLS_SUBTYPE_SPE_IN    3
#define CELLS_SUBTYPE_SPE_OUT   4
#define CELLS_SUBTYPE_SPE_SENS  5
#define CELLS_SUBTYPE_SPE_CH    6
#define CELLS_SUBTYPE_SPE_HC    7
#define CELLS_SUBTYPE_SPE_HOR   8
#define CELLS_SUBTYPE_SPE_FEU   9

int cells_rendu_general_couleur_fond=0;
int cells_rendu_general_couleur_grille=0;
int cells_rendu_general_couleur_texte=0;
int cells_rendu_general_couleur_on=0;
int cells_rendu_general_couleur_off=0;
int cells_rendu_libre_couleur_rail=0;
int cells_rendu_libre_couleur_fond=0;
int cells_rendu_occupe_couleur_rail=0;
int cells_rendu_occupe_couleur_fond=0;
int cells_rendu_occupe_couleur_fond_auto=0;
int cells_rendu_occupe_use_rail_gras=0;
int cells_rendu_occupe_use_fleche_selectif=0;
int cells_rendu_occupe_use_fleche_auto=0;
int cells_rendu_prev_couleur_fleche_selectif=0;
int cells_rendu_prev_couleur_fleche_auto=0;
int cells_rendu_prev_couleur_fond_auto=0;
int cells_rendu_debug_use_fleche_sens=0;

#define RENDU_COLOR_RAIL_LIBRE     0
#define RENDU_COLOR_FOND_LIBRE     1
#define RENDU_USE_GROS_LIBRE       2
#define RENDU_USE_FLECHE_LIBRE     3

#define RENDU_COLOR_RAIL_OCC       4
#define RENDU_COLOR_FOND_OCC       5
#define RENDU_USE_GROS_OCC         6
#define RENDU_USE_FLECHE_OCC       7

#define RENDU_COLOR_RAIL_SELPREV   8
#define RENDU_COLOR_FOND_SELPREV   9
#define RENDU_USE_GROS_SELPREV    10
#define RENDU_USE_FLECHE_SELPREV  11

#define RENDU_COLOR_RAIL_SELOCC   12
#define RENDU_COLOR_FOND_SELOCC   13
#define RENDU_USE_GROS_SELOCC     14
#define RENDU_USE_FLECHE_SELOCC   15

#define RENDU_COLOR_RAIL_AUTOPREV 16
#define RENDU_COLOR_FOND_AUTOPREV 17
#define RENDU_USE_GROS_AUTOPREV   18
#define RENDU_USE_FLECHE_AUTOPREV 19

#define RENDU_COLOR_RAIL_AUTOOCC  20
#define RENDU_COLOR_FOND_AUTOOCC  21
#define RENDU_USE_GROS_AUTOOCC    22
#define RENDU_USE_FLECHE_AUTOOCC  23

#define RENDU_COLOR_RAIL_GARALOCK 24
#define RENDU_COLOR_FOND_GARALOCK 25
#define RENDU_USE_GROS_GARALOCK   26
#define RENDU_USE_FLECHE_GARALOCK 27 // non util

#define RENDU_COLOR_FOND          28
#define RENDU_COLOR_FOND_RAIL     29
#define RENDU_COLOR_GRILLE        30
#define RENDU_COLOR_TEXT          31

#define RENDU_COLOR_DET_ON        32
#define RENDU_COLOR_DET_OFF       33
#define RENDU_COLOR_AIG_ON        34
#define RENDU_COLOR_AIG_OFF       35
#define RENDU_COLOR_VOY_ON        36
#define RENDU_COLOR_VOY_OFF       37
#define RENDU_COLOR_INT_ON        38
#define RENDU_COLOR_INT_OFF       39
#define RENDU_COLOR_IPP_ON        40
#define RENDU_COLOR_IPP_OFF       41
#define RENDU_COLOR_IPP_LOCKON    42
#define RENDU_COLOR_IPP_LOCKOFF   43

#define RENDU_NB                  44

int rendu[RENDU_NB];

int color_canton[4][16];
int color_train[16];

int cells_tick=0;

int cells[CELLS_TCO_NB][CELLS_X_NB][CELLS_Y_NB][CELLS_ENR_NB];

char sz_cells[CELLS_TCO_NB][CELLS_X_NB][CELLS_Y_NB][CELLS_SZ_LEN];

HDC hdc_mem_cells;

void cells_config(char sz_filename[])
{
    int i,j,c,x,y,e;
    FILE* pf;
    char szTemp[100];
    char cTemp;

    hdc_mem_cells=CreateCompatibleDC(hdc);

    for(c=0;c<CELLS_TCO_NB;c++) for(x=0;x<CELLS_X_NB;x++) for(y=0;y<CELLS_Y_NB;y++) for(e=0;e<CELLS_ENR_NB;e++)
    {
        cells[c][x][y][e]=-1;
    }

    for(c=0;c<CELLS_TCO_NB;c++) for(x=0;x<CELLS_X_NB;x++) for(y=0;y<CELLS_Y_NB;y++) strcpy(sz_cells[c][x][y],"                    ");

    for(i=0;i<RENDU_NB;i++) rendu[i]=0;

    for(j=0;j<4;j++) for(i=0;i<16;i++) color_canton[j][i]=0;

    for(i=0;i<16;i++) color_train[i]=0;

    pf=fopen(sz_filename,"rt");

    if(pf==NULL) return;

    fscanf(pf," %s",szTemp); // remove [TCO_data]
    for(c=0;c<CELLS_TCO_NB;c++)
    {
        fscanf(pf," %s",szTemp); // remove tco=<0-7>
        for(x=0;x<CELLS_X_NB;x++) for(y=0;y<CELLS_Y_NB;y++)
        {
            fscanf(pf," %s %s %s",szTemp,szTemp,szTemp); // remove x=%02d y=%02d data:
            for(e=0;e<CELLS_ENR_NB;e++) fscanf(pf," %d",&cells[c][x][y][e]);
            fscanf(pf," %s",szTemp); // remove string=
            fscanf(pf," %c",&cTemp); // remove "
            for(e=0;e<20;e++) fscanf(pf,"%c",&sz_cells[c][x][y][e]); sz_cells[c][x][y][20]='\0';
            fscanf(pf," %c",&cTemp); // remove "
        }
    }

    fscanf(pf," %s %s",szTemp,szTemp); // remove rendu data:

    for(i=0;i<RENDU_NB;i++) fscanf(pf," %d",&rendu[i]);
    for(j=0;j<4;j++) for(i=0;i<16;i++) fscanf(pf," %d",&color_canton[j][i]);
    for(i=0;i<16;i++) fscanf(pf," %d",&color_train[i]);

    fclose(pf);
}

void cells_save(char sz_filename[])
{
    FILE* pf;
    int i,j,c,x,y,e;

    pf=fopen(sz_filename,"wt");

    if(pf==NULL) return;

    fprintf(pf,"[TCO_data]");
    for(c=0;c<CELLS_TCO_NB;c++)
    {
        fprintf(pf,"\n\ntco=%d",c);
        for(x=0;x<CELLS_X_NB;x++) for(y=0;y<CELLS_Y_NB;y++)
        {
            fprintf(pf,"\nx=%02d y=%02d data:",x,y);
            for(e=0;e<CELLS_ENR_NB;e++) fprintf(pf," %4d",cells[c][x][y][e]);
            fprintf(pf," string= \"%20s\"",sz_cells[c][x][y]);
        }
    }

    fprintf(pf,"\n\nrendu\ndata:");

    for(i=0;i<RENDU_NB;i++) fprintf(pf,"\n%4d",rendu[i]);
    for(j=0;j<4;j++) for(i=0;i<16;i++) fprintf(pf,"\n%4d",color_canton[j][i]);
    for(i=0;i<16;i++) fprintf(pf,"\n%4d",color_train[i]);

    fclose(pf);
}


#define CELLS_NO x+0,y+0
#define CELLS_N  x+20,y+0
#define CELLS_NE x+39,y+0
#define CELLS_E  x+39,y+20
#define CELLS_SE x+39,y+39
#define CELLS_S  x+20,y+39
#define CELLS_SO x+0,y+39
#define CELLS_O  x+0,y+20
#define CELLS_C  x+20,y+20

void rendu_select_pen_for_canton(int c)
{
    int color;

    SelectObject(hdc_mem_cells,bmp_stylo_noir);
    if(c!=-1)
    {
        if(     copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==0) color=rendu[RENDU_COLOR_RAIL_AUTOPREV];
        else if(copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==1) color=rendu[RENDU_COLOR_RAIL_AUTOOCC];
        else if(copy_master_selectif[c/100][c%100]                     ) color=rendu[RENDU_COLOR_RAIL_SELOCC];
        else if(copy_update_selectif[c/100][c%100]                     ) color=rendu[RENDU_COLOR_RAIL_SELPREV];
        else if(                               vio_det[c/100][c%100]==1) color=rendu[RENDU_COLOR_RAIL_OCC];
        else   /*                              vio_det[c/100][c%100]==0*/color=rendu[RENDU_COLOR_RAIL_LIBRE];

        if(color==16) if(copy_num_train[c/100][c%100]!=-1) color=color_train[copy_num_train[c/100][c%100]];
        if(color==17) if(c!=1) color=color_canton[c/100][c%100];
        bmp_select_pen(color);
    }
}

void rendu_select_brush_for_canton(int c)
{
    int color;

    //SelectObject(hdc_mem_cells,bmp_stylo_noir);
    bmp_select_brush(rendu[RENDU_COLOR_FOND_RAIL]);
    if(c!=-1)
    {
        if(     copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==0) color=rendu[RENDU_COLOR_FOND_AUTOPREV];
        else if(copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==1) color=rendu[RENDU_COLOR_FOND_AUTOOCC];
        else if(copy_master_selectif[c/100][c%100]                     ) color=rendu[RENDU_COLOR_FOND_SELOCC];
        else if(copy_update_selectif[c/100][c%100]                     ) color=rendu[RENDU_COLOR_FOND_SELPREV];
        else if(                               vio_det[c/100][c%100]==1) color=rendu[RENDU_COLOR_FOND_OCC];
        else                                 /*vio_det[c/100][c%100]==0*/color=rendu[RENDU_COLOR_FOND_LIBRE];

        if(color==16) if(copy_num_train[c/100][c%100]!=-1) color=color_train[copy_num_train[c/100][c%100]];
        if(color==17) if(c!=1) color=color_canton[c/100][c%100];
        bmp_select_brush(color);
    }
}

int rendu_need_fleche(int c)
{
    int r=0;

    if(c!=-1)
    {
        if(     copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==0) r=rendu[RENDU_USE_FLECHE_AUTOPREV];
        else if(copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==1) r=rendu[RENDU_USE_FLECHE_AUTOOCC];
        else if(copy_master_selectif[c/100][c%100]                     ) r=rendu[RENDU_USE_FLECHE_SELOCC];
        else if(copy_update_selectif[c/100][c%100]                     ) r=rendu[RENDU_USE_FLECHE_SELPREV];
        else if(                               vio_det[c/100][c%100]==1) r=rendu[RENDU_USE_FLECHE_OCC];
        else                                 /*vio_det[c/100][c%100]==0*/r=rendu[RENDU_USE_FLECHE_LIBRE];
    }

    return r;
}

int rendu_need_grostrait(int c)
{
    int r=0;

    if(c!=-1)
    {
        if(     copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==0) r=rendu[RENDU_USE_GROS_AUTOPREV];
        else if(copy_res_auto[c/100][c%100] && vio_det[c/100][c%100]==1) r=rendu[RENDU_USE_GROS_AUTOOCC];
        else if(copy_master_selectif[c/100][c%100]                     ) r=rendu[RENDU_USE_GROS_SELOCC];
        else if(copy_update_selectif[c/100][c%100]                     ) r=rendu[RENDU_USE_GROS_SELPREV];
        else if(                               vio_det[c/100][c%100]==1) r=rendu[RENDU_USE_GROS_OCC];
        else                                 /*vio_det[c/100][c%100]==0*/r=rendu[RENDU_USE_GROS_LIBRE];
    }

    return r;
}

void draw_fleche(char* sz, int x, int y)
{
    if(STR_SAME stricmp(sz,"N")) { MoveToEx(hdc_mem_cells,x+17,y+3 ,NULL); LineTo(hdc_mem_cells,CELLS_N); LineTo(hdc_mem_cells,x+23,y+3 ); LineTo(hdc_mem_cells,x+17,y+3 ); }
    if(STR_SAME stricmp(sz,"S")) { MoveToEx(hdc_mem_cells,x+17,y+36,NULL); LineTo(hdc_mem_cells,CELLS_S); LineTo(hdc_mem_cells,x+23,y+36); LineTo(hdc_mem_cells,x+17,y+36); }
    if(STR_SAME stricmp(sz,"O")) { MoveToEx(hdc_mem_cells,x+3 ,y+17,NULL); LineTo(hdc_mem_cells,CELLS_O); LineTo(hdc_mem_cells,x+3 ,y+23); LineTo(hdc_mem_cells,x+3 ,y+17); }
    if(STR_SAME stricmp(sz,"E")) { MoveToEx(hdc_mem_cells,x+36,y+17,NULL); LineTo(hdc_mem_cells,CELLS_E); LineTo(hdc_mem_cells,x+36,y+23); LineTo(hdc_mem_cells,x+36,y+17); }
                                                                                                          
    if(STR_SAME stricmp(sz,"NO")){ MoveToEx(hdc_mem_cells,x+1 ,y+5 ,NULL); LineTo(hdc_mem_cells,CELLS_NO); LineTo(hdc_mem_cells,x+5 ,y+1 ); LineTo(hdc_mem_cells,x+1 ,y+5 ); }
    if(STR_SAME stricmp(sz,"NE")){ MoveToEx(hdc_mem_cells,x+38,y+5 ,NULL); LineTo(hdc_mem_cells,CELLS_NE); LineTo(hdc_mem_cells,x+34,y+1 ); LineTo(hdc_mem_cells,x+38,y+5 ); }
    if(STR_SAME stricmp(sz,"SO")){ MoveToEx(hdc_mem_cells,x+1 ,y+34,NULL); LineTo(hdc_mem_cells,CELLS_SO); LineTo(hdc_mem_cells,x+5 ,y+38); LineTo(hdc_mem_cells,x+1 ,y+34); }
    if(STR_SAME stricmp(sz,"SE")){ MoveToEx(hdc_mem_cells,x+38,y+34,NULL); LineTo(hdc_mem_cells,CELLS_SE); LineTo(hdc_mem_cells,x+34,y+38); LineTo(hdc_mem_cells,x+38,y+34); }
}

void private_cells_draw_one(int type, int subtype, int x, int y, char szTxt[], int cant, int n1, int n2,  int v1, int v2, int v3, int v4, int c1,int c2, int c3, int c4, int opt, int sens)
{
    int i,j,v,t,g,color;
    char szTemp[100];
    int use_gros_trait=0;

    g=-1;
    if(cant>=1000)
    {
        g=cant-1000;
        if(g>=0 && g<=15) cant=copy_garage_ass_canton[g]; else { g=0; cant=-1; }
    }

    bmp_select_pen(rendu[RENDU_COLOR_GRILLE]);
    bmp_select_brush(rendu[RENDU_COLOR_FOND]);
    if(type==CELLS_TYPE_LINK || type==CELLS_TYPE_AIG || type==CELLS_TYPE_SPE) rendu_select_brush_for_canton(cant);
    if(g!=-1) if(vio_garage_lock_status[g]) if(cant!=-1) // verouille
    {
        bmp_select_pen(rendu[RENDU_COLOR_GRILLE]);
        color=rendu[RENDU_COLOR_FOND_GARALOCK];
        if(color==16) if(copy_num_train[cant/100][cant%100]!=-1) color=color_train[copy_num_train[cant/100][cant%100]];
        if(color==17) if(cant!=1) color=color_canton[cant/100][cant%100];
        bmp_select_brush(color);
    }
    Rectangle(hdc_mem_cells,x,y,x+41,y+41);

    if(type==CELLS_TYPE_SPE && subtype==CELLS_SUBTYPE_SPE_CANT)
    {
        bmp_select_pen(rendu[RENDU_COLOR_GRILLE]);
        if(cant!=-1) if(g==-1 /**/|| (g!=-1 && vio_garage_lock_status[g]==0)/**/)
        {
            if(cells_tick&2) if(canton_pb_capt[cant/100][cant%100]) SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
        }
        Rectangle(hdc_mem_cells,x+2,y+2,x+41-2,y+41-2);
    }

    rendu_select_pen_for_canton(cant);
    use_gros_trait=rendu_need_grostrait(cant);

    if(g!=-1) if(vio_garage_lock_status[g]) if(cant!=-1) // verouille
    {
        color=rendu[RENDU_COLOR_RAIL_GARALOCK];
        if(color==16) if(copy_garage_num_train[g]!=-1) color=color_train[copy_garage_num_train[g]];
        if(color==17) if(cant!=1) color=color_canton[cant/100][cant%100];
        bmp_select_pen(color);

        if(rendu[RENDU_USE_GROS_GARALOCK]) use_gros_trait=1; else use_gros_trait=0;
    }


    //if(x==800 && y==120)
    //{
    //    draw_fleche("N" ,x,y); draw_fleche("O" ,x,y); draw_fleche("S" ,x,y); draw_fleche("E" ,x,y);
    //    draw_fleche("NO",x,y); draw_fleche("NE",x,y); draw_fleche("SE",x,y); draw_fleche("SO",x,y);
    //}

    if(type==CELLS_TYPE_LINK)
    {
        switch(subtype)
        {
            case CELLS_SUBTYPE_LINK_H   :
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_V   :
                MoveToEx(hdc_mem_cells,CELLS_N,NULL); LineTo(hdc_mem_cells,CELLS_S);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+19,y+0,NULL); LineTo(hdc_mem_cells,x+19,y+39);
                    MoveToEx(hdc_mem_cells,x+21,y+0,NULL); LineTo(hdc_mem_cells,x+21,y+39);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("N",x,y); if(sens==1) draw_fleche("S",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("S",x,y); if(sens==1) draw_fleche("N",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_SONE:
                MoveToEx(hdc_mem_cells,CELLS_SO,NULL); LineTo(hdc_mem_cells,CELLS_NE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+38,NULL); LineTo(hdc_mem_cells,x+38,y+0);
                    MoveToEx(hdc_mem_cells,x+1,y+39,NULL); LineTo(hdc_mem_cells,x+39,y+1);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("NE",x,y); if(sens==1) draw_fleche("SO",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("SO",x,y); if(sens==1) draw_fleche("NE",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_NOSE:
                MoveToEx(hdc_mem_cells,CELLS_NO,NULL); LineTo(hdc_mem_cells,CELLS_SE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+1,y+0,NULL); LineTo(hdc_mem_cells,x+39,y+38);
                    MoveToEx(hdc_mem_cells,x+0,y+1,NULL); LineTo(hdc_mem_cells,x+38,y+39);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("SE",x,y); if(sens==1) draw_fleche("NO",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("NO",x,y); if(sens==1) draw_fleche("SE",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_SE  :
                MoveToEx(hdc_mem_cells,CELLS_S,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+19,y+39,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+21,y+39,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("S",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("S",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_OS  :
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_S);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+19,y+39,NULL); LineTo(hdc_mem_cells,x+0,y+21);
                    MoveToEx(hdc_mem_cells,x+21,y+39,NULL); LineTo(hdc_mem_cells,x+0,y+19);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("S",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("S",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_NE  :
                MoveToEx(hdc_mem_cells,CELLS_N,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+19,y+0,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+21,y+0,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("N",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("N",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_ON  :
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_N);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+19,y+0);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+21,y+0);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("N",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("N",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_SOE :
                MoveToEx(hdc_mem_cells,CELLS_SO,NULL); LineTo(hdc_mem_cells,CELLS_C);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+38,NULL); LineTo(hdc_mem_cells,x+20,y+19); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+1,y+39,NULL); LineTo(hdc_mem_cells,x+20,y+21); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E" ,x,y); if(sens==1) draw_fleche("SO",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("SO",x,y); if(sens==1) draw_fleche("E" ,x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_OSE :
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_C);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_SE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+20,y+19); LineTo(hdc_mem_cells,x+39,y+38);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+20,y+21); LineTo(hdc_mem_cells,x+38,y+39);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("SE",x,y); if(sens==1) draw_fleche("O" ,x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O" ,x,y); if(sens==1) draw_fleche("SE",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_NOE :
                MoveToEx(hdc_mem_cells,CELLS_NO,NULL); LineTo(hdc_mem_cells,CELLS_C);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+1,y+0 ,NULL); LineTo(hdc_mem_cells,x+20,y+19); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+1 ,NULL); LineTo(hdc_mem_cells,x+20,y+21); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E" ,x,y); if(sens==1) draw_fleche("NO",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("NO",x,y); if(sens==1) draw_fleche("E" ,x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_ONE :
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_C);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_NE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+20,y+19); LineTo(hdc_mem_cells,x+38,y+0);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+20,y+21); LineTo(hdc_mem_cells,x+39,y+1);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("NE",x,y); if(sens==1) draw_fleche("O" ,x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O" ,x,y); if(sens==1) draw_fleche("NE",x,y); }
                }
                break;
            case CELLS_SUBTYPE_LINK_BALA:
                break;
            default: break;
        }
    }

    if(type==CELLS_TYPE_AIG)
    {
        switch(subtype)
        {
            case CELLS_SUBTYPE_AIG_CH:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_NE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);

                    MoveToEx(hdc_mem_cells,x+20,y+19,NULL); LineTo(hdc_mem_cells,x+38,y+0);
                    MoveToEx(hdc_mem_cells,x+20,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+1);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { /*if(sens==0) draw_fleche("E",x,y);*/ if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); /*if(sens==1) draw_fleche("E",x,y);*/ }
                }
                if(n1!=-1)
                {
                    v=vio_aig_pos0[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+20-4,x+30+8,y+20+4);

                    v=vio_aig_pos1[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+4,x+30+8,y+4+8);

                    if(vio_aig_res[n1])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+7,y+12,x+13,y+18);
                        Rectangle(hdc_mem_cells,x+8,y+10,x+12,y+12);
                    }

                    if(n1==-1) sprintf(szTemp,"aXX "); else sprintf(szTemp,"a%-2d ",n1);
                    TextOut(hdc_mem_cells,x+3,y+3,szTemp,4); // else: +3
                }
                break;
            case CELLS_SUBTYPE_AIG_CB:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_SE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);

                    MoveToEx(hdc_mem_cells,x+20,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+38);
                    MoveToEx(hdc_mem_cells,x+20,y+21,NULL); LineTo(hdc_mem_cells,x+38,y+39);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { /*if(sens==0) draw_fleche("E",x,y);*/ if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); /*if(sens==1) draw_fleche("E",x,y);*/ }
                }
                if(n1!=-1)
                {
                    v=vio_aig_pos0[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+20-4,x+30+8,y+20+4);

                    v=vio_aig_pos1[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+28,x+30+8,y+28+8);

                    if(vio_aig_res[n1])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+7,y+25,x+13,y+25+6);
                        Rectangle(hdc_mem_cells,x+8,y+23,x+12,y+25);
                    }

                    if(n1==-1) sprintf(szTemp,"aXX "); else sprintf(szTemp,"a%-2d ",n1);
                    TextOut(hdc_mem_cells,x+3,y+31,szTemp,4); // else: +3
                }
                break;
            case CELLS_SUBTYPE_AIG_CHB:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_NE);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_SE);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);

                    MoveToEx(hdc_mem_cells,x+20,y+19,NULL); LineTo(hdc_mem_cells,x+38,y+0);
                    MoveToEx(hdc_mem_cells,x+20,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+1);

                    MoveToEx(hdc_mem_cells,x+20,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+38);
                    MoveToEx(hdc_mem_cells,x+20,y+21,NULL); LineTo(hdc_mem_cells,x+38,y+39);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { /*if(sens==0) draw_fleche("E",x,y);*/ if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); /*if(sens==1) draw_fleche("E",x,y);*/ }
                }

                if(n1!=-1 && n2!=-1)
                {
                    if(vio_aig_pos0[n1] && vio_aig_pos0[n2]) v=1; else v=0;
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+20-4,x+30+8,y+20+4);

                    if(vio_aig_pos1[n1] && vio_aig_pos0[n2]) v=1; else v=0;
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+4,x+30+8,y+4+8);

                    if(vio_aig_pos0[n1] && vio_aig_pos1[n2]) v=1; else v=0;
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+30,y+28,x+30+8,y+28+8);

                    if(vio_aig_res[n1])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+7,y+12,x+13,y+18);
                        Rectangle(hdc_mem_cells,x+8,y+10,x+12,y+12);
                    }

                    if(vio_aig_res[n2])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+7,y+25,x+13,y+25+6);
                        Rectangle(hdc_mem_cells,x+8,y+23,x+12,y+25);
                    }

                    if(n1==-1) sprintf(szTemp,"aXX "); else sprintf(szTemp,"a%-2d ",n1);
                    TextOut(hdc_mem_cells,x+3,y+3,szTemp,4); // else: +3
                    if(n2==-1) sprintf(szTemp,"aXX "); else sprintf(szTemp,"a%-2d ",n2);
                    TextOut(hdc_mem_cells,x+3,y+31,szTemp,4); // else: +3
                }
                break;
            case CELLS_SUBTYPE_AIG_HC:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_NO);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);

                    MoveToEx(hdc_mem_cells,x+1 ,y+0 ,NULL); LineTo(hdc_mem_cells,x+20,y+19);
                    MoveToEx(hdc_mem_cells,x+0 ,y+1 ,NULL); LineTo(hdc_mem_cells,x+20,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); /*if(sens==1) draw_fleche("O",x,y);*/ }
                    if(vio_canton_vit[cant/100][cant%100]<0) { /*if(sens==0) draw_fleche("O",x,y);*/ if(sens==1) draw_fleche("E",x,y); }
                }
                if(n1!=-1)
                {
                    v=vio_aig_pos0[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+20-4,x+3+8,y+20+4);

                    v=vio_aig_pos1[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+4,x+3+8,y+4+8);

                    if(vio_aig_res[n1])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+27,y+12,x+33,y+18);
                        Rectangle(hdc_mem_cells,x+28,y+10,x+32,y+12);
                    }

                    SelectObject(hdc_mem_cells,cells_font);
                    SetBkMode(hdc_mem_cells,TRANSPARENT);
                    SetTextColor(hdc_mem_cells,RGB(0,0,128));
                    if(n1==-1) sprintf(szTemp," aXX"); else sprintf(szTemp," a%-2d",n1);
                    TextOut(hdc_mem_cells,x+3,y+3,szTemp,4); // else: +3
                }
                break;
            case CELLS_SUBTYPE_AIG_BC:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_SO);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);

                    MoveToEx(hdc_mem_cells,x+0 ,y+38,NULL); LineTo(hdc_mem_cells,x+20,y+19);
                    MoveToEx(hdc_mem_cells,x+1 ,y+39,NULL); LineTo(hdc_mem_cells,x+20,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); /*if(sens==1) draw_fleche("O",x,y);*/ }
                    if(vio_canton_vit[cant/100][cant%100]<0) { /*if(sens==0) draw_fleche("O",x,y);*/ if(sens==1) draw_fleche("E",x,y); }
                }
                if(n1!=-1)
                {
                    v=vio_aig_pos0[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+20-4,x+3+8,y+20+4);

                    v=vio_aig_pos1[n1];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+28,x+3+8,y+28+8);

                    if(vio_aig_res[n1])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+27,y+25,x+33,y+25+6);
                        Rectangle(hdc_mem_cells,x+28,y+23,x+32,y+25);
                    }

                    SelectObject(hdc_mem_cells,cells_font);
                    SetBkMode(hdc_mem_cells,TRANSPARENT);
                    SetTextColor(hdc_mem_cells,RGB(0,0,128));
                    if(n1==-1) sprintf(szTemp," aXX"); else sprintf(szTemp," a%-2d",n1);
                    TextOut(hdc_mem_cells,x+3,y+31,szTemp,4); // else: +3
                }
                break;
            case CELLS_SUBTYPE_AIG_HBC:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_NO);
                MoveToEx(hdc_mem_cells,CELLS_C,NULL); LineTo(hdc_mem_cells,CELLS_SO);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);

                    MoveToEx(hdc_mem_cells,x+1 ,y+0 ,NULL); LineTo(hdc_mem_cells,x+20,y+19);
                    MoveToEx(hdc_mem_cells,x+0 ,y+1 ,NULL); LineTo(hdc_mem_cells,x+20,y+21);

                    MoveToEx(hdc_mem_cells,x+0 ,y+38,NULL); LineTo(hdc_mem_cells,x+20,y+19);
                    MoveToEx(hdc_mem_cells,x+1 ,y+39,NULL); LineTo(hdc_mem_cells,x+20,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); /*if(sens==1) draw_fleche("O",x,y);*/ }
                    if(vio_canton_vit[cant/100][cant%100]<0) { /*if(sens==0) draw_fleche("O",x,y);*/ if(sens==1) draw_fleche("E",x,y); }
                }

                if(n1!=-1 && n2!=-1)
                {
                    if(vio_aig_pos0[n1] && vio_aig_pos0[n2]) v=1; else v=0;
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+20-4,x+3+8,y+20+4);

                    if(vio_aig_pos1[n1] && vio_aig_pos0[n2]) v=1; else v=0;
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else  bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+4,x+3+8,y+4+8);

                    if(vio_aig_pos0[n1] && vio_aig_pos1[n2]) v=1; else v=0;
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_AIG_ON]); else bmp_select_brush(rendu[RENDU_COLOR_AIG_OFF]);
                    Rectangle(hdc_mem_cells,x+3,y+28,x+3+8,y+28+8);

                    if(vio_aig_res[n1])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+27,y+12,x+33,y+18);
                        Rectangle(hdc_mem_cells,x+28,y+10,x+32,y+12);
                    }

                    if(vio_aig_res[n2])
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+27,y+25,x+33,y+25+6);
                        Rectangle(hdc_mem_cells,x+28,y+23,x+32,y+25);
                    }

                    if(n1==-1) sprintf(szTemp," aXX"); else sprintf(szTemp," a%-2d",n1);
                    TextOut(hdc_mem_cells,x+3,y+3,szTemp,4); // else: +3
                    if(n2==-1) sprintf(szTemp," aXX"); else sprintf(szTemp," a%-2d",n2);
                    TextOut(hdc_mem_cells,x+3,y+31,szTemp,4); // else: +3
                }
                break;
           default: break;
        }
    }

    if(type==CELLS_TYPE_SPE)
    {
        switch(subtype)
        {
            case CELLS_SUBTYPE_SPE_VOY:
                    MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                    if(use_gros_trait)
                    {
                        MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                        MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                    }
                if(g==-1)
                {
                    if(rendu_need_fleche(cant))
                    {
                        if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                        if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                    }
                    SelectObject(hdc_mem_cells,bmp_stylo_noir);
                    SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                    if(cant!=-1)
                    {
                        v=vio_det[cant/100][cant%100];
                        if(v) bmp_select_brush(rendu[RENDU_COLOR_DET_ON]); else bmp_select_brush(rendu[RENDU_COLOR_DET_OFF]);
                    }
                    Rectangle(hdc_mem_cells,x+10,y+15,x+30,y+25);
                }

                if(g!=-1)
                {
                    if(vio_garage_lock_status[g]) if(cant!=-1) // verouille
                    {
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        Rectangle(hdc_mem_cells,x+10,y+15,x+30,y+25);
                    }

                    if(vio_garage_lock_status[g]==0) if(cant!=-1) // connecte
                    {
                        if(rendu_need_fleche(cant))
                        {
                            if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                            if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                        }
                        SelectObject(hdc_mem_cells,bmp_stylo_noir);
                        SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                        if(cant!=-1)
                        {
                            v=vio_det[cant/100][cant%100];
                            if(v) bmp_select_brush(rendu[RENDU_COLOR_DET_ON]); else bmp_select_brush(rendu[RENDU_COLOR_DET_OFF]);
                        }
                        Rectangle(hdc_mem_cells,x+10,y+15,x+30,y+25);
                    }
                }

                break;
            case CELLS_SUBTYPE_SPE_DETEL:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                MoveToEx(hdc_mem_cells,x+10,y+30,NULL); LineTo(hdc_mem_cells,x+19,y+30);
                MoveToEx(hdc_mem_cells,x+17,y+23,NULL); LineTo(hdc_mem_cells,x+19,y+25); LineTo(hdc_mem_cells,x+19,y+35); LineTo(hdc_mem_cells,x+17,y+37);
                MoveToEx(hdc_mem_cells,x+23,y+23,NULL); LineTo(hdc_mem_cells,x+21,y+25); LineTo(hdc_mem_cells,x+21,y+35); LineTo(hdc_mem_cells,x+23,y+37);
                MoveToEx(hdc_mem_cells,x+21,y+30,NULL); LineTo(hdc_mem_cells,x+30,y+30);
                break;
            case CELLS_SUBTYPE_SPE_CANT:

                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(g==-1)
                {
                    if(rendu_need_fleche(cant))
                    {
                        if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                        if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                    }

                    SelectObject(hdc_mem_cells,cells_font);
                    SetBkMode(hdc_mem_cells,TRANSPARENT);
                    SetTextColor(hdc_mem_cells,RGB(0,0,128));
                    if(cant==-1) sprintf(szTemp,"cXXX");
                    else
                    {
                        sprintf(szTemp,"c%3d",cant);
                        TextOut(hdc_mem_cells,x,y+3,szTemp,4);

                        strcpy(szTemp,"    ");
                        if(copy_res_auto[cant/100][cant%100] && vio_det[cant/100][cant%100]   ) szTemp[0]='A';
                        if(copy_res_auto[cant/100][cant%100] && vio_det[cant/100][cant%100]==0) szTemp[0]='a';
                        if(copy_master_selectif[cant/100][cant%100]                           ) szTemp[0]='S';
                        if(copy_update_selectif[cant/100][cant%100]                           ) szTemp[0]='s';

                        if(     vio_canton_vit[cant/100][cant%100]>0) sprintf(&szTemp[1],"+%02d",vio_canton_vit[cant/100][cant%100]);
                        else if(vio_canton_vit[cant/100][cant%100]<0) sprintf(&szTemp[1],"%02d", vio_canton_vit[cant/100][cant%100]);
                        else sprintf(&szTemp[1],"  0");
                        TextOut(hdc_mem_cells,x,y+11,szTemp,4);

                        t=copy_num_train[cant/100][cant%100];
                        if(t!=-1)
                        {
                            if(cells_tick&2 && train_pb_capt[t])
                            {
                                TextOut(hdc_mem_cells,x,y+23," PB ",4);
                                TextOut(hdc_mem_cells,x,y+31,"CAPT",4);
                            }
                            else if(strlen(copy_train_name[t])==8)
                            {
                                sprintf(szTemp,"%s",copy_train_name[t]);     szTemp[4]='\0'; TextOut(hdc_mem_cells,x,y+23,szTemp,4);
                                sprintf(szTemp,"%s",&copy_train_name[t][4]); szTemp[4]='\0'; TextOut(hdc_mem_cells,x,y+31,szTemp,4);
                            }
                            else
                            {
                                sprintf(szTemp," t%-2d",t); TextOut(hdc_mem_cells,x,y+23,szTemp,4);
                                TextOut(hdc_mem_cells,x,y+31,"    ",4);
                            }
                        }
                    }
                }

                if(g!=-1)
                {
                    if(vio_garage_lock_status[g]) if(cant!=-1) // verouille
                    {
                        SelectObject(hdc_mem_cells,cells_font);
                        SetBkMode(hdc_mem_cells,TRANSPARENT);
                        SetTextColor(hdc_mem_cells,RGB(0,0,128));
                        if(g==-1) sprintf(szTemp,"gXX");
                        if(g!=-1 && cant!=-1)
                        {
                            sprintf(szTemp,"g%2d",g);
                            TextOut(hdc_mem_cells,x,y+3,szTemp,3);

                            t=copy_garage_num_train[g];
                            if(t!=-1)
                            {
                                if(strlen(copy_train_name[t])==8)
                                {
                                    sprintf(szTemp,"%s",copy_train_name[t]);     szTemp[4]='\0'; TextOut(hdc_mem_cells,x,y+23,szTemp,4);
                                    sprintf(szTemp,"%s",&copy_train_name[t][4]); szTemp[4]='\0'; TextOut(hdc_mem_cells,x,y+31,szTemp,4);
                                }
                                else
                                {
                                    sprintf(szTemp," t%-2d",t); TextOut(hdc_mem_cells,x,y+23,szTemp,4);
                                    TextOut(hdc_mem_cells,x,y+31,"    ",4);
                                }
                            }

                            SelectObject(hdc_mem_cells,bmp_stylo_noir);
                            bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                            Rectangle(hdc_mem_cells,x+2,y+10,x+38,y+18);
                        }

                    }

                    if(vio_garage_lock_status[g]==0) if(cant!=-1) // connecte
                    {
                        if(rendu_need_fleche(cant))
                        {
                            if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                            if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                        }

                        SelectObject(hdc_mem_cells,cells_font);
                        SetBkMode(hdc_mem_cells,TRANSPARENT);
                        SetTextColor(hdc_mem_cells,RGB(0,0,128));
                        if(g==-1) sprintf(szTemp,"gXX");
                        if(g!=-1 && cant!=-1)
                        {
                            sprintf(szTemp,"g%2d",g);
                            TextOut(hdc_mem_cells,x,y+3,szTemp,3);

                            t=copy_num_train[cant/100][cant%100];
                            if(t!=-1)
                            {
                                if(cells_tick&2 && train_pb_capt[t])
                                {
                                    TextOut(hdc_mem_cells,x,y+23," PB ",4);
                                    TextOut(hdc_mem_cells,x,y+31,"CAPT",4);
                                }
                                else if(strlen(copy_train_name[t])==8)
                                {
                                    sprintf(szTemp,"%s",copy_train_name[t]);     szTemp[4]='\0'; TextOut(hdc_mem_cells,x,y+23,szTemp,4);
                                    sprintf(szTemp,"%s",&copy_train_name[t][4]); szTemp[4]='\0'; TextOut(hdc_mem_cells,x,y+31,szTemp,4);
                                }
                                else
                                {
                                    sprintf(szTemp," t%-2d",t); TextOut(hdc_mem_cells,x,y+23,szTemp,4);
                                    TextOut(hdc_mem_cells,x,y+31,"    ",4);
                                }
                            }

                            SelectObject(hdc_mem_cells,bmp_stylo_noir);
                            bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);
                            Rectangle(hdc_mem_cells,x+2,y+10,x+38,y+18);
                        }
                    }
                }

                break;
            case CELLS_SUBTYPE_SPE_IN:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                v=-1;if(v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]); else bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                    //if(v)    if(c1==-1) bmp_select_pen(hdc_mem_cells,cells_rendu_general_couleur_on);
                    //if(v)    if(c1>=0 ) bmp_select_pen(hdc_mem_cells,c1);
                    //if(v==0) if(c2==-1) bmp_select_pen(hdc_mem_cells,cells_rendu_general_couleur_off);
                    //if(v==0) if(c2>=0 ) bmp_select_pen(hdc_mem_cells,c2);
                }
                for(i=0;i<10;i++) { MoveToEx(hdc_mem_cells,x+20-i,y+24+i,NULL); LineTo(hdc_mem_cells,x+20+i,y+24+i); }
                break;
            case CELLS_SUBTYPE_SPE_OUT:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                if(cant!=-1)
                {
                    v=vio_det[cant/100][cant%100];
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]); else bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                    //if(v)    if(c1==-1) bmp_select_pen(hdc_mem_cells,cells_rendu_general_couleur_on);
                    //if(v)    if(c1>=0 ) bmp_select_pen(hdc_mem_cells,c1);
                    //if(v==0) if(c2==-1) bmp_select_pen(hdc_mem_cells,cells_rendu_general_couleur_off);
                    //if(v==0) if(c2>=0 ) bmp_select_pen(hdc_mem_cells,c2);
                }
                for(i=0;i<10;i++) { MoveToEx(hdc_mem_cells,x+20-i,y+34-i,NULL); LineTo(hdc_mem_cells,x+20+i,y+34-i); }
                if(v1!=-1) pio_set_val(v1,v);
                break;
            case CELLS_SUBTYPE_SPE_SENS:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                if(sens==0 && (copy_allowed_sens[cant/100][cant%100]&2)) SelectObject(hdc_mem_cells,bmp_stylo_vert);
                if(sens==1 && (copy_allowed_sens[cant/100][cant%100]&1)) SelectObject(hdc_mem_cells,bmp_stylo_vert);
                for(i=0;i<10;i++) { MoveToEx(hdc_mem_cells,x+8+i,y+20-i,NULL); LineTo(hdc_mem_cells,x+8+i,y+20+i); }
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                if(sens==0 && (copy_allowed_sens[cant/100][cant%100]&1)) SelectObject(hdc_mem_cells,bmp_stylo_vert);
                if(sens==1 && (copy_allowed_sens[cant/100][cant%100]&2)) SelectObject(hdc_mem_cells,bmp_stylo_vert);
                for(i=0;i<10;i++) { MoveToEx(hdc_mem_cells,x+32-i,y+20-i,NULL); LineTo(hdc_mem_cells,x+32-i,y+20+i); }
                break;
            case CELLS_SUBTYPE_SPE_CH:
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,x+30,y+20);
                MoveToEx(hdc_mem_cells,x+30,y+10,NULL); LineTo(hdc_mem_cells,x+30,y+30);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+30,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+30,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                }
                break;
            case CELLS_SUBTYPE_SPE_HC:
                MoveToEx(hdc_mem_cells,x+10,y+20,NULL); LineTo(hdc_mem_cells,CELLS_E);
                MoveToEx(hdc_mem_cells,x+10,y+10,NULL); LineTo(hdc_mem_cells,x+10,y+30);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+10,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+10,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                break;
            case CELLS_SUBTYPE_SPE_HOR:

                bmp_select_pen(hdc_mem_cells,cells_rendu_general_couleur_grille);
                if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_fond);
                else bmp_select_brush(hdc_mem_cells,c1);
                if(horo_blocked && (cells_tick&2) )
                {
                    if(c3==-1) SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                    else       bmp_select_brush(hdc_mem_cells,c2);
                }
                if(horo_tic_on==0)
                {
                    if(c2==-1) SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                    else       bmp_select_brush(hdc_mem_cells,c2);
                }
                Rectangle(hdc_mem_cells,x,y,x+41,y+41);

                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                sprintf(szTemp," J%d %02d%02d",horo_j,horo_h,horo_m);
                if(horo_blocked) strcpy(&szTemp[8],"bloc"); else strcpy(&szTemp[8],"    ");
                if(horo_tic_on) strcpy(&szTemp[12],"    "); else strcpy(&szTemp[12],"off ");
                TextOut(hdc_mem_cells,x,y+3,szTemp,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTemp[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTemp[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTemp[12],4);
                break;
            case CELLS_SUBTYPE_SPE_FEU:
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                if(use_gros_trait)
                {
                    MoveToEx(hdc_mem_cells,x+0,y+19,NULL); LineTo(hdc_mem_cells,x+39,y+19);
                    MoveToEx(hdc_mem_cells,x+0,y+21,NULL); LineTo(hdc_mem_cells,x+39,y+21);
                }
                if(rendu_need_fleche(cant))
                {
                    if(vio_canton_vit[cant/100][cant%100]>0) { if(sens==0) draw_fleche("E",x,y); if(sens==1) draw_fleche("O",x,y); }
                    if(vio_canton_vit[cant/100][cant%100]<0) { if(sens==0) draw_fleche("O",x,y); if(sens==1) draw_fleche("E",x,y); }
                }
                MoveToEx(hdc_mem_cells,CELLS_O,NULL); LineTo(hdc_mem_cells,CELLS_E);
                if(opt==1) { MoveToEx(hdc_mem_cells,x+6,y+20,NULL); LineTo(hdc_mem_cells,x+6,y+9); LineTo(hdc_mem_cells,x+14,y+9); }
                if(opt==2) { MoveToEx(hdc_mem_cells,x+6,y+20,NULL); LineTo(hdc_mem_cells,x+6,y+31); LineTo(hdc_mem_cells,x+14,y+31); }
                if(opt==3) { MoveToEx(hdc_mem_cells,x+34,y+20,NULL); LineTo(hdc_mem_cells,x+34,y+9); LineTo(hdc_mem_cells,x+26,y+9); }
                if(opt==4) { MoveToEx(hdc_mem_cells,x+34,y+20,NULL); LineTo(hdc_mem_cells,x+34,y+31); LineTo(hdc_mem_cells,x+26,y+31); }
                for(j=0;j<4;j++) for(i=0;i<5;i++)
                {
                    v=1;
                    if(szTxt[5*j+i]=='0') SelectObject(hdc_mem_cells,bmp_pinceau_gris);
                    if(szTxt[5*j+i]=='1')
                    {
                        v=-1; if(v1!=-1) v=pio_get_val(v1);
                        if(v>0) bmp_select_brush(hdc_mem_cells,c1);
                        else SelectObject(hdc_mem_cells,bmp_pinceau_gris);
                    }
                    if(szTxt[5*j+i]=='2')
                    {
                        v=-1; if(v2!=-1) v=pio_get_val(v2);
                        if(v>0) bmp_select_brush(hdc_mem_cells,c2);
                        else SelectObject(hdc_mem_cells,bmp_pinceau_gris);
                    }
                    if(szTxt[5*j+i]=='3')
                    {
                        v=-1; if(v3!=-1) v=pio_get_val(v3);
                        if(v>0) bmp_select_brush(hdc_mem_cells,c3);
                        else SelectObject(hdc_mem_cells,bmp_pinceau_gris);
                    }
                    if(szTxt[5*j+i]=='4')
                    {
                        v=-1; if(v4!=-1) v=pio_get_val(v4);
                        if(v>0) bmp_select_brush(hdc_mem_cells,c4);
                        else SelectObject(hdc_mem_cells,bmp_pinceau_gris);
                    }
                    if(szTxt[5*j+i]>='1' && szTxt[5*j+i]<='4')
                    {
                        if(j<=1) Rectangle(hdc_mem_cells,x+3+7*i,y+3+6*j,x+3+7*i+7,y+3+6*j+7);
                        if(j>=2) Rectangle(hdc_mem_cells,x+3+7*i,y+3+6*j+10,x+3+7*i+7,y+3+6*j+7+10);
                    }
                }
                break;
            default: break;
        }
        
    }

    if(type==CELLS_TYPE_CMDVOY)
    {
        SelectObject(hdc_mem_cells,bmp_stylo_noir);

        switch(subtype)
        {
            case CELLS_SUBTYPE_CMDVOY_POUSS:
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);

                MoveToEx(hdc_mem_cells,x+2,y+2,NULL); LineTo(hdc_mem_cells,x+37,y+2); LineTo(hdc_mem_cells,x+37,y+37); LineTo(hdc_mem_cells,x+2,y+37);  LineTo(hdc_mem_cells,x+2,y+2);

                SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                v=-1;
                if(v2!=-1) v=pio_get_val(v2);
                if(v3!=-1) v=pio_get_val(v3);
                if(v1!=-1) v=pio_get_val(v1);
                if(v4!=-1) v=pio_get_val(v4);
                if(v!=-1)
                {
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_INT_ON]); else bmp_select_brush(rendu[RENDU_COLOR_INT_OFF]);
                    //if(v)    if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_on);
                    //if(v)    if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c1);
                    //if(v==0) if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_off);
                    //if(v==0) if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c2);
                }
                Rectangle(hdc_mem_cells,x+4,y+4,x+10,y+10);
                break;
            case CELLS_SUBTYPE_CMDVOY_INT:
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);

                MoveToEx(hdc_mem_cells,x+2,y+2,NULL); LineTo(hdc_mem_cells,x+37,y+2); LineTo(hdc_mem_cells,x+37,y+37); LineTo(hdc_mem_cells,x+2,y+37);  LineTo(hdc_mem_cells,x+2,y+2);
                MoveToEx(hdc_mem_cells,x+2,y+18,NULL); LineTo(hdc_mem_cells,x+37,y+18);

                SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                v=-1; if(v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_INT_ON]); else bmp_select_brush(rendu[RENDU_COLOR_INT_OFF]);
                //  if(v)    if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_on);
                //  if(v)    if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c1);
                //  if(v==0) if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_off);
                //  if(v==0) if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c2);
                }
                Rectangle(hdc_mem_cells,x+4,y+4,x+10,y+10);
                break;
            case CELLS_SUBTYPE_CMDVOY_ITI:
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                bmp_select_brush(rendu[RENDU_COLOR_IPP_LOCKOFF]);
                if(opt==1)
                {
                    bmp_select_brush(rendu[RENDU_COLOR_IPP_LOCKON]);
                    //if(c3==-1) bmp_select_brush(hdc_mem_cells,BMP_CST_COLOR_ORANGE);
                    //if(c3>=0 ) bmp_select_brush(hdc_mem_cells,c3);
                }
                Ellipse(hdc_mem_cells,x+2,y+2,x+38,y+38);
                SelectObject(hdc_mem_cells,bmp_pinceau_bleu);
                v=-1;
                if(v3!=-1 || v4!=-1)
                {
                    v=0;
                    if(v4!=-1) if(pio_get_val(v4)) v=(cells_tick>>1)&1;
                    if(v3!=-1) if(pio_get_val(v3)) v=1;
                }
                if(v3==-1 && v4==-1 && v2==-1 && v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v) bmp_select_brush(rendu[RENDU_COLOR_IPP_ON]); else bmp_select_brush(rendu[RENDU_COLOR_IPP_OFF]);
                    //if(v)    if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_on);
                    //if(v)    if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c1);
                    //if(v==0) if(c1==-1) bmp_select_brush(hdc_mem_cells,cells_rendu_general_couleur_off);
                    //if(v==0) if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c2);
                }
                Ellipse(hdc_mem_cells,x+6,y+6,x+34,y+34);
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);

                break;
            case CELLS_SUBTYPE_CMDVOY_VOY1:
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);

                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                v=-1;
                if(v2!=-1) { v=0; if(pio_get_val(v2)) v=(cells_tick>>1)&1; }
                if(v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v)    { /*if(c1==-1)*/ bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);  /*else bmp_select_brush(hdc_mem_cells,c1);*/ }
                    else     { /*if(c2==-1)*/ bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]); /*else bmp_select_brush(hdc_mem_cells,c2);*/ }
                }
                Ellipse(hdc_mem_cells,x+2,y+2,x+38,y+38);
                break;
            case CELLS_SUBTYPE_CMDVOY_VOY2:
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);

                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                v=-1;
                if(v2!=-1) { v=0; if(pio_get_val(v2)) v=(cells_tick>>1)&1; }
                if(v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v)    { /*if(c1==-1)*/ bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);  /*else bmp_select_brush(hdc_mem_cells,c1);*/ }
                    else     { /*if(c2==-1)*/ bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]); /*else bmp_select_brush(hdc_mem_cells,c2);*/ }
                }
                Ellipse(hdc_mem_cells,x+2,y+2,x+18,y+18);

                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                v=-1;
                if(v4!=-1) { v=0; if(pio_get_val(4)) v=(cells_tick>>1)&1; }
                if(v3!=-1) v=pio_get_val(v3);
                if(v!=-1)
                {
                    if(v)    { /*if(c3==-1)*/ bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);  /*else bmp_select_brush(hdc_mem_cells,c3);*/ }
                    else     { /*if(c4==-1)*/ bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]); /*else bmp_select_brush(hdc_mem_cells,c4);*/ }
                }
                Ellipse(hdc_mem_cells,x+2,y+22,x+18,y+38);
                break;
            case CELLS_SUBTYPE_CMDVOY_VOY4:
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                SetTextColor(hdc_mem_cells,RGB(0,0,128));
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);

                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                SelectObject(hdc_mem_cells,bmp_pinceau_rouge);
                v=-1; if(v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v)    if(c1==-1) bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);
                //  if(v)    if(c1>=0 ) bmp_select_brush(hdc_mem_cells,c1);
                    if(v==0)            bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                }
                Rectangle(hdc_mem_cells,x+4,y+4,x+10,y+10);
                SelectObject(hdc_mem_cells,bmp_pinceau_noir);
                v=-1; if(v2!=-1) v=pio_get_val(v2);
                if(v!=-1)
                {
                    if(v)    if(c2==-1) bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);
                //  if(v)    if(c2>=0 ) bmp_select_brush(hdc_mem_cells,c2);
                    if(v==0)            bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                }
                Rectangle(hdc_mem_cells,x+4,y+12,x+10,y+18);
                SelectObject(hdc_mem_cells,bmp_pinceau_vert);
                v=-1; if(v3!=-1) v=pio_get_val(v3);
                if(v!=-1)
                {
                    if(v)    if(c3==-1) bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);
                //  if(v)    if(c3>=0 ) bmp_select_brush(hdc_mem_cells,c3);
                    if(v==0)            bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                }
                Rectangle(hdc_mem_cells,x+4,y+20,x+10,y+26);
                SelectObject(hdc_mem_cells,bmp_pinceau_bleu);
                v=-1; if(v4!=-1) v=pio_get_val(v4);
                if(v!=-1)
                {
                    if(v)    if(c4==-1) bmp_select_brush(rendu[RENDU_COLOR_VOY_ON]);
                //  if(v)    if(c4>=0 ) bmp_select_brush(hdc_mem_cells,c4);
                    if(v==0)            bmp_select_brush(rendu[RENDU_COLOR_VOY_OFF]);
                }
                Rectangle(hdc_mem_cells,x+4,y+28,x+10,y+34);
                break;
            case CELLS_SUBTYPE_CMDVOY_LABEL:
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                //SetTextColor(hdc_mem_cells,RGB(0,0,128));
                bmp_SetTextColor(rendu[RENDU_COLOR_TEXT]);
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);  //EasyTextOut(x+2,y+2,ch);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);
                break;
            case CELLS_SUBTYPE_CMDVOY_GO:
                SelectObject(hdc_mem_cells,bmp_stylo_noir);
                //bmp_select_pen(rendu[RENDU_COLOR_TEXT]);
                MoveToEx(hdc_mem_cells,x+2,y+2,NULL); LineTo(hdc_mem_cells,x+30,y+2); LineTo(hdc_mem_cells,x+38,y+20);
                LineTo(hdc_mem_cells,x+30,y+38); LineTo(hdc_mem_cells,x+2,y+38); LineTo(hdc_mem_cells,x+2,y+2);
                SelectObject(hdc_mem_cells,cells_font);
                SetBkMode(hdc_mem_cells,TRANSPARENT);
                bmp_SetTextColor(rendu[RENDU_COLOR_TEXT]);
                TextOut(hdc_mem_cells,x,y+3,szTxt,4);
                TextOut(hdc_mem_cells,x,y+11,&szTxt[4],4);
                TextOut(hdc_mem_cells,x,y+19,&szTxt[8],4);
                TextOut(hdc_mem_cells,x,y+27,&szTxt[12],4);
                break;
            default: break;
        }
    }

}

int conf_symb[]={ 1,1,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_H,
                  1,2,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_V,
                  2,1,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_SONE,
                  2,2,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_NOSE,
                  3,1,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_SE,
                  3,2,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_NE,
                  4,1,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_OS,
                  4,2,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_ON,
                  5,1,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_SOE,
                  5,2,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_NOE,
                  6,1,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_OSE,
                  6,2,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_ONE,

                  1,3,CELLS_TYPE_AIG,CELLS_SUBTYPE_AIG_CH,
                  1,4,CELLS_TYPE_AIG,CELLS_SUBTYPE_AIG_CB,
                  2,3,CELLS_TYPE_AIG,CELLS_SUBTYPE_AIG_HC,
                  2,4,CELLS_TYPE_AIG,CELLS_SUBTYPE_AIG_BC,
                  3,3,CELLS_TYPE_AIG,CELLS_SUBTYPE_AIG_CHB,
                  3,4,CELLS_TYPE_AIG,CELLS_SUBTYPE_AIG_HBC,
                  5,3,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_CH,
                  5,4,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_HC,
                  6,3,CELLS_TYPE_LINK,CELLS_SUBTYPE_LINK_BALA,

                  1,5,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_VOY,
                  2,5,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_CANT,
                  3,5,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_IN,
                  4,5,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_OUT,
                  5,5,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_SENS,
                  6,5,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_FEU,

                  1,6,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_POUSS,
                  2,6,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_INT,
                  3,6,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_ITI,
                  4,6,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_VOY1,
                  5,6,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_VOY2,
                  6,6,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_VOY4,
                  1,7,CELLS_TYPE_RIEN,0,
                  2,7,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_LABEL,
                  3,7,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_HOR,
                  4,7,CELLS_TYPE_CMDVOY,CELLS_SUBTYPE_CMDVOY_GO,

                  0 };

// 2,6,CELLS_TYPE_SPE,CELLS_SUBTYPE_SPE_DETEL,

char c_conf_wnd=' ';
int do_not_redraw=1;
int cells_redraw=0;

int cells_type_sel=-1;
int cells_subtype_sel=0;
int temp_conf_canton=-1;
int temp_conf_sens=-1;
int temp_conf_n1=-1;
int temp_conf_n2=-1;
int temp_conf_v1=-1;
int temp_conf_v2=-1;
int temp_conf_v3=-1;
int temp_conf_v4=-1;
int temp_conf_opt=-1;
int temp_conf_c1=0;
int temp_conf_c2=0;
int temp_conf_c3=0;
int temp_conf_c4=0;
char sz_temp_conf_txt[]="                    ";

int cells_entry_sel=-1;

int yopt=400;


void draw_win_conf_V(void)
{
    int i;
    int xdep,ydep,xopt;
    char szTemp[100];

    xdep=0; ydep=0;
    if(c_conf_wnd=='E') xdep=400;

    //0. total config window redraw
    if(do_not_redraw==0 || cells_redraw==1)
    {
    cells_redraw=0;
    SelectObject(hdc_mem_cells,bmp_pinceau_grisvert);
    SelectObject(hdc_mem_cells,bmp_stylo_grisvert);
    Rectangle(hdc_mem_cells,xdep,0,xdep+400,600);

    SelectObject(hdc_mem_cells,bmp_stylo_noir);
    MoveToEx(hdc_mem_cells,xdep+390, 0,NULL); LineTo(hdc_mem_cells,xdep+400,10);
    MoveToEx(hdc_mem_cells,xdep+400, 0,NULL); LineTo(hdc_mem_cells,xdep+390,10);
    MoveToEx(hdc_mem_cells,xdep+380, 0,NULL); LineTo(hdc_mem_cells,xdep+390, 5);
    MoveToEx(hdc_mem_cells,xdep+380,10,NULL); LineTo(hdc_mem_cells,xdep+390, 5);
    MoveToEx(hdc_mem_cells,xdep+370, 5,NULL); LineTo(hdc_mem_cells,xdep+380, 0);
    MoveToEx(hdc_mem_cells,xdep+370, 5,NULL); LineTo(hdc_mem_cells,xdep+380,10);
    }


    //1. partial config window redraw
    i=0;
    while(conf_symb[i])
    {
        if(conf_symb[i+2]==CELLS_TYPE_SPE && conf_symb[i+3]==CELLS_SUBTYPE_SPE_FEU) strcpy(szTemp,"           123 "); else strcpy(szTemp,"    text        ");
        private_cells_draw_one(conf_symb[i+2],conf_symb[i+3],xdep+40*conf_symb[i+0],ydep+40*conf_symb[i+1],szTemp, -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1);

        i=i+4;
    }

    private_cells_draw_one(cells_type_sel,cells_subtype_sel,320+xdep,40,sz_temp_conf_txt,temp_conf_canton,temp_conf_n1,temp_conf_n2,temp_conf_v1,temp_conf_v2,temp_conf_v3,temp_conf_v4,temp_conf_c1,temp_conf_c2,temp_conf_c3,temp_conf_c4,temp_conf_opt,temp_conf_sens);

    SelectObject(hdc_mem_cells,cells_font);
    SetBkMode(hdc_mem_cells,TRANSPARENT);
    SetTextColor(hdc_mem_cells,RGB(0,0,0)); //SetTextColor(hdc_mem_cells,RGB(0,128,128));
    SelectObject(hdc_mem_cells,bmp_pinceau_jaune);
    SelectObject(hdc_mem_cells,bmp_stylo_noir);

    sprintf(szTemp,"cant"); TextOut(hdc_mem_cells,10+xdep,yopt+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+0-2,40+xdep+50,yopt+0+10);
    sprintf(szTemp,"%d",temp_conf_canton); TextOut(hdc_mem_cells,40+xdep,yopt+0,szTemp,strlen(szTemp));

    sprintf(szTemp,"#1"); TextOut(hdc_mem_cells,110+xdep,yopt+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,140+xdep,yopt+0-2,140+xdep+50,yopt+0+10);
    sprintf(szTemp,"%d",temp_conf_n1); TextOut(hdc_mem_cells,140+xdep,yopt+0,szTemp,strlen(szTemp));

    sprintf(szTemp,"#2"); TextOut(hdc_mem_cells,210+xdep,yopt+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,240+xdep,yopt+0-2,240+xdep+50,yopt+0+10);
    sprintf(szTemp,"%d",temp_conf_n2); TextOut(hdc_mem_cells,240+xdep,yopt+0,szTemp,strlen(szTemp));

    sprintf(szTemp,"v1"); TextOut(hdc_mem_cells,10+xdep,yopt+20+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+20+0-2,40+xdep+50,yopt+20+10);
    sprintf(szTemp,"%d",temp_conf_v1); TextOut(hdc_mem_cells,40+xdep,yopt+20+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,100+xdep,yopt+20+0-2,100+xdep+150,yopt+20+10);
    if(temp_conf_v1!=-1) { pio_var_int2ch(temp_conf_v1,szTemp); TextOut(hdc_mem_cells,100+xdep,yopt+20+0,szTemp,strlen(szTemp));}

    sprintf(szTemp,"v2"); TextOut(hdc_mem_cells,10+xdep,yopt+40+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+40+0-2,40+xdep+50,yopt+40+10);
    sprintf(szTemp,"%d",temp_conf_v2); TextOut(hdc_mem_cells,40+xdep,yopt+40+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,100+xdep,yopt+40+0-2,100+xdep+150,yopt+40+10);
    if(temp_conf_v2!=-1) { pio_var_int2ch(temp_conf_v2,szTemp); TextOut(hdc_mem_cells,100+xdep,yopt+40+0,szTemp,strlen(szTemp));}

    sprintf(szTemp,"v3"); TextOut(hdc_mem_cells,10+xdep,yopt+60+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+60+0-2,40+xdep+50,yopt+60+10);
    sprintf(szTemp,"%d",temp_conf_v3); TextOut(hdc_mem_cells,40+xdep,yopt+60+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,100+xdep,yopt+60+0-2,100+xdep+150,yopt+60+10);
    if(temp_conf_v3!=-1) { pio_var_int2ch(temp_conf_v3,szTemp); TextOut(hdc_mem_cells,100+xdep,yopt+60+0,szTemp,strlen(szTemp));}

    sprintf(szTemp,"v4"); TextOut(hdc_mem_cells,10+xdep,yopt+80+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+80+0-2,40+xdep+50,yopt+80+10);
    sprintf(szTemp,"%d",temp_conf_v4); TextOut(hdc_mem_cells,40+xdep,yopt+80+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,100+xdep,yopt+80+0-2,100+xdep+150,yopt+80+10);
    if(temp_conf_v4!=-1) { pio_var_int2ch(temp_conf_v4,szTemp); TextOut(hdc_mem_cells,100+xdep,yopt+80+0,szTemp,strlen(szTemp));}

    sprintf(szTemp,"opt"); TextOut(hdc_mem_cells,10+xdep,yopt+100+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+100+0-2,40+xdep+100,yopt+100+10);
    sprintf(szTemp,"%d",temp_conf_opt); TextOut(hdc_mem_cells,40+xdep,yopt+100+0,szTemp,strlen(szTemp));

    sprintf(szTemp,"txt"); TextOut(hdc_mem_cells,10+xdep,yopt+120+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,40+xdep,yopt+120+0-2,40+xdep+200,yopt+120+10);
    sprintf(szTemp,"%s",sz_temp_conf_txt); TextOut(hdc_mem_cells,40+xdep,yopt+120+0,szTemp,strlen(szTemp));


    bmp_select_brush(hdc_mem_cells,temp_conf_c1);
    sprintf(szTemp,"c1"); TextOut(hdc_mem_cells,310+xdep,yopt+20+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,340+xdep,yopt+20+0,340+xdep+20,yopt+20+10);

    bmp_select_brush(hdc_mem_cells,temp_conf_c2);
    sprintf(szTemp,"c2"); TextOut(hdc_mem_cells,310+xdep,yopt+40+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,340+xdep,yopt+40+0,340+xdep+20,yopt+40+10);

    bmp_select_brush(hdc_mem_cells,temp_conf_c3);
    sprintf(szTemp,"c3"); TextOut(hdc_mem_cells,310+xdep,yopt+60+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,340+xdep,yopt+60+0,340+xdep+20,yopt+60+10);

    bmp_select_brush(hdc_mem_cells,temp_conf_c4);
    sprintf(szTemp,"c4"); TextOut(hdc_mem_cells,310+xdep,yopt+80+0,szTemp,strlen(szTemp));
    Rectangle(hdc_mem_cells,340+xdep,yopt+80+0,340+xdep+20,yopt+80+10);


    sprintf(szTemp,"s+"); TextOut(hdc_mem_cells,310+xdep,yopt+0,szTemp,strlen(szTemp));
    SelectObject(hdc_mem_cells,bmp_pinceau_gris);
    SelectObject(hdc_mem_cells,bmp_stylo_gris);
    Rectangle(hdc_mem_cells,340+xdep,yopt+0,0+xdep+360,yopt+15);
    SelectObject(hdc_mem_cells,bmp_stylo_noir);
    if(temp_conf_sens==0)
    {
        MoveToEx(hdc_mem_cells,345+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+345,yopt+0);
        MoveToEx(hdc_mem_cells,345+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+355,yopt+0);
        MoveToEx(hdc_mem_cells,345+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+355,yopt+7);
        MoveToEx(hdc_mem_cells,345+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+355,yopt+15);
    }
    if(temp_conf_sens==1)
    {
        MoveToEx(hdc_mem_cells,355+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+355,yopt+15);
        MoveToEx(hdc_mem_cells,355+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+345,yopt+0);
        MoveToEx(hdc_mem_cells,355+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+345,yopt+7);
        MoveToEx(hdc_mem_cells,355+xdep,yopt+7,NULL); LineTo(hdc_mem_cells,xdep+345,yopt+15);
    }

}


void draw_win_conf_H(void)
{
    int ydep;

    ydep=0;
    if(c_conf_wnd=='N') ydep=300;

    SelectObject(hdc_mem_cells,bmp_pinceau_grisvert);
    SelectObject(hdc_mem_cells,bmp_stylo_grisvert);
    Rectangle(hdc_mem_cells,0,ydep,800,ydep+299);
}


void move_win_conf(void)
{
    switch(c_conf_wnd)
    {
        case ' ': c_conf_wnd='E'; break;
        case 'E': c_conf_wnd='O'; break;
        case 'O': c_conf_wnd='N'; break;
        case 'N': c_conf_wnd='S'; break;
        case 'S': c_conf_wnd='R'; break;
        case 'R': c_conf_wnd=' '; break;
        default: break;
    }
}


void rendu_rect(int x,int y, int color)
{
   SelectObject(hdc_mem_cells,bmp_stylo_noir);
   if(color<100)
   {
       if(color<=15) bmp_select_brush(color);
       if(color==16) bmp_select_brush(BMP_CST_COLOR_JAUNE);
       if(color==17) bmp_select_brush(BMP_CST_COLOR_JAUNE);
       Rectangle(hdc_mem_cells,x,y-2,x+15,y+15);
       if(color==16) TextOut(hdc_mem_cells,x, y,"T",1);
       if(color==17) TextOut(hdc_mem_cells,x, y,"C",1);
   }

   if(color>=100)
   {
       if(color==100) bmp_select_brush(BMP_CST_COLOR_GRIS);
       if(color==101) bmp_select_brush(BMP_CST_COLOR_VERT);
       Rectangle(hdc_mem_cells,x,y-2,x+15,y+15);
       if(color==100) TextOut(hdc_mem_cells,x, y,"0",1);
       if(color==101) TextOut(hdc_mem_cells,x, y,"1",1);
   }

   SelectObject(hdc_mem_cells,bmp_pinceau_gris); SelectObject(hdc_mem_cells,bmp_stylo_gris);
}

void rendu_little_rect(int x,int y, int color)
{
   SelectObject(hdc_mem_cells,bmp_stylo_noir);
   bmp_select_brush(color);
   Rectangle(hdc_mem_cells,x,y,x+12,y+8);

   SelectObject(hdc_mem_cells,bmp_pinceau_gris); SelectObject(hdc_mem_cells,bmp_stylo_gris);
}

void draw_win_rendu(void)
{
    int i,j,x,y,v;
    char szTemp[100];

    //if(c_conf_wnd=='R')

    //0. total config window redraw
    if(do_not_redraw==0 || cells_redraw==1)
    {
    cells_redraw=0;
    SelectObject(hdc_mem_cells,bmp_pinceau_grisvert);
    SelectObject(hdc_mem_cells,bmp_stylo_grisvert);
    Rectangle(hdc_mem_cells,0,0,400,600);

    SelectObject(hdc_mem_cells,bmp_stylo_noir);
    MoveToEx(hdc_mem_cells,390, 0,NULL); LineTo(hdc_mem_cells,400,10);
    MoveToEx(hdc_mem_cells,400, 0,NULL); LineTo(hdc_mem_cells,390,10);
    }


    //1. partial config window redraw
    SelectObject(hdc_mem_cells,cells_font);
    SetBkMode(hdc_mem_cells,TRANSPARENT);
    SetTextColor(hdc_mem_cells,RGB(0,0,0)); //SetTextColor(hdc_mem_cells,RGB(0,128,128));
    SelectObject(hdc_mem_cells,bmp_pinceau_gris);
    SelectObject(hdc_mem_cells,bmp_stylo_gris);

    x=90;
    y=5;   Rectangle(hdc_mem_cells,x, y, x+200, y+10); strcpy(szTemp,"Selection du rendu"); TextOut(hdc_mem_cells,x,y,szTemp,strlen(szTemp));

    x=10;
    y=40;  Rectangle(hdc_mem_cells,x, y, x+370, y+10); strcpy(szTemp,"voies"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));

    x=220; y=60;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
           y=70;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"rail"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=260; y=60;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
           y=70;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"fond"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=300; y=60;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"gros"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
           y=70;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"rail"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=340; y=60;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"sens"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
           y=70;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"    "            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));

    x=40;  y=100; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"libre"          ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_LIBRE]);    rendu_rect(260,y,rendu[RENDU_COLOR_FOND_LIBRE]);    rendu_rect(300,y,rendu[RENDU_USE_GROS_LIBRE]+100);    rendu_rect(340,y,rendu[RENDU_USE_FLECHE_LIBRE]+100);
           y=120; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"err occ"        ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_OCC]);      rendu_rect(260,y,rendu[RENDU_COLOR_FOND_OCC]);      rendu_rect(300,y,rendu[RENDU_USE_GROS_OCC]+100);      rendu_rect(340,y,rendu[RENDU_USE_FLECHE_OCC]+100);
           y=140; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"sel prev"       ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_SELPREV]);  rendu_rect(260,y,rendu[RENDU_COLOR_FOND_SELPREV]);  rendu_rect(300,y,rendu[RENDU_USE_GROS_SELPREV]+100);  rendu_rect(340,y,rendu[RENDU_USE_FLECHE_SELPREV]+100);
           y=160; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"sel occ"        ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_SELOCC]);   rendu_rect(260,y,rendu[RENDU_COLOR_FOND_SELOCC]);   rendu_rect(300,y,rendu[RENDU_USE_GROS_SELOCC]+100);   rendu_rect(340,y,rendu[RENDU_USE_FLECHE_SELOCC]+100);
           y=180; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"auto prev"      ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_AUTOPREV]); rendu_rect(260,y,rendu[RENDU_COLOR_FOND_AUTOPREV]); rendu_rect(300,y,rendu[RENDU_USE_GROS_AUTOPREV]+100); rendu_rect(340,y,rendu[RENDU_USE_FLECHE_AUTOPREV]+100);
           y=200; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"auto occ"       ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_AUTOOCC]);  rendu_rect(260,y,rendu[RENDU_COLOR_FOND_AUTOOCC]);  rendu_rect(300,y,rendu[RENDU_USE_GROS_AUTOOCC]+100);  rendu_rect(340,y,rendu[RENDU_USE_FLECHE_AUTOOCC]+100);
           y=220; Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"garage ver"     ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp)); rendu_rect(220,y,rendu[RENDU_COLOR_RAIL_GARALOCK]); rendu_rect(260,y,rendu[RENDU_COLOR_FOND_GARALOCK]); rendu_rect(300,y,rendu[RENDU_USE_GROS_GARALOCK]+100);

    x=10;  y=245;  Rectangle(hdc_mem_cells,x, y, x+370, y+10); strcpy(szTemp,"general"       ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));

    x=220; y=260;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=220; y=270;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"fond"          ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=260; y=260;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=260; y=270;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"bala"          ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=300; y=260;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=300; y=270;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"gril"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=340; y=260;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=340; y=270;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"text"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));

    x=40;  y=300;  Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"cell"          ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));  rendu_rect(220,y,rendu[RENDU_COLOR_FOND]); rendu_rect(260,y,rendu[RENDU_COLOR_FOND_RAIL]); rendu_rect(300,y,rendu[RENDU_COLOR_GRILLE]); rendu_rect(340,y,rendu[RENDU_COLOR_TEXT]);

    x=220; y=340;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=260; y=340;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=300; y=340;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=340; y=340;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"coul"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=220; y=350;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"off"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=260; y=350;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"on"             ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=300; y=350;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"voff"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=340; y=350;  Rectangle(hdc_mem_cells,x, y, x+38, y+10); strcpy(szTemp,"von"            ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));

    x=40;  y=380;  Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"det"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));  rendu_rect(220,y,rendu[RENDU_COLOR_DET_OFF]); rendu_rect(260,y,rendu[RENDU_COLOR_DET_ON]);
           y=400;  Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"aig"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));  rendu_rect(220,y,rendu[RENDU_COLOR_AIG_OFF]); rendu_rect(260,y,rendu[RENDU_COLOR_AIG_ON]);
           y=420;  Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"voy"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));  rendu_rect(220,y,rendu[RENDU_COLOR_VOY_OFF]); rendu_rect(260,y,rendu[RENDU_COLOR_VOY_ON]);
           y=440;  Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"int"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));  rendu_rect(220,y,rendu[RENDU_COLOR_INT_OFF]); rendu_rect(260,y,rendu[RENDU_COLOR_INT_ON]);
           y=460;  Rectangle(hdc_mem_cells,x, y, x+140, y+10); strcpy(szTemp,"ipp"           ); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));  rendu_rect(220,y,rendu[RENDU_COLOR_IPP_OFF]); rendu_rect(260,y,rendu[RENDU_COLOR_IPP_ON]); rendu_rect(300,y,rendu[RENDU_COLOR_IPP_LOCKOFF]); rendu_rect(340,y,rendu[RENDU_COLOR_IPP_LOCKON]);

    x=10;  y=500;  Rectangle(hdc_mem_cells,x, y, x+370, y+10); strcpy(szTemp,"cantons/trains"); TextOut(hdc_mem_cells,x, y,szTemp,strlen(szTemp));
    x=60;  y=520;  for(j=0;j<4;j++) for(i=0;i<16;i++) rendu_little_rect(x+20*i,y+10*j,color_canton[j][i]);
    x=60;  y=580;                   for(i=0;i<16;i++) rendu_little_rect(x+20*i,y,color_train[i]);

    x=10;  y=520;  for(j=0;j<4;j++)  { Rectangle(hdc_mem_cells,x     , y+10*j, x+40     , y+10+10*j); sprintf(szTemp,"c%d",100*j); TextOut(hdc_mem_cells,x,y+10*j,szTemp,strlen(szTemp)); }
    x=10;  y=580;                    { Rectangle(hdc_mem_cells,x     , y     , x+40     , y+10     ); sprintf(szTemp,"t0"       ); TextOut(hdc_mem_cells,x,y     ,szTemp,strlen(szTemp)); }
    x=60;  y=565;  for(i=0;i<16;i++) { Rectangle(hdc_mem_cells,x+20*i, y     , x+20*i+18, y+10     ); sprintf(szTemp,"%d",i     ); TextOut(hdc_mem_cells,x+20*i,y,szTemp,strlen(szTemp)); }

}


void cells_draw(int tco)
{
    int x,y,xdep,xfin,ydep,yfin;
    RECT rect;

    hdc_mem_cells=hdc;



    cells_tick++;

    GetClientRect(hwnd,&rect);

    xdep=0; xfin=(rect.right )/40; if(xfin>(CELLS_X_NB-1)) xfin=CELLS_X_NB-1; if(xfin<0) xfin=0;
    ydep=0; yfin=(rect.bottom)/40; if(yfin>(CELLS_Y_NB-1)) yfin=CELLS_Y_NB-1; if(yfin<0) yfin=0;

    for(x=xdep;x<=xfin;x++) for(y=ydep;y<=yfin;y++)
    {
        if(c_conf_wnd=='R' && x>=0  && x<=9  && y<=14) continue;
        if(c_conf_wnd=='O' && x>=0  && x<=9  && y<=14) continue;
        if(c_conf_wnd=='E' && x>=10 && x<=19 && y<=14) continue;
        if(c_conf_wnd=='N' && y>=0  && y<=6 ) continue;
        if(c_conf_wnd=='S' && y>=7  && y<=14) continue;

        private_cells_draw_one(cells[tco][x][y][CELLS_TYPE],cells[tco][x][y][CELLS_SUBTYPE],CELLS_SIZE*x,CELLS_SIZE*y,sz_cells[tco][x][y],
        cells[tco][x][y][CELLS_CANT],cells[tco][x][y][CELLS_N1],cells[tco][x][y][CELLS_N2],
        cells[tco][x][y][CELLS_V1],cells[tco][x][y][CELLS_V2],cells[tco][x][y][CELLS_V3],cells[tco][x][y][CELLS_V4],
        cells[tco][x][y][CELLS_C1],cells[tco][x][y][CELLS_C2],cells[tco][x][y][CELLS_C3],cells[tco][x][y][CELLS_C4],
        cells[tco][x][y][CELLS_OPT],cells[tco][x][y][CELLS_SENS]);

        if(x>=1)
        if(cells[tco][x][y][CELLS_TYPE]==CELLS_TYPE_AIG  || cells[tco][x][y][CELLS_TYPE]==CELLS_TYPE_SPE
        ||(cells[tco][x][y][CELLS_TYPE]==CELLS_TYPE_LINK && cells[tco][x][y][CELLS_SUBTYPE]==CELLS_SUBTYPE_LINK_H))
        if(cells[tco][x][y][CELLS_CANT]!=cells[tco][x-1][y][CELLS_CANT])
        if(cells[tco][x-1][y][CELLS_CANT]!=-1)
        {
            SelectObject(hdc_mem_cells,bmp_stylo_noir);
            SelectObject(hdc_mem_cells,bmp_pinceau_noir);
            Ellipse(hdc_mem_cells,CELLS_SIZE*x-3,CELLS_SIZE*y+17,CELLS_SIZE*x+6-3,CELLS_SIZE*y+17+6);
        }
    }

    if(c_conf_wnd=='E' || c_conf_wnd=='O') draw_win_conf_V();

    if(c_conf_wnd=='N' || c_conf_wnd=='S') draw_win_conf_H();

    if(c_conf_wnd=='R') draw_win_rendu();


    //BitBlt(hdc,0,0,800,600,hdc_mem_cells,0,0,SRCCOPY); // MERGECOPY not really good
}

int cells_pouss_en_cours=-1;

int mouse_in_rendu_rect(int x, int y)
{
    if(x_mouse>x && x_mouse<(x+15) && y_mouse>y && y_mouse<(y+15)) return 1;

    return 0;
}

void cells_debug(int tco,int action)
{
    int xdep,i,j,x_sel,y_sel,x,y,v,v1,v2,v3,v4,n1,n2,cant,sens,g;

    xdep=0;

    if(action==DEBUG_KEY)
    {
        if(touche_char=='+') move_win_conf();

         if(cells_entry_sel!=-1)
         {
             switch(cells_entry_sel)
             {
                 case 1: if(touche_char>='0' && touche_char<='9') { if(temp_conf_canton==-1) temp_conf_canton=0; temp_conf_canton=temp_conf_canton*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_canton=-1; break;
                 case 2: if(touche_char>='0' && touche_char<='9') { if(temp_conf_n1==-1) temp_conf_n1=0; temp_conf_n1=temp_conf_n1*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_n1=-1; break;
                 case 3: if(touche_char>='0' && touche_char<='9') { if(temp_conf_n2==-1) temp_conf_n2=0; temp_conf_n2=temp_conf_n2*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_n2=-1; break;
                 case 4: if(touche_char>='0' && touche_char<='9') { if(temp_conf_v1==-1) temp_conf_v1=0; temp_conf_v1=temp_conf_v1*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_v1=-1; break;
                 case 5: if(touche_char>='0' && touche_char<='9') { if(temp_conf_v2==-1) temp_conf_v2=0; temp_conf_v2=temp_conf_v2*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_v2=-1; break;
                 case 6: if(touche_char>='0' && touche_char<='9') { if(temp_conf_v3==-1) temp_conf_v3=0; temp_conf_v3=temp_conf_v3*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_v3=-1; break;
                 case 7: if(touche_char>='0' && touche_char<='9') { if(temp_conf_v4==-1) temp_conf_v4=0; temp_conf_v4=temp_conf_v4*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_v4=-1; break;
                 case 8: if(touche_char>='0' && touche_char<='9') { if(temp_conf_opt==-1) temp_conf_opt=0; temp_conf_opt=temp_conf_opt*10+touche_char-'0'; }
                         if(touche_char==' ') temp_conf_opt=-1; break;
                 case 9: if((touche_char>='0' && touche_char<='9') || (touche_char>='a' && touche_char<='z') || (touche_char>='A' && touche_char<='Z') || touche_char==' ' || touche_char=='_')
                         {
                             for(i=0;i<19;i++) sz_temp_conf_txt[i]=sz_temp_conf_txt[i+1];
                             sz_temp_conf_txt[19]=touche_char;
                             sz_temp_conf_txt[20]='\0';
                         }
                         break;
                 default: break;
             }
         }

    }

    if(action==DEBUG_MOUSE)
    {
         if(c_conf_wnd=='R') // fenetre rendu ouverte
         {
             x=390; y=0;   if(y_mouse>y && y_mouse<(y+10) && x_mouse>x && x_mouse<(x+15)) c_conf_wnd=' ';

             y=100;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_LIBRE]=(rendu[RENDU_COLOR_RAIL_LIBRE]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_LIBRE]=(rendu[RENDU_COLOR_FOND_LIBRE]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_LIBRE  ]=(rendu[RENDU_USE_GROS_LIBRE  ]+1)%2;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_USE_FLECHE_LIBRE]=(rendu[RENDU_USE_FLECHE_LIBRE]+1)%2;

             y=120;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_OCC]=(rendu[RENDU_COLOR_RAIL_OCC  ]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_OCC]=(rendu[RENDU_COLOR_FOND_OCC  ]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_OCC  ]=(rendu[RENDU_USE_GROS_OCC    ]+1)%2;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_USE_FLECHE_OCC]=(rendu[RENDU_USE_FLECHE_OCC  ]+1)%2;

             y=140;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_SELPREV]=(rendu[RENDU_COLOR_RAIL_SELPREV]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_SELPREV]=(rendu[RENDU_COLOR_FOND_SELPREV]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_SELPREV  ]=(rendu[RENDU_USE_GROS_SELPREV  ]+1)%2;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_USE_FLECHE_SELPREV]=(rendu[RENDU_USE_FLECHE_SELPREV]+1)%2;

             y=160;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_SELOCC]=(rendu[RENDU_COLOR_RAIL_SELOCC]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_SELOCC]=(rendu[RENDU_COLOR_FOND_SELOCC]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_SELOCC  ]=(rendu[RENDU_USE_GROS_SELOCC  ]+1)%2;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_USE_FLECHE_SELOCC]=(rendu[RENDU_USE_FLECHE_SELOCC]+1)%2;

             y=180;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_AUTOPREV]=(rendu[RENDU_COLOR_RAIL_AUTOPREV]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_AUTOPREV]=(rendu[RENDU_COLOR_FOND_AUTOPREV]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_AUTOPREV  ]=(rendu[RENDU_USE_GROS_AUTOPREV  ]+1)%2;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_USE_FLECHE_AUTOPREV]=(rendu[RENDU_USE_FLECHE_AUTOPREV]+1)%2;

             y=200;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_AUTOOCC]=(rendu[RENDU_COLOR_RAIL_AUTOOCC]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_AUTOOCC]=(rendu[RENDU_COLOR_FOND_AUTOOCC]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_AUTOOCC  ]=(rendu[RENDU_USE_GROS_AUTOOCC  ]+1)%2;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_USE_FLECHE_AUTOOCC]=(rendu[RENDU_USE_FLECHE_AUTOOCC]+1)%2;

             y=220;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_RAIL_GARALOCK]=(rendu[RENDU_COLOR_RAIL_GARALOCK]+1)%18;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_GARALOCK]=(rendu[RENDU_COLOR_FOND_GARALOCK]+1)%18;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_USE_GROS_GARALOCK  ]=(rendu[RENDU_USE_GROS_GARALOCK  ]+1)%2;

             y=300;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_FOND        ]=(rendu[RENDU_COLOR_FOND        ]+1)%16;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_FOND_RAIL   ]=(rendu[RENDU_COLOR_FOND_RAIL   ]+1)%16;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_COLOR_GRILLE      ]=(rendu[RENDU_COLOR_GRILLE      ]+1)%16;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_COLOR_TEXT        ]=(rendu[RENDU_COLOR_TEXT        ]+1)%16;

             y=380;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_DET_OFF     ]=(rendu[RENDU_COLOR_DET_OFF     ]+1)%16;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_DET_ON      ]=(rendu[RENDU_COLOR_DET_ON      ]+1)%16;

             y=400;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_AIG_OFF     ]=(rendu[RENDU_COLOR_AIG_OFF     ]+1)%16;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_AIG_ON      ]=(rendu[RENDU_COLOR_AIG_ON      ]+1)%16;

             y=420;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_VOY_OFF     ]=(rendu[RENDU_COLOR_VOY_OFF     ]+1)%16;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_VOY_ON      ]=(rendu[RENDU_COLOR_VOY_ON      ]+1)%16;

             y=440;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_INT_OFF     ]=(rendu[RENDU_COLOR_INT_OFF     ]+1)%16;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_INT_ON      ]=(rendu[RENDU_COLOR_INT_ON      ]+1)%16;

             y=460;
             if( mouse_in_rendu_rect(220,y)) rendu[RENDU_COLOR_IPP_OFF     ]=(rendu[RENDU_COLOR_IPP_OFF     ]+1)%16;
             if( mouse_in_rendu_rect(260,y)) rendu[RENDU_COLOR_IPP_ON      ]=(rendu[RENDU_COLOR_IPP_ON      ]+1)%16;
             if( mouse_in_rendu_rect(300,y)) rendu[RENDU_COLOR_IPP_LOCKOFF ]=(rendu[RENDU_COLOR_IPP_LOCKOFF ]+1)%16;
             if( mouse_in_rendu_rect(340,y)) rendu[RENDU_COLOR_IPP_LOCKON  ]=(rendu[RENDU_COLOR_IPP_LOCKON  ]+1)%16;

             j=(y_mouse-520)/10; i=(x_mouse-60)/20;
             //sprintf(gszErr,"i=%d j=%d x=%d y=%d",i,j,x_mouse,y_mouse); MessageBox(NULL,gszErr,"debug",MB_OK);
             if(j>=0 && j<=3 && i>=0 && i<=15) color_canton[j][i]=(color_canton[j][i]+1)%16;
             if(j==6         && i>=0 && i<=15) color_train[i]=(color_train[i]+1)%16;
         }

         if(c_conf_wnd=='O' || c_conf_wnd=='E') // fenetre config ouverte
         {
             if((c_conf_wnd=='E' && x_mouse>400 && x_mouse<800 && y_mouse<600)||(c_conf_wnd=='O' && x_mouse<400 && y_mouse<600))  // dans fenetre config
             {
                 if(c_conf_wnd=='E') xdep=400;
                 x_sel=(x_mouse-xdep)/40;
                 y_sel=(y_mouse)/40;


                 if(y_mouse<10)
                 {
                     if((x_mouse-xdep)>370 && (x_mouse-xdep)<380) { c_conf_wnd='O'; cells_redraw=1; }
                     if((x_mouse-xdep)>380 && (x_mouse-xdep)<390) { c_conf_wnd='E'; cells_redraw=1; }
                     if((x_mouse-xdep)>390 && (x_mouse-xdep)<400) c_conf_wnd=' ';
                 }

                 i=0;
                 while(conf_symb[i])
                 {
                     if(x_sel==conf_symb[i+0] && y_sel==conf_symb[i+1])
                     {
                         cells_type_sel=conf_symb[i+2];
                         cells_subtype_sel=conf_symb[i+3];
                     }
                     i=i+4;
                 }

                 if((x_mouse-xdep)>340 && (x_mouse-xdep)<360 && (y_mouse-yopt)>0  && (y_mouse-yopt)<( 0+15)) temp_conf_sens=(temp_conf_sens^1)&1;

                 if((x_mouse-xdep)>340 && (x_mouse-xdep)<360 && (y_mouse-yopt)>20 && (y_mouse-yopt)<(20+10)) temp_conf_c1=(temp_conf_c1+1)&15;
                 if((x_mouse-xdep)>340 && (x_mouse-xdep)<360 && (y_mouse-yopt)>40 && (y_mouse-yopt)<(40+10)) temp_conf_c2=(temp_conf_c2+1)&15;
                 if((x_mouse-xdep)>340 && (x_mouse-xdep)<360 && (y_mouse-yopt)>60 && (y_mouse-yopt)<(60+10)) temp_conf_c3=(temp_conf_c3+1)&15;
                 if((x_mouse-xdep)>340 && (x_mouse-xdep)<360 && (y_mouse-yopt)>80 && (y_mouse-yopt)<(80+10)) temp_conf_c4=(temp_conf_c4+1)&15;

                 cells_entry_sel=-1;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<90  && (y_mouse-yopt)>0   && (y_mouse-yopt)<10 ) cells_entry_sel=1;
                 if((x_mouse-xdep)>140 && (x_mouse-xdep)<190 && (y_mouse-yopt)>0   && (y_mouse-yopt)<10 ) cells_entry_sel=2;
                 if((x_mouse-xdep)>240 && (x_mouse-xdep)<290 && (y_mouse-yopt)>0   && (y_mouse-yopt)<10 ) cells_entry_sel=3;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<140 && (y_mouse-yopt)>20  && (y_mouse-yopt)<30 ) cells_entry_sel=4;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<140 && (y_mouse-yopt)>40  && (y_mouse-yopt)<50 ) cells_entry_sel=5;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<140 && (y_mouse-yopt)>60  && (y_mouse-yopt)<70 ) cells_entry_sel=6;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<140 && (y_mouse-yopt)>80  && (y_mouse-yopt)<90 ) cells_entry_sel=7;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<140 && (y_mouse-yopt)>100 && (y_mouse-yopt)<110) cells_entry_sel=8;
                 if((x_mouse-xdep)>40  && (x_mouse-xdep)<240 && (y_mouse-yopt)>120 && (y_mouse-yopt)<130) cells_entry_sel=9;
             }

             else // dans la grille
             {
                 x_sel=(x_mouse)/40;
                 y_sel=(y_mouse)/40;

                 cells[tco][x_sel][y_sel][CELLS_TYPE]=cells_type_sel;
                 cells[tco][x_sel][y_sel][CELLS_SUBTYPE]=cells_subtype_sel;
                 cells[tco][x_sel][y_sel][CELLS_CANT]=temp_conf_canton;
                 cells[tco][x_sel][y_sel][CELLS_N1]=temp_conf_n1;
                 cells[tco][x_sel][y_sel][CELLS_N2]=temp_conf_n2;
                 cells[tco][x_sel][y_sel][CELLS_V1]=temp_conf_v1;
                 cells[tco][x_sel][y_sel][CELLS_V2]=temp_conf_v2;
                 cells[tco][x_sel][y_sel][CELLS_V3]=temp_conf_v3;
                 cells[tco][x_sel][y_sel][CELLS_V4]=temp_conf_v4;
                 cells[tco][x_sel][y_sel][CELLS_C1]=temp_conf_c1;
                 cells[tco][x_sel][y_sel][CELLS_C2]=temp_conf_c2;
                 cells[tco][x_sel][y_sel][CELLS_C3]=temp_conf_c3;
                 cells[tco][x_sel][y_sel][CELLS_C4]=temp_conf_c4;
                 cells[tco][x_sel][y_sel][CELLS_OPT]=temp_conf_opt;
                 cells[tco][x_sel][y_sel][CELLS_SENS]=temp_conf_sens;
                 strcpy(sz_cells[tco][x_sel][y_sel],sz_temp_conf_txt);
             }
         }

         x_sel=(x_mouse)/40;
         y_sel=(y_mouse)/40;
         if(c_conf_wnd==' ') // fenetre config fermee (donc dans grille)
         if(x_sel>=0 && x_sel<CELLS_X_NB && y_sel>=0 && y_sel<CELLS_Y_NB)
         {

             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_CMDVOY)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_CMDVOY_INT)
             {
                v1=cells[tco][x_sel][y_sel][CELLS_V1];
                v=-1; if(v1!=-1) v=pio_get_val(v1);
                if(v!=-1)
                {
                    if(v)    pio_set_val(v1,0);
                    if(v==0) pio_set_val(v1,1);
                }
             }

             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_CMDVOY)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_CMDVOY_POUSS)
             {
                v1=cells[tco][x_sel][y_sel][CELLS_V1]; if(v1!=-1) { pio_set_val(v1,1); cells_pouss_en_cours=v1; }
                v2=cells[tco][x_sel][y_sel][CELLS_V2]; if(v2!=-1) pio_set_val(v2,1);
                v3=cells[tco][x_sel][y_sel][CELLS_V3]; if(v3!=-1) pio_set_val(v3,0);
             }

             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_CMDVOY)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_CMDVOY_ITI)
             {
                if((x_mouse%40)<4) cells[tco][x_sel][y_sel][CELLS_OPT]=(cells[tco][x_sel][y_sel][CELLS_OPT]++)&1;

                if((x_mouse%40)>=4) if(cells[tco][x_sel][y_sel][CELLS_OPT]!=1)
                {
                    v1=cells[tco][x_sel][y_sel][CELLS_V1];
                    if(v1!=-1) pio_set_val(v1,1);
                }
             }

             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_SPE)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_SPE_HOR)
             {
                 horo_tic_on=(horo_tic_on^1)&1;
             }

             n1=cells[tco][x_sel][y_sel][CELLS_N1];
             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_AIG)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_AIG_CH
             || cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_AIG_CB
             || cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_AIG_HC
             || cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_AIG_BC)
             if(n1>=0 && n1<=63)
             if(vio_aig_res[n1]==0)
             {
                 vio_aig_cmd[n1]^=1;
             }

             n1=cells[tco][x_sel][y_sel][CELLS_N1];
             n2=cells[tco][x_sel][y_sel][CELLS_N2];
             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_AIG)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_AIG_CHB
             || cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_AIG_HBC)
             if(n1>=0 && n1<=63 && n2>=0 && n2<=63)
             if(vio_aig_res[n1]==0 && vio_aig_res[n2]==0)
             {
                 if(     vio_aig_cmd[n1]==0 && vio_aig_cmd[n2]==0) { vio_aig_cmd[n1]=1; vio_aig_cmd[n2]=0; }
                 else if(vio_aig_cmd[n1]==1 && vio_aig_cmd[n2]==0) { vio_aig_cmd[n1]=0; vio_aig_cmd[n2]=1; }
                 else                                              { vio_aig_cmd[n1]=0; vio_aig_cmd[n2]=0; }
             }

             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_CMDVOY)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_CMDVOY_GO)
             {
                switch(cells[tco][x_sel][y_sel][CELLS_OPT])
                {
                    case 0 : screen_mode=MD_SCREEN_TCO0;    break;
                    case 1 : screen_mode=MD_SCREEN_TCO1;    break;
                    case 2 : screen_mode=MD_SCREEN_TCO2;    break;
                    case 3 : screen_mode=MD_SCREEN_TCO3;    break;
                    case 4 : screen_mode=MD_SCREEN_TCO4;    break;
                    case 5 : screen_mode=MD_SCREEN_TCO5;    break;
                    case 6 : screen_mode=MD_SCREEN_TCO6;    break;
                    case 7 : screen_mode=MD_SCREEN_TCO7;    break;
                    case 8 : screen_mode=MD_SCREEN_HORO;    break;
                    case 9 : screen_mode=MD_SCREEN_SERIAL;  break;
                    case 10: screen_mode=MD_SCREEN_AIG;     break;
                    case 11: screen_mode=MD_SCREEN_ITI;     break;
                    case 12: screen_mode=MD_SCREEN_SELECTIF;break;
                    case 13: screen_mode=MD_SCREEN_AUTO;    break;
                    case 14: screen_mode=MD_SCREEN_TRAIN;   break;
                    case 15: screen_mode=MD_SCREEN_CANTON;  break;
                    case 16: screen_mode=MD_SCREEN_VIB;     break;
                    //case : screen_mode=MD_SCREEN_SPARE0;  break;
                    //case : screen_mode=MD_SCREEN_SPARE1;  break;
                    //case : screen_mode=MD_SCREEN_SPARE2;  break;
                    //case : screen_mode=MD_SCREEN_SPARE3;  break;
                }
             }

             cant=cells[tco][x_sel][y_sel][CELLS_CANT];
             sens=cells[tco][x_sel][y_sel][CELLS_SENS];
             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_SPE)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_SPE_SENS)
             if(cant!=-1) if(sens!=-1)
             {
                  if((x_mouse%40)>=20)
                  {
                      if(sens==0) copy_allowed_sens[cant/100][cant%100]^=1;
                      if(sens==1) copy_allowed_sens[cant/100][cant%100]^=2;
                  }

                  if((x_mouse%40)<20)
                  {
                      if(sens==0) copy_allowed_sens[cant/100][cant%100]^=2;
                      if(sens==1) copy_allowed_sens[cant/100][cant%100]^=1;
                  }
             }

             if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_SPE)
             if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_SPE_CANT)
             if(cant>=1000)
             {
                 g=cant-1000;
                 if(g>=0 && g<=15) vio_garage_lock_cmd[g]^=1;
             }
         }

     } // end mouse

    if(action==DEBUG_MOUSE_RIGHT)
    {
         if(c_conf_wnd=='O' || c_conf_wnd=='E') // fenetre config ouverte
         {
             if((c_conf_wnd=='E' && x_mouse>400 && x_mouse<800 && y_mouse<600)||(c_conf_wnd=='O' && x_mouse<400 && y_mouse<600))  // dans fenetre config
             //if((c_conf_wnd=='E' && x_mouse>400)||(c_conf_wnd=='O' && x_mouse<400)) // dans fenetre config
             {
             }
             else // dans la grille
             {
                 x_sel=(x_mouse)/40;
                 y_sel=(y_mouse)/40;
                 cells_type_sel=cells[tco][x_sel][y_sel][CELLS_TYPE];
                 cells_subtype_sel=cells[tco][x_sel][y_sel][CELLS_SUBTYPE];
                 temp_conf_canton=cells[tco][x_sel][y_sel][CELLS_CANT];
                 temp_conf_n1=cells[tco][x_sel][y_sel][CELLS_N1];
                 temp_conf_n2=cells[tco][x_sel][y_sel][CELLS_N2];
                 temp_conf_v1=cells[tco][x_sel][y_sel][CELLS_V1];
                 temp_conf_v2=cells[tco][x_sel][y_sel][CELLS_V2];
                 temp_conf_v3=cells[tco][x_sel][y_sel][CELLS_V3];
                 temp_conf_v4=cells[tco][x_sel][y_sel][CELLS_V4];
                 temp_conf_c1=cells[tco][x_sel][y_sel][CELLS_C1];
                 temp_conf_c2=cells[tco][x_sel][y_sel][CELLS_C2];
                 temp_conf_c3=cells[tco][x_sel][y_sel][CELLS_C3];
                 temp_conf_c4=cells[tco][x_sel][y_sel][CELLS_C4];
                 temp_conf_opt=cells[tco][x_sel][y_sel][CELLS_OPT];
                 temp_conf_sens=cells[tco][x_sel][y_sel][CELLS_SENS];
                 strcpy(sz_temp_conf_txt,sz_cells[tco][x_sel][y_sel]);
             }
         }
         else if(c_conf_wnd==' ') // fenetre config fermee (donc dans grille)
         {
             x_sel=(x_mouse)/40;
             y_sel=(y_mouse)/40;

             if(x_sel>=0 && x_sel<CELLS_X_NB && y_sel>=0 && y_sel<CELLS_Y_NB)
             if(c_conf_wnd==' ') // dans la grille
             {
                 if(cells[tco][x_sel][y_sel][CELLS_TYPE]==CELLS_TYPE_CMDVOY)
                 if(cells[tco][x_sel][y_sel][CELLS_SUBTYPE]==CELLS_SUBTYPE_CMDVOY_ITI)
                 if(cells[tco][x_sel][y_sel][CELLS_OPT]!=1)
                 {
                    v1=cells[tco][x_sel][y_sel][CELLS_V1];
                    v2=cells[tco][x_sel][y_sel][CELLS_V2];
                    if(v2!=-1) pio_set_val(v2,1);
                    if(v1!=-1 && v2==-1) pio_set_val(v1,0);
                 }
             }
         }
    }  // end mouse_right

    if(action==DEBUG_MOUSE_UP)
    {
        if(cells_pouss_en_cours!=-1) { pio_set_val(cells_pouss_en_cours,0); cells_pouss_en_cours=-1; }
    }

}



void cells_open_edit(void)
{
    c_conf_wnd='O';
    cells_redraw=1;
}

void cells_open_render(void)
{
    c_conf_wnd='R';
    cells_redraw=1;
}

/*****************************************************************************/
/* FIN TCO                                                                   */
/*****************************************************************************/




#ifdef UU
/*****************************************************************************/
/* FOND            --><--                                                          */
/*****************************************************************************/


#define FOND_TAB_NB          8
#define FOND_TAB_IND_NB      4
#define FOND_TAB_IND_TYPE    0
#define FOND_TAB_IND_FILE    1
#define FOND_TAB_IND_R       1
#define FOND_TAB_IND_V       2
#define FOND_TAB_IND_B       3
#define FOND_TAB_IND_DX      2
#define FOND_TAB_IND_DY      3
#define FOND_DXDY_IND_X      0
#define FOND_DXDY_IND_Y      1
#define FOND_CST_RVB         0
#define FOND_CST_FILE        1
int fond_tab[FOND_TAB_NB][FOND_TAB_IND_NB];
char filename_fond[5][100];
int filename_fond_dx_dy[5][2];
HBRUSH fond_tab_brush[8];

void fond_set_tco(int tco)
{
    int dx,dy,no_file;

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_blanc);
    Rectangle(hdc,0,0,1280,1024);
    SelectObject(hdc,bmp_pinceau_gris);
    Rectangle(hdc,0,0,100,1024);
    if(tco>=FOND_TAB_NB) return;

    if(fond_tab[tco][FOND_TAB_IND_TYPE]==FOND_CST_RVB)
    {
        //SelectObject(hdc,bmp_pinceau_blanc);
        SelectObject(hdc,fond_tab_brush[tco]);
        Rectangle(hdc,0,0,1280,1024);
    }

    if(fond_tab[tco][FOND_TAB_IND_TYPE]==FOND_CST_FILE)
    {
        dx=fond_tab[tco][FOND_TAB_IND_DX];
        dy=fond_tab[tco][FOND_TAB_IND_DY];

        no_file=fond_tab[tco][FOND_TAB_IND_FILE];

        switch(no_file)
        {
            case 0: BitBlt(hdc,0,0,dx,dy,bmp_hdc_fond_0,0,0,SRCCOPY); break;
            case 1: BitBlt(hdc,0,0,dx,dy,bmp_hdc_fond_1,0,0,SRCCOPY); break;
            case 2: BitBlt(hdc,0,0,dx,dy,bmp_hdc_fond_2,0,0,SRCCOPY); break;
            case 3: BitBlt(hdc,0,0,dx,dy,bmp_hdc_fond_3,0,0,SRCCOPY); break;
            default: break;
        }
    }

}

void fond_init_file(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int no_tco,no_file,ch_nb;
    int i,j;
    HBITMAP   hbitmap;

    for(j=0;j<FOND_TAB_NB;j++) for(i=0;i<FOND_TAB_IND_NB;i++) fond_tab[j][i]=0;  //RVB noir
    for(j=0;j<5;j++)
    {
        filename_fond[j][0]='\0';
        filename_fond_dx_dy[j][0]=800;
        filename_fond_dx_dy[j][1]=600;
    }

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des fonds","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    /*ex:
    #fond
    [
        filedescr:voyant,800,600,voyant.bmp
        filedescr:0     ,700,300,fond_ribo.bmp
        filedescr:1     ,700,300,fond_ribo_old.bmp
        tco:0 file:0
        tco:1 file:0
        tco:2 file:1
        tco:3 file:0
        tco:4 rvb:255,255,255
        tco:5 rvb:  0,255,255
        tco:6 rvb:  0,255,  0
        tco:7 rvb:  0,  0,255
    ]
    */
    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#fond"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                i=0;
                while(i<ch_nb)
                {
                    if((ch_nb-i)>=3)
                    if( (!strcmp(ch_tab[i],"tco")) && ch_tab[i+1][0]==':' )
                    {
                        no_tco=atoi(ch_tab[i+2]);
                        i=i+3;
                        continue;
                    }

                    if((ch_nb-i)>=7)
                    if( (!strcmp(ch_tab[i],"rvb")) && ch_tab[i+1][0]==':'
                       && ch_tab[i+3][0]==',' && ch_tab[i+5][0]==',' )
                    {
                        fond_tab[no_tco][FOND_TAB_IND_TYPE]=FOND_CST_RVB;
                        fond_tab[no_tco][FOND_TAB_IND_R]=atoi(ch_tab[i+2]);
                        fond_tab[no_tco][FOND_TAB_IND_V]=atoi(ch_tab[i+4]);
                        fond_tab[no_tco][FOND_TAB_IND_B]=atoi(ch_tab[i+6]);
                        i=i+7;
                        continue;
                    }

                    if((ch_nb-i)>=11)
                    if( (!strcmp(ch_tab[i],"filedescr")) && ch_tab[i+1][0]==':'
                       && ch_tab[i+3][0]==',' && ch_tab[i+5][0]==','
                       && ch_tab[i+7][0]==',' && ch_tab[i+9][0]=='.'
                       && (!strcmp(ch_tab[i+10],"bmp"))  )
                    {
                         if(!strcmp(ch_tab[i+2],"voyant")) no_file=4;
                         else no_file=atoi(ch_tab[i+2]);
                        sprintf(filename_fond[no_file],"%s.%s",ch_tab[i+8],ch_tab[i+10]);
                        filename_fond_dx_dy[no_file][FOND_DXDY_IND_X]=atoi(ch_tab[i+4]);
                        filename_fond_dx_dy[no_file][FOND_DXDY_IND_Y]=atoi(ch_tab[i+6]);
                        i=i+11;
                        continue;
                    }

                    if((ch_nb-i)>=3)
                    if( (!strcmp(ch_tab[i],"file")) && ch_tab[i+1][0]==':')
                    {
                        fond_tab[no_tco][FOND_TAB_IND_TYPE]=FOND_CST_FILE;
                        no_file=atoi(ch_tab[i+2]);
                        fond_tab[no_tco][FOND_TAB_IND_FILE]=no_file;
                        fond_tab[no_tco][FOND_TAB_IND_DX]=filename_fond_dx_dy[no_file][FOND_DXDY_IND_X];
                        fond_tab[no_tco][FOND_TAB_IND_DY]=filename_fond_dx_dy[no_file][FOND_DXDY_IND_Y];
                        i=i+3;
                        continue;
                    }

                    strcpy(ch_error,"Fond Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine
        }      //fin #fond
    }        //fin file

    fclose(pf);

    bmp_fonte=CreateFont(15,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier");

    bmp_pinceau_noir      = CreateSolidBrush(RGB(  0,  0,  0));
    bmp_pinceau_bleu      = CreateSolidBrush(RGB(  0,128,255));
    bmp_pinceau_vert      = CreateSolidBrush(RGB(  0,255,  0));
    bmp_pinceau_cyan      = CreateSolidBrush(RGB(  0,255,255));
    bmp_pinceau_rouge     = CreateSolidBrush(RGB(255,  0,  0));
    bmp_pinceau_violet    = CreateSolidBrush(RGB(128,  0,255));
    bmp_pinceau_jaune     = CreateSolidBrush(RGB(255,255,  0));
    bmp_pinceau_blanc     = CreateSolidBrush(RGB(255,255,255));
    bmp_pinceau_gris      = CreateSolidBrush(RGB(192,192,192));
    bmp_pinceau_rose      = CreateSolidBrush(RGB(128,128,255));
    bmp_pinceau_orange    = CreateSolidBrush(RGB(255,128,  0));
    bmp_pinceau_marron    = CreateSolidBrush(RGB(128, 64,  0));
    bmp_pinceau_kaki      = CreateSolidBrush(RGB(128,128,  0));
    bmp_pinceau_bordeau   = CreateSolidBrush(RGB(128,  0, 64));
    bmp_pinceau_grisvert  = CreateSolidBrush(RGB( 64,128,128));
    bmp_pinceau_vertfonce = CreateSolidBrush(RGB(  0,128,  0));

    bmp_stylo_noir        = CreatePen(PS_SOLID,1,RGB(0  ,0  ,0  ));
    bmp_stylo_bleu        = CreatePen(PS_SOLID,1,RGB(  0,128,255));
    bmp_stylo_vert        = CreatePen(PS_SOLID,1,RGB(  0,255,  0));
    bmp_stylo_cyan        = CreatePen(PS_SOLID,1,RGB(  0,255,255));
    bmp_stylo_rouge       = CreatePen(PS_SOLID,1,RGB(255,  0,  0));
    bmp_stylo_violet      = CreatePen(PS_SOLID,1,RGB(128,  0,255));
    bmp_stylo_jaune       = CreatePen(PS_SOLID,1,RGB(255,255,  0));
    bmp_stylo_blanc       = CreatePen(PS_SOLID,1,RGB(255,255,255));
    bmp_stylo_gris        = CreatePen(PS_SOLID,1,RGB(192,192,192));
    bmp_stylo_rose        = CreatePen(PS_SOLID,1,RGB(255,128,255));
    bmp_stylo_orange      = CreatePen(PS_SOLID,1,RGB(255,128,  0));
    bmp_stylo_marron      = CreatePen(PS_SOLID,1,RGB(128, 64,  0));
    bmp_stylo_kaki        = CreatePen(PS_SOLID,1,RGB(128,128,  0));
    bmp_stylo_bordeau     = CreatePen(PS_SOLID,1,RGB(128,  0, 64));
    bmp_stylo_grisvert    = CreatePen(PS_SOLID,1,RGB( 64,128,128));
    bmp_stylo_vertfonce   = CreatePen(PS_SOLID,1,RGB(  0,128,  0));

    for(j=0;j<8;j++)
    {
        if(fond_tab[j][FOND_TAB_IND_TYPE]==FOND_CST_RVB)
          fond_tab_brush[j]=CreateSolidBrush(RGB(fond_tab[j][FOND_TAB_IND_R],fond_tab[j][FOND_TAB_IND_V],fond_tab[j][FOND_TAB_IND_B]));
    }

    //MessageBox(NULL,"Init brush tab ok","Error",MB_OK|MB_ICONERROR);

    for(j=0;j<5;j++)
    if(filename_fond[j][0]!='\0')
    {
        hbitmap=(HBITMAP)LoadImage(ghinstance,filename_fond[j],
          IMAGE_BITMAP,filename_fond_dx_dy[j][FOND_DXDY_IND_X],
          filename_fond_dx_dy[j][FOND_DXDY_IND_Y],LR_LOADFROMFILE);
        if(hbitmap==NULL)
        {
            MessageBox(NULL,"Impossible d'ouvrir un des fichiers bmp des fonds (ou des voyants)","Error",MB_OK|MB_ICONERROR);
            exit(1);
        }
        switch(j)
        {
            case 0:  bmp_hdc_fond_0=CreateCompatibleDC(hdc);SelectObject(bmp_hdc_fond_0,hbitmap);break;
            case 1:  bmp_hdc_fond_1=CreateCompatibleDC(hdc);SelectObject(bmp_hdc_fond_1,hbitmap);break;
            case 2:  bmp_hdc_fond_2=CreateCompatibleDC(hdc);SelectObject(bmp_hdc_fond_2,hbitmap);break;
            case 3:  bmp_hdc_fond_3=CreateCompatibleDC(hdc);SelectObject(bmp_hdc_fond_3,hbitmap);break;
            case 4:  bmp_hdc_mem   =CreateCompatibleDC(hdc);SelectObject(bmp_hdc_mem   ,hbitmap);break;
            default: break;
        }
    }

}


void fond_debug(void)
{
    FILE* pf;
    int i,j;

    if((pf=fopen("debug_fond.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_fond.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    fprintf(pf,"\n\nFOND_TAB_TYPE\n");
    for(j=0;j<FOND_TAB_NB;j++)
    {
        fprintf(pf,"\n%3d:",j);
        for(i=0;i<FOND_TAB_IND_NB;i++) fprintf(pf," %3d",fond_tab[j][i]);
    }

    fprintf(pf,"\n\nFILENAME_FOND_DX_DY & FILENAME_FOND (interne)\n");
    for(j=0;j<5;j++)
    {
        fprintf(pf,"\n%3d: dx=%3d dy=%3d ch=%s",j,filename_fond_dx_dy[j][0],filename_fond_dx_dy[j][1],filename_fond[j]);
    }

    fclose(pf);

}


/*****************************************************************************/
/* END FOND                                                                  */
/*****************************************************************************/
#endif //UU


/*****************************************************************************/
/* VIBRATOR                                                                   */
/*****************************************************************************/


void vib_init_file(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int  ch_nb,i,var;

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration du vibrateur","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    vib_on=0;
    vib_state=0;
    vib_var=-1;
    vib_var_inv=0;
    vib_pwm_no=-1;
    vib_pwm_vit=32;
    vib_time_before=0;
    vib_time_after=0;
    vib_dec_before=0;
    vib_dec_after=0;

    // on
    // nb_det_dep:2
    // out:io_out_3
    // out_pwm:0,-35
    // time_before:3
    // time_after:8

    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#vibrator") || !strcmp(ch,"#vib") )
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                i=0;
                while(i<ch_nb)
                {

                    if((ch_nb-i)>=3) if( (!strcmp(ch_tab[i],"time_before")) && ch_tab[i+1][0]==':' )
                    {
                        vib_time_before=atoi(ch_tab[i+2]);
                        i=i+3;
                        continue;
                    }

                    if((ch_nb-i)>=3) if( (!strcmp(ch_tab[i],"time_after")) && ch_tab[i+1][0]==':' )
                    {
                        vib_time_after=atoi(ch_tab[i+2]);
                        i=i+3;
                        continue;
                    }

                    if((ch_nb-i)>=5) if( (!strcmp(ch_tab[i],"out_pwm")) && ch_tab[i+1][0]==':' && ch_tab[i+3][0]==',')
                    {
                        vib_pwm_no =atoi(ch_tab[i+2]);
                        vib_pwm_vit=atoi(ch_tab[i+4]);
                        i=i+5;
                        continue;
                    }

                    if((ch_nb-i)>=4) if( (!strncmp(ch_tab[i],"out",3)) && ch_tab[i+1][0]==':' && ch_tab[i+2][0]=='!')  if((var=pio_var_ch2int(ch_tab[i+3]))!=-1)
                    {
                            vib_var=var;
                            vib_var_inv=1;
                            i=i+4;
                            continue;
                    }

                    if((ch_nb-i)>=3) if( (!strncmp(ch_tab[i],"out",3)) && ch_tab[i+1][0]==':') if((var=pio_var_ch2int(ch_tab[i+2]))!=-1)
                    {
                        vib_var=var;
                        vib_var_inv=0;
                        i=i+4;
                        continue;
                    }

                    if((ch_nb-i)>=1) if( !strcmp(ch_tab[i],"on" ) ) { vib_on=1; i++; continue; }

                    if((ch_nb-i)>=1) if( !strcmp(ch_tab[i],"off") ) { vib_on=0; i++; continue; }

                    strcpy(ch_error,"Vibrator Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine
        }      //fin #vibrator
    }        //fin file

    fclose(pf);
}

void vib_maj(void)
{
    int j,i,pb;

    pb=0; for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton_pb_capt[j][i]==1) pb=1;

    if(vib_state==0 && pb==0)
    {
        vib_dec_before=vib_time_before;
        vib_dec_after=vib_time_after;
    }

    if(vib_state==0 && pb==1 && vib_on)
    {
        if(vib_dec_before==0) vib_state=1;
        if(vib_dec_before>0)  vib_dec_before--;
    }

    if(vib_state==1 && pb==1)
    {
            vib_dec_after=vib_time_after;
    }

    if(vib_state==1 && pb==0)
    {
         if(vib_dec_after>0) vib_dec_after--;
         if(vib_dec_after==0) vib_state=0;
    }

    if(vib_state==0)   //pas de vibrations
    {
        if(vib_var!=-1) pio_set_val(vib_var,vib_var_inv);
        if(vib_pwm_no!=-1) vio_canton_vit[vib_pwm_no/100][vib_pwm_no%100]=0;
    }
    else             //vibrations
    {
        if(vib_var!=-1) pio_set_val(vib_var,vib_var_inv^1);
        if(vib_pwm_no!=-1) vio_canton_vit[vib_pwm_no/100][vib_pwm_no%100]=vib_pwm_vit;
    }
}

void vib_debug(int action)
{
    int i,j,t,y;
    char ch[100];

    if(action==DEBUG_MOUSE)
    {
        i=(y_mouse/20)-6;

        if(i==0 && x_mouse>  0 && x_mouse<100) if(vib_time_before>0) vib_time_before--;
        if(i==0 && x_mouse>100 && x_mouse<200) vib_time_before++;

        if(i==1 && x_mouse>  0 && x_mouse<100) if(vib_time_after>0 ) vib_time_after--;
        if(i==1 && x_mouse>100 && x_mouse<200) vib_time_after++;

        if(i==2 && x_mouse>  0 && x_mouse<100) vib_on=1;
        if(i==2 && x_mouse>100 && x_mouse<200) vib_on=0;
    }

    if(action==DEBUG_TOTAL_PAINT)
    {
        SelectObject(hdc,bmp_pinceau_blanc);
        SelectObject(hdc,bmp_stylo_gris);
        Rectangle(hdc,0,0,1280,1024);

        y=100;
        Rectangle(hdc,0,y,200,20+y);
        //SelectObject(hdc,bmp_fonte);
        SetBkMode(hdc,TRANSPARENT);
        SetTextColor(hdc,RGB(255,0,0));
        EasyTextOut(10,2+y,"Reglages");
        EasyLine(190,y+20,200,y+10);
    
        SetTextColor(hdc,RGB(0,0,255));

        y=120;
        Rectangle(hdc,0,y,200,y+20);
        EasyLine(100,y,100,20+y);
        EasyTextOut(  0+5,2+y,"Tic avant --");
        EasyTextOut(100+5,2+y,"Tic avant ++");

        y=140;
        Rectangle(hdc,0,y,200,y+20);
        EasyLine(100,y,100,20+y);
        EasyTextOut(  0+5,2+y,"Tic apres --");
        EasyTextOut(100+5,2+y,"Tic apres ++");

        y=160;
        Rectangle(hdc,0,y,200,y+20);
        EasyLine(100,y,100,20+y);
        EasyTextOut( 0+5,2+y,"ON" );
        EasyTextOut(100+5,2+y,"OFF");
    }

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_blanc);
    Rectangle(hdc,0,0,1024,80);

//    SelectObject(hdc,bmp_pinceau_gris);
//    SelectObject(hdc,bmp_stylo_gris);
//    Rectangle(hdc,0,0,500,60);

    EasyTextOut(100,5,"Configuration du Vibreur");

    SetBkMode(hdc,TRANSPARENT);
    if(vib_state && vib_on) SetTextColor(hdc,RGB(255,0,0)); else SetTextColor(hdc,RGB(0,0,255));
    if(vib_on) sprintf(ch,"surveillance: active"); else sprintf(ch,"surveillance: inactive");
    EasyTextOut(5,40,ch);
    if(vib_state) sprintf(ch,"etat: vibrations ON"); else sprintf(ch,"etat: vibrations OFF");
    EasyTextOut(5,60,ch);

    sprintf(ch,"attente avant declenchement %2d/%2d",vib_dec_before,vib_time_before);
    EasyTextOut(270,40,ch);
    sprintf(ch,"attente apres declenchement %2d/%2d",vib_dec_after,vib_time_after);
    EasyTextOut(270,60,ch);

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);
    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
        if(canton_pb_capt[j][i]) SelectObject(hdc,bmp_pinceau_rouge); else SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,60+25*i,200+25*j,60+25*i+20,200+25*j+20);
    }

    for(t=0;t<16;t++)
    {
        if(train_pb_capt[t]) SelectObject(hdc,bmp_pinceau_rouge); else SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,60+25*t,330,60+25*t+20,330+20);
    }

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_blanc);
    Rectangle(hdc,0,200,59,350);
    Rectangle(hdc,60,300,1024,320);

    SetTextColor(hdc,RGB(192,192,192));
    for(t=0;t<16;t++) { sprintf(ch,"%d",t);    EasyTextOut(60+25*t,300,ch); }
    for(j=0;j<4 ;j++) { sprintf(ch,"c%dxx",j); EasyTextOut(10,200+25*j,ch); }
                                               EasyTextOut(10,330,"txxx");


}


/*****************************************************************************/
/* FIN VIBRATOR                                                              */
/*****************************************************************************/





/*****************************************************************************/
/* Horodateur                                                                */
/*****************************************************************************/


#define HORO_TAB_NB           200
#define HORO_TAB_IND_HD_J       0
#define HORO_TAB_IND_HD_H       1
#define HORO_TAB_IND_HD_M       2
#define HORO_TAB_IND_HF_H       3
#define HORO_TAB_IND_HF_M       4
#define HORO_TAB_IND_HI_H       5
#define HORO_TAB_IND_HI_M       6
#define HORO_TAB_IND_HB_H       7
#define HORO_TAB_IND_HB_M       8
#define HORO_TAB_IND_TYPEB      9
#define HORO_TAB_IND_VB_INV    10
#define HORO_TAB_IND_VB_NUM    11
#define HORO_TAB_IND_V0_OP     12
#define HORO_TAB_IND_V0_NUM    13
#define HORO_TAB_IND_V1_OP     14
#define HORO_TAB_IND_V1_NUM    15
#define HORO_TAB_IND_V2_OP     16
#define HORO_TAB_IND_V2_NUM    17
#define HORO_TAB_IND_V3_OP     18
#define HORO_TAB_IND_V3_NUM    19
#define HORO_TAB_IND_V4_OP     20
#define HORO_TAB_IND_V4_NUM    21
#define HORO_TAB_IND_V5_OP     22
#define HORO_TAB_IND_V5_NUM    23
#define HORO_TAB_IND_VAR_STATE 24
#define HORO_TAB_IND_VAR_HB_H  25
#define HORO_TAB_IND_VAR_HB_M  26
#define HORO_TAB_IND_NB        27
int horo_tab[HORO_TAB_NB][HORO_TAB_IND_NB];
//int horo_j=0,horo_j_dep=0;    //global    //0-6    //por depart: 7=week 8=weekend
//int horo_h=5,horo_h_dep=5;    //global    //0-23
//int horo_m=0,horo_m_dep=0;    //global    //0-59
//int horo_tic_on=0;            //global
//int horo_blocked=0;           //global
int horo_tic_min=16; //4s_reel/min  4min_reel/h  48min_reel/j
int horo_tic_dec=16;

#define HORO_CST_NOTHING       0
#define HORO_CST_WAIT_BLOCKING 1
#define HORO_CST_BLOCKED       2
#define HORO_CST_BLOCK_H       0
#define HORO_CST_BLOCK_DELAY   1
#define HORO_CST_OP_SET        1
#define HORO_CST_OP_CLR        0
#define HORO_CST_J_WEEK        7
#define HORO_CST_J_WEEKEND     8
//ex:
//#horo
//[
//    depart j0 5:00 tic_par_min:16
//    hd 7:00 hf 19:00 hi 00:30 hb +25 vf:!depl3 s:depl3
//]

void horo_init_file(char filename[])
{
   FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int  ch_nb,j,i;
    int  no_horo,no_var,var;

    for(j=0;j<HORO_TAB_NB;j++) for(i=0;i<HORO_TAB_IND_NB;i++) horo_tab[j][i]=-1;
    for(j=0;j<HORO_TAB_NB;j++) horo_tab[j][HORO_TAB_IND_VAR_STATE]=HORO_CST_NOTHING;
    no_horo=-1;
    no_var=0;

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration de l'horodateur","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#horo"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                i=0;
                while(i<ch_nb)
                {
                    // depart j:0 5:00
                    if((ch_nb-i)>=7)
                    if( (!strcmp(ch_tab[i],"depart")) && ch_tab[i+1][0]=='j'
                    &&  ch_tab[i+2][0]==':' &&  ch_tab[i+5][0]==':')
                    {
                        horo_j=horo_j_dep=atoi(ch_tab[i+3]);
                        horo_h=horo_h_dep=atoi(ch_tab[i+4]);
                        horo_m=horo_m_dep=atoi(ch_tab[i+6]);
                        i=i+7;
                        continue;
                    }

                    // tic_par_min:16
                    if((ch_nb-i)>=3)
                    if( (!strcmp(ch_tab[i],"tic_par_min")) && ch_tab[i+1][0]==':')
                    {
                        horo_tic_min=atoi(ch_tab[i+2]);
                        i=i+3;
                        continue;
                    }

                    //hd j:0:7:00
                    if((ch_nb-i)>=8)
                    if( (!strcmp(ch_tab[i],"hd")) && (!strcmp(ch_tab[i+1],"j"))
                    && ch_tab[i+2][0]==':' && ch_tab[i+4][0]==':' && ch_tab[i+6][0]==':')
                    {
                        no_horo++;no_var=0;
                        if     (ch_tab[i+3][0]=='w') horo_tab[no_horo][HORO_TAB_IND_HD_J]=HORO_CST_J_WEEK;
                        else if(ch_tab[i+3][0]=='e') horo_tab[no_horo][HORO_TAB_IND_HD_J]=HORO_CST_J_WEEKEND;
                        else                         horo_tab[no_horo][HORO_TAB_IND_HD_J]=atoi(ch_tab[i+3]);
                        horo_tab[no_horo][HORO_TAB_IND_HD_H]=atoi(ch_tab[i+5]);
                        horo_tab[no_horo][HORO_TAB_IND_HD_M]=atoi(ch_tab[i+7]);
                        i=i+8;
                        continue;
                    }

                    //hd 7:00
                    if((ch_nb-i)>=4)
                    if( (!strcmp(ch_tab[i],"hd")) && ch_tab[i+2][0]==':')
                    {
                        no_horo++;no_var=0;
                        horo_tab[no_horo][HORO_TAB_IND_HD_H]=atoi(ch_tab[i+1]);
                        horo_tab[no_horo][HORO_TAB_IND_HD_M]=atoi(ch_tab[i+3]);
                        i=i+4;
                        continue;
                    }

                    //hf 19:00
                    if((ch_nb-i)>=4)
                    if( (!strcmp(ch_tab[i],"hf")) && ch_tab[i+2][0]==':')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_HF_H]=atoi(ch_tab[i+1]);
                        horo_tab[no_horo][HORO_TAB_IND_HF_M]=atoi(ch_tab[i+3]);
                        i=i+4;
                        continue;
                    }

                    //hi 00:30
                    if((ch_nb-i)>=4)
                    if( (!strcmp(ch_tab[i],"hi")) && ch_tab[i+2][0]==':')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_HI_H]=atoi(ch_tab[i+1]);
                        horo_tab[no_horo][HORO_TAB_IND_HI_M]=atoi(ch_tab[i+3]);
                        i=i+4;
                        continue;
                    }

                    //hb 07:25
                    if((ch_nb-i)>=4)
                    if( (!strcmp(ch_tab[i],"hb")) && ch_tab[i+2][0]==':')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_TYPEB]=HORO_CST_BLOCK_H;
                        horo_tab[no_horo][HORO_TAB_IND_HB_H ]=atoi(ch_tab[i+1]);
                        horo_tab[no_horo][HORO_TAB_IND_HB_M ]=atoi(ch_tab[i+3]);
                        i=i+4;
                        continue;
                    }

                    //hb +0:25
                    if((ch_nb-i)>=5)
                    if( (!strcmp(ch_tab[i],"hb")) && ch_tab[i+1][0]=='+' && ch_tab[i+3][0]==':')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_TYPEB]=HORO_CST_BLOCK_DELAY;
                        horo_tab[no_horo][HORO_TAB_IND_HB_H ]=atoi(ch_tab[i+2]);
                        horo_tab[no_horo][HORO_TAB_IND_HB_M ]=atoi(ch_tab[i+4]);
                        i=i+5;
                        continue;
                    }

                    //vf:depl3
                    if((ch_nb-i)>=3)
                    if( (!strcmp(ch_tab[i],"vf")) && ch_tab[i+1][0]==':' && ch_tab[i+2][0]!='!')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_VB_INV]=0;
                        if(pio_define_convert(ch_tab[i+2],ch_syst)==0) strcpy(ch_syst,ch_tab[i+2]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) horo_tab[no_horo][HORO_TAB_IND_VB_NUM]=var;
                        i=i+3;
                        continue;
                    }

                    //vf:!depl3
                    if((ch_nb-i)>=4)
                    if( (!strcmp(ch_tab[i],"vf"))  && ch_tab[i+1][0]==':' && ch_tab[i+2][0]=='!')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_VB_INV]=1;
                        if(pio_define_convert(ch_tab[i+3],ch_syst)==0) strcpy(ch_syst,ch_tab[i+3]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) horo_tab[no_horo][HORO_TAB_IND_VB_NUM]=var;
                        i=i+4;
                        continue;
                    }

                    //s:depl3
                    if((ch_nb-i)>=3)
                    if( (!strcmp(ch_tab[i],"s")) && ch_tab[i+1][0]==':')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_V0_OP+2*no_var]=HORO_CST_OP_SET;
                        if(pio_define_convert(ch_tab[i+2],ch_syst)==0) strcpy(ch_syst,ch_tab[i+2]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) horo_tab[no_horo][HORO_TAB_IND_V0_NUM+2*no_var]=var;
                        no_var++;
                        i=i+3;
                        continue;
                    }

                    //c:depl3
                    if((ch_nb-i)>=3)
                    if( (!strcmp(ch_tab[i],"c")) && ch_tab[i+1][0]==':')
                    {
                        horo_tab[no_horo][HORO_TAB_IND_V0_OP+2*no_var]=HORO_CST_OP_CLR;
                        if(pio_define_convert(ch_tab[i+2],ch_syst)==0) strcpy(ch_syst,ch_tab[i+2]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) horo_tab[no_horo][HORO_TAB_IND_V0_NUM+2*no_var]=var;
                        no_var++;
                        i=i+3;
                        continue;
                    }

                    strcpy(ch_error,"Horodateur Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine
        }      //fin #horo
    }        //fin file

    fclose(pf);
}

void horo_save_conf(void)
{
    FILE* pf;
    int i,j;

    if((pf=fopen("debug_horo.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_horo.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(j=0;j<HORO_TAB_NB;j++)
    {
        fprintf(pf,"\n%3d:",j);
        for(i=0;i<HORO_TAB_IND_NB;i++) fprintf(pf," %4d",horo_tab[j][i]);
    }

    fclose(pf);
}

void horo_maj(void)
{
    int i,blocked,j,h,m,var,hb,mb,inv,ok_j,ok_hm;
    int timec,timed,timef,timei,timet;

    //chercher si blocage
    blocked=0;
    for(i=0;i<HORO_TAB_NB;i++)
    {
        if(horo_tab[i][HORO_TAB_IND_HD_H]==-1) break;
        if(horo_tab[i][HORO_TAB_IND_VAR_STATE]==HORO_CST_BLOCKED) blocked=1;
    }
    horo_blocked=blocked;

    //gestion de l'horloge
    if(horo_tic_on && blocked==0)
    {
        if(horo_tic_dec==0)
        {
             horo_tic_dec=horo_tic_min;
             horo_m++;
             if(horo_m>=60) {horo_m=0;  horo_h++;}
             if(horo_h>=24) {horo_h=0;  horo_j++;}
             if(horo_j>=7)  horo_j=0;
        }
        horo_tic_dec--;
    }

    if(horo_tic_dec!=(horo_tic_min-1)) return;  //car resolution evolution en minute

    //evolution
    for(i=0;i<HORO_TAB_NB;i++)
    {
        if(horo_tab[i][HORO_TAB_IND_HD_H]==-1) break;

        if(horo_tab[i][HORO_TAB_IND_VAR_STATE]==HORO_CST_NOTHING)
        {
            ok_j=0;
            j=horo_tab[i][HORO_TAB_IND_HD_J];
            if(   j==-1     || (j==HORO_CST_J_WEEK && horo_j<=4)
               || j==horo_j || (j==HORO_CST_J_WEEKEND && horo_j>=5) )
                ok_j=1;

            ok_hm=0;
            timec=60*horo_h+horo_m;
            timed=60*horo_tab[i][HORO_TAB_IND_HD_H]+horo_tab[i][HORO_TAB_IND_HD_M];
            timef=60*horo_tab[i][HORO_TAB_IND_HF_H]+horo_tab[i][HORO_TAB_IND_HF_M];
            timei=60*horo_tab[i][HORO_TAB_IND_HI_H]+horo_tab[i][HORO_TAB_IND_HI_M];
            if(horo_tab[i][HORO_TAB_IND_HI_H]==-1 && horo_tab[i][HORO_TAB_IND_HF_H]==-1)
            {
                if(timec==timed) ok_hm=1;      //declenchement simple
            }
            else
            {
                if(timef<timed) timef+=24*60;  //declenchement recursif
                if(timec>=timed && timec<=timef) if(((timec-timed)%timei)==0) ok_hm=1;
            }

            if(ok_j && ok_hm)
            {
                //MessageBox(NULL,"OK H M","Debug",MB_OK|MB_ICONERROR);
                // gestion des etats et calcul de l'heure de blocage
                if(horo_tab[i][HORO_TAB_IND_TYPEB]==HORO_CST_BLOCK_H)
                {
                    horo_tab[i][HORO_TAB_IND_VAR_HB_H]=horo_tab[i][HORO_TAB_IND_HB_H];
                    horo_tab[i][HORO_TAB_IND_VAR_HB_M]=horo_tab[i][HORO_TAB_IND_HB_M];
                    horo_tab[i][HORO_TAB_IND_VAR_STATE]=HORO_CST_WAIT_BLOCKING;
                }
                else if(horo_tab[i][HORO_TAB_IND_TYPEB]==HORO_CST_BLOCK_DELAY)
                {
                    horo_tab[i][HORO_TAB_IND_VAR_HB_H]=horo_h+horo_tab[i][HORO_TAB_IND_HB_H];
                    horo_tab[i][HORO_TAB_IND_VAR_HB_M]=horo_m+horo_tab[i][HORO_TAB_IND_HB_M];
                    horo_tab[i][HORO_TAB_IND_VAR_STATE]=HORO_CST_WAIT_BLOCKING;
                }
                else horo_tab[i][HORO_TAB_IND_VAR_STATE]=HORO_CST_NOTHING;

                // actions
                for(j=0;j<6;j++)
                {
                    var=horo_tab[i][HORO_TAB_IND_V0_NUM+2*j];
                    if(var==-1) break;
                    if(horo_tab[i][HORO_TAB_IND_V0_OP+2*j]==HORO_CST_OP_SET) pio_set_val(var,1);
                    if(horo_tab[i][HORO_TAB_IND_V0_OP+2*j]==HORO_CST_OP_CLR) pio_set_val(var,0);
                }
            }
        }
        if(horo_tab[i][HORO_TAB_IND_VAR_STATE]==HORO_CST_WAIT_BLOCKING)
        {
            //debut de blockage
            hb=horo_tab[i][HORO_TAB_IND_VAR_HB_H];
            mb=horo_tab[i][HORO_TAB_IND_VAR_HB_M];
            if(hb==horo_h && mb==horo_m) horo_tab[i][HORO_TAB_IND_VAR_STATE]=HORO_CST_BLOCKED;

            // fin avant blockage
            var=horo_tab[i][HORO_TAB_IND_VB_NUM];
            inv=horo_tab[i][HORO_TAB_IND_VB_INV];
            if( (pio_get_val(var) && inv==0) || (pio_get_val(var)==0 && inv) )
                horo_tab[i][HORO_TAB_IND_VAR_STATE]=HORO_CST_BLOCKED;
        }
        if(horo_tab[i][HORO_TAB_IND_VAR_STATE]==HORO_CST_BLOCKED)
        {
            //fin de blockage
            var=horo_tab[i][HORO_TAB_IND_VB_NUM];
            inv=horo_tab[i][HORO_TAB_IND_VB_INV];
            if( (pio_get_val(var) && inv==0) || (pio_get_val(var)==0 && inv) )
                horo_tab[i][HORO_TAB_IND_VAR_STATE]=HORO_CST_NOTHING;
        }
    }

}

void horo_debug(int action)
{
    int i,y;
    char ch[100];

    if(action==DEBUG_MOUSE)
    {
        i=(y_mouse/20)-4;

        if(i==0 && x_mouse>  0 && x_mouse< 50) { if(horo_j>0) horo_j--; else horo_j=6; }
        if(i==0 && x_mouse> 50 && x_mouse<100) horo_j=(horo_j+1)%7;
        if(i==0 && x_mouse>100 && x_mouse<150) horo_j=0;
        if(i==0 && x_mouse>150 && x_mouse<200) { horo_j=horo_j_dep; horo_h=horo_h_dep; horo_m=horo_m_dep; }

        if(i==1 && x_mouse>  0 && x_mouse< 50) { if(horo_h>0) horo_h--; else horo_h=23; }
        if(i==1 && x_mouse> 50 && x_mouse<100) horo_h=(horo_h+1)%24;
        if(i==1 && x_mouse>100 && x_mouse<150) { if(horo_h>4) horo_h-=4; else horo_h=horo_h+24-4; }
        if(i==1 && x_mouse>150 && x_mouse<200) horo_h=(horo_h+4)%24;

        if(i==2 && x_mouse>  0 && x_mouse< 50) { if(horo_m>0) horo_m--; else horo_m=59; }
        if(i==2 && x_mouse> 50 && x_mouse<100) horo_m=(horo_m+1)%60;
        if(i==2 && x_mouse>100 && x_mouse<150) { if(horo_m>10) horo_m-=10; else horo_m=horo_m+60-10; }
        if(i==2 && x_mouse>150 && x_mouse<200) horo_m=(horo_m+10)%60;

        if(i==3 && x_mouse>  0 && x_mouse< 50) if(horo_tic_min>1)   horo_tic_min--;
        if(i==3 && x_mouse> 50 && x_mouse<100) if(horo_tic_min<240) horo_tic_min++;
        if(i==3 && x_mouse>100 && x_mouse<150) horo_tic_on=1;
        if(i==3 && x_mouse>150 && x_mouse<200) horo_tic_on=0;
    }

    if(action==DEBUG_TOTAL_PAINT)
    {
        SelectObject(hdc,bmp_pinceau_blanc);
        SelectObject(hdc,bmp_stylo_gris);
        Rectangle(hdc,0,0,1280,1024);

        y=60;
        Rectangle(hdc,0,y,200,20+y);
        SelectObject(hdc,bmp_fonte);
        SetBkMode(hdc,TRANSPARENT);
        SetTextColor(hdc,RGB(255,0,0));
        EasyTextOut(10,2+y,"Reglages");
        EasyLine(190,y+20,200,y+10);
    
        SetTextColor(hdc,RGB(0,0,255));

        y=80;
        Rectangle(hdc,0,y,200,y+20);
        EasyLine( 50,y, 50,20+y);
        EasyLine(100,y,100,20+y);
        EasyLine(150,y,150,20+y);
        EasyTextOut(  0+5,2+y,"J-"  );
        EasyTextOut( 50+5,2+y,"J+"  );
        EasyTextOut(100+5,2+y,"J0"  );
        EasyTextOut(150+5,2+y,"Init");

        y=100;
        Rectangle(hdc,0,y,200,20+y);
        EasyLine( 50,y, 50,20+y);
        EasyLine(100,y,100,20+y);
        EasyLine(150,y,150,20+y);
        EasyTextOut(  0+5,2+y,"H-" );
        EasyTextOut( 50+5,2+y,"H+" );
        EasyTextOut(100+5,2+y,"H--");
        EasyTextOut(150+5,2+y,"H++");

        y=120;
        Rectangle(hdc,0,y,200,20+y);
        EasyLine( 50,y, 50,20+y);
        EasyLine(100,y,100,20+y);
        EasyLine(150,y,150,20+y);
        EasyTextOut(  0+5,2+y,"M-" );
        EasyTextOut( 50+5,2+y,"M+" );
        EasyTextOut(100+5,2+y,"M--");
        EasyTextOut(150+5,2+y,"M++");

        y=140;
        Rectangle(hdc,0,y,200,y+20);
        EasyLine( 50,y, 50,20+y);
        EasyLine(100,y,100,20+y);
        EasyLine(150,y,150,20+y);
        EasyTextOut(  0+2,2+y,"tic/M-");
        EasyTextOut( 50+2,2+y,"tic/M+");
        EasyTextOut(100+5,2+y,"ON"    );
        EasyTextOut(150+5,2+y,"OFF"   );
    }

    SelectObject(hdc,bmp_pinceau_gris);
    SelectObject(hdc,bmp_stylo_gris);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(0,255,0));

    y=20;
    Rectangle(hdc,0,y,300,y+20);
    sprintf(ch,"J%d %02d:%02d tic:%02d %dtic/min",horo_j,horo_h,horo_m,horo_tic_dec,horo_tic_min);
    if(horo_blocked) strcat(ch," blocked");
    if(horo_tic_on) strcat(ch," on"); else strcat(ch," off");
    EasyTextOut(5,2+y,ch);
}


/*****************************************************************************/
/* fin horodateur                                                            */
/*****************************************************************************/





/*****************************************************************************/
/* debut CANTON                                                               */
/*****************************************************************************/

class cCanton
{
    public:

    int  num_train[4][16];
    int  res_auto[4][16];
    int  master_selectif[4][16];
    int  inv_selectif[4][16];
    int  update_selectif[4][16];
    int  vit_auto[4][16];
    int  vit_selectif[4][16];
    int  allowed_sens[4][16];

         cCanton(void);
    void init(char filename[]);
    void save_conf();
    void maj(void);
    void debug(int action);

    private:
    int get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb);
};

int cCanton::get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb)
{
    int ret;

    moins_char_normal=0;  // - is not a normal character (so it is parsed)
    ret=get_line(pf,ch_tab,ch_nb);
    moins_char_normal=1;

    return ret;
}

cCanton::cCanton(void)
{

}

void cCanton::init(char filename[])
{
    int i,j;

    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
        num_train[j][i]=-1;
        res_auto[j][i]=0;
        master_selectif[j][i]=0;
        inv_selectif[j][i]=0;
        update_selectif[j][i]=0;
        vit_auto[j][i]=0;
        vit_selectif[j][i]=0;
        copy_allowed_sens[j][i]=allowed_sens[j][i]=3; // bit poid 1 = sens + ,bit poid 2 = sens '-'
    }
}

void cCanton::save_conf(void)
{
    FILE* pf;
    int   i,j;

    if((pf=fopen("debug_canton.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_canton.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
        fprintf(pf,"\nnum_train=%2d res_auto=%d master_sel=%d inv_sel=%d update_sel=%d",num_train[j][i],res_auto[j][i],master_selectif[j][i],inv_selectif[j][i],update_selectif[j][i]);
    }

    fclose(pf);
}

void cCanton::maj(void)
{
    int i,j;

    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
        vio_canton_vit[j][i]=0;
        if(res_auto[j][i]==0 && num_train[j][i]!=-1 && (master_selectif[j][i] || update_selectif[j][i])) vio_canton_vit[j][i]=vit_selectif[j][i];
        if(res_auto[j][i]) vio_canton_vit[j][i]=vit_auto[j][i];
    }
}

void cCanton::debug(int action)
{
    int i,j;
    int x,y;
    int cant_i,cant_j;
    char ch[100];
    static int cant_deb=0;

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);
    if(action==DEBUG_TOTAL_PAINT) Rectangle(hdc,0,0,1280,1024);

    if(action==DEBUG_MOUSE)
    {
    //        cur_ligne=(y_mouse-20)/20;
    }

    if(action==DEBUG_KEY)
    {
        if(touche_char=='+') if(cant_deb<(64-1)) cant_deb++;
        if(touche_char=='-') if(cant_deb>0)      cant_deb--;
        SelectObject(hdc,bmp_pinceau_blanc);
        SelectObject(hdc,bmp_stylo_blanc);
        Rectangle(hdc,0,0,1280,1024);
    }

    y=0;
    Rectangle(hdc,0,y,700,y+20);
    EasyLine( 50,y, 50,y+20);
    EasyLine(100,y,100,y+20);
    EasyLine(150,y,150,y+20);
    EasyLine(200,y,200,y+20);
    EasyLine(250,y,250,y+20);
    EasyLine(300,y,300,y+20);
    EasyLine(350,y,350,y+20);
    EasyLine(400,y,400,y+20);
    EasyLine(450,y,450,y+20);
    EasyLine(500,y,500,y+20);
    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));
    EasyTextOut(  0+02,2,"Cant" );
    EasyTextOut( 50+02,2,"Train");
    EasyTextOut(100+02,2,"ResA" );
    EasyTextOut(150+05,2,"VitA" );
    EasyTextOut(200+05,2,"mstS" );
    EasyTextOut(250+05,2,"updS" );
    EasyTextOut(300+05,2,"invS" );
    EasyTextOut(350+05,2,"VitS" );
    EasyTextOut(400+05,2,"Vit"  );
    EasyTextOut(450+05,2,"Det"  );

    SetTextColor(hdc,RGB(0,0,255));
    for(i=0;i<32;i++)
    {
        y=20*i+20;
        SelectObject(hdc,bmp_pinceau_blanc);
        cant_j=((i+cant_deb)/16);
        cant_i=((i+cant_deb)%16);
        if(cant_j>3) continue;

        //vio_det[i] ) SelectObject(hdc,bmp_pinceau_jaune);
        Rectangle(hdc, 0,y,700,y+20);
        EasyLine( 50,y, 50,y+20);
        EasyLine(100,y,100,y+20);
        EasyLine(150,y,150,y+20);
        EasyLine(200,y,200,y+20);
        EasyLine(250,y,250,y+20);
        EasyLine(300,y,300,y+20);
        EasyLine(350,y,350,y+20);
        EasyLine(400,y,400,y+20);
        EasyLine(450,y,450,y+20);
        EasyLine(500,y,500,y+20);

        SelectObject(hdc,bmp_fonte);
        SetBkMode(hdc,TRANSPARENT);
        SetTextColor(hdc,RGB(0,0,255));
        x=0;   sprintf(ch,"%d",100*cant_j+cant_i);                 EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",num_train[cant_j][cant_i]);         EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",res_auto[cant_j][cant_i]);          EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vit_auto[cant_j][cant_i]);          EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",master_selectif[cant_j][cant_i]);   EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",update_selectif[cant_j][cant_i]);   EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",inv_selectif[cant_j][cant_i]);      EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vit_selectif[cant_j][cant_i]);      EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vio_canton_vit[cant_j][cant_i]);    EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vio_det[cant_j][cant_i]);           EasyTextOut(x+2,y+2,ch);
    }

}

/*****************************************************************************/
/* fin CANTON                                                                */
/*****************************************************************************/
cCanton  canton;

void update_copy_canton(void)
{
    int i,j;

    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
        copy_res_auto[j][i]=canton.res_auto[j][i];
        copy_master_selectif[j][i]=canton.master_selectif[j][i];
        copy_update_selectif[j][i]=canton.update_selectif[j][i];
        copy_num_train[j][i]=canton.num_train[j][i];
        //copy_allowed_sens[j][i]=canton.allowed_sens[j][i];
        canton.allowed_sens[j][i]=copy_allowed_sens[j][i];
    }
}


/*****************************************************************************/
/* debut GARAGE                                                               */
/*****************************************************************************/

#define GARAGE_NB 64
class cGarage
{
    public:

    int  ass_canton[GARAGE_NB];
    int  ass_out[GARAGE_NB];
    int  ass_out_pol[GARAGE_NB];
    int  num_train[GARAGE_NB];
//    int  state_lock[GARAGE_NB];  // now vio_garage_lock_status
//    int  cmd_lock[GARAGE_NB];    // now vio_garage_lock_cmd
//    int  res_auto[GARAGE_NB];    // now vio_garage_lock_res

         cGarage(void);
    void init(char filename[]);
    void save_conf();
    void maj(void);
    void debug(int action);

    private:
    int get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb);
};

int cGarage::get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb)
{
    int ret;

    moins_char_normal=0;  // - is not a normal character (so it is parsed)
    ret=get_line(pf,ch_tab,ch_nb);
    moins_char_normal=1;

    return ret;
}

cGarage::cGarage(void)
{

}

void cGarage::init(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int  ch_nb,i,num_garage=0;


    for(i=0;i<GARAGE_NB;i++)
    {
        ass_canton[i]=-1;
        ass_out[i]=0;
        ass_out_pol[i]=1;
        num_train[i]=-1;
        vio_garage_lock_status[i]=0;
        vio_garage_lock_cmd[i]=0;
        vio_garage_lock_res[i]=0;
    }

    // g0: c1 out3 pol1
    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des garages","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    moins_char_normal=1; // - est un character normal (donc dans les chaines)
    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#garage"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                i=0;
                while(i<ch_nb)
                {
                    //sprintf(ch_error,"i=%d",i);
                    //MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);

                    // g0:
                    if((ch_nb-i)>=2)
                    if( ch_tab[i][0]=='g')
                    if( ch_tab[i+1][0]==':')
                    {
                        num_garage=atoi(&ch_tab[i][1]);
                        i=i+2;
                        continue;
                    }

                    // c1
                    if((ch_nb-i)>=1)
                    if( ch_tab[i][0]=='c')
                    {
                        ass_canton[num_garage]=atoi(&ch_tab[i][1]);
                        i=i+1;
                        continue;
                    }

                    // out3
                    if((ch_nb-i)>=1)
                    if(STR_SAME strncmp(ch_tab[i],"out",3) )
                    {
                        ass_out[num_garage]=atoi(&ch_tab[i][3]);
                        i=i+1;
                        continue;
                    }

                    // pol1
                    if((ch_nb-i)>=1)
                    if(STR_SAME strncmp(ch_tab[i],"pol",3) )
                    {
                        ass_out_pol[num_garage]=atoi(&ch_tab[i][3]);
                        i=i+1;
                        continue;
                    }

                    strcpy(ch_error,"Garage Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine
        }      //fin #garage
    }        //fin file
    moins_char_normal=1;

    fclose(pf);



}

void cGarage::save_conf(void)
{
    FILE* pf;
    int   i,j;

    if((pf=fopen("debug_garage.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_garage.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(i=0;i<GARAGE_NB;i++)
    {
        fprintf(pf,"\ngarage=%2d ass_canton=%3d ass_out=%3d num_train=%2d cmd_lock=%d state_lock=%d res_auto=%d",
                   i, ass_canton[i], ass_out[i], ass_out_pol[i], num_train[i], vio_garage_lock_cmd[i], vio_garage_lock_status[i], vio_garage_lock_res[i] );
    }

    fclose(pf);
}

void garage_lock_and_unlock(void);

void cGarage::maj(void)
{
    int i,cant,out,val;

    for(i=0;i<GARAGE_NB;i++) if(ass_canton[i]!=-1)
    {
        cant=ass_canton[i];

        // lock & unlock are put below because it needs train
        garage_lock_and_unlock();

        // out according state
        if(vio_garage_lock_cmd[i]) val=ass_out_pol[i]; else val=1-ass_out_pol[i];
        vio_out[ass_out[i]/100][ass_out[i]%100]=val;
    }
}

void cGarage::debug(int action)
{
    int i;
    int x,y;
    char ch[100];
    int cur_ligne=0;


    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);
    if(action==DEBUG_TOTAL_PAINT) Rectangle(hdc,0,0,1280,1024);

    if(action==DEBUG_MOUSE)
    {
        cur_ligne=(y_mouse-20)/20;
        if(x_mouse>200 && x_mouse<250 && cur_ligne<16) if(vio_garage_lock_res[cur_ligne]==0) vio_garage_lock_cmd[cur_ligne]^=1;
    }

    if(action==DEBUG_KEY)
    {
    //        if(touche_char=='+')
    }

    y=0;
    Rectangle(hdc,0,y,700,y+20);
    EasyLine( 50,y, 50,y+20);
    EasyLine(100,y,100,y+20);
    EasyLine(150,y,150,y+20);
    EasyLine(200,y,200,y+20);
    EasyLine(250,y,250,y+20);
    EasyLine(300,y,300,y+20);
    EasyLine(350,y,350,y+20);
    EasyLine(400,y,400,y+20);
    EasyLine(450,y,450,y+20);
    EasyLine(500,y,500,y+20);
    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));
    EasyTextOut(  0+02,2,"Garage");
    EasyTextOut( 50+02,2,"Canton");
    EasyTextOut(100+02,2,"Out"   );
    EasyTextOut(150+05,2,"Pol"   );
    EasyTextOut(200+05,2,"Cmd_L" );
    EasyTextOut(250+05,2,"Locked");
    EasyTextOut(300+05,2,"Res"   );
    EasyTextOut(350+05,2,"Train" );
    EasyTextOut(400+05,2,""      );
    EasyTextOut(450+05,2,""      );

    SetTextColor(hdc,RGB(0,0,255));
    for(i=0;i<16;i++) // only first 16 (in waiting)
    {
        y=20*i+20;
        SelectObject(hdc,bmp_pinceau_blanc);
        //vio_det[i] ) SelectObject(hdc,bmp_pinceau_jaune);
        Rectangle(hdc, 0,y,700,y+20);
        EasyLine( 50,y, 50,y+20);
        EasyLine(100,y,100,y+20);
        EasyLine(150,y,150,y+20);
        EasyLine(200,y,200,y+20);
        EasyLine(250,y,250,y+20);
        EasyLine(300,y,300,y+20);
        EasyLine(350,y,350,y+20);
        EasyLine(400,y,400,y+20);
        EasyLine(450,y,450,y+20);
        EasyLine(500,y,500,y+20);
        SelectObject(hdc,bmp_fonte);
        SetBkMode(hdc,TRANSPARENT);
        SetTextColor(hdc,RGB(0,0,255));
        x=0;   sprintf(ch,"%d",i);                         EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",ass_canton[i]            ); EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",ass_out[i]               ); EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",ass_out_pol[i]           ); EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vio_garage_lock_cmd[i]   ); EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vio_garage_lock_status[i]); EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",vio_garage_lock_res[i]   ); EasyTextOut(x+2,y+2,ch);
        x+=50; sprintf(ch,"%d",num_train[i]             ); EasyTextOut(x+2,y+2,ch);
    }

}

/*****************************************************************************/
/* fin GARAGE                                                                */
/*****************************************************************************/
cGarage  garage;





/*****************************************************************************/
/* debut TRAIN                                                               */
/*****************************************************************************/

#define NB_TRAIN 16

class cTrain
{
    public:

    int  enable[NB_TRAIN];
    char name[NB_TRAIN][10];
    int  cmd[NB_TRAIN];
    int  en_auto[NB_TRAIN];
    int  inv[NB_TRAIN];
    int  vmin[NB_TRAIN];
    int  vmax[NB_TRAIN];
    int  acc[NB_TRAIN];
    int  dec[NB_TRAIN];
    int  frein[NB_TRAIN];
    int  cons[NB_TRAIN];
    int  vit[NB_TRAIN];
    int  cant_lock[NB_TRAIN];
    char mode[NB_TRAIN][10];
    char sz_cant_ind[NB_TRAIN][100];
    int  capt[NB_TRAIN];
    int  entry;

         cTrain(void);
    void init(char filename[]);
    void save_conf();
    void maj(void);
    void debug(int action);

    private:
    int get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb);
    int dynamique_vit(int cons,int vit, int acc, int dec, int frein, int vmin, int vmax);
};

int cTrain::get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb)
{
    int ret;

    moins_char_normal=0;  // - is not a normal character (so it is parsed)
    ret=get_line(pf,ch_tab,ch_nb);
    moins_char_normal=1;

    return ret;
}

cTrain::cTrain(void)
{

}

void cTrain::init(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int  ch_nb,i,j,t=0,g,cant,no;


    for(i=0;i<NB_TRAIN;i++)
    {
        enable[i]=0;
        strcpy(name[i],"");
        cmd[i]=-1;
        en_auto[i]=0;
        inv[i]=0;
        vmin[i]=0;
        vmax[i]=64;
        acc[i]=-1;
        dec[i]=-1;
        frein[i]=-1;
        cons[i]=0;
        vit[i]=0;
        cant_lock[i]=-1;
        strcpy(sz_cant_ind[i],"");
        strcpy(mode[i],"SEL"); // modes are SEL or AUTO
    }

    // train:1 ter_3852 c1 pot1 inv 00-64-xx-xx-xx en_auto
    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des deplacements","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    moins_char_normal=1; // - est un character normal (donc dans les chaines)
    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#train"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                i=0;
                while(i<ch_nb)
                {
                    //sprintf(ch_error,"i=%d",i);
                    //MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);

                    // train1:
                    if((ch_nb-i)>=3)
                    if( STR_SAME strncmp(ch_tab[i],"train",5) )
                    if( ch_tab[i+1][0]==':')
                    {
                        t=atoi(&ch_tab[i][5]);
                        sprintf(name[t],"train %d",t);
                        i=i+2;
                        continue;
                    }

                    // pot3
                    if((ch_nb-i)>=1)
                    if(STR_SAME strncmp(ch_tab[i],"pot",3) )
                    {
                        cmd[t]=atoi(&ch_tab[i][3]);
                        i=i+1;
                        continue;
                    }

                    // clav_conf_2
                    if((ch_nb-i)>=2)
                    if(STR_SAME strncmp(ch_tab[i],"clav_conf_",4) )
                    if( ch_tab[i+1][0]==':')
                    {
                        no=atoi(&ch_tab[i][10]);

                        i=i+2;
                        while((ch_nb-i)>0)
                        {
                            if(     (ch_nb-i)>=1 && ch_tab[i][0]=='-') { vio_pot_virtual_conf[no][2]=ch_tab[i  ][1]; i++;   } // car - n'est pas un caractere special
                            else if((ch_nb-i)>=2 && ch_tab[i][0]=='+') { vio_pot_virtual_conf[no][0]=ch_tab[i+1][0]; i=i+2; }
                            else if((ch_nb-i)>=2 && ch_tab[i][0]=='!') { vio_pot_virtual_conf[no][1]=ch_tab[i+1][0]; i=i+2; }
                            else { i++; break; }
                        }
                        continue;
                    }

                    // clav3
                    if((ch_nb-i)>=1)
                    if(STR_SAME strncmp(ch_tab[i],"clav",4) )
                    {
                        cmd[t]=1000+atoi(&ch_tab[i][4]);
                        i=i+1;
                        //sprintf(gszErr,"<clav-cmd[%d]=%d>",t,cmd[t]); log(gszErr);
                        continue;
                    }

                    // c1
                    if((ch_nb-i)>=1)
                    if( ch_tab[i][0]=='c')
                    {
                        cant=atoi(&ch_tab[i][1]);
                        canton.num_train[cant/100][cant%100]=t;
                        canton.master_selectif[cant/100][cant%100]=1;
                        canton.inv_selectif[cant/100][cant%100]=0;
                        canton.update_selectif[cant/100][cant%100]=0;
                        enable[t]=1;
                        i=i+1;
                        continue;
                    }

                    // g1
                    if((ch_nb-i)>=1)
                    if( ch_tab[i][0]=='g')
                    {
                        g=atoi(&ch_tab[i][1]);
                        cant_lock[t]=g;
                        vio_garage_lock_cmd[g]=1;
                        vio_garage_lock_status[g]=1;
                        garage.num_train[g]=t;
                        enable[t]=1;
                        i=i+1;
                        continue;
                    }

                    // inv
                    if((ch_nb-i)>=1)
                    if(STR_SAME strcmp(ch_tab[i],"inv") )
                    {
                        inv[t]=1;
                        i=i+1;
                        continue;
                    }

                    // en_auto
                    if((ch_nb-i)>=1)
                    if(STR_SAME strcmp(ch_tab[i],"en_auto") )
                    {
                        en_auto[t]=1;
                        i=i+1;
                        continue;
                    }

                    if((ch_nb-i)>=1)
                    if(strlen(ch_tab[i])==8)
                    {
                        strcpy(name[t],ch_tab[i]);
                        for(j=0;j<8;j++) if(name[t][j]=='_') name[t][j]=' ';
                        i=i+1;
                        continue;
                    }

                    if((ch_nb-i)>=1)
                    if(strlen(ch_tab[i])==14)
                    if( ch_tab[i][2]=='-' && ch_tab[i][5]=='-' && ch_tab[i][8]=='-' && ch_tab[i][11]=='-')
                    {
                        if(ch_tab[i][ 0]>='0' && ch_tab[i][ 0]<='9') vmin [t]=atoi(&ch_tab[i][ 0]);
                        if(ch_tab[i][ 3]>='0' && ch_tab[i][ 3]<='9') vmax [t]=atoi(&ch_tab[i][ 3]);
                        if(ch_tab[i][ 6]>='0' && ch_tab[i][ 6]<='9') acc  [t]=atoi(&ch_tab[i][ 6]);
                        if(ch_tab[i][ 9]>='0' && ch_tab[i][ 9]<='9') dec  [t]=atoi(&ch_tab[i][ 9]);
                        if(ch_tab[i][12]>='0' && ch_tab[i][12]<='9') frein[t]=atoi(&ch_tab[i][12]);
                        i=i+1;
                        continue;
                    }

                    strcpy(ch_error,"train Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine
        }      //fin #depl
    }        //fin file
    moins_char_normal=1;

    fclose(pf);

}

void cTrain::save_conf(void)
{
    FILE* pf;
    int   i,j;

    if((pf=fopen("debug_train.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_train.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(i=0;i<NB_TRAIN;i++)
    {
        fprintf(pf,"\nen=%d name=%8s cmd=%3d en_auto=%d inv=%d vmin=%02d vmax=%02d acc=%02d dec=%02d frein=%02d cons=%03d vit=%03d mode=%4s",enable[i],name[i],cmd[i],en_auto[i],inv[i],vmin[i],vmax[i],acc[i],dec[i],frein[i],cons[i],vit[i],mode[i]);
    }

    for(j=0;j<5;j++)
    {
        fprintf(pf,"\nclav_conf_%d",j);
        for(i=0;i<3;i++) fprintf(pf," >%c<",vio_pot_virtual_conf[j][i]);
    }

    fclose(pf);
}

/*
    function: dynamique vit: calcul la nouvelle vitesse en fonction:
    - la consigne (-64 a +64)  (-1000=frein)
    - la vitesse actuelle
    - les parametres d'acceleration, deceleration et freinage
*/
int cTrain::dynamique_vit(int cons,int vit, int acc, int dec, int frein, int vmin, int vmax)
{
    int next_vit;


    //1. Freinage
    if(cons==-99)
    {
        if(frein==-1) next_vit=0;
        else
        {
            if(vit>0) { next_vit=vit-frein; if(next_vit<0) next_vit=0; }
            else      { next_vit=vit+frein; if(next_vit>0) next_vit=0; }
        }
        return next_vit;
    }

    //2. Consigne et vitesse de sens different
    if(cons==0 && vit==0) { next_vit=0; }

    if(cons==0 && vit<0)  { if(dec==-1) next_vit=0; else { next_vit=vit+dec; if(next_vit>0) next_vit=0; } } // deceleration vers 0 sens -
    if(cons==0 && vit>0)  { if(dec==-1) next_vit=0; else { next_vit=vit-dec; if(next_vit<0) next_vit=0; } } // deceleration vers 0 sens +

    if(cons>0  && vit<0)  { if(dec==-1) next_vit=0; else { next_vit=vit+dec; if(next_vit>0) next_vit=0; } } // deceleration vers 0 sens -
    if(cons<0  && vit>0)  { if(dec==-1) next_vit=0; else { next_vit=vit-dec; if(next_vit<0) next_vit=0; } } // deceleration vers 0 sens +

    //if(cons>0  && vit==0) { if(acc==-1) next_vit=cons; else next_vit=vit+acc; } // acceleration sens +
    //if(cons<0  && vit==0) { if(acc==-1) next_vit=cons; else next_vit=vit-acc; } // acceleration sens -
    if(cons>0  && vit==0) { if(acc==-1) next_vit=cons; else next_vit=vmin;  } // acceleration sens +    //UU-MODIF-01jul2005
    if(cons<0  && vit==0) { if(acc==-1) next_vit=cons; else next_vit=-vmin; } // acceleration sens -    //UU-MODIF-01jul2005

    if(cons>0  && vit>0)
    {
        if(cons==vit) next_vit=cons;
        if(cons>vit) { if(acc==-1) next_vit=cons; else { next_vit=vit+acc; if(next_vit>cons) next_vit=cons; } }  // acceleration sens +
        if(cons<vit) { if(dec==-1) next_vit=cons; else { next_vit=vit-dec; if(next_vit<cons) next_vit=cons; } } // deceleration sens +
    }

    if(cons<0  && vit<0)
    {
        if(cons==vit) next_vit=cons;
        if(cons<vit) { if(acc==-1) next_vit=cons; else { next_vit=vit-acc; if(next_vit<cons) next_vit=cons; } } // acceleration sens -
        if(cons>vit) { if(dec==-1) next_vit=cons; else { next_vit=vit+dec; if(next_vit>cons) next_vit=cons; } } // deceleration sens -
    }

    if(next_vit>vmax)     next_vit=vmax;
    if(next_vit<(0-vmax)) next_vit=-vmax;
    if(next_vit<vmin && next_vit>(0-vmin)) next_vit=0;

    //sprintf(gszErr,"\ncons=%d next_vit=%d",cons,next_vit); log(gszErr);

    return next_vit;
}

void cTrain::maj(void)
{
    int i,j,t,can,cons_,vit_,enbreak;

    //sprintf(gszErr,"\nin trainmaj"); log(gszErr);

    // 1. Regulateur

    for(t=0;t<NB_TRAIN;t++)
    {
        // 1.1. Pas de commande
        if(cmd[t]==-1 || enable[t]==0 || cant_lock[t]!=-1 || STR_SAME stricmp(mode[i],"AUTO") ) { cons[t]=0; vit[t]=0; }

        // 1.2. OK pour commande
        else
        {
            // 1.2.1. Commande potentiometrique
            if(cmd[t]>=0 && cmd[t]<=305)
            {
                //sprintf(gszErr,"\nin trainmaj-pot for train %d",t); log(gszErr);

                can=vio_can[cmd[t]/100][cmd[t]%100];
                if(inv[t]) can=255-can;
                //if(frein[t]!=-1) enbreak=1; else enbreak=0;
                /**/ enbreak=1;
                cons_=can_to_cons(can,vmin[t],vmax[t],enbreak);  // cons a -99 = frein
                vit_=dynamique_vit(cons_,vit[t],acc[t],dec[t],frein[t],vmin[t],vmax[t]);
                cons[t]=cons_;
                vit[t]=vit_;

                //sprintf(gszErr,"\ncons[i]=%d vit[i]=%d",cons[t],vit[t]); log(gszErr);
            }

            // 1.2.2. Commande clavier
            if(cmd[t]>=1000 && cmd[t]<=1005)
            {
                //UU:TBD plus tard
                cons_=virtualstep_to_cons(vio_pot_virtual_step[cmd[t]%100],vmin[t],vmax[t]);
                vit_=dynamique_vit(cons_,vit[t],acc[t],dec[t],frein[t],vmin[t],vmax[t]);
                cons[t]=cons_;
                vit[t]=vit_;

                //sprintf(gszErr,"t=%d cmd[t]=%d step=%d cons=%d vit=%d",t,cmd[t],vio_pot_virtual_step[cmd[t]%100],cons_,vit_);
                //log(gszErr);
            }
        }
    }

    // 2. Indicateur de canton

    for(t=0;t<NB_TRAIN;t++)
    {
        strcpy(sz_cant_ind[t],"");

        for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.num_train[j][i]==t)
        {
            if(canton.master_selectif[j][i]) sprintf(sz_cant_ind[t],"%sc%d ",sz_cant_ind[t],100*j+i);
            if(canton.res_auto[j][i] && vio_det[j][i]) sprintf(sz_cant_ind[t],"%sc%d ",sz_cant_ind[t],100*j+i);
        }

        sz_cant_ind[t][20]='\0'; // troncate
    }

    // 3. Indicateur de captage
    for(t=0;t<NB_TRAIN;t++)
    {
        capt[t]=0;

        for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.num_train[j][i]==t)
        {
            if(canton.master_selectif[j][i] && vio_det[j][i]) capt[t]=1;
            if(canton.res_auto[j][i] && vio_det[j][i]) capt[t]=1;
        }

        if( cant_lock[t]!=-1 ) capt[t]=2;
    }
}

#define ENTRY_CMD 0
#define ENTRY_CANTON 1
#define ENTRY_NAME 2
#define ENTRY_PROFILE 3
#define ENTRY_LOCK 4

void cTrain::debug(int action)
{
    int  i,j,c,g;
    int  x,y;
    char ch[100];
    static int selected_train=-1;
    static int selected_entry=-1;
    int val;
    static char szEntryName[10];
    int len;

    if(action==DEBUG_MOUSE)
    {
        j=(y_mouse-20)/20;
        if(selected_entry==-1) if(j>=0 && j<NB_TRAIN)
        {
           selected_train=j;

           if(x_mouse>0   && x_mouse<50 )
           {
                if(enable[selected_train]==0) // enable train
                {
                    enable[selected_train]=1;
                    selected_entry=ENTRY_CANTON;
                    sprintf(name[selected_train],"train_%d",selected_train);
                }
                else // disable train
                {
                    if( STR_SAME stricmp(mode[selected_train],"AUTO") ) { EasyTextOut(100,400,"Err: Cannot Deactivate an AUTO train"); }
                    else
                    {
                        enable[selected_train]=0;               // liberation train
                        cmd[selected_train]=-1;
                        en_auto[selected_train]=0;
                        inv[selected_train]=0;
                        vmin[selected_train]=0;
                        vmax[selected_train]=64;
                        acc[selected_train]=-1;
                        dec[selected_train]=-1;
                        frein[selected_train]=-1;
                        cons[selected_train]=0;
                        vit[selected_train]=0;
                        strcpy(mode[selected_train],"SEL");

                        for(j=0;j<4;j++) for(i=0;i<16;i++)      // liberation canton (et donc selectif)
                        {
                            if(canton.num_train[j][i]==selected_train)
                            {
                                canton.master_selectif[j][i]=0;
                                canton.inv_selectif[j][i]=0;
                                canton.update_selectif[j][i]=0;
                            }
                        }

                        g=cant_lock[selected_train];            // liberation garage
                        if(g!=-1)
                        {
                            vio_garage_lock_cmd[g]=0;
                            vio_garage_lock_status[g]=0;
                            vio_garage_lock_res[g]=0;
                            garage.num_train[g]=-1;
                            cant_lock[selected_train]=-1;
                        }
                    }
                }
            }

            if(enable[selected_train])
            {
                if(x_mouse> 50 && x_mouse<150)  { selected_entry=ENTRY_NAME; strcpy(szEntryName,""); }
                if(x_mouse>150 && x_mouse<200)  { selected_entry=ENTRY_CMD;  }
                if(x_mouse>200 && x_mouse<250)  en_auto[selected_train]^=1;
                if(x_mouse>250 && x_mouse<300)  inv[selected_train]^=1;
                if(x_mouse>300 && x_mouse<450)  { selected_entry=ENTRY_PROFILE; }
                if(x_mouse>700 && x_mouse<750)
                {
                    g=cant_lock[selected_train];
                    if(g!=-1) { if(vio_garage_lock_res[g]==0) vio_garage_lock_cmd[g]=0; }
                    else      { selected_entry=ENTRY_LOCK; }
                }
            }
        }

        if(selected_entry==ENTRY_LOCK)
        {
            j=((y_mouse)/20)-1-NB_TRAIN-1-1-5;
            i=(x_mouse/50);
            if(j>=0 && j<=4) if(i>=0 && i<=15)
            {
                g=16*j+i;
                c=garage.ass_canton[g];
                if(c!=-1)  if(canton.num_train[c/100][c%100]==selected_train) vio_garage_lock_cmd[g]=1; // verouillage pour le train selectionne
                selected_train=-1;
                selected_entry=-1;
            }

        }

        if(selected_entry==ENTRY_CMD)
        {
            j=((y_mouse)/20)-1-NB_TRAIN-1-1;
            i=(x_mouse/100)-1;
            if(j>=0 && j<=4) if(i>=0 && i<=4)
            {
                if(j==4) val=1000+i; else val=100*j+i;
                cmd[selected_train]=val;
                selected_train=-1;
                selected_entry=-1;
            }
            else
            {
                cmd[selected_train]=-1;
                selected_train=-1;
                selected_entry=-1;
            }
        }

        if(selected_entry==ENTRY_CANTON)
        {
            j=((y_mouse)/20)-1-NB_TRAIN-1-1;
            i=(x_mouse/50);
            if(j>=0 && j<=4) if(i>=0 && i<=15)
            {
                val=100*j+i;
                canton.num_train[val/100][val%100]=selected_train;
                canton.master_selectif[val/100][val%100]=1;
                canton.inv_selectif[val/100][val%100]=0;
                canton.update_selectif[val/100][val%100]=0;
                selected_train=-1;
                selected_entry=-1;
            }

            j=((y_mouse)/20)-1-NB_TRAIN-1-1-5;
            i=(x_mouse/50);
            if(j>=0 && j<=4) if(i>=0 && i<=15)
            {
                g=16*j+i;
                cant_lock[selected_train]=g;
                vio_garage_lock_cmd[g]=1;
                vio_garage_lock_status[g]=1;
                garage.num_train[g]=selected_train;
                selected_train=-1;
                selected_entry=-1;
            }

        }

        if(selected_entry==ENTRY_PROFILE)
        {
            j=((y_mouse)/20)-1-NB_TRAIN-1-1;
            i=(x_mouse/50);

            if(j==0 && i==2) { vmin[selected_train]-=10; if(vmin[selected_train]<0) vmin[selected_train]=0; }
            if(j==0 && i==3) { vmin[selected_train]--;   if(vmin[selected_train]<0) vmin[selected_train]=0; }
            if(j==0 && i==4)   vmin[selected_train]=0;
            if(j==0 && i==5) { vmin[selected_train]++;   if(vmin[selected_train]>64) vmin[selected_train]=64; }
            if(j==0 && i==6) { vmin[selected_train]+=10; if(vmin[selected_train]>64) vmin[selected_train]=64; }

            if(j==1 && i==2) { vmax[selected_train]-=10; if(vmax[selected_train]<0) vmax[selected_train]=0; }
            if(j==1 && i==3) { vmax[selected_train]--;   if(vmax[selected_train]<0) vmax[selected_train]=0; }
            if(j==1 && i==4)   vmax[selected_train]=64;
            if(j==1 && i==5) { vmax[selected_train]++;   if(vmax[selected_train]>64) vmax[selected_train]=64; }
            if(j==1 && i==6) { vmax[selected_train]+=10; if(vmax[selected_train]>64) vmax[selected_train]=64; }

            if(j==2 && i==2) { acc[selected_train]-=10; if(acc[selected_train]<0) acc[selected_train]=0; }
            if(j==2 && i==3) { acc[selected_train]--;   if(acc[selected_train]<0) acc[selected_train]=0; }
            if(j==2 && i==4)   acc[selected_train]=-1;
            if(j==2 && i==5) { acc[selected_train]++;   if(acc[selected_train]>64) acc[selected_train]=64; }
            if(j==2 && i==6) { acc[selected_train]+=10; if(acc[selected_train]>64) acc[selected_train]=64; }

            if(j==3 && i==2) { dec[selected_train]-=10; if(dec[selected_train]<0) dec[selected_train]=0; }
            if(j==3 && i==3) { dec[selected_train]--;   if(dec[selected_train]<0) dec[selected_train]=0; }
            if(j==3 && i==4)   dec[selected_train]=-1;
            if(j==3 && i==5) { dec[selected_train]++;   if(dec[selected_train]>64) dec[selected_train]=64; }
            if(j==3 && i==6) { dec[selected_train]+=10; if(dec[selected_train]>64) dec[selected_train]=64; }

            if(j==4 && i==2) { frein[selected_train]-=10; if(frein[selected_train]<0) frein[selected_train]=0; }
            if(j==4 && i==3) { frein[selected_train]--;   if(frein[selected_train]<0) frein[selected_train]=0; }
            if(j==4 && i==4)   frein[selected_train]=-1;
            if(j==4 && i==5) { frein[selected_train]++;   if(frein[selected_train]>64) frein[selected_train]=64; }
            if(j==4 && i==6) { frein[selected_train]+=10; if(frein[selected_train]>64) frein[selected_train]=64; }

            if(j==3 && (i==14 || i==15)) { vmin[selected_train]=0;  vmax[selected_train]=64;  acc[selected_train]=dec[selected_train]=frein[selected_train]=-1; }

            if(j==4 && (i==14 || i==15)) { selected_train=-1; selected_entry=-1; }
        }

    }

    if(action==DEBUG_KEY)
    {
        if(selected_entry==ENTRY_NAME)
        {
            if(touche_char!=0xd) //'\n'==0x10 !!!!
            {
                len=strlen(szEntryName);
                if(len<8) { szEntryName[len]=touche_char; szEntryName[len+1]='\0'; }
            }
            else
            {
                strcpy(name[selected_train],szEntryName);
                selected_entry=-1;
                selected_train=-1;
            }
        }
    }
    if(action==DEBUG_KEY)
    {
        //if(touche_char=='+') if(iti_deb<(NB_ITI-1)) iti_deb++;
    }

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);
    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));

    Rectangle(hdc,0,0,800,20);
    x=0;y=0;
    EasyTextOut(x+5,2,"TR"        ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Nom"       ); x+=100; EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Cmd"       ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Auto"      ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Inv"       ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Profile"   ); x+=150; EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Cons"      ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Vit"       ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Mode"      ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"  Cantons" ); x+=100; EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Garag"     ); x+=50;  EasyLine(x,y,x,y+20);
    EasyTextOut(x+5,2,"Capt"      ); x+=50;

    SetTextColor(hdc,RGB(0,0,255));
    for(i=0;i<NB_TRAIN;i++)
    {
        y=20+20*i;
        SelectObject(hdc,bmp_pinceau_blanc);
        //if((iti_deb+i)>=NB_ITI) break;
        //if(iti_tab[iti_deb+i][NB_ITI_VAR_WAIT]) SelectObject(hdc,bmp_pinceau_jaune);
        //if(iti_tab[iti_deb+i][NB_ITI_VAR_OK])   SelectObject(hdc,bmp_pinceau_vert);
        Rectangle(hdc,0,y,800,y+20);

        x=0;
        x+=50;  EasyLine(x,y,x,y+20);
        x+=100; EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=150; EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=100; EasyLine(x,y,x,y+20);
        x+=50;  EasyLine(x,y,x,y+20);
        x+=50;

        x=0;
        sprintf(ch,"%d",i);                                                            EasyTextOut(x+5,y+2,ch); x+=50;
        if(enable[i]==0) continue;
        sprintf(ch,"%s",name[i]);                                                      EasyTextOut(x+5,y+2,ch); x+=100;
        if(cmd[i]==-1) sprintf(ch,"",cmd[i]);
        else if(cmd[i]<1000) sprintf(ch,"P_%d",cmd[i]);
        else sprintf(ch,"C_%d",cmd[i]-1000);                                           EasyTextOut(x+5,y+2,ch); x+=50;
        if(en_auto[i]) strcpy(ch,"Y"); else strcpy(ch,"N");                            EasyTextOut(x+5,y+2,ch); x+=50;
        if(inv[i]) strcpy(ch,"Inv"); else strcpy(ch,"");                               EasyTextOut(x+5,y+2,ch); x+=50;
        sprintf(ch,"%02d-%02d-%02d-%02d-%02d",vmin[i],vmax[i],acc[i],dec[i],frein[i]);
        if(  acc[i]==-1) strncpy(&ch[6] ,"xx",2);
        if(  dec[i]==-1) strncpy(&ch[9] ,"xx",2);
        if(frein[i]==-1) strncpy(&ch[12],"xx",2);                                      EasyTextOut(x+5,y+2,ch); x+=150;
        sprintf(ch,"%d",cons[i]);                                                      EasyTextOut(x+5,y+2,ch); x+=50;
        sprintf(ch,"%d",vit[i]);                                                       EasyTextOut(x+5,y+2,ch); x+=50;
        strcpy(ch,mode[i]);                                                            EasyTextOut(x+5,y+2,ch); x+=50;
        strcpy(ch,sz_cant_ind[i]);                                                     EasyTextOut(x+5,y+2,ch); x+=100;
        if(cant_lock[i]!=-1) {sprintf(ch,"g%d",cant_lock[i]);                          EasyTextOut(x+5,y+2,ch);}x+=50;
        strcpy(ch,""); if(capt[i]==1) strcpy(ch,"OK"); if(capt[i]==0) strcpy(ch,"PB"); EasyTextOut(x+5,y+2,ch); x+=50;

    }

    x=0; y=20*(NB_TRAIN+2);

    if(selected_entry==-1)
    {
        SelectObject(hdc,bmp_stylo_blanc);
        SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,x,y,x+800,y+200);
    }

    if(selected_entry==ENTRY_CMD)
    {
        SelectObject(hdc,bmp_stylo_gris);
        SetTextColor(hdc,RGB(255,0,0));
        sprintf(ch,"Select command for train %d %s",selected_train,name[selected_train]);
        EasyTextOut(x+100+5,y+2,ch);
        SetTextColor(hdc,RGB(0,0,255));
        for(j=0;j<5;j++) for(i=0;i<5;i++)
        {
            x=100*i+100;
            y=20*(NB_TRAIN+3+j);
            Rectangle(hdc,x,y,x+100,y+20);
            if(j==4) sprintf(ch,"CLAV_%d",i); else sprintf(ch,"POT_%d",100*j+i);
            EasyTextOut(x+5,y+2,ch);
        }
    }

    if(selected_entry==ENTRY_CANTON)
    {
        SelectObject(hdc,bmp_stylo_gris);
        SetTextColor(hdc,RGB(255,0,0));
        sprintf(ch,"Select canton for train %d %s",selected_train,name[selected_train]);
        EasyTextOut(x+100+5,y+2,ch);
        SetTextColor(hdc,RGB(0,0,255));
        for(j=0;j<4;j++) for(i=0;i<16;i++)
        {
            x=50*i;
            y=20*(NB_TRAIN+3+j);
            Rectangle(hdc,x,y,x+50,y+20);
            sprintf(ch,"c%d",100*j+i);
            EasyTextOut(x+5,y+2,ch);
        }

        for(j=0;j<4;j++) for(i=0;i<16;i++)
        {
            x=50*i;
            y=20*(NB_TRAIN+3+5+j);
            Rectangle(hdc,x,y,x+50,y+20);
            sprintf(ch,"g%d",16*j+i);
            EasyTextOut(x+5,y+2,ch);
        }

    }

    if(selected_entry==ENTRY_LOCK)
    {
        SelectObject(hdc,bmp_stylo_gris);
        SetTextColor(hdc,RGB(255,0,0));
        sprintf(ch,"Select canton for train %d %s",selected_train,name[selected_train]);
        EasyTextOut(x+100+5,y+2,ch);
        SetTextColor(hdc,RGB(0,0,255));

        for(j=0;j<4;j++) for(i=0;i<16;i++)
        {
            x=50*i;
            y=20*(NB_TRAIN+3+5+j);
            Rectangle(hdc,x,y,x+50,y+20);
            sprintf(ch,"g%d",16*j+i);
            EasyTextOut(x+5,y+2,ch);
        }

    }

    if(selected_entry==ENTRY_NAME)
    {
        SelectObject(hdc,bmp_stylo_gris);
        SetTextColor(hdc,RGB(255,0,0));
        sprintf(ch,"Enter Train Name for train %d",selected_train);
        EasyTextOut(x+100+5,y+2,ch);
        SetTextColor(hdc,RGB(0,0,255));
        sprintf(ch,"%s",szEntryName);
        EasyTextOut(x+100+5,y+2+20,ch);
    }

    if(selected_entry==ENTRY_PROFILE)
    {
        SelectObject(hdc,bmp_stylo_gris);
        SetTextColor(hdc,RGB(255,0,0));
        sprintf(ch,"Adjust profile for train %d %s",selected_train,name[selected_train]);
        EasyTextOut(x+100+5,y+2,ch);
        SetTextColor(hdc,RGB(0,0,255));

        // ajustement
        for(j=0;j<5;j++) for(i=0;i<7;i++)
        {
            x=50*i;
            y=20*(NB_TRAIN+3+j);
            Rectangle(hdc,x,y,x+50,y+20);
            if(i==0)
            {
                if(j==0) { sprintf(ch,"VMIN");  EasyTextOut(x+5,y+2,ch); }
                if(j==1) { sprintf(ch,"VMAX");  EasyTextOut(x+5,y+2,ch); }
                if(j==2) { sprintf(ch,"ACC");   EasyTextOut(x+5,y+2,ch); }
                if(j==3) { sprintf(ch,"DEC");   EasyTextOut(x+5,y+2,ch); }
                if(j==4) { sprintf(ch,"FREIN"); EasyTextOut(x+5,y+2,ch); }
            }
            if(i==1)
            {
                if(j==0) { sprintf(ch,"%d",vmin[selected_train]); EasyTextOut(x+5,y+2,ch); }
                if(j==1) { sprintf(ch,"%d",vmax[selected_train]); EasyTextOut(x+5,y+2,ch); }
                if(j==2) { if(acc[selected_train]==-1) sprintf(ch,"xx"); else sprintf(ch,"%d",  acc[selected_train]  ); EasyTextOut(x+5,y+2,ch); }
                if(j==3) { if(dec[selected_train]==-1) sprintf(ch,"xx"); else sprintf(ch,"%d",  dec[selected_train]  ); EasyTextOut(x+5,y+2,ch); }
                if(j==4) { if(frein[selected_train]==-1) sprintf(ch,"xx"); else sprintf(ch,"%d",frein[selected_train]); EasyTextOut(x+5,y+2,ch); }
            }
            if(i==2) { sprintf(ch,"--"); EasyTextOut(x+5,y+2,ch); }
            if(i==3) { sprintf(ch,"-" ); EasyTextOut(x+5,y+2,ch); }
            if(i==4)
            {
                if(j==0) sprintf(ch,"0");
                if(j==1) sprintf(ch,"64");
                if(j>=2) sprintf(ch,"xx");
                EasyTextOut(x+5,y+2,ch);
            }
            if(i==5) { sprintf(ch,"+" ); EasyTextOut(x+5,y+2,ch); }
            if(i==6) { sprintf(ch,"++"); EasyTextOut(x+5,y+2,ch); }
        }

        // profiles
        for(j=0;j<5;j++) for(i=0;i<4;i++)
        {
            x=400+100*i;
            y=20*(NB_TRAIN+3+j);
            Rectangle(hdc,x,y,x+100,y+20);
            if((5*i+j)==18) { sprintf(ch,"DEFAULT");  EasyTextOut(x+5,y+2,ch); }
            if((5*i+j)==19) { sprintf(ch,"OK");       EasyTextOut(x+5,y+2,ch); }
        }
    }

    entry=selected_entry;
}

/*****************************************************************************/
/* fin TRAIN                                                                 */
/*****************************************************************************/
cTrain   train;

void update_copy_train(void)
{
    int i,j,t;

    for(t=0;t<16;t++)
    {
        strcpy(copy_train_name[t],train.name[t]);
        train_pb_capt[t]=0; for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.num_train[j][i]==t) if(train.capt[t]==0) train_pb_capt[t]=1;
    }

    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
        canton_pb_capt[j][i]=0;
        for(t=0;t<NB_TRAIN;t++) if(canton.num_train[j][i]==t) if(train.capt[t]==0) canton_pb_capt[j][i]=1;
    }

    for(i=0;i<16;i++)
    {
        copy_garage_num_train[i]=garage.num_train[i];
        copy_garage_ass_canton[i]=garage.ass_canton[i];
    }
}



void garage_lock_and_unlock(void)
{
    int i,j,k,c,t;


    for(i=0;i<64;i++) // pour chaque garage
    {
        if(vio_garage_lock_res[i]==1) continue;

        if(vio_garage_lock_status[i]==0 && vio_garage_lock_cmd[i]==1)  // lock
        {
            vio_garage_lock_cmd[i]=0;
            // verifier train sur canton principal
            c=garage.ass_canton[i];             if(c==-1) continue; if(canton.master_selectif[c/100][c%100]==0) continue;
            t=canton.num_train[c/100][c%100];   if(t==-1) continue;
            // liberer le canton principal
            for(j=0;j<4;j++) for(k=0;k<16;k++) if(canton.num_train[j][k]==t)
            {
                canton.num_train[j][k]=-1;
                canton.master_selectif[j][k]=0;
                canton.update_selectif[j][k]=0;
            }
            // verouiller
            train.cant_lock[t]=i;
            garage.num_train[i]=t;
            vio_garage_lock_cmd[i]=1;
            vio_garage_lock_status[i]=1;
        }

        else if(vio_garage_lock_status[i]==1 && vio_garage_lock_cmd[i]==0)  // unlock
        {
            vio_garage_lock_cmd[i]=1;
            // verifier canton principal libre
            c=garage.ass_canton[i]; if(c==-1) continue;
            if(canton.res_auto[c/100][c%100]==1) continue;
            if(canton.master_selectif[c/100][c%100]==1) continue;
            t=garage.num_train[i];
            // updater le canton principal
            canton.num_train[c/100][c%100]=t;
            canton.master_selectif[c/100][c%100]=1;
            // deverouiller
            train.cant_lock[t]=-1;
            garage.num_train[i]=-1;
            vio_garage_lock_cmd[i]=0;
            vio_garage_lock_status[i]=0;
        }

    }

}






/*****************************************************************************/
/* SELECTIF                                                                  */
/*****************************************************************************/


#define IND_CANT_COUR_NUM  0
#define IND_CANT_COUR_SENS 1
#define IND_CANT_PREC_NUM  2
#define IND_CANT_PREC_SENS 3
#define IND_AIG_NUM_BASE   4
#define IND_AIG_POS_BASE   5

#define IND_REG            0
#define IND_STATUS         1
#define IND_CPT            2
#define IND_DET            3
#define IND_VIT            4
#define IND_SENS           5
#define IND_INV            6

#define SM_LIBRE           0
#define SM_OCCUPE          1
#define SM_RESERVE         2

class cSelectif
{
    public:

    int nb;
    int descr[100][16];
    int var[16][10];
    int check_aig;

         cSelectif(void);
    void init(char filename[]);
    void verif(void);
    void tick(void);
    //void cSelectif::new_canton_selectif(int canton, int reg); //passage d'un canton en mode selectif
    void cSelectif::debug(int action);
};

cSelectif::cSelectif(void)
{
    int i,j;
    for(i=0;i<16;i++) vio_canton_selectif[i]=0;
    for(j=0;j<16;j++) for(i=0;i<10;i++) var[j][i]=0;
    //var[0 ][IND_REG]=0;  var[0 ][IND_STATUS]=SM_OCCUPE;
    //var[13][IND_REG]=3;  var[13][IND_STATUS]=SM_OCCUPE;
    check_aig=0;
}

void cSelectif::init(char filename[])
{
    FILE* pf;
    char ch[10];
    char c,c1,c2;
    int  i,j,i_aig;
    int  nb,aig,pos,cant,cant_base,sens_base;

    for(j=0;j<100;j++) for(i=0;i<16;i++) descr[j][i]=-1;
    nb=-1;

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration du selectif","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    while(fscanf(pf," %c",&c)!=EOF)
    {
        if(c=='@')
        {
             do{ if(fscanf(pf,"%c",&c)==EOF) break; }while(c!='\n');
             continue;
        }

        if(c=='#')
        {
             fscanf(pf," %s",ch);

             if(!strcmp(ch,"selectif"))
             {
                  fscanf(pf," %s",ch); //remove [
                  do
                  {
                      fscanf(pf," %c",&c);

                      if(c=='c')
                      {
                          fscanf(pf," %d",&cant); //get canton no
                          fscanf(pf,"%c",&c1);    //get : + -
                          if(c1==':')
                          {
                              nb++;
                              cant_base=cant;
                              descr[nb][IND_CANT_COUR_NUM]=cant_base;
                              i_aig=0;
                              fscanf(pf,"%c",&c2);
                              if(c2=='-') descr[nb][IND_CANT_COUR_SENS]=sens_base=1;
                              if(c2=='+') descr[nb][IND_CANT_COUR_SENS]=sens_base=0;
                          }
                          else
                          {
                              descr[nb][IND_CANT_PREC_NUM]=cant;
                              if(c1=='-') descr[nb][IND_CANT_PREC_SENS]=1;
                              if(c1=='+') descr[nb][IND_CANT_PREC_SENS]=0;
                          }
                      }

                      if(c=='+' || c=='-')
                      {
                              nb++;
                              descr[nb][IND_CANT_COUR_NUM]=cant_base;
                              descr[nb][IND_CANT_COUR_SENS]=sens_base;
                              i_aig=0;
                      }

                      if(c=='a')
                      {
                          fscanf(pf," %d",&aig);     //get aig no
                          fscanf(pf," %c",&c1);      //remove .
                          fscanf(pf," %d",&pos);     //get aig pos
                          descr[nb][IND_AIG_NUM_BASE+2*i_aig]=aig;
                          descr[nb][IND_AIG_POS_BASE+2*i_aig]=pos;
                          i_aig++;
                      }

                  }
                  while(c!=']');
             }

        }
    }

    fclose(pf);
}

void cSelectif::verif(void)
{
    FILE* pf;
    int j,i;

    fopen("selectif_debug.txt","wt");
    for(j=0;j<100;j++)
    {
        fprintf(pf,"\n");
        for(i=0;i<16;i++) fprintf(pf,"%3d ",descr[j][i]);
    }
    fclose(pf);
}

void cSelectif::tick(void)
{
    int t,i,j,k,ok,canton_prec,canton_cour,sens,inv,a,aig,pos;  // pour les boucles

    //1. maj master_selectif (met a zero si pas de detection et au moins une autre detection pour un train)
    for(t=0;t<NB_TRAIN;t++)
    {
        //1.1. ajout
        for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.res_auto[j][i]==0 && canton.num_train[j][i]==t && canton.master_selectif[j][i]==0 && vio_det[j][i]==1 && canton.update_selectif[j][i]==1) canton.master_selectif[j][i]=1;
        //1.2. retrait
        ok=0;  for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.num_train[j][i]==t && canton.master_selectif[j][i]==1 && vio_det[j][i]==1) ok=1;
        if(ok) for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.num_train[j][i]==t && canton.master_selectif[j][i]==1 && vio_det[j][i]==0) canton.master_selectif[j][i]=0;
    }
    for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.res_auto[j][i]==0 && canton.master_selectif[j][i]==0) canton.num_train[j][i]=-1;

    //2. maj des cantons adjacents aux cantons master
    for(j=0;j<4;j++) for(i=0;i<16;i++) canton.update_selectif[j][i]=0;
    for(t=0;t<NB_TRAIN;t++) /*if(train.vit[t]!=0)*/ if(train.vit[t]>5 || train.vit[t]<-5) if(train.enable[t])
    {
        for(j=0;j<4;j++) for(i=0;i<16;i++) if(canton.master_selectif[j][i]==0 && vio_det[j][i]==0 && canton.res_auto[j][i]==0 && canton.update_selectif[j][i]==0)
        {
            canton_cour=100*j+i;
            for(k=0;k<100;k++) if(descr[k][IND_CANT_COUR_NUM]!=-1) if(descr[k][IND_CANT_COUR_NUM]==100*j+i)
            {
                canton_prec=descr[k][IND_CANT_PREC_NUM];

                ok=1;
                for(a=0;a<6;a++)
                {
                    aig=descr[k][IND_AIG_NUM_BASE+2*a];
                    pos=descr[k][IND_AIG_POS_BASE+2*a];
                    if(aig!=-1) if(pos==0 && vio_aig_pos0[aig]==0) ok=0;
                    if(aig!=-1) if(pos==1 && vio_aig_pos1[aig]==0) ok=0;
                }

                if(ok) if(canton.num_train[canton_prec/100][canton_prec%100]==t && canton.master_selectif[canton_prec/100][canton_prec%100]==1 /*&& vio_det[canton_prec/100][canton_prec%100]==1*/)
                {
                    if(train.vit[t]>=0) sens=0; else sens=1;
                    if(canton.inv_selectif[canton_prec/100][canton_prec%100]) sens^=1;
                    if(descr[k][IND_CANT_PREC_SENS]==sens)
                    if(    (sens==0 && descr[k][IND_CANT_PREC_SENS]==descr[k][IND_CANT_COUR_SENS] && (canton.allowed_sens[j][i]&1))   // UU-NEW-SENS-allowed
                        || (sens==1 && descr[k][IND_CANT_PREC_SENS]==descr[k][IND_CANT_COUR_SENS] && (canton.allowed_sens[j][i]&2))   // UU-NEW-SENS-allowed
                        || (sens==0 && descr[k][IND_CANT_PREC_SENS]!=descr[k][IND_CANT_COUR_SENS] && (canton.allowed_sens[j][i]&2))   // UU-NEW-SENS-allowed
                        || (sens==1 && descr[k][IND_CANT_PREC_SENS]!=descr[k][IND_CANT_COUR_SENS] && (canton.allowed_sens[j][i]&1)) ) // UU-NEW-SENS-allowed
                    {
                        inv=canton.inv_selectif[canton_prec/100][canton_prec%100];
                        if(descr[k][IND_CANT_PREC_SENS]!=descr[k][IND_CANT_COUR_SENS]) inv^=1;
                        canton.inv_selectif[j][i]=inv;
                        canton.update_selectif[j][i]=1;
                        canton.num_train[j][i]=t;
                        //sprintf(gszErr,"\ncour=%d prec=%d",canton_cour,canton_prec); log(gszErr);
                    }
                }
            }
        }
    }

    //3. attribution des vitesses
    for(j=0;j<4;j++) for(i=0;i<16;i++)
    {
         t=canton.num_train[j][i];
         if(t!=-1 && canton.res_auto[j][i]==0 && (canton.master_selectif[j][i]==1 || canton.update_selectif[j][i]==1) )
         {
             if(canton.inv_selectif[j][i]==0) canton.vit_selectif[j][i]=train.vit[t]; else canton.vit_selectif[j][i]=0-train.vit[t];
         }
         else canton.vit_selectif[j][i]=0;
    }



}

void cSelectif::debug(int action)
{
}


/*****************************************************************************/
/* fin SELECTIF                                                              */
/*****************************************************************************/





/*****************************************************************************/
/* DEPLACEMENT                                                               */
/*****************************************************************************/
#define DEPL_TAB_NB                   100
#define DEPL_TAB_IND_CANT_0_NO          0
#define DEPL_TAB_IND_CANT_0_VIT         1
#define DEPL_TAB_IND_AIG_0_NO          16
#define DEPL_TAB_IND_AIG_0_POS         17
#define DEPL_TAB_IND_FIN_0_VAR         32
#define DEPL_TAB_IND_FIN_0_VAL         33
#define DEPL_TAB_IND_FIN_1_VAR         34
#define DEPL_TAB_IND_FIN_1_VAL         35
#define DEPL_TAB_IND_TAF               36
#define DEPL_TAB_IND_TSF               37
#define DEPL_TAB_IND_START_RUN         38
#define DEPL_TAB_IND_STOP              39
#define DEPL_TAB_IND_STEP              40
#define DEPL_TAB_IND_TEMPO             41
#define DEPL_TAB_IND_ACTION_OP         42
#define DEPL_TAB_IND_ACTION_VAR        43
#define DEPL_TAB_IND_TR_NUM_SAVE       50
#define DEPL_TAB_IND_TR_NUM_ONLY       51
#define DEPL_TAB_IND_CANT_START        52
#define DEPL_TAB_IND_CANT_START2       53
#define DEPL_TAB_IND_CANT_STOP         54
#define DEPL_TAB_IND_END_GARAGE_LOCKED 55
#define DEPL_TAB_IND_CONS              56
#define DEPL_TAB_IND_VIT               57
#define DEPL_TAB_IND_SRV_NO            58
#define DEPL_TAB_IND_SRV_VAL           59
#define DEPL_TAB_IND_NB                60
//int depl_tab[DEPL_TAB_NB][DEPL_TAB_IND_NB];  //declare plus haut

#define DEPL_CST_NB_MAX_CANT      8
#define DEPL_CST_NB_MAX_AIG       8
#define DEPL_CST_NB_MAX_ACTION    4

#define DEPL_CST_ACTION_OP_SET_DEB 0
#define DEPL_CST_ACTION_OP_SET_FIN 1
#define DEPL_CST_ACTION_OP_CLR_DEB 2
#define DEPL_CST_ACTION_OP_CLR_FIN 3
#define DEPL_CST_ACTION_OP_SET_CLR 4

#define DEPL_CST_STATE_IDLE           0
#define DEPL_CST_STATE_RESERVATION    1
#define DEPL_CST_STATE_ACTION_DEB     2
#define DEPL_CST_STATE_ACTION_AIG     3
#define DEPL_CST_STATE_WAIT_AIG       4
#define DEPL_CST_STATE_ACTION_CANTON  5
#define DEPL_CST_STATE_WAIT_FIN0      6
#define DEPL_CST_STATE_WAIT_FIN1      7
#define DEPL_CST_STATE_ACTION_TAF     8
#define DEPL_CST_STATE_WAIT_TAF       9
#define DEPL_CST_STATE_ACTION_CANTON0 10
#define DEPL_CST_STATE_ACTION_TSF     11
#define DEPL_CST_STATE_WAIT_TSF       12
#define DEPL_CST_STATE_ACTION_FIN     13
#define DEPL_CST_STATE_DERESERVATION  14

char* depl_state_name[]= { "DEPL_CST_STATE_IDLE",
                           "DEPL_CST_STATE_RESERVATION",
                           "DEPL_CST_STATE_ACTION_DEB",
                           "DEPL_CST_STATE_ACTION_AIG",
                           "DEPL_CST_STATE_WAIT_AIG",
                           "DEPL_CST_STATE_ACTION_CANTON",
                           "DEPL_CST_STATE_WAIT_FIN0",
                           "DEPL_CST_STATE_WAIT_FIN1",
                           "DEPL_CST_STATE_ACTION_TAF",
                           "DEPL_CST_STATE_WAIT_TAF",
                           "DEPL_CST_STATE_ACTION_CANTON0",
                           "DEPL_CST_STATE_ACTION_TSF",
                           "DEPL_CST_STATE_WAIT_TSF",
                           "DEPL_CST_STATE_ACTION_FIN",
                           "DEPL_CST_STATE_DERESERVATION"};


class cDeplacement
{
    public:

    char depl_name[DEPL_TAB_NB][50];

         cDeplacement(void);
    void init(char filename[]);
    void verif(void);
    void tick(void);
    void debug(int action);

    private:

    void follow_vit(void);
};

cDeplacement::cDeplacement(void)
{
//    int i,j;
//    for(i=0;i<16;i++)
}

void cDeplacement::init(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int  ch_nb,j,i;
    int  no_depl,i_cant,i_aig,i_action;
    int  no,var,val;

    for(j=0;j<DEPL_TAB_NB;j++) for(i=0;i<DEPL_TAB_IND_NB;i++) depl_tab[j][i]=-1;
    for(j=0;j<DEPL_TAB_NB;j++)
    {
        depl_tab[j][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_IDLE;
        depl_tab[j][DEPL_TAB_IND_START_RUN]=0;
        depl_tab[j][DEPL_TAB_IND_STOP]=0;
        depl_tab[j][DEPL_TAB_IND_TEMPO]=0;
    }
    for(j=0;j<16;j++) vio_canton_res[j]=0;
    for(j=0;j<32;j++) vio_aig_res[j]=0;
    for(j=0;j<DEPL_TAB_NB;j++) depl_name[j][0]='\0';

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des deplacements","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    moins_char_normal=0;
    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#depl"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                i=0;
                while(i<ch_nb)
                {
                    // d0
                    if((ch_nb-i)>=1)
                    if( ch_tab[i][0]=='d')
                    {
                        no_depl=atoi(&ch_tab[i][1]);
                        i_cant=0;
                        i_aig=0;
                        i_action=0;
                        i=i+1;
                        continue;
                    }

                    // sdeb:io_det_0
                    if((ch_nb-i)>=3)
                    if( !strcmp(ch_tab[i],"sdeb") || !strcmp(ch_tab[i],"cdeb") ||
                        !strcmp(ch_tab[i],"sfin") || !strcmp(ch_tab[i],"cfin") ||
                        !strcmp(ch_tab[i],"sc") )
                    if( ch_tab[i+1][0]==':')
                    {
                        if(!strcmp(ch_tab[i],"sdeb")) depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+i_action*2]=DEPL_CST_ACTION_OP_SET_DEB;
                        if(!strcmp(ch_tab[i],"cdeb")) depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+i_action*2]=DEPL_CST_ACTION_OP_CLR_DEB;
                        if(!strcmp(ch_tab[i],"sfin")) depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+i_action*2]=DEPL_CST_ACTION_OP_SET_FIN;
                        if(!strcmp(ch_tab[i],"cfin")) depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+i_action*2]=DEPL_CST_ACTION_OP_CLR_FIN;
                        if(!strcmp(ch_tab[i],"sc"  )) depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+i_action*2]=DEPL_CST_ACTION_OP_SET_CLR;
                        if(pio_define_convert(ch_tab[i+2],ch_syst)==0) strcpy(ch_syst,ch_tab[i+2]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) depl_tab[no_depl][DEPL_TAB_IND_ACTION_VAR+i_action*2]=var;
                        i_action++;
                        i=i+3;
                        continue;
                    }

                    // start2:c1
                    if((ch_nb-i)>=3)
                    if( STR_SAME strcmp(ch_tab[i],"start2") )
                    if( ch_tab[i+1][0]==':')
                    if( ch_tab[i+2][0]=='c')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_START2]=atoi(&ch_tab[i+2][1]);
                        i=i+3;
                        continue;
                    }

                    // start:c1
                    if((ch_nb-i)>=3)
                    if( STR_SAME strcmp(ch_tab[i],"start") )
                    if( ch_tab[i+1][0]==':')
                    if( ch_tab[i+2][0]=='c')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_START]=atoi(&ch_tab[i+2][1]);
                        i=i+3;
                        continue;
                    }

                    // start:g3
                    if((ch_nb-i)>=3)
                    if( STR_SAME strcmp(ch_tab[i],"start") )
                    if( ch_tab[i+1][0]==':')
                    if( ch_tab[i+2][0]=='g')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_START]=1000+atoi(&ch_tab[i+2][1]); //1000 for garage
                        i=i+3;
                        continue;
                    }

                    // stop:c1
                    if((ch_nb-i)>=3)
                    if( STR_SAME strcmp(ch_tab[i],"stop") )
                    if( ch_tab[i+1][0]==':')
                    if( ch_tab[i+2][0]=='c')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_STOP]=atoi(&ch_tab[i+2][1]);
                        i=i+3;
                        continue;
                    }

                    // stop:g3
                    if((ch_nb-i)>=3)
                    if( STR_SAME strcmp(ch_tab[i],"stop") )
                    if( ch_tab[i+1][0]==':')
                    if( ch_tab[i+2][0]=='g')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_STOP]=1000+atoi(&ch_tab[i+2][1]);
                        i=i+3;
                        continue;
                    }

                    // train:1
                    if((ch_nb-i)>=3)
                    if( STR_SAME strcmp(ch_tab[i],"train") )
                    if( ch_tab[i+1][0]==':')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_ONLY]=atoi(ch_tab[i+2]);
                        i=i+3;
                        continue;
                    }

                    // c0+12
                    if((ch_nb-i)>=3)
                    if( ch_tab[i][0]=='c' && (ch_tab[i+1][0]=='+' || ch_tab[i+1][0]=='-') )
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+i_cant*2]=atoi(&ch_tab[i][1]);
                        if(ch_tab[i+1][0]=='+') depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+i_cant*2]=atoi(ch_tab[i+2]);
                        if(ch_tab[i+1][0]=='-') depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+i_cant*2]=0-atoi(ch_tab[i+2]);
                        i_cant++;
                        i=i+3;
                        continue;
                    }

                    // g3
                    if((ch_nb-i)>=1)
                    if( ch_tab[i][0]=='g' )
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+i_cant*2]=1000+atoi(&ch_tab[i][1]);
                        depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+i_cant*2]=-1;
                        i_cant++;
                        i=i+1;
                        continue;
                    }

                    // a3.1
                    if((ch_nb-i)>=3)
                    if( ch_tab[i][0]=='a' && ch_tab[i+1][0]=='.')
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_AIG_0_NO +i_aig*2]=atoi(&ch_tab[i][1]);
                        depl_tab[no_depl][DEPL_TAB_IND_AIG_0_POS+i_aig*2]=atoi(ch_tab[i+2]);
                        i_aig++;
                        i=i+3;
                        continue;
                    }

                    // taf2
                    if((ch_nb-i)>=1)
                    if( !strncmp(ch_tab[i],"taf",3) )
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_TAF]=atoi(&ch_tab[i][3]);
                        i=i+1;
                        continue;
                    }

                    // tsf3
                    if((ch_nb-i)>=1)
                    if( !strncmp(ch_tab[i],"tsf",3) )
                    {
                        depl_tab[no_depl][DEPL_TAB_IND_TSF]=atoi(&ch_tab[i][3]);
                        i=i+1;
                        continue;
                    }

                    // fin0:io_det_0
                    if((ch_nb-i)>=3)
                    if( !strncmp(ch_tab[i],"fin",3) && ch_tab[i+1][0]==':' && ch_tab[i+2][0]!='!')
                    {
                        no=atoi(&ch_tab[i][3]);
                        depl_tab[no_depl][DEPL_TAB_IND_FIN_0_VAL+2*no]=1;
                        if(pio_define_convert(ch_tab[i+2],ch_syst)==0) strcpy(ch_syst,ch_tab[i+2]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) depl_tab[no_depl][DEPL_TAB_IND_FIN_0_VAR+2*no]=var;
                        i=i+3;
                        continue;
                    }

                    // fin0:!io_det_0
                    if((ch_nb-i)>=4)
                    if( !strncmp(ch_tab[i],"fin",3) && ch_tab[i+1][0]==':' && ch_tab[i+2][0]=='!')
                    {
                        no=atoi(&ch_tab[i][3]);
                        depl_tab[no_depl][DEPL_TAB_IND_FIN_0_VAL+2*no]=0;
                        if(pio_define_convert(ch_tab[i+3],ch_syst)==0) strcpy(ch_syst,ch_tab[i+3]);
                        if((var=pio_var_ch2int(ch_syst))!=-1) depl_tab[no_depl][DEPL_TAB_IND_FIN_0_VAR+2*no]=var;
                        i=i+4;
                        continue;
                    }

                    // name:DE_gare_voie3_A_entree
                    if((ch_nb-i)>=3)
                    if( !strncmp(ch_tab[i],"name",3) && ch_tab[i+1][0]==':')
                    {
                        strcpy(depl_name[no_depl],ch_tab[i+2]);
                        i=i+3;
                        continue;
                    }

                    // srv0:27
                    if((ch_nb-i)>=3)
                    if( !strncmp(ch_tab[i],"srv",3) && ch_tab[i+1][0]==':')
                    {
                        no=atoi(&ch_tab[i][3]);
                        val=atoi(ch_tab[i+2]);
                        depl_tab[no_depl][DEPL_TAB_IND_SRV_NO]=no;
                        depl_tab[no_depl][DEPL_TAB_IND_SRV_VAL]=val;
                        i=i+3;
                        continue;
                    }


                    strcpy(ch_error,"Deplacement Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine
        }      //fin #depl
    }        //fin file
    moins_char_normal=1;

    fclose(pf);

}

void cDeplacement::verif(void)
{
    FILE* pf;
    int i,j;

    if((pf=fopen("debug_depl.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_depl.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(j=0;j<DEPL_TAB_NB;j++)
    {
        fprintf(pf,"\n%3d:",j);
        for(i=0;i<DEPL_TAB_IND_NB;i++) fprintf(pf," %4d",depl_tab[j][i]);
    }

    fclose(pf);
}


void cDeplacement::tick(void)
{
    int no_depl,cant,cant_start,cant_start1,cant_start2,cant_stop,aig,tempo,action,ok,ok1,ok2,i,var,val,nop,pos,vit,t,t1,t2,t_only,g,g_start,g_stop,s;

    for(no_depl=0;no_depl<DEPL_TAB_NB;no_depl++)
    {
        if(depl_tab[no_depl][DEPL_TAB_IND_STOP])
        {
            depl_tab[no_depl][DEPL_TAB_IND_STOP]=0;
            if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_RESERVATION)
            {
                depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_IDLE;
                depl_tab[no_depl][DEPL_TAB_IND_START_RUN]=0;
            }
            else if(depl_tab[no_depl][DEPL_TAB_IND_STEP]!=DEPL_CST_STATE_IDLE)
                depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_FIN;
        }

        //DEPL_CST_STATE_IDLE
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_IDLE)
        {
            if(depl_tab[no_depl][DEPL_TAB_IND_START_RUN]==0) continue;
            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_RESERVATION;
        }

        //DEPL_CST_STATE_RESERVATION
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_RESERVATION)
        {
            //verification train sur canton start
            ok=1;
            cant_start1=depl_tab[no_depl][DEPL_TAB_IND_CANT_START];
            cant_start2=depl_tab[no_depl][DEPL_TAB_IND_CANT_START2];
            cant_start=-1;
            g_start=-1;
            if(cant_start1>1000 || cant_start2>1000)
            {
                if(cant_start1>=1000) g_start=cant_start1-1000; else g_start=cant_start2-1000;
                if(vio_garage_lock_res[g_start]==1) continue;
                if(vio_garage_lock_status[g_start]==0) continue;
                t=garage.num_train[g_start];
                if(t==-1) continue;
            }
            else
            {
                ok1=ok2=0;
                if(cant_start1!=-1) if(canton.master_selectif[cant_start1/100][cant_start1%100]) { ok1=1; t1=canton.num_train[cant_start1/100][cant_start1%100]; }
                if(cant_start2!=-1) if(canton.master_selectif[cant_start2/100][cant_start2%100]) { ok2=1; t2=canton.num_train[cant_start2/100][cant_start2%100]; }
                if(ok1 && ok2) if(t1!=t2) ok1=ok2=0;
                if(ok1) { cant_start=cant_start1; t=t1; }
                if(ok2) { cant_start=cant_start2; t=t2; }
                if(cant_start==-1 || t==-1) continue;
            }
            if(train.en_auto[t]==0 || train.enable[t]==0) ok=0;
            t_only=depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_ONLY];
            if(t_only!=-1 && t_only!=t) ok=0;
            depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_SAVE]=t;
            // verification canton libres
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                if(cant<1000)
                {
                    if(cant!=-1) if(canton.res_auto[cant/100][cant%100]==1) ok=0;
                    if(cant!=-1) if(cant!=cant_start1 && cant!=cant_start2) if(canton.master_selectif[cant/100][cant%100]==1) ok=0;
                }
                else
                {
                    g=cant-1000;
                    if(vio_garage_lock_res[g]==1) ok=0;
                    if(g!=g_start) if(vio_garage_lock_status[g]==1) ok=0;
                }

                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];                     // UU-NEW-SENS
                vit=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+2*i];                     // UU-NEW-SENS
                if(cant!=-1) if(cant<1000)                                              // UU-NEW-SENS
                {                                                                       // UU-NEW-SENS
                    if(vit>0 && (canton.allowed_sens[cant/100][cant%100]&1)==0) ok=0;   // UU-NEW-SENS
                    if(vit<0 && (canton.allowed_sens[cant/100][cant%100]&2)==0) ok=0;   // UU-NEW-SENS
                }                                                                       // UU-NEW-SENS

            }
            // verification aiguillages libres
            for(i=0;i<DEPL_CST_NB_MAX_AIG;i++)
            {
                aig=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_NO+2*i];
                if(aig!=-1) if(vio_aig_res[aig]==1) {ok=0;break;}
            }
            // verification servo libre
            s=depl_tab[no_depl][DEPL_TAB_IND_SRV_NO];
            if(s!=-1)
            {
                if(vio_srv_res[s/100][s%100]) ok=0;
            }
            // si verifications positives alors reservation cantons, aiguillages et servo
            if(ok)
            {
                for(i=0;i<8;i++)
                {
                    cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                    if(cant!=-1) if(cant<1000)
                    {
                        canton.res_auto[cant/100][cant%100]=1;
                        canton.vit_auto[cant/100][cant%100]=0;
                        canton.master_selectif[cant/100][cant%100]=0;
                        canton.num_train[cant/100][cant%100]=t;
                    }
                    if(cant>1000)
                    {
                        g=cant-1000;
                        vio_garage_lock_res[g]=1;
                    }
                }
                for(i=0;i<DEPL_CST_NB_MAX_AIG;i++)
                {
                    aig=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_NO+2*i];
                    if(aig!=-1) vio_aig_res[aig]=1;
                }
                s=depl_tab[no_depl][DEPL_TAB_IND_SRV_NO];
                if(s!=-1)
                {
                    vio_srv_res[s/100][s%100]=1;
                }

                t=depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_SAVE];
                strcpy(train.mode[t],"AUTO");

                depl_tab[no_depl][DEPL_TAB_IND_END_GARAGE_LOCKED]=0;
                depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_DEB;
            }
        }

        //DEPL_CST_STATE_ACTION_DEB
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_DEB)
        {
            for(i=0;i<DEPL_CST_NB_MAX_ACTION;i++)
            if((action=depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+2*i])!=-1)
            {
                var=depl_tab[no_depl][DEPL_TAB_IND_ACTION_VAR+2*i];
                if(action==DEPL_CST_ACTION_OP_SET_DEB ||action==DEPL_CST_ACTION_OP_SET_CLR) pio_set_val(var,1);
                if(action==DEPL_CST_ACTION_OP_CLR_DEB)                                      pio_set_val(var,0);
            }
            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_AIG;
        }

        //DEPL_CST_STATE_ACTION_AIG (et servo)
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_AIG)
        {
            for(i=0;i<DEPL_CST_NB_MAX_AIG;i++)
            {
                aig=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_NO+2*i];
                pos=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_POS+2*i];

                if(aig!=-1)  vio_aig_cmd[aig]=pos;
            }

            s=depl_tab[no_depl][DEPL_TAB_IND_SRV_NO];
            if(s!=-1)
            {
                val=depl_tab[no_depl][DEPL_TAB_IND_SRV_VAL];
                vio_srv_cmd[s/100][s%100]=val;
            }

            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_WAIT_AIG;
        }

        //DEPL_CST_STATE_WAIT_AIG (et servo)
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_AIG)
        {
            ok=1;

            for(i=0;i<DEPL_CST_NB_MAX_AIG;i++)
            {
                aig=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_NO+2*i];
                pos=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_POS+2*i];

                if(aig!=-1) if(pos==0 && vio_aig_pos0[aig]==0) ok=0;
                if(aig!=-1) if(pos==1 && vio_aig_pos1[aig]==0) ok=0;
            }

            s=depl_tab[no_depl][DEPL_TAB_IND_SRV_NO];
            if(s!=-1)
            {
                val=depl_tab[no_depl][DEPL_TAB_IND_SRV_VAL];
                if(vio_srv[s/100][s%100]!=val) ok=0;
            }

            if(ok) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_CANTON;
        }

        //DEPL_CST_STATE_ACTION_CANTON
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_CANTON)
        {
            // unlock
            cant_start1=depl_tab[no_depl][DEPL_TAB_IND_CANT_START];
            cant_start2=depl_tab[no_depl][DEPL_TAB_IND_CANT_START2];
            if(cant_start1>1000 ||cant_start2>1000)
            {
                if(cant_start1>=1000) g_start=cant_start1-1000; else g_start=cant_start2-1000;
                vio_garage_lock_cmd[g_start]=0; //unlock
                vio_garage_lock_status[g_start]=0; //unlock
                garage.num_train[g_start]=-1;
                t=depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_SAVE];
                train.cant_lock[t]=-1;
            }

            // set vit
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                vit=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+2*i];

                if(cant!=-1) if(cant<1000) canton.vit_auto[cant/100][cant%100]=vit;
            }

            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_WAIT_FIN0;
        }

        //DEPL_CST_STATE_WAIT_FIN0
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_FIN0)
        {
            var=depl_tab[no_depl][DEPL_TAB_IND_FIN_0_VAR];
            val=depl_tab[no_depl][DEPL_TAB_IND_FIN_0_VAL];

            if(var==-1) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_WAIT_FIN1;
            else if(pio_get_val(var)==val) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_WAIT_FIN1;
        }

        //DEPL_CST_STATE_WAIT_FIN1
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_FIN1)
        {
            var=depl_tab[no_depl][DEPL_TAB_IND_FIN_1_VAR];
            val=depl_tab[no_depl][DEPL_TAB_IND_FIN_1_VAL];

            if(var==-1) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_TAF;
            else if(pio_get_val(var)==val) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_TAF;
        }

        //DEPL_CST_STATE_ACTION_TAF
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_TAF)
        {
            if((tempo=depl_tab[no_depl][DEPL_TAB_IND_TAF])==-1) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_CANTON0;
            else
            {
                depl_tab[no_depl][DEPL_TAB_IND_TEMPO]=tempo*4;
                depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_WAIT_TAF;
            }
        }

        //DEPL_CST_STATE_WAIT_TAF
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_TAF)
        {
            if((tempo=depl_tab[no_depl][DEPL_TAB_IND_TEMPO])==0) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_CANTON0;
            else depl_tab[no_depl][DEPL_TAB_IND_TEMPO]--;
        }

        //DEPL_CST_STATE_ACTION_CANTON0
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_CANTON0) if(depl_tab[no_depl][DEPL_TAB_IND_VIT]==0)
        {
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];

                if(cant!=-1) if(cant<1000) canton.vit_auto[cant/100][cant%100]=0;
            }

            g_stop=depl_tab[no_depl][DEPL_TAB_IND_CANT_STOP];
            if(g_stop>1000)
            {
                g_stop=g_stop-1000;
                cant_stop=garage.ass_canton[g_stop];
                if(cant_stop!=-1) if(vio_det[cant_stop])
                {
                    vio_garage_lock_cmd[g_stop]=1; //lock
                    vio_garage_lock_status[g_stop]=1; //lock
                    t=depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_SAVE];
                    garage.num_train[g_stop]=t;
                    train.cant_lock[t]=g_stop;
                    depl_tab[no_depl][DEPL_TAB_IND_END_GARAGE_LOCKED]=1;
                }
            }

            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_TSF;
        }

        //DEPL_CST_STATE_ACTION_TSF
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_TSF)
        {
            if((tempo=depl_tab[no_depl][DEPL_TAB_IND_TSF])==-1) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_FIN;
            else
            {
                depl_tab[no_depl][DEPL_TAB_IND_TEMPO]=tempo*4;
                depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_WAIT_TSF;
            }
        }

        //DEPL_CST_STATE_WAIT_TSF
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_TSF)
        {
            if((tempo=depl_tab[no_depl][DEPL_TAB_IND_TEMPO])==0) depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_ACTION_FIN;
            else depl_tab[no_depl][DEPL_TAB_IND_TEMPO]--;
        }

        //DEPL_CST_STATE_ACTION_FIN
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_FIN)
        {
            for(i=0;i<DEPL_CST_NB_MAX_ACTION;i++)
            if((action=depl_tab[no_depl][DEPL_TAB_IND_ACTION_OP+2*i])!=-1)
            {
                var=depl_tab[no_depl][DEPL_TAB_IND_ACTION_VAR+2*i];
                if(action==DEPL_CST_ACTION_OP_SET_FIN) pio_set_val(var,1);
                if(action==DEPL_CST_ACTION_OP_CLR_FIN ||action==DEPL_CST_ACTION_OP_SET_CLR) pio_set_val(var,0);
            }
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)      //refait canton=0 si stop (on ne verouille pas le garage fin car on ne sait pas ou est le train qui passe donc en selectif)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];

                if(cant!=-1) if(cant<1000) canton.vit_auto[cant/100][cant%100]=0;
            }
            depl_tab[no_depl][DEPL_TAB_IND_TEMPO]=0; //plus beau en debug si stop

            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_DERESERVATION;
        }

        //DEPL_CST_STATE_DERESERVATION
        if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_DERESERVATION)
        {
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                if(cant!=-1) if(cant<1000)                                 // NE PAS METTRE EN SELECTIF SI GARAGE FINAL (et train sur canton final)
                {
                    if(cant!=-1) canton.res_auto[cant/100][cant%100]=0;
                    if(depl_tab[no_depl][DEPL_TAB_IND_END_GARAGE_LOCKED]==0)
                            canton.master_selectif[cant/100][cant%100]=1; // selectif va ensuite garder le canton ou il y a detection
                                                                          // fonctionne egalement si arret premature
                    else    canton.num_train[cant/100][cant%100]=-1;
                }
                if(cant>1000)
                {
                    g=cant-1000;
                    vio_garage_lock_res[g]=0;
                }
            }

            for(i=0;i<DEPL_CST_NB_MAX_AIG;i++)
            {
                aig=depl_tab[no_depl][DEPL_TAB_IND_AIG_0_NO+2*i];
                if(aig!=-1) vio_aig_res[aig]=0;
            }

            s=depl_tab[no_depl][DEPL_TAB_IND_SRV_NO];
            if(s!=-1)
            {
                vio_srv_res[s/100][s%100]=0;
            }

            t=depl_tab[no_depl][DEPL_TAB_IND_TR_NUM_SAVE];
            strcpy(train.mode[t],"SEL");
            depl_tab[no_depl][DEPL_TAB_IND_STEP]=DEPL_CST_STATE_IDLE;
            depl_tab[no_depl][DEPL_TAB_IND_START_RUN]=0;
        }

    }//fin for each depl

    follow_vit();
}


void cDeplacement::follow_vit(void)
{
    int no_depl,i,cons,vit,vit_cant,cant;

    for(no_depl=0;no_depl<DEPL_TAB_NB;no_depl++)
    {
        // 1. Regulation de la vitesse
        if(   depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_FIN0
           || depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_FIN1
           || depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_TAF
           || depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_WAIT_TAF  )
        {
            // 1.1. Recherche de la consigne (plus basse vitesse des cantons en detection)
            if(depl_tab[no_depl][DEPL_TAB_IND_CONS]==-1) depl_tab[no_depl][DEPL_TAB_IND_CONS]=30; //anti blocage pour le depart
            cons=-1;
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                if(cant!=-1) if(cant<1000)
                {
                    if(vio_det[cant/100][cant%100])
                    {
                        vit_cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+2*i];
                        if(vit_cant<0) vit_cant=0-vit_cant;
                        if(cons==-1 || vit<cons) cons=vit_cant;
                    }
                }
            }
            if(cons!=-1) depl_tab[no_depl][DEPL_TAB_IND_CONS]=cons;

            // 1.2. Calcul de la vitesse
            cons=depl_tab[no_depl][DEPL_TAB_IND_CONS];
            vit =depl_tab[no_depl][DEPL_TAB_IND_VIT ];

            if(cons>vit) { vit+=5; if(vit>cons) vit=cons; }
            if(cons<vit) { vit-=5; if(vit<cons) vit=cons; }

            depl_tab[no_depl][DEPL_TAB_IND_VIT ]=vit;

            // 1.3. Attribution aux cantons
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                if(cant!=-1) if(cant<1000)
                {
                    vit_cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+2*i];
                    if(vit_cant>=0) canton.vit_auto[cant/100][cant%100]=vit;
                    else            canton.vit_auto[cant/100][cant%100]=0-vit;
                }
            }
        }
        // 2. Freinage pour arret
        else if(depl_tab[no_depl][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_ACTION_CANTON0)
        {
            // 2.1. calcul de la vitesse (consigne a 0)
            vit =depl_tab[no_depl][DEPL_TAB_IND_VIT ];
            vit-=7; if(vit<0) vit=0;
            depl_tab[no_depl][DEPL_TAB_IND_VIT ]=vit;

            // 2.2.  Attribution aux cantons
            for(i=0;i<DEPL_CST_NB_MAX_CANT;i++)
            {
                cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_NO+2*i];
                if(cant!=-1) if(cant<1000)
                {
                    vit_cant=depl_tab[no_depl][DEPL_TAB_IND_CANT_0_VIT+2*i];
                    if(vit_cant>=0) canton.vit_auto[cant/100][cant%100]=vit;
                    else            canton.vit_auto[cant/100][cant%100]=0-vit;
                }
            }
        }
        // 3. Hors regulation
        else
        {
            depl_tab[no_depl][DEPL_TAB_IND_CONS]=-1;
            depl_tab[no_depl][DEPL_TAB_IND_VIT ]=0;
        }

    }
}


void cDeplacement::debug(int action)
{
    int i,j,x,y;
    static int depl_deb=0;
    char ch[100];

    if(action==DEBUG_MOUSE)
    {
        i=(y_mouse-20)/20;
        if(i<30 && ((depl_deb+i)<DEPL_TAB_IND_NB))
        {
            if(x_mouse>30 && x_mouse<70 ) depl_tab[depl_deb+i][DEPL_TAB_IND_START_RUN]=1;
            if(x_mouse>70 && x_mouse<110) depl_tab[depl_deb+i][DEPL_TAB_IND_STOP]=1;
        }
    }

    if(action==DEBUG_KEY)
    {
        if(touche_char=='+') if(depl_deb<(DEPL_TAB_NB-1)) depl_deb++;
        if(touche_char=='-') if(depl_deb>0) depl_deb--;
    }

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);
    //Rectangle(hdc,0,0,800,600);    // trop lent

    Rectangle(hdc,0,0,800,20);
    EasyLine( 30,0, 30,20);
    EasyLine( 70,0, 70,20);
    EasyLine(110,0,110,20);
    EasyLine(150,0,150,20);
    EasyLine(400,0,400,20);
    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));
    EasyTextOut(    10,2,"No"   );
    EasyTextOut( 30+02,2,"Start");
    EasyTextOut( 70+05,2,"Stop" );
    EasyTextOut(110+02,2,"Tempo");
    EasyTextOut(150+10,2,"State");
    EasyTextOut(400+10,2,"Name" );
    EasyLine( 60,20, 70,10);
    EasyLine(100,20,110,10);


    SetTextColor(hdc,RGB(0,0,255));
    for(i=0;i<30;i++)
    {
        if(depl_tab[depl_deb+i][DEPL_TAB_IND_STEP]==DEPL_CST_STATE_RESERVATION) SelectObject(hdc,bmp_pinceau_jaune);
        else if(depl_tab[depl_deb+i][DEPL_TAB_IND_START_RUN])                   SelectObject(hdc,bmp_pinceau_vert);
        else                                                                    SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,0,20*i+20,800,20*i+20+20);
        EasyLine( 30,20*i+20, 30,20*i+20+20);
        EasyLine( 70,20*i+20, 70,20*i+20+20);
        EasyLine(110,20*i+20,110,20*i+20+20);
        EasyLine(150,20*i+20,150,20*i+20+20);
        EasyLine(400,20*i+20,400,20*i+20+20);
        if((depl_deb+i)>=DEPL_TAB_NB) break;
        sprintf(ch,"%d",depl_deb+i);                                            EasyTextOut(    10,22+20*i,ch);
        sprintf(ch,"%d",depl_tab[depl_deb+i][DEPL_TAB_IND_START_RUN]);          EasyTextOut( 30+10,22+20*i,ch);
        sprintf(ch,"%d",depl_tab[depl_deb+i][DEPL_TAB_IND_STOP]);               EasyTextOut( 70+10,22+20*i,ch);
        sprintf(ch,"%d",depl_tab[depl_deb+i][DEPL_TAB_IND_TEMPO]);              EasyTextOut(110+10,22+20*i,ch);
        strcpy(ch,depl_state_name[depl_tab[depl_deb+i][DEPL_TAB_IND_STEP]]);    EasyTextOut(150+10,22+20*i,ch);
        strcpy(ch,depl_name[depl_deb+i]);                                       EasyTextOut(400+10,22+20*i,ch);
    }
}


/*****************************************************************************/
/* fin DEPLACEMENT                                                           */
/*****************************************************************************/





/*****************************************************************************/
/* AIG                                                                       */
/*****************************************************************************/

#define SM_IDLE   0
#define SM_PREP   1
#define SM_GO     2
#define SM_LIB    3

#define AIG_DROIT 0
#define AIG_DEVIE 1

#define AIG_NB                    64
#define AIG_DESCR_IND_PREP_POS_0   0
#define AIG_DESCR_IND_GO_POS_0     1
#define AIG_DESCR_IND_LIB_POS_0    2
#define AIG_DESCR_IND_PREP_POS_1   3
#define AIG_DESCR_IND_GO_POS_1     4
#define AIG_DESCR_IND_LIB_POS_1    5
#define AIG_DESCR_IND_OUT_NO_0     0
#define AIG_DESCR_IND_OUT_VAL_0    1
#define AIG_DESCR_IND_TIME        16
#define AIG_DESCR_NB_OUT           8

#define AIG_DESCR_IDLE_NB_OUT          40
#define AIG_DESCR_IDLE_IND_OUT_NO_0     0
#define AIG_DESCR_IDLE_IND_OUT_VAL_0    1

#define AIG_DESCR_INFO_IND_NB              5
#define AIG_DESCR_INFO_IND_EXIST           0
#define AIG_DESCR_INFO_IND_VERIF_NUM_POS_0 1
#define AIG_DESCR_INFO_IND_VERIF_VAL_POS_0 2
#define AIG_DESCR_INFO_IND_VERIF_NUM_POS_1 3
#define AIG_DESCR_INFO_IND_VERIF_VAL_POS_1 4

int aig_descr[AIG_NB][6][2*AIG_DESCR_NB_OUT+1]; //64 aig, 3 modes: PREP,GO,LIB 2*nbsorties+time
int aig_descr_idle[2*AIG_DESCR_IDLE_NB_OUT];    //40 variables (no + val);
int aig_descr_info[AIG_NB][AIG_DESCR_INFO_IND_NB];
int aig_enable;
int aig_cpt;
int aig_state;
int aig_select;
int aig_pos_select;

void aig_init_file(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100],ch_error[200],ch_syst[100];
    int  ch_nb,i,j,k,ok,aig_no=0,op=0,ind=0,var;

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des aiguillages","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    aig_state=SM_IDLE;
    aig_enable=1;
    aig_cpt=0;
    aig_select=-1;    //car preincrementation
    aig_pos_select=0;
    for(i=0;i<AIG_NB;i++) for(j=0;j<6;j++) for(k=0;k<(2*AIG_DESCR_NB_OUT+1);k++) aig_descr[i][j][k]=-1;
    for(i=0;i<2*AIG_DESCR_IDLE_NB_OUT;i++)                                       aig_descr_idle[i]=-1;
    for(i=0;i<AIG_NB;i++) for(j=1;j<AIG_DESCR_INFO_IND_NB;j++)                   aig_descr_info[i][j]=-1;
    for(i=0;i<AIG_NB;i++)                                                        aig_descr_info[i][0]=0;
    for(i=0;i<AIG_NB;i++)                                                        vio_aig_res[i]=0;
    for(i=0;i<AIG_NB;i++)                                                        vio_aig_pos0[i]=vio_aig_pos1[i]=0;  //pour obliger a mettre en position 0
    for(i=0;i<AIG_NB;i++)                                                        vio_aig_cmd[i]=0;


    // aig0:  prep0:      out0=0 out1=0 out2=0 tic=1
    //        go0:        out0=0 out1=1 out2=0 tic=2
    //        lib0:       out0=0 out1=0 out2=0 tic=1
    //        prep1,lib1: out0=1 out1=0 out2=0 tic=1
    //        go1:        out0=1 out1=1 out2=0 tic=2
    //        verif0:     io_in_25=0
    //        verif1:     io_in_25=1
    // repos:             out0=0 out1=0 out2=0
    // default_tic:1,2,1,1,2,1

    op=-1; //repos
    ind=0;
    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#aig"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                if(ch_tab[0][0]==']') break;

                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments

                i=0;
                while(i<ch_nb)
                {
                    if((ch_nb-i)>=2)
                    if( !strncmp(ch_tab[i],"aig",3) && ch_tab[i+1][0]==':' )
                    {
                        aig_no=atoi(&ch_tab[i][3]);
                        aig_descr_info[aig_no][AIG_DESCR_INFO_IND_EXIST]=1;
                        i=i+2;
                        continue;
                    }

                    if((ch_nb-i)>=2)
                    if(ch_tab[i+1][0]==':' )
                    {
                        ok=1;
                        if(     !strcmp(ch_tab[i],"prep0"))    {op=AIG_DESCR_IND_PREP_POS_0; ind=0;}
                        else if(!strcmp(ch_tab[i],"prep1"))    {op=AIG_DESCR_IND_PREP_POS_1; ind=0;}
                        else if(!strcmp(ch_tab[i],"go0"  ))    {op=AIG_DESCR_IND_GO_POS_0  ; ind=0;}
                        else if(!strcmp(ch_tab[i],"go1"  ))    {op=AIG_DESCR_IND_GO_POS_1  ; ind=0;}
                        else if(!strcmp(ch_tab[i],"lib0" ))    {op=AIG_DESCR_IND_LIB_POS_0 ; ind=0;}
                        else if(!strcmp(ch_tab[i],"lib1" ))    {op=AIG_DESCR_IND_LIB_POS_1 ; ind=0;}
                        else if(!strcmp(ch_tab[i],"repos"))    {op=-1                      ; ind=0;}
                        else if(!strcmp(ch_tab[i],"preplib0")) {op=-2                      ; ind=0;}
                        else if(!strcmp(ch_tab[i],"preplib1")) {op=-3                      ; ind=0;}
                        else ok=0;
                        if(ok) {i=i+2;continue;}
                    }

                    if((ch_nb-i)>=3)
                    if( !strncmp(ch_tab[i],"out",3) && ch_tab[i+1][0]=='=' )
                    {
                        if(op!=-1 && op!=-2 && op!=-3)
                        {
                            aig_descr[aig_no][op][2*ind+AIG_DESCR_IND_OUT_NO_0]=atoi(&ch_tab[i][3]);
                            aig_descr[aig_no][op][2*ind+AIG_DESCR_IND_OUT_VAL_0]=atoi(ch_tab[i+2]);
                        }
                        else if(op==-1)
                        {
                            aig_descr_idle[2*ind+AIG_DESCR_IDLE_IND_OUT_NO_0]=atoi(&ch_tab[i][3]);
                            aig_descr_idle[2*ind+AIG_DESCR_IDLE_IND_OUT_VAL_0]=atoi(ch_tab[i+2]);
                        }
                        else if(op==-2)
                        {
                            aig_descr[aig_no][AIG_DESCR_IND_PREP_POS_0][2*ind+AIG_DESCR_IND_OUT_NO_0 ]=atoi(&ch_tab[i][3]);
                            aig_descr[aig_no][AIG_DESCR_IND_PREP_POS_0][2*ind+AIG_DESCR_IND_OUT_VAL_0]=atoi(ch_tab[i+2]);
                            aig_descr[aig_no][AIG_DESCR_IND_LIB_POS_0 ][2*ind+AIG_DESCR_IND_OUT_NO_0 ]=atoi(&ch_tab[i][3]);
                            aig_descr[aig_no][AIG_DESCR_IND_LIB_POS_0 ][2*ind+AIG_DESCR_IND_OUT_VAL_0]=atoi(ch_tab[i+2]);
                        }
                        else if(op==-3)
                        {
                            aig_descr[aig_no][AIG_DESCR_IND_PREP_POS_1][2*ind+AIG_DESCR_IND_OUT_NO_0 ]=atoi(&ch_tab[i][3]);
                            aig_descr[aig_no][AIG_DESCR_IND_PREP_POS_1][2*ind+AIG_DESCR_IND_OUT_VAL_0]=atoi(ch_tab[i+2]);
                            aig_descr[aig_no][AIG_DESCR_IND_LIB_POS_1 ][2*ind+AIG_DESCR_IND_OUT_NO_0 ]=atoi(&ch_tab[i][3]);
                            aig_descr[aig_no][AIG_DESCR_IND_LIB_POS_1 ][2*ind+AIG_DESCR_IND_OUT_VAL_0]=atoi(ch_tab[i+2]);
                        }
                        ind++;
                        i=i+3;
                        continue;
                    }

                    if((ch_nb-i)>=3)
                    if( !strcmp(ch_tab[i],"tic") && ch_tab[i+1][0]=='=' )
                    {
                        if(op>=0) aig_descr[aig_no][op][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+2]);
                        if(op==-2)
                        {
                            aig_descr[aig_no][AIG_DESCR_IND_PREP_POS_0][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+2]);
                            aig_descr[aig_no][AIG_DESCR_IND_LIB_POS_0 ][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+2]);
                        }
                        if(op==-3)
                        {
                            aig_descr[aig_no][AIG_DESCR_IND_PREP_POS_1][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+2]);
                            aig_descr[aig_no][AIG_DESCR_IND_LIB_POS_1 ][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+2]);
                        }
                        i=i+3;
                        continue;
                    }

                    if((ch_nb-i)>=5)
                    if( !strncmp(ch_tab[i],"verif",5) && ch_tab[i+1][0]==':' && ch_tab[i+3][0]=='=' )
                    {

                        if(pio_define_convert(ch_tab[i+2],ch_syst)==0) strcpy(ch_syst,ch_tab[i+2]);
                        if((var=pio_var_ch2int(ch_syst))!=-1)
                        {
                            if(ch_tab[i][5]=='0')
                            {
                                aig_descr_info[aig_no][AIG_DESCR_INFO_IND_VERIF_NUM_POS_0]=var;
                                aig_descr_info[aig_no][AIG_DESCR_INFO_IND_VERIF_VAL_POS_0]=atoi(ch_tab[i+4]);
                            }
                            if(ch_tab[i][5]=='1')
                            {
                                aig_descr_info[aig_no][AIG_DESCR_INFO_IND_VERIF_NUM_POS_1]=var;
                                aig_descr_info[aig_no][AIG_DESCR_INFO_IND_VERIF_VAL_POS_1]=atoi(ch_tab[i+4]);
                            }
                            i=i+5;
                            continue;
                        }
                    }

                    if((ch_nb-i)>=13)
                    if(   !strcmp(ch_tab[i],"default_tic") && ch_tab[i+1][0]==':'
                       && ch_tab[i+3 ][0]==','             && ch_tab[i+5][0]==','
                       && ch_tab[i+7 ][0]==','             && ch_tab[i+9][0]==','
                       && ch_tab[i+11][0]==',' )
                    {
                        for(j=0;j<AIG_NB;j++)
                        {
                            if(aig_descr[j][AIG_DESCR_IND_PREP_POS_0][AIG_DESCR_IND_TIME]==-1 ) aig_descr[j][AIG_DESCR_IND_PREP_POS_0][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+2]);
                            if(aig_descr[j][AIG_DESCR_IND_GO_POS_0  ][AIG_DESCR_IND_TIME]==-1 ) aig_descr[j][AIG_DESCR_IND_GO_POS_0  ][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+4]);
                            if(aig_descr[j][AIG_DESCR_IND_LIB_POS_0 ][AIG_DESCR_IND_TIME]==-1 ) aig_descr[j][AIG_DESCR_IND_LIB_POS_0 ][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+6]);
                            if(aig_descr[j][AIG_DESCR_IND_PREP_POS_1][AIG_DESCR_IND_TIME]==-1 ) aig_descr[j][AIG_DESCR_IND_PREP_POS_1][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+8]);
                            if(aig_descr[j][AIG_DESCR_IND_GO_POS_1  ][AIG_DESCR_IND_TIME]==-1 ) aig_descr[j][AIG_DESCR_IND_GO_POS_1  ][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+10]);
                            if(aig_descr[j][AIG_DESCR_IND_LIB_POS_1 ][AIG_DESCR_IND_TIME]==-1 ) aig_descr[j][AIG_DESCR_IND_LIB_POS_1 ][AIG_DESCR_IND_TIME]=atoi(ch_tab[i+12]);
                        }
                        i=i+13;
                        continue;
                    }

                    strcpy(ch_error,"Aig Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin groupe de mot
            }    //fin chaine ligne
        }      //fin #aig
    }        //fin file

    fclose(pf);
}

void aig_save_conf(void)
{
    FILE* pf;
    int i,j,k;

    if((pf=fopen("debug_aig.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_aig.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    fprintf(pf,"\nAIG_DESCR");
    for(k=0;k<AIG_NB;k++)
    {
        fprintf(pf,"\nAIG%d:",k);
        for(j=0;j<6;j++)
        {
            fprintf(pf,"\n    %2d: ",j);
            for(i=0;i<(2*AIG_DESCR_NB_OUT+1);i++) fprintf(pf," %4d",aig_descr[k][j][i]);
        }
    }

    fprintf(pf,"\n\nAIG_DESCR_IDLE");
    for(i=0;i<(2*AIG_DESCR_IDLE_NB_OUT);i++) fprintf(pf," %4d",aig_descr_idle[i]);

    fprintf(pf,"\n\nAIG_DESCR_INFO");
    for(j=0;j<AIG_NB;j++)
    {
         fprintf(pf,"\n %2d:  ",j);
         for(i=0;i<AIG_DESCR_INFO_IND_NB;i++) fprintf(pf," %4d",aig_descr_info[j][i]);
    }

    fclose(pf);
}

int aig_in_pos(int aig_select)
{
    if(vio_aig_cmd[aig_select]==0 && vio_aig_pos0[aig_select]==1) return 1;
    if(vio_aig_cmd[aig_select]==1 && vio_aig_pos1[aig_select]==1) return 1;
    return 0;
}


void aig_maj(void)
{
    int i,ok,var,val,time;

    // 0. toujours mettre les indicateurs de position a 0 si l'aiguillage n'est pas dans la position souhaite
    for(i=0;i<AIG_NB;i++) if(!aig_in_pos(i)) {vio_aig_pos0[i]=0; vio_aig_pos1[i]=0;}

    // 1. ETAT IDLE
    if(aig_state==SM_IDLE)
    {
        if(aig_enable==0) return;

        // 1.1. etat IDLE sorties au repos telle que definit
        for(i=0;i<AIG_DESCR_IDLE_NB_OUT;i++)
        {
            var=aig_descr_idle[2*i+AIG_DESCR_IDLE_IND_OUT_NO_0];
            val=aig_descr_idle[2*i+AIG_DESCR_IDLE_IND_OUT_VAL_0];
            if(var==-1) break; else vio_out[var/100][var%100]=val;
        }
        // 1.2. recherche de changement d'etat
        ok=0;
        for(i=0;i<AIG_NB;i++)
        {
            aig_select++; if(aig_select>=AIG_NB) aig_select=0;
            if(aig_descr_info[aig_select][AIG_DESCR_INFO_IND_EXIST]==0) continue;
            if(aig_in_pos(aig_select)==0 /*|| vio_aig_ver[aig_select]==0*/) {ok=1;break;}
        }
        // 1.3. changement d'etat
        if(ok==1)
        {
            //MessageBox(NULL,"Ok==1","Debug",MB_OK|MB_ICONERROR); exit(1);
        
            aig_state=SM_PREP;
            aig_pos_select=vio_aig_cmd[aig_select];
            time=aig_descr[aig_select][AIG_DESCR_IND_PREP_POS_0+3*aig_pos_select][AIG_DESCR_IND_TIME];
            if(time==-1) aig_cpt=2; else aig_cpt=time;
        }
    }

    // 2. ETAT PREP
    if(aig_state==SM_PREP)
    {
        // 2.1. actions de l'etat PREP sorties PREP
        //vio_aig_ver[aig_select]=0;
        for(i=0;i<AIG_DESCR_NB_OUT;i++)
        {
            var=aig_descr[aig_select][AIG_DESCR_IND_PREP_POS_0+3*aig_pos_select][2*i+AIG_DESCR_IND_OUT_NO_0 ];
            val=aig_descr[aig_select][AIG_DESCR_IND_PREP_POS_0+3*aig_pos_select][2*i+AIG_DESCR_IND_OUT_VAL_0];
            if(var==-1) break; else vio_out[var/100][var%100]=val;
        }

        // 2.2. recherche de changement d'etat
        ok=0;
        if(aig_cpt==0) ok=1;
        else aig_cpt--;

        // 2.3. changement d'etat
        if(ok==1)
        {
            aig_state=SM_GO;
            time=aig_descr[aig_select][AIG_DESCR_IND_GO_POS_0+3*aig_pos_select][AIG_DESCR_IND_TIME];
            if(time==-1) aig_cpt=2; else aig_cpt=time;
        }
    }

    // 3. ETAT GO
    if(aig_state==SM_GO)
    {
        // 3.1. actions de l'etat GO sorties PREP
        //vio_aig_ver[aig_select]=0;
        for(i=0;i<AIG_DESCR_NB_OUT;i++)
        {
            var=aig_descr[aig_select][AIG_DESCR_IND_GO_POS_0+3*aig_pos_select][2*i+AIG_DESCR_IND_OUT_NO_0 ];
            val=aig_descr[aig_select][AIG_DESCR_IND_GO_POS_0+3*aig_pos_select][2*i+AIG_DESCR_IND_OUT_VAL_0];
            if(var==-1) break; else vio_out[var/100][var%100]=val;
        }

        // 3.2. recherche de changement d'etat
        ok=0;
        if(aig_cpt==0) ok=1;
        else aig_cpt--;

        // 3.3. changement d'etat
        if(ok==1)
        {
            aig_state=SM_LIB;
            time=aig_descr[aig_select][AIG_DESCR_IND_LIB_POS_0+3*aig_pos_select][AIG_DESCR_IND_TIME];
            if(time==-1) aig_cpt=2; else aig_cpt=time;
        }
    }

    // 4. ETAT LIB
    if(aig_state==SM_LIB)
    {
        // 4.1. actions de l'etat LIB sorties PREP
        //vio_aig_ver[aig_select]=0;
        for(i=0;i<AIG_DESCR_NB_OUT;i++)
        {
            var=aig_descr[aig_select][AIG_DESCR_IND_LIB_POS_0+3*aig_pos_select][2*i+AIG_DESCR_IND_OUT_NO_0 ];
            val=aig_descr[aig_select][AIG_DESCR_IND_LIB_POS_0+3*aig_pos_select][2*i+AIG_DESCR_IND_OUT_VAL_0];
            if(var==-1) break; else vio_out[var/100][var%100]=val;
        }

        // 2.2. recherche de changement d'etat
        ok=0;
        if(aig_cpt==0) ok=1;
        else aig_cpt--;

        // 2.3. changement d'etat
        if(ok==1)
        {
            aig_state=SM_IDLE;
            if(aig_pos_select) { vio_aig_pos0[aig_select]=0; vio_aig_pos1[aig_select]=1;} else { vio_aig_pos0[aig_select]=1; vio_aig_pos1[aig_select]=0;}
            var=aig_descr_info[aig_select][AIG_DESCR_INFO_IND_VERIF_NUM_POS_0+2*aig_pos_select];
            val=aig_descr_info[aig_select][AIG_DESCR_INFO_IND_VERIF_VAL_POS_0+2*aig_pos_select];

            //if(     var==-1              ) vio_aig_ver[aig_select]=1;
            //else if(pio_get_val(var)==val) vio_aig_ver[aig_select]=1;
            //else                           vio_aig_ver[aig_select]=0;

            // 1.1. actions de l'etat IDLE sorties IDLE
            for(i=0;i<AIG_DESCR_IDLE_NB_OUT;i++)
            {
                var=aig_descr_idle[2*i+AIG_DESCR_IDLE_IND_OUT_NO_0];
                val=aig_descr_idle[2*i+AIG_DESCR_IDLE_IND_OUT_VAL_0];
                if(var==-1) break; else vio_out[var/100][var%100]=val;
            }
        }

    }

    //sprintf(gszErr,"\nstate=%d aig_sel=%d pos_sel=%d",aig_state,aig_select,aig_pos_select); log(gszErr);
}


void aig_debug(int action)
{
    int i;
    static int aig_deb=0;
    char ch[100];

    if(action==DEBUG_MOUSE)
    {
        i=(y_mouse-20)/20;
        if( i<30 && (aig_deb+i)<64 ) //visible: 30 max, aig: 64 max
        {
            if(x_mouse>50  && x_mouse<100) vio_aig_cmd[aig_deb+i]^=1;
            if(x_mouse>200 && x_mouse<250) vio_aig_res[aig_deb+i]^=1;
        }
    }

    if(action==DEBUG_KEY)
    {
        if(touche_char=='+') if(aig_deb<(64-1)) aig_deb++;
        if(touche_char=='-') if(aig_deb>0)      aig_deb--;
    }

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);

    Rectangle(hdc,0,0,300,20);
    EasyLine( 50,0, 50,20);
    EasyLine(100,0,100,20);
    EasyLine(150,0,150,20);
    EasyLine(200,0,200,20);
    EasyLine(250,0,250,20);
    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));
    EasyTextOut(    05,2,"No"  );
    EasyTextOut( 50+05,2,"Cmd" );
    EasyTextOut(100+05,2,"Pos0");
    EasyTextOut(150+05,2,"Pos1");
    EasyTextOut(200+05,2,"Res" );
    EasyTextOut(250+05,2,""    );
    EasyLine( 90,20,100,10);
    EasyLine(240,20,250,10);

    SetTextColor(hdc,RGB(0,0,255));
    for(i=0;i<32;i++)
    {
        SelectObject(hdc,bmp_pinceau_blanc);
        if((aig_deb+i)>=64)
        {
            SelectObject(hdc,bmp_stylo_blanc);
            Rectangle(hdc,0,20*i+20,300,20*i+20+20);
            continue;
        }
        SelectObject(hdc,bmp_stylo_gris);
        if(aig_in_pos(aig_deb+i)==0)                               SelectObject(hdc,bmp_pinceau_jaune);
        //if(vio_aig_ver[aig_deb+i]==0)                              SelectObject(hdc,bmp_pinceau_rouge);
        if(aig_descr_info[aig_deb+i][AIG_DESCR_INFO_IND_EXIST]==0) SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,0,20*i+20,300,20*i+20+20);
        EasyLine( 50,20*i+20, 50,20*i+20+20);
        EasyLine(100,20*i+20,100,20*i+20+20);
        EasyLine(150,20*i+20,150,20*i+20+20);
        EasyLine(200,20*i+20,200,20*i+20+20);
        EasyLine(250,20*i+20,250,20*i+20+20);
        sprintf(ch,"%d",aig_deb+i);                EasyTextOut(  0+05,22+20*i,ch);
        if(aig_descr_info[aig_deb+i][AIG_DESCR_INFO_IND_EXIST]==0) continue;
        sprintf(ch,"%d",vio_aig_cmd[aig_deb+i]);   EasyTextOut( 50+05,22+20*i,ch);
        sprintf(ch,"%d",vio_aig_pos0[aig_deb+i]);  EasyTextOut(100+05,22+20*i,ch);
        sprintf(ch,"%d",vio_aig_pos1[aig_deb+i]);  EasyTextOut(150+05,22+20*i,ch);
        sprintf(ch,"%d",vio_aig_res[aig_deb+i]);   EasyTextOut(200+05,22+20*i,ch);
        //sprintf(ch,"%d",vio_aig_ver[aig_deb+i]); EasyTextOut(250+05,22+20*i,ch);
    }
}


/*****************************************************************************/
/* FIN AIG                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* debut ITI                                                                 */
/*****************************************************************************/


#define NB_ITI             50
#define NB_ITI_AIG          8
#define NB_ITI_EXIST        0
#define NB_ITI_TYPE         1
#define NB_ITI_VAR_START    2
#define NB_ITI_VAR_STOP     3
#define NB_ITI_VAR_STEP     4
#define NB_ITI_TEMPO        5
#define NB_ITI_VAR_WAIT     6
#define NB_ITI_VAR_OK       7
#define NB_ITI_CANT_START   8
#define NB_ITI_CANT_STOP    9
#define NB_ITI_AIG_NO      10
#define NB_ITI_AIG_POS     11
#define NB_ITI_DIRECT       0
#define NB_ITI_ONOFF        1
#define NB_ITI_STEP_IDLE          0
#define NB_ITI_STEP_WAIT_CANT_DEP 1
#define NB_ITI_STEP_WAIT_RES      2
#define NB_ITI_STEP_WAIT_VER      3
#define NB_ITI_STEP_WAIT_CANT_FIN 4
#define NB_ITI_STEP_WAIT_WAIT     5
#define NB_ITI_STEP_WAIT_STOP     6
#define NB_ITI_STEP_RELEASE       7
//int iti_tab[NB_ITI][10+2*NB_ITI_AIG];  //declare plus haut
char iti_name[NB_ITI][100];


class cIti
{
    public:
    //int nb;

         cIti(void);
    void init(char filename[]);
    void save_conf();
    void tick(void);
    void debug(int action);

    private:
    int get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb);
};


int cIti::get_iti_line(FILE* pf, char ch_tab[][100], int* ch_nb)
{
    int ret;

    moins_char_normal=0;  // - is not a normal character (so it is parsed)
    ret=get_line(pf,ch_tab,ch_nb);
    moins_char_normal=1;

    return ret;
}


cIti::cIti(void)
{

}


void cIti::init(char filename[])
{
    FILE* pf;
    char ch[100];
    char ch_tab[50][100];
    char ch_error[200];
    int  ch_nb;
    int  j,i;
    int iti_no;
    int aig_no;

    for(j=0;j<NB_ITI;j++)
    {
        for(i=0                ;i<NB_ITI_CANT_START;i++) iti_tab[j][i]=0;
        for(i=NB_ITI_CANT_START;i<(10+2*NB_ITI_AIG);i++) iti_tab[j][i]=-1;
        iti_name[j][0]='\0';
    }

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration des itineraires","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    //   iti19: onoff  a9.0 a1.1 a2.1       start c2 stop c7  @ V3  <--> U
    //   iti0:  direct a9.1 a4.0 a5.1      @ M   <--> U

    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(!strcmp(ch,"#iti"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_iti_line(pf,ch_tab,&ch_nb))
            {
                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments
                iti_no=-1;
                i=0;
                while(i<ch_nb)
                {
                    if((ch_nb-i)>=2)
                    if( (!strncmp(ch_tab[i],"iti",3)) && ch_tab[i+1][0]==':' )
                    {
                        iti_no=atoi(&ch_tab[i][3]);
                        iti_tab[iti_no][NB_ITI_EXIST]=1;
                        i=i+2;
                        aig_no=0;
                        continue;
                    }

                    if(iti_no!=-1)
                    {

                        if((ch_nb-i)>=1)
                        if( !strcmp(ch_tab[i],"direct") )
                        {
                            iti_tab[iti_no][NB_ITI_TYPE]=NB_ITI_DIRECT;
                            i=i+1;
                            continue;
                        }

                        if((ch_nb-i)>=1)
                        if( !strcmp(ch_tab[i],"onoff") )
                        {
                            iti_tab[iti_no][NB_ITI_TYPE]=NB_ITI_ONOFF;
                            i=i+1;
                            continue;
                        }

                        if((ch_nb-i)>=2)
                        if( (!strcmp(ch_tab[i],"start")) && ch_tab[i+1][0]=='c' )
                        {
                            iti_tab[iti_no][NB_ITI_CANT_START]=atoi(&ch_tab[i+1][1]);
                            i=i+2;
                            continue;
                        }

                        if((ch_nb-i)>=2)
                        if( (!strcmp(ch_tab[i],"stop")) && ch_tab[i+1][0]=='c' )
                        {
                            iti_tab[iti_no][NB_ITI_CANT_STOP]=atoi(&ch_tab[i+1][1]);
                            i=i+2;
                            continue;
                        }

                        if(aig_no<NB_ITI_AIG)
                        if((ch_nb-i)>=3)
                        if( ch_tab[i][0]=='a' && ch_tab[i+1][0]=='.' )
                        {
                            iti_tab[iti_no][NB_ITI_AIG_NO +2*aig_no]=atoi(&ch_tab[i][1]);
                            iti_tab[iti_no][NB_ITI_AIG_POS+2*aig_no]=atoi(ch_tab[i+2]);

                            i=i+3;
                            aig_no++;
                            continue;
                        }

                        if((ch_nb-i)>=3)
                        if( (!strcmp(ch_tab[i],"name")) && ch_tab[i+1][0]==':' )
                        {
                            strcpy(iti_name[iti_no],ch_tab[i+2]);
                            i=i+3;
                            continue;
                        }

                    } //fin iti_no ok

                    strcpy(ch_error,"Itineraire Error");
                    for(i=0;i<ch_nb;i++)
                    {
                        strcat(ch_error,"  ");
                        strcat(ch_error,ch_tab[i]);
                    }
                    MessageBox(NULL,ch_error,"Error",MB_OK|MB_ICONERROR);
                    exit(1);

                }  //fin while
            }    //fin chaine
        }      //fin #iti
    }        //fin file

    fclose(pf);
}

    
void cIti::save_conf(void)
{
    FILE* pf;
    int i,j;

    if((pf=fopen("debug_iti.txt","wt"))==NULL)
    {
        MessageBox(NULL,"Impossible de creer debug_iti.txt","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    for(j=0;j<NB_ITI;j++)
    {
        fprintf(pf,"\n");
        for(i=0;i<(10+2*NB_ITI_AIG);i++) fprintf(pf," %2d",iti_tab[j][i]);
    }

   fclose(pf);
}


void cIti::tick(void)
{
    int i;
    int aig_ind;
    int ok;
    int aig_no;
    int aig_pos;
    int canton;

    for(i=0;i<NB_ITI;i++) if(iti_tab[i][NB_ITI_EXIST])
    {

        if(iti_tab[i][NB_ITI_TYPE]==NB_ITI_DIRECT)
        {
            if(iti_tab[i][NB_ITI_VAR_START])
            {
                iti_tab[i][NB_ITI_VAR_START]=0;
                for(aig_ind=0;aig_ind<NB_ITI_AIG;aig_ind++)
                {
                    aig_no =iti_tab[i][NB_ITI_AIG_NO +2*aig_ind];
                    aig_pos=iti_tab[i][NB_ITI_AIG_POS+2*aig_ind];

                    if(aig_no!=-1 && vio_aig_res[aig_no]==0) vio_aig_cmd[aig_no]=aig_pos;  // ( ne modifie pas les aiguillages reserves )
                }
            }

            ok=1;
            for(aig_ind=0;aig_ind<NB_ITI_AIG;aig_ind++)
            {
                aig_no =iti_tab[i][NB_ITI_AIG_NO +2*aig_ind];
                aig_pos=iti_tab[i][NB_ITI_AIG_POS+2*aig_ind];

                if(aig_no!=-1) if(  (aig_pos==1 && vio_aig_pos1[aig_no]!=1) || (aig_pos==0 && vio_aig_pos0[aig_no]!=1) ) ok=0;
            }
            iti_tab[i][NB_ITI_VAR_OK]=ok;
        }

        if(iti_tab[i][NB_ITI_TYPE]==NB_ITI_ONOFF)
        {
            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_IDLE)
            if(iti_tab[i][NB_ITI_VAR_START]==1)
            {
                iti_tab[i][NB_ITI_VAR_START]=0;
                iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_CANT_DEP;
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_CANT_DEP)
            {
                canton=iti_tab[i][NB_ITI_CANT_START];
                if(canton==-1) iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_RES;
                else if(vio_det[canton/100][canton%100]) iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_RES;
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_RES)
            {
                //mettre la verification et reservation
                ok=1;
                for(aig_ind=0;aig_ind<NB_ITI_AIG;aig_ind++)        // verifie si pas reservation
                {
                    aig_no =iti_tab[i][NB_ITI_AIG_NO +2*aig_ind];
                    aig_pos=iti_tab[i][NB_ITI_AIG_POS+2*aig_ind];

                    if(aig_no!=-1 && vio_aig_res[aig_no]!=0) ok=0;
                }
                if(ok) for(aig_ind=0;aig_ind<NB_ITI_AIG;aig_ind++) // reserve et commande
                {
                    aig_no =iti_tab[i][NB_ITI_AIG_NO +2*aig_ind];
                    aig_pos=iti_tab[i][NB_ITI_AIG_POS+2*aig_ind];

                    if(aig_no!=-1) { vio_aig_cmd[aig_no]=aig_pos; vio_aig_res[aig_no]=1; }
                }
                if(ok) iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_VER;
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_VER)
            {
                ok=1;
                for(aig_ind=0;aig_ind<NB_ITI_AIG;aig_ind++)
                {
                    aig_no =iti_tab[i][NB_ITI_AIG_NO +2*aig_ind];
                    aig_pos=iti_tab[i][NB_ITI_AIG_POS+2*aig_ind];

                    if(aig_no!=-1) if(  (aig_pos==1 && vio_aig_pos1[aig_no]!=1) || (aig_pos==0 && vio_aig_pos0[aig_no]!=1) ) ok=0;
                }
                if(ok) iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_CANT_FIN;
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_CANT_FIN)
            {
                canton=iti_tab[i][NB_ITI_CANT_STOP];
                if(canton==-1) iti_tab[i][NB_ITI_VAR_STEP]=iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_STOP;
                else if(vio_det[canton/100][canton%100])
                {
                    iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_WAIT_WAIT;
                    iti_tab[i][NB_ITI_TEMPO]=16; //4s
                }
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_WAIT)  // stop automatic par detection canton + 4s
            {
                if(iti_tab[i][NB_ITI_TEMPO]!=0) iti_tab[i][NB_ITI_TEMPO]--;
                else  iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_RELEASE;
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_STOP)  // stop manual
            if(iti_tab[i][NB_ITI_VAR_STOP]==1)
            {
                iti_tab[i][NB_ITI_VAR_STOP]=0;
                iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_RELEASE;
            }

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_RELEASE)
            {
                //dereservation
                for(aig_ind=0;aig_ind<NB_ITI_AIG;aig_ind++)        // verifie si pas reservation
                {
                    aig_no =iti_tab[i][NB_ITI_AIG_NO +2*aig_ind];
                    aig_pos=iti_tab[i][NB_ITI_AIG_POS+2*aig_ind];

                    if(aig_no!=-1) vio_aig_res[aig_no]=0;
                }

                iti_tab[i][NB_ITI_VAR_STEP]=NB_ITI_STEP_IDLE;
            }

            //mise a jour des indicateurs
            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_STOP ||
               iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_CANT_FIN ||
               iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_WAIT)
            iti_tab[i][NB_ITI_VAR_OK]=1; else iti_tab[i][NB_ITI_VAR_OK]=0;

            if(iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_CANT_DEP ||
               iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_RES      ||
               iti_tab[i][NB_ITI_VAR_STEP]==NB_ITI_STEP_WAIT_VER)
            iti_tab[i][NB_ITI_VAR_WAIT]=1; else iti_tab[i][NB_ITI_VAR_WAIT]=0;

        } // fin onoff
    } // fin for
}


char* iti_step_name[]={ "NB_ITI_STEP_IDLE",
                        "NB_ITI_STEP_WAIT_CANT_DEP",
                        "NB_ITI_STEP_WAIT_RES",
                        "NB_ITI_STEP_WAIT_VER",
                        "NB_ITI_STEP_WAIT_CANT_FIN",
                        "NB_ITI_STEP_WAIT_WAIT",
                        "NB_ITI_STEP_WAIT_STOP",
                        "NB_ITI_STEP_RELEASE" };


void cIti::debug(int action)
{
    int i;
    static int iti_deb=0;
    char ch[100];

    if(action==DEBUG_MOUSE)
    {
        i=(y_mouse-20)/20;
        if(i<30 && ((iti_deb+i)<NB_ITI))
        {
            if(x_mouse>50  && x_mouse<100)  iti_tab[iti_deb+i][NB_ITI_VAR_START]^=1;
            if(x_mouse>100 && x_mouse<150)  iti_tab[iti_deb+i][NB_ITI_VAR_STOP]^=1;
        }
    }

    if(action==DEBUG_KEY)
    {
        if(touche_char=='+') if(iti_deb<(NB_ITI-1)) iti_deb++;
        if(touche_char=='-') if(iti_deb>0) iti_deb--;
        SelectObject(hdc,bmp_pinceau_blanc);
        SelectObject(hdc,bmp_stylo_blanc);
        Rectangle(hdc,0,0,1280,1024);
    }

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_gris);

    Rectangle(hdc,0,0,800,20);
    EasyLine( 50,0, 50,20);
    EasyLine(100,0,100,20);
    EasyLine(150,0,150,20);
    EasyLine(200,0,200,20);
    EasyLine(250,0,250,20);
    EasyLine(300,0,300,20);
    EasyLine(500,0,500,20);
    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));
    EasyTextOut(    05,2,"No"   );
    EasyTextOut( 50+05,2,"Start");
    EasyTextOut(100+05,2,"Stop" );
    EasyTextOut(150+05,2,"Wait" );
    EasyTextOut(200+05,2,"Ok"   );
    EasyTextOut(250+05,2,"Tempo");
    EasyTextOut(300+05,2,"State");
    EasyTextOut(500+05,2,"Name" );
    EasyLine( 90,20,100,10);
    EasyLine(140,20,150,10);

    SetTextColor(hdc,RGB(0,0,255));
    for(i=0;i<30;i++)
    {
        SelectObject(hdc,bmp_pinceau_blanc);
        if((iti_deb+i)>=NB_ITI) break;
        if(iti_tab[iti_deb+i][NB_ITI_VAR_WAIT]) SelectObject(hdc,bmp_pinceau_jaune);
        if(iti_tab[iti_deb+i][NB_ITI_VAR_OK])   SelectObject(hdc,bmp_pinceau_vert);
        Rectangle(hdc,0,20*i+20,800,20*i+20+20);
        EasyLine( 50,20*i+20, 50,20*i+20+20);
        EasyLine(100,20*i+20,100,20*i+20+20);
        EasyLine(150,20*i+20,150,20*i+20+20);
        EasyLine(200,20*i+20,200,20*i+20+20);
        EasyLine(250,20*i+20,250,20*i+20+20);
        EasyLine(300,20*i+20,300,20*i+20+20);
        EasyLine(500,20*i+20,500,20*i+20+20);
        sprintf(ch,"%d",iti_deb+i);                                    EasyTextOut(  0+05,22+20*i,ch);
        if(iti_tab[iti_deb+i][NB_ITI_EXIST]==0) continue;
        sprintf(ch,"%d",iti_tab[iti_deb+i][NB_ITI_VAR_START]);         EasyTextOut( 50+05,22+20*i,ch);
        sprintf(ch,"%d",iti_tab[iti_deb+i][NB_ITI_VAR_STOP]);          EasyTextOut(100+05,22+20*i,ch);
        sprintf(ch,"%d",iti_tab[iti_deb+i][NB_ITI_VAR_WAIT]);          EasyTextOut(150+05,22+20*i,ch);
        sprintf(ch,"%d",iti_tab[iti_deb+i][NB_ITI_VAR_OK]);            EasyTextOut(200+05,22+20*i,ch);
        sprintf(ch,"%d",iti_tab[iti_deb+i][NB_ITI_TEMPO]);             EasyTextOut(250+05,22+20*i,ch);
        strcpy(ch,iti_step_name[iti_tab[iti_deb+i][NB_ITI_VAR_STEP]]); EasyTextOut(300+05,22+20*i,ch);
        strcpy(ch,iti_name[iti_deb+i]);                                EasyTextOut(500+05,22+20*i,ch);
    }
}


/*****************************************************************************/
/* fin Iti                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* LIAISON SERIE                                                             */
/*****************************************************************************/


int serial_error=0;


/* protocole

; 0 sync
; 1 reply 83
; 2 set   current adr
; 3 write data at current adr
; 4 read  data at current adr
; 5 increment current adr and write data at current adr 
; 6 increment current adr and read  data at current adr
; 7 increment current adr and read  data at current adr and clear current register
; 8-15 total transfere 
; 16-255 only the 4 LSB are processed
;
; rx    0    1    2    3    4    5    6     7     8
; tx         83             data      +data +data
;
; rx2             adr  data      +data            data
; tx2                                             data
*/


/* adresses des registres du uc de la carte

;*** adresse des variables (bank 0) ***

pwm_r0   EQU     0x20   ;0    registres virtuels des sorties
pwm_r1   EQU     0x21   ;0
pwm_r2   EQU     0x22   ;0
pwm_r3   EQU     0x23   ;0
pwm_s03  EQU     0x24   ;0
pwm_r4   EQU     0x25   ;0
pwm_r5   EQU     0x26   ;0
pwm_r6   EQU     0x27   ;0
pwm_r7   EQU     0x28   ;0
pwm_s47  EQU     0x29   ;0
pwm_r8   EQU     0x2a   ;0
pwm_r9   EQU     0x2b   ;0
pwm_r10  EQU     0x2c   ;0
pwm_r11  EQU     0x2d   ;0
pwm_s8   EQU     0x2e   ;0
pwm_r12  EQU     0x2f   ;0
pwm_r13  EQU     0x30   ;0
pwm_r14  EQU     0x31   ;0
pwm_r15  EQU     0x32   ;0
pwm_s12  EQU     0x33   ;0
out_out3 EQU     0x34   ;0
out_out4 EQU     0x35   ;0
out_out5 EQU     0x36   ;0
led_on0  EQU     0x37   ;0
led_on1  EQU     0x38   ;0
led_on01 EQU     0x39   ;0
led_on2  EQU     0x3a   ;0
led_on3  EQU     0x3b   ;0
led_on23 EQU     0x3c   ;0
led_cl0  EQU     0x3d   ;0
led_cl1  EQU     0x3e   ;0
led_cl01 EQU     0x3f   ;0
led_cl2  EQU     0x40   ;0
led_cl3  EQU     0x41   ;0
led_cl23 EQU     0x42   ;0
led_in0  EQU     0x43   ;0
led_in1  EQU     0x44   ;0
led_in01 EQU     0x45   ;0
led_in2  EQU     0x46   ;0
led_in3  EQU     0x47   ;0
led_in23 EQU     0x48   ;0

can_r0   EQU     0x4a   ;0    registres virtuels des entrees
can_r1   EQU     0x4b   ;0
can_r2   EQU     0x4c   ;0
can_r3   EQU     0x4d   ;0
can_r4   EQU     0x4e   ;0
det_i1   EQU     0x4f   ;0
det_i2   EQU     0x50   ;0
det_i1m  EQU     0x51   ;0
det_i2m  EQU     0x52   ;0
mat_in0  EQU     0x53   ;0
mat_in1  EQU     0x54   ;0
mat_in2  EQU     0x55   ;0
mat_in3  EQU     0x56   ;0
mat_in4  EQU     0x57   ;0
mat_in5  EQU     0x58   ;0
mat_in6  EQU     0x59   ;0
mat_in7  EQU     0x5a   ;0
mat_in8  EQU     0x5b   ;0

W_TEMP   EQU     0x60   ;01    registres de variables
S_TEMP   EQU     0x61   ;0
W_TEMP2  EQU     0x62   ;01
S_TEMP2  EQU     0x63   ;0
cpt      EQU     0x64   ;0
F_TEMP   EQU     0x65   ;0
rs_adr   EQU     0x66   ;0
rs_mode  EQU     0x67   ;0  
rs_rx    EQU     0x68   ;0
can_mode EQU     0x69   ;0
cpt2     EQU     0x6a   ;0
cpt_i    EQU     0x6b   ;0
det_i1t  EQU     0x6c   ;0
det_i2t  EQU     0x6d   ;0
led_cpt  EQU     0x6e   ;0
led_cli  EQU     0x6f   ;0
mat_tmp  EQU     0x70   ;0
proc_on  EQU     0x71   ;0
pwm_cpt  EQU     0x72   ;0
pwm_stp  EQU     0x73   ;0
pwm_wrk  EQU     0x74   ;0
out_out1 EQU     0x75   ;0
out_out2 EQU     0x76   ;0
out_pwm1 EQU     0x77   ;0
out_pwm2 EQU     0x78   ;0
out_pwm3 EQU     0x79   ;0
out_pwm4 EQU     0x7a   ;0
out_mat  EQU     0x7b   ;0

Le registre proc_on (0x71) permet d'activer les differents modules de la carte
b7: maj de la led clignotante             (1 au reset)
b6: maj can                                1
b5: maj des entrees                        1
b4: 4094 des entrees utilise en sortie     0
b3: maj des 5 4094 des sorties             1
b2: calcul des leds                        1
b1: maj des 4 4094 des cantons             1
b0: calcul de la pwm                       1

*/


class cSerialPort
{
    public:

    DCB     dcb;                   // description de la liaison serie
    HANDLE  hCom;                  // handler sur la liaison derie
    int     card0_ok;              // la carte est presente
    int     card1_ok;              // la carte est presente
    int     card2_ok;              // la carte est presente
    int     card3_ok;              // la carte est presente
    int     enable;                // le module rs232 est actif

         cSerialPort(void);        // constructeur (desactive le module rs232)
    int  simple_write(int data);   // effectue une ecriture sur la rs232
    int  simple_read(int* pdata);  // effectue une lecture securisee sur la rs232
    int  read(int* pdata);         // effectue une lecture securisee sur la rs232 et une reinit si PB
    void dtr(int state);           // permet de mettre un etat sur la ligne DTR
    void rts(int state);           // permet de mettre un etat sur la ligne RTS
    int  init(void);               // cherche la carte
    void close(void);              // close serial port
};  //Ne pas oublier le ;

/*------------------------------------------------------------------------------
NAME  : cSerial::cSerial

DESCR : constructeur de la classe serial.
        Desactive le module rs232.
        Il sera active pendant init

ARG   : void

RETURN:

NOTES :
------------------------------------------------------------------------------*/
cSerialPort::cSerialPort(void)
{
     card0_ok=0;
     card1_ok=0;
     card2_ok=0;
     card3_ok=0;
     enable=0;
}

/*------------------------------------------------------------------------------
NAME  : cSerialPort::simple_write

DESCR : effectue une ecriture d'un octet sur la rs232

ARG   : DWORD buf[]: tableau pour stoquer l'octet en position 0 .

RETURN: 1: ok, 0: PB

NOTES : Aucun

------------------------------------------------------------------------------*/
int cSerialPort::simple_write(int data)
{
    DWORD num;            // byte number wrote
    DWORD buffer[100];    // buffer

    if(enable==0) return 0;

    buffer[0]=(DWORD) data;
    WriteFile(hCom,buffer,1,&num,NULL);

    return 1;
}

/*------------------------------------------------------------------------------
NAME  : cSerialPort::simple_read

DESCR : effectue une lecture non bloquante d'un octet sur la rs232

ARG   : DWORD buf[]: tableau pour stoquer l'octet en position 0 .

RETURN: 1: ok, 0: PB

NOTES : essaye de lire pendant 500ms

------------------------------------------------------------------------------*/
int cSerialPort::simple_read(int* pdata)
{
    DWORD num;            // byte number readed
    DWORD start_time;     // to measure time (used for timeout)
    DWORD No_Error;       // error number
    DWORD buffer[100];    // buffer
    COMSTAT Status;       // pour voir si rx ok


    if(enable==0) return 0;

    start_time=GetTickCount();
    do
    {
        ClearCommError(hCom,&No_Error,&Status);
        if(Status.cbInQue!=0)
        {
            ReadFile(hCom,buffer,1,&num,NULL);
            *pdata=(int) buffer[0];
            return 1;
        }
        Sleep(10);
    }
    while((GetTickCount()-start_time)<500);

    return 0;
}

/*------------------------------------------------------------------------------
NAME  : cSerial::read

DESCR : effectue une lecture securise d'un octet sur la rs232

ARG   : DWORD buf[]: tableau pour stoquer l'octet en position 0 .

RETURN: 0: ok, 1: PB

NOTES : si ne peut pas lire au bout de 500ms, alors essaye une resynchronisation
        et incremente un compteur d'erreur

------------------------------------------------------------------------------*/
int cSerialPort::read(int* pdata)
{
    DWORD num;            // byte number readed
    DWORD start_time;     // to measure time (used for timeout)
    DWORD No_Error;       // error number
    DWORD buffer[100];    // buffer
    COMSTAT Status;       // pour voir si rx ok
    int i;                // for loops


    if(enable==0) return 0;

    start_time=GetTickCount();
    do
    {
        ClearCommError(hCom,&No_Error,&Status);
        if(Status.cbInQue!=0)
        {
            ReadFile(hCom,buffer,1,&num,NULL);
            *pdata=(int) buffer[0];
            return 1;
        }
        Sleep(10);
    }
    while((GetTickCount()-start_time)<500);

    for(i=0;i<50;i++) {simple_write(0); Sleep(1); }
    serial_error++;

    return 0;
}

/*------------------------------------------------------------------------------
NAME  : init

DESCR : essaye de trouver la carte sur COM1 ou COM2

ARG   : void

RETURN: 0: carte non trouvee, 1: carte sur COM1, 2: carte sur COM2 ...

NOTES : l'OS ferme automatiquement les ports lorsque l'application se termine
------------------------------------------------------------------------------*/
int cSerialPort::init(void)
{
    int i;
    int ok_com;
    char ch_err[400]="Impossible de trouver la carte sur les ports series";
    int com_no;
    char com_name[10];
    int data;

    //Cherche les cartes sur les COM1,2,3,4
    for(com_no=1;com_no<=4;com_no++)
    {
        ok_com=1;
        sprintf(com_name,"COM%d",com_no);
        strcat(ch_err,"\n"); strcat(ch_err,com_name); strcat(ch_err,": ");
        hCom=CreateFile(com_name,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
        if(hCom==INVALID_HANDLE_VALUE) { ok_com=0; strcat(ch_err,"Impossible d'ouvrir le port serie (CreateFile)"); }
        if(ok_com) if(!GetCommState(hCom,&dcb)) { ok_com=0; strcat(ch_err,"Impossible d'ouvrir le port serie (GetCommState)"); }
        if(ok_com)
        {
            dcb.BaudRate = CBR_19200;
            dcb.ByteSize = 8;
            dcb.Parity   = NOPARITY;
            dcb.StopBits = ONESTOPBIT;
        }
        if(ok_com) if(!SetCommState(hCom,&dcb)) { ok_com=0; strcat(ch_err,"Impossible d'ouvrir le port serie (SetCommState)"); }
        if(ok_com)
        {
            enable=1;
            for(i=0;i<64;i++) { simple_write(0); }  //send 64 sync
            simple_write(0x41);  if(simple_read(&data)) { if(data==0x83) card0_ok=1; }  //test non adressable card (873_rs11)
            if(card0_ok==0)
            {
            simple_write(0x01);  if(simple_read(&data)) { if(data==0x83              ) card0_ok=1; }  //test adressable card 0 (873_rs13 / next)
            simple_write(0x11);  if(simple_read(&data)) { if(data==0x83 || data==0x93) card1_ok=1; }  //test adressable card 1
            simple_write(0x21);  if(simple_read(&data)) { if(data==0x83 || data==0xa3) card2_ok=1; }  //test adressable card 2
            simple_write(0x31);  if(simple_read(&data)) { if(data==0x83 || data==0xb3) card3_ok=1; }  //test adressable card 3
            }
            enable=0;

            if(card0_ok==0 && card1_ok==0 && card2_ok==0 && card3_ok==0) { ok_com=0; CloseHandle(hCom); strcat(ch_err,"Echec de  communication avec la carte"); }
        }
        if(ok_com) // OK, au moins une carte est la
        {
            enable=1;
            sprintf(ch_err,"card0=%d card1=%d card2=%d card4=%d",card0_ok,card1_ok,card2_ok,card3_ok);
            if(cfg_show_cards_found) MessageBox(NULL,ch_err,"Debug",MB_OK|MB_ICONERROR);
            return com_no;
        }
    }

    strcat(ch_err,"\nFonctionnement en mode deconnecte");
    MessageBox(NULL,ch_err,"Erreur",MB_OK|MB_ICONERROR);
    return 0;
}

/*------------------------------------------------------------------------------
NAME  : cSerialPort::close

DESCR : ferme le port serie

ARG   : Aucun

RETURN: Aucun

NOTES : Aucun

------------------------------------------------------------------------------*/
void cSerialPort::close(void)
{
    if(enable)
    {
        CloseHandle(hCom);
        card0_ok=0;
        card1_ok=0;
        card2_ok=0;
        card3_ok=0;
        enable=0;
    }
}

/*------------------------------------------------------------------------------
NAME  : cSerial::dtr

DESCR : ermet de mettre un etat sur la ligne DTR

ARG   : int state: etat de la ligne DTR: 0 pour -12V et 1 pour +12V

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void cSerialPort::dtr(int state)
{
    if(enable==0) return;

    if(state==0) EscapeCommFunction(hCom,CLRDTR);
    else         EscapeCommFunction(hCom,SETDTR);
}

/*------------------------------------------------------------------------------
NAME  : cSerial::rts

DESCR : ermet de mettre un etat sur la ligne RTS

ARG   : int state: etat de la ligne RTS: 0 pour -12V et 1 pour +12V

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void cSerialPort::rts(int state)
{
    if(enable==0) return;

    if(state==0) EscapeCommFunction(hCom,CLRRTS);
    else         EscapeCommFunction(hCom,SETRTS);
}





cSerialPort serialPort;

int serial_tab_cmd[4][5]={ {'x','x','x','x','x'}, {'x','x','x','x','x'}, {'x','x','x','x','x'}, {'x','x','x','x','x'} };  //actions demandees a la maj serie
int serial_tab_adresse[4][5]={ {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0} };
int serial_tab_data[4][5]=   { {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0} };
int tab_auto_read[4][4]=     { {0,0,0,0},   {0,0,0,0},   {0,0,0,0},   {0,0,0,0}   };


#define NO_CHANGE 1000

/*------------------------------------------------------------------------------
NAME  : cSerial

DESCR : class cSerial: Permet de communiquer avec la carte.

NOTES :
------------------------------------------------------------------------------*/
class cSerial
{
    public:

    int     card_adr;     // adresse de la carte
    DCB     dcb;          // description de la liaison serie
    HANDLE  hCom;         // handler sur la liaison derie
    COMSTAT Status;       // pour voir si rx ok
    DWORD   buff[100];    // buffer pour la liaison derie
    int     enable;       // le module rs232 est actif
    DWORD   tab_out[128]; // buffers images des registres du uc de la  carte
    DWORD   tab_in[128];  // "

         cSerial(void);                         // constructeur (desactive le module rs232)
    int  init(int card_adr_, int card_enable);  // cherche la carte
    int  transfer(void);                        // fait un transfert entre la carte et les registres images
    void import_tab_out(void);                  // copie les variables utilisateurs dans le registre image out
    void export_tab_in(void);                   // met a jour les variables utilisateurs en fonction du registre image in
    void maj(void);                             // enchaine: import, transfert, export
};


/*------------------------------------------------------------------------------
NAME  : cSerial::cSerial

DESCR : constructeur de la classe serial.
        Desactive le module rs232.
        Il sera active pendant init

ARG   : void

RETURN:

NOTES :
------------------------------------------------------------------------------*/
cSerial::cSerial(void)
{
     enable=0;
}


/*------------------------------------------------------------------------------
NAME  : init

DESCR : essaye de trouver la carte sur COM1 ou COM2

ARG   : void

RETURN: 0: carte non trouvee, 1: carte sur COM1, 2: carte sur COM2 ...

NOTES : l'OS ferme automatiquement les ports lorsque l'application se ermine
------------------------------------------------------------------------------*/
int cSerial::init(int card_adr_, int card_enable)
{
    enable=card_enable;
    card_adr=card_adr_;

    return 0; //// UU NEW
}


/*------------------------------------------------------------------------------
NAME  : cSerial::transfer

DESCR : fait un transfert entre la carte et les registres images

ARG   : void

RETURN: 0: ok, 1: PB de lecture

NOTES : utilise la fonction cSerial::read pour une lecture securisee
------------------------------------------------------------------------------*/
int cSerial::transfer(void)
{
    DWORD num;
    int adr_out;
    int adr_in;
    int i;
    int data;

    if(serialPort.enable==0) return 0;
    if(enable==0)            return 0;


    /* 1. transfert normal 1 cmd + 41 out + 18 in = 60 octets @ 19200 = 30ms */
    //buff[0]=0   ;    WriteFile(hCom,buff,1,&num,NULL); //sync
    //buff[0]=0   ;    WriteFile(hCom,buff,1,&num,NULL); //sync

    serialPort.simple_write((card_adr<<4)+0x01);   //select correct card 0x01 (card0), 0x11 (card1), 0x21 (card2), 0x31 (card3)
    if(serialPort.read(&data)==0) return 1;        //read ping reply           (0x83)        (0x93)        (0xa3)        (0xb3)

    serialPort.simple_write(8);             //cmd global exchange

    for(adr_out=0x20;adr_out<=0x48;adr_out++)
    {
        // ecriture
        serialPort.simple_write(tab_out[adr_out]); //data out global

        // lecture
        adr_in=adr_out+(0x4a-0x20);
        if(adr_in<=0x5b)
        {
            //ReadFile( hCom,buff,1,&num,NULL); tab_in[adr_out+0x4a-0x20]=buff[0];
            if(serialPort.read(&data)==0) return 1;
            tab_in[adr_in]=data;
        }
    }

    /* 2. transfert d'effacement pour les det et in */
    // plus la peine car a chaque transfer global, 0x51 a 0x5b sont effaces
    // buff[0]=2;    WriteFile(hCom,buff,1,&num,NULL); //cmd set adr
    // buff[0]=0x51; WriteFile(hCom,buff,1,&num,NULL); //start adress det1m
    // buff[0]=3;    WriteFile(hCom,buff,1,&num,NULL); //cmd write data
    // buff[0]=0;    WriteFile(hCom,buff,1,&num,NULL); //data (det1m)
    // buff[0]=5;    WriteFile(hCom,buff,1,&num,NULL); //cmd inc adr and write data
    // buff[0]=0;    WriteFile(hCom,buff,1,&num,NULL); //data (det2m)
    // buff[0]=5;    WriteFile(hCom,buff,1,&num,NULL); //cmd inc adr and write data
    // buff[0]=0;    WriteFile(hCom,buff,1,&num,NULL); //data (in0)
    //..

    /* 2. transferts additionels (rajoutes a partir de 873_rs11) */
    if(tab_out[0x75]!=NO_CHANGE && tab_out[0x76]!=NO_CHANGE)  // 0x75 & 0x76 : registres des sorties qui remplacent les leds
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x75);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x75]);  //data
        serialPort.simple_write(5);              //cmd inc adr and write data
        serialPort.simple_write(tab_out[0x76]);  //data
    }
    else if(tab_out[0x75]!=NO_CHANGE)
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x75);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x75]);  //data
    }
    else if(tab_out[0x76]!=NO_CHANGE)
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x76);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x76]);  //data
    }

    if(tab_out[0x71]!=NO_CHANGE)  // 0x71 : registre du repartiteur de charge (utilise pour activer ou desactiver les leds)
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x87);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x71]);  //data
    }

    if(tab_out[0x49]!=NO_CHANGE)  // 0x49 : registre du premier servo moteur
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x49);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x49]);  //data
    }

    if(tab_out[0x5f]!=NO_CHANGE)  // 0x5f : registre du second servo moteur
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x5f);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x5f]);  //data
    }

    if(tab_out[0x87]!=NO_CHANGE)  // 0x87 : registre de direction du portC (utilise pour activer ou desactiver les servos)
    {
        serialPort.simple_write(2);              //cmd set adr
        serialPort.simple_write(0x87);           //reg adr
        serialPort.simple_write(3);              //cmd write data
        serialPort.simple_write(tab_out[0x87]);  //data
    }

    /* 3. transfets de debug */
    for(i=0;i<5;i++)
    {
        if(serial_tab_cmd[card_adr][i]=='w')
        {
            serial_tab_cmd[card_adr][i]='x';
            serialPort.simple_write(2);                               //cmd set adr
            serialPort.simple_write(serial_tab_adresse[card_adr][i]); //start adress
            serialPort.simple_write(3);                               //cmd write data
            serialPort.simple_write(serial_tab_data[card_adr][i]);    //data
        }
        if(serial_tab_cmd[card_adr][i]=='r' || serial_tab_cmd[card_adr][i]=='a')
        {
            if(serial_tab_cmd[card_adr][i]=='r') serial_tab_cmd[card_adr][i]='x';
            serialPort.simple_write(2);                                      //cmd set adr
            serialPort.simple_write(serial_tab_adresse[card_adr][i]);        //start adress
            serialPort.simple_write(4);                                      //cmd read data
            if(serialPort.read(&serial_tab_data[card_adr][i])==0) return 1;  //data
        }
    }

    return 0;
}


/*------------------------------------------------------------------------------
NAME  : cSerial::import_tab_out

DESCR : copie les variables utilisateurs dans le registre image out

ARG   : void

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
int get_canton_vit(int card, int i)    { if(serial_debug_select_canton_vit[card][i]==0) return vio_canton_vit[card][i]; else return serial_debug_canton_vit[card][i];}
int get_out_val(int card, int i)       { if(serial_debug_select_out[card][i]==0)        return vio_out[card][i];        else return serial_debug_out[card][i];       }
int get_led_val(int card, int i)       { if(serial_debug_select_led[card][i]==0)        return vio_led[card][i];        else return serial_debug_led[card][i];       }
int get_led_cli_val(int card, int i)   { if(serial_debug_select_led[card][i]==0)        return vio_led_cli[card][i];    else return serial_debug_led_cli[card][i];   }
int get_led_phase_val(int card, int i) { if(serial_debug_select_led[card][i]==0)        return vio_led_phase[card][i];  else return serial_debug_led_phase[card][i]; }
int get_srv(int card, int i)           { if(serial_debug_select_srv[card][i]==0)        return vio_srv[card][i];        else return serial_debug_srv[card][i];       }

void cSerial::import_tab_out(void)
{
    int i,j,data,adr;
    static int old_0x71=NO_CHANGE; int req_0x71; // 0x71 : registre du repartiteur de charge (utilise pour activer ou desactiver les leds)
    static int old_0x75=NO_CHANGE; int req_0x75; // 0x75 : registres des sorties qui remplacent les leds
    static int old_0x76=NO_CHANGE; int req_0x76; // 0x76 : "
    static int old_0x87=NO_CHANGE; int req_0x87; // 0x87 : registre de direction du portC (utilise pour activer ou desactiver les servos)
    static int old_0x49=NO_CHANGE; int req_0x49; // 0x49 : registre du premier servo moteur
    static int old_0x5f=NO_CHANGE; int req_0x5f; // 0x5f : registre du second servo moteur

    if(enable==0) return;


    /* fill tab_out buffer tfrom user variables*/

    //pwm+sens
    adr=0x20;
    for(j=0;j<4;j++)
    {
        for(i=0;i<4;i++)
        {
            if(get_canton_vit(card_adr,4*j+i)>=0) tab_out[adr++]= get_canton_vit(card_adr,4*j+i);
            else                                  tab_out[adr++]=-get_canton_vit(card_adr,4*j+i);
        }
        data=0;
        if(get_canton_vit(card_adr,4*j+0)>=0) data|=1;  else data|=2;
        if(get_canton_vit(card_adr,4*j+1)>=0) data|=4;  else data|=8;
        if(get_canton_vit(card_adr,4*j+2)>=0) data|=16; else data|=32;
        if(get_canton_vit(card_adr,4*j+3)>=0) data|=64; else data|=128;

        if(cfg_canton_inv[card_adr][4*j+0]) data^=0x03;
        if(cfg_canton_inv[card_adr][4*j+1]) data^=0x0c;
        if(cfg_canton_inv[card_adr][4*j+2]) data^=0x30;
        if(cfg_canton_inv[card_adr][4*j+3]) data^=0xc0;
        tab_out[adr++]=data;
    }

    //out 0-23
    adr=0x34;
    for(j=0;j<3;j++)
    {
         data=0;
         for(i=0;i<8;i++) if(get_out_val(card_adr,8*j+i)) data|=1<<i;
         tab_out[adr]=data;
         adr++;
    }

    //out 24-39 (si elles sont utilisees a la place des leds)
    // remplacement des leds par des sorties
    adr=0x71;
    if(cfg_enable_leds[card_adr]==0) req_0x71=0xef; else req_0x71=0xeb;
    if(req_0x71!=old_0x71) tab_out[adr]=req_0x71; else tab_out[adr]=NO_CHANGE;
    old_0x71=req_0x71;

    adr=0x75;
    j=0;
    data=0;
    for(i=0;i<8;i++) if(get_out_val(card_adr,24+8*j+i)) data|=1<<i;
    req_0x75=data;
    if(req_0x75!=old_0x75) tab_out[adr]=req_0x75; else tab_out[adr]=NO_CHANGE;
    old_0x75=req_0x75;

    adr=0x76;
    j=1;
    data=0;
    for(i=0;i<8;i++) if(get_out_val(card_adr,24+8*j+i)) data|=1<<i;
    req_0x76=data;
    if(req_0x76!=old_0x76) tab_out[adr]=req_0x76; else tab_out[adr]=NO_CHANGE;
    old_0x76=req_0x76;

    // led
    adr=0x37;
    for(j=0;j<2;j++) //led on
    {
        data=0; for(i=0;i<8;i++) if(get_led_val(card_adr,     i+24*j)) data|=1<<i;     tab_out[adr]=data; adr++;
        data=0; for(i=0;i<8;i++) if(get_led_val(card_adr,  12+i+24*j)) data|=1<<i;     tab_out[adr]=data; adr++;
        data=0; for(i=0;i<4;i++) if(get_led_val(card_adr,   8+i+24*j)) data|=1<<i;
                for(i=0;i<4;i++) if(get_led_val(card_adr,12+8+i+24*j)) data|=1<<(i+4); tab_out[adr]=data; adr++;
    }
    for(j=0;j<2;j++) //led clignotement (mettre a 0 pour un clignotement)
    {
        data=0; for(i=0;i<8;i++) if(get_led_cli_val(card_adr,     i+24*j)==0) data|=1<<i;     tab_out[adr]=data; adr++;
        data=0; for(i=0;i<8;i++) if(get_led_cli_val(card_adr,  12+i+24*j)==0) data|=1<<i;     tab_out[adr]=data; adr++;
        data=0; for(i=0;i<4;i++) if(get_led_cli_val(card_adr,   8+i+24*j)==0) data|=1<<i;
                for(i=0;i<4;i++) if(get_led_cli_val(card_adr,12+8+i+24*j)==0) data|=1<<(i+4); tab_out[adr]=data; adr++;
    }
    for(j=0;j<2;j++) //led inversion de phase de clignotement
    {
        data=0; for(i=0;i<8;i++) if(get_led_phase_val(card_adr,     i+24*j)) data|=1<<i;     tab_out[adr]=data; adr++;
        data=0; for(i=0;i<8;i++) if(get_led_phase_val(card_adr,  12+i+24*j)) data|=1<<i;     tab_out[adr]=data; adr++;
        data=0; for(i=0;i<4;i++) if(get_led_phase_val(card_adr,   8+i+24*j)) data|=1<<i;
                for(i=0;i<4;i++) if(get_led_phase_val(card_adr,12+8+i+24*j)) data|=1<<(i+4); tab_out[adr]=data; adr++;
    }

    // servo
    adr=0x87;
    if(cfg_enable_servos[card_adr][0]==0 && cfg_enable_servos[card_adr][1]==0) req_0x87=0x8f;
    if(cfg_enable_servos[card_adr][0]==1 && cfg_enable_servos[card_adr][1]==0) req_0x87=0x8b;
    if(cfg_enable_servos[card_adr][0]==0 && cfg_enable_servos[card_adr][1]==1) req_0x87=0x8d;
    if(cfg_enable_servos[card_adr][0]==1 && cfg_enable_servos[card_adr][1]==1) req_0x87=0x89;
    if(req_0x87!=old_0x87) tab_out[adr]=req_0x87; else tab_out[adr]=NO_CHANGE;
    old_0x87=req_0x87;

    adr=0x49;
    req_0x49=get_srv(card_adr,0);
    if(req_0x49!=old_0x49) tab_out[adr]=req_0x49; else tab_out[adr]=NO_CHANGE;
    old_0x49=req_0x49;

    adr=0x5f;
    req_0x5f=get_srv(card_adr,1);
    if(req_0x5f!=old_0x5f) tab_out[adr]=req_0x5f; else tab_out[adr]=NO_CHANGE;
    old_0x5f=req_0x5f;

}


/*------------------------------------------------------------------------------
NAME  : cSerial::export_tab_in

DESCR : met a jour les variables utilisateurs en fonction du registre image in

ARG   : void

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void cSerial::export_tab_in(void)
{
    int i,j,data,adr;

    if(enable==0) return;


    /* tab_in buffer to user variables*/

    //can
    adr=0x4a;
    for(i=0;i<5;i++)
    {
        vio_can[card_adr][i]=tab_in[adr++];
        if(cfg_can_inv[card_adr][i]) vio_can[card_adr][i]=255-vio_can[card_adr][i];
    }

    //det
    //adr=0x51;  //mem
    adr=0x4f;  //sans mem
    data=tab_in[adr++];
    for(i=0;i<8;i++) if(data&(1<<i)) vio_det[card_adr][i]=1; else vio_det[card_adr][i]=0;
    data=tab_in[adr++];
    for(i=0;i<8;i++) if(data&(1<<i)) vio_det[card_adr][8+i]=1; else vio_det[card_adr][8+i]=0;

    //in
    adr=0x53;
    for(j=0;j<9;j++)
    {
        for(i=0;i<4;i++) if(tab_in[adr]&(1<<i)) vio_in[card_adr][4*j+i]=1; else vio_in[card_adr][4*j+i]=0;
        adr++;
    }
    
}


/*------------------------------------------------------------------------------
NAME  : cSerial::maj

DESCR : enchaine: import, transfert, export

ARG   : void

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void cSerial::maj(void)
{
    int i,j,data,adr;
    DWORD num;
    char  szErr[100];

    if(serialPort.enable==0) return;
    if(enable==0) return;

    import_tab_out();
    for(i=0;i<4;i++)
    {
        if(transfer()==0) break;
        sprintf(szErr,"Gros Probleme avec la liaison serie (carte %d)",card_adr);
        if(i==3) MessageBox(NULL,szErr,"Erreur",MB_OK|MB_ICONERROR);
    }
    export_tab_in();
}


/*****************************************************************************/
/* FIN LIAISON SERIE                                                         */
/*****************************************************************************/





/*****************************************************************************/
/* DEBUG BOARD SCREEN                                                        */
/*****************************************************************************/


int selected_card=0;
int selected_can_and_card=-1;
int debug_tic_nb=0;


int atoh(char ch[])
{
    int i=0;
    int val=0;

    while(ch[i])
    {
        val=val<<4;
        if(ch[i]>='0' && ch[i]<='9') val=val+ch[i]-'0';
        if(ch[i]>='a' && ch[i]<='f') val=val+10+ch[i]-'a';
        if(ch[i]>='A' && ch[i]<='F') val=val+10+ch[i]-'A';
        i++;
    }
    return val;
}




void serial_debug(int action)
{
    int i,j,k;
    static int redraw=0;
    int val;
    char ch[100];
    static int cpt=0;
    int x,y;

    static char tab_cmd_ch[4]="000";
    static int tab_cmd_colone=-1;
    static int tab_cmd_ligne=0;
    static int srv_debug_cmd=-1;
    static int selected_pot=-1;

    if(action==DEBUG_TICK) //occured even when debug screen is not selected
    {
        for(j=0;j<4;j++) for(i=0;i<16;i++) if(serial_debug_select_canton_vit[j][i]) if((val=rs232_debug_link[j][i])!=-1)
        {
            serial_debug_canton_vit[j][i]=can_to_cons(vio_can[val/100][val%100],0,64,0);
        }
        return; // return because other part is only executed when debug screen is selected
    }

    cpt++;
    if(cpt==40) {cpt=0;redraw=1;}

    if(action==DEBUG_KEY)
    {
        if(touche_char=='l' || touche_char=='L') { redraw=1; if(cfg_enable_leds[selected_card])      cfg_enable_leds[selected_card]=0;       else cfg_enable_leds[selected_card]=1;      }
        if(touche_char=='g' || touche_char=='G') { redraw=1; if(cfg_enable_servos[selected_card][0]) cfg_enable_servos[selected_card][0]=0; else cfg_enable_servos[selected_card][0]=1; }
        if(touche_char=='h' || touche_char=='H') { redraw=1; if(cfg_enable_servos[selected_card][1]) cfg_enable_servos[selected_card][1]=0; else cfg_enable_servos[selected_card][1]=1; }
    }

    SelectObject(hdc,bmp_fonte);
    SetBkMode(hdc,TRANSPARENT);
    SetTextColor(hdc,RGB(255,0,0));

    if(action==DEBUG_TOTAL_PAINT || redraw)
    {
        redraw=0;
        SelectObject(hdc,bmp_pinceau_jaune);
        SelectObject(hdc,bmp_stylo_gris);
        Rectangle(hdc,0,0,1280,1024);
    }

    // carte
    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));
    y=50;
    x=350;
    for(i=0;i<4;i++)
    {
        SelectObject(hdc,bmp_pinceau_gris);
        if(i==0) if(serialPort.card0_ok) SelectObject(hdc,bmp_pinceau_rouge);
        if(i==1) if(serialPort.card1_ok) SelectObject(hdc,bmp_pinceau_rouge);
        if(i==2) if(serialPort.card2_ok) SelectObject(hdc,bmp_pinceau_rouge);
        if(i==3) if(serialPort.card3_ok) SelectObject(hdc,bmp_pinceau_rouge);
        if(i==selected_card) SelectObject(hdc,bmp_pinceau_vert);

        Rectangle(hdc,x+50*i,y,x+50*i+45,y+17);
        sprintf(ch,"card%d",i); EasyTextOut(x+50*i+3,y,ch);
    }

    if(action==DEBUG_MOUSE)
    {
        for(i=0;i<=4;i++)
        if( (i==0 && serialPort.card0_ok) || (i==1 && serialPort.card1_ok) || (i==2 && serialPort.card2_ok) || (i==3 && serialPort.card3_ok) )
        if( x_mouse>(x+50*i) && x_mouse<(x+50*i+45) )
        if( y_mouse>y        && y_mouse<(y+17)      )
        {
            selected_card=i;
            redraw=1;
        }
    }

    //sorties

    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));
    y=100;
    for(j=0;j<=4;j++) for(i=0;i<8;i++)
    {
        if(j>=0 && j<=2) x=5+155*(j+2)+18*i;
        if(j>=3 && j<=4) { x=5+155*(j-3)+18*i; if(cfg_enable_leds[selected_card]) continue; }

        if(      serial_debug_select_out[selected_card][8*j+i]==0 && vio_out[selected_card][8*j+i]         ) SelectObject(hdc,bmp_pinceau_vert);
        else if( serial_debug_select_out[selected_card][8*j+i]    && serial_debug_out[selected_card][8*j+i]) SelectObject(hdc,bmp_pinceau_vert);
        else                                                                                                 SelectObject(hdc,bmp_pinceau_rouge);
        Rectangle(hdc,x,y,x+17,y+17);

        if(serial_debug_select_out[selected_card][8*j+i]==0)
        {
            EasyLine(x   ,y,x+17,y+17);
            EasyLine(x+17,y,x   ,y+17);
        }

        sprintf(ch,"%d",8*j+i);
        if((8*j+i)<10) EasyTextOut(x+5,y,ch);
        else           EasyTextOut(x+0,y,ch);
    }

    if(action==DEBUG_MOUSE)
    {
        for(j=0;j<=4;j++) for(i=0;i<8;i++)
        {
            if(j>=0 && j<=2) x=5+155*(j+2)+18*i;
            if(j>=3 && j<=4) x=5+155*(j-3)+18*i;

            if(x_mouse>x && x_mouse<(x+17) && y_mouse>y && y_mouse<(y+17))
                if(serial_debug_select_out[selected_card][8*j+i])
                    serial_debug_out[selected_card][8*j+i]^=1;
        }
    }

    if(action==DEBUG_MOUSE_RIGHT)
    {
        for(j=0;j<=4;j++) for(i=0;i<8;i++)
        {
            if(j>=0 && j<=2) x=5+155*(j+2)+18*i;
            if(j>=3 && j<=4) x=5+155*(j-3)+18*i;

            if(x_mouse>x && x_mouse<(x+17) && y_mouse>y && y_mouse<(y+17))
            {
                serial_debug_select_out[selected_card][8*j+i]^=1;
                if(serial_debug_select_out[selected_card][8*j+i]) serial_debug_out[selected_card][8*j+i]=vio_out[selected_card][8*j+i];
            }
        }
    }

    // leds

    if(cfg_enable_leds[selected_card])
    {
        SelectObject(hdc,bmp_stylo_noir);
        SetTextColor(hdc,RGB(0,0,0));

        for(j=0;j<4;j++) for(i=0;i<12;i++)
        {
            if(i<8) x=5+18*i;
            else    x=5+155+18*(i-8);
            y=100-18*(3-j);

            if(serial_debug_select_led[selected_card][12*j+i]==0) //normal
            {
                if(vio_led[selected_card][12*j+i]==0) SelectObject(hdc,bmp_pinceau_rouge);
                else
                {
                    if(vio_led_cli[selected_card][12*j+i]==0) SelectObject(hdc,bmp_pinceau_vert);
                    else
                    {
                        if(vio_led_phase[selected_card][12*j+i]==0) SelectObject(hdc,bmp_pinceau_jaune);
                        else                                        SelectObject(hdc,bmp_pinceau_bleu);
                    }
                }
                Rectangle(hdc,x,y,x+17,y+17);
                EasyLine(x   ,y,x+17,y+17);
                EasyLine(x+17,y,x   ,y+17);
            }

            if(serial_debug_select_led[selected_card][12*j+i]==1) //debug
            {
                if(serial_debug_led[selected_card][12*j+i]==0) SelectObject(hdc,bmp_pinceau_rouge);
                else
                {
                    if(serial_debug_led_cli[selected_card][12*j+i]==0) SelectObject(hdc,bmp_pinceau_vert);
                    else
                    {
                        if(serial_debug_led_phase[selected_card][12*j+i]==0) SelectObject(hdc,bmp_pinceau_jaune);
                        else                                                 SelectObject(hdc,bmp_pinceau_bleu);
                    }
                }
                Rectangle(hdc,x,y,x+17,y+17);
            }
            sprintf(ch,"%d",12*j+i);
            EasyTextOut(x,y,ch);
        }

        SelectObject(hdc,bmp_pinceau_gris);
        for(i=0;i<4;i++) {x=5+155+18*(4+i);Rectangle(hdc,x,y,x+17,y+17);}

        if(action==DEBUG_MOUSE)
        {
            for(j=0;j<=4;j++) for(i=0;i<12;i++)
            {
                if(i<8) x=5+18*i;
                else    x=5+155+18*(i-8);
                y=100-18*(3-j);

                if(x_mouse>x && x_mouse<(x+17) && y_mouse>y && y_mouse<(y+17))
                if(serial_debug_select_led[12*j+i])
                {
                    if(serial_debug_led[selected_card][12*j+i]==0)
                    {
                        serial_debug_led[selected_card][12*j+i]=1;
                        serial_debug_led_cli[selected_card][12*j+i]=0;
                        serial_debug_led_phase[selected_card][12*j+i]=0;
                    }
                    else if(serial_debug_led_cli[selected_card][12*j+i]==0)
                    {
                        serial_debug_led_cli[selected_card][12*j+i]=1;
                        serial_debug_led_phase[selected_card][12*j+i]=0;
                    }
                    else if(serial_debug_led_phase[selected_card][12*j+i]==0)
                    {
                        serial_debug_led_phase[selected_card][12*j+i]=1;
                    }
                    else
                    {
                        serial_debug_led[selected_card][12*j+i]=0;
                        serial_debug_led_cli[selected_card][12*j+i]=0;
                        serial_debug_led_phase[selected_card][12*j+i]=0;
                    }
                }
            }
        }

        if(action==DEBUG_MOUSE_RIGHT)
        {
            for(j=0;j<=4;j++) for(i=0;i<12;i++)
            {
                if(i<8) x=5+18*i;
                else    x=5+155+18*(i-8);
                y=100-18*(3-j);

                if(x_mouse>x && x_mouse<(x+17) && y_mouse>y && y_mouse<(y+17))
                {
                    serial_debug_select_led[selected_card][12*j+i]^=1;
                    if(serial_debug_select_led[selected_card][12*j+i])
                    {
                        serial_debug_led[selected_card][12*j+i]=vio_led[selected_card][12*j+i];
                        serial_debug_led_cli[selected_card][12*j+i]=vio_led_cli[selected_card][12*j+i];
                        serial_debug_led_phase[selected_card][12*j+i]=vio_led_phase[selected_card][12*j+i];
                    }
                }
            }
        }

    }

    // aff can

    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));
    for(i=0;i<5;i++)
    {
        x=210+20*i;
        val=vio_can[selected_card][i];
        SelectObject(hdc,bmp_pinceau_gris);
        Rectangle(hdc,x,290,x+17,290+255-val);
        SelectObject(hdc,bmp_pinceau_cyan);
        Rectangle(hdc,x,290+255,x+17,290+255-val);

        sprintf(ch,"%d",i);EasyTextOut(x+5,255,ch);
        if(val>=100) {sprintf(ch,"%d",val/100);EasyTextOut(x+5,500,ch);}
        if(val>=10 ) {sprintf(ch,"%d",(val/10)%10);EasyTextOut(x+5,515,ch);}
        sprintf(ch,"%d",val%10);EasyTextOut(x+5,530,ch);

        y=560;
        if(cfg_can_inv[selected_card][i]==0) { SelectObject(hdc,bmp_pinceau_vert);  sprintf(ch,"D"); }
        else                                 { SelectObject(hdc,bmp_pinceau_rouge); sprintf(ch,"I"); }
        Rectangle(hdc,x,y,x+17,y+17); EasyTextOut(x+2,y,ch);
    }
    for(i=0;i<5;i++)
    {
        x=210+20*i;
        y=560;
        if(cfg_can_inv[selected_card][i]==0) { SelectObject(hdc,bmp_pinceau_vert);  sprintf(ch,"D"); }
        else                                 { SelectObject(hdc,bmp_pinceau_rouge); sprintf(ch,"I"); }
        Rectangle(hdc,x,y,x+17,y+17); EasyTextOut(x+2,y,ch);
    }
    for(i=0;i<5;i++)
    {
        x=210+20*i;
        y=580;
        if(selected_can_and_card==100*selected_card+i) { SelectObject(hdc,bmp_pinceau_vert);  sprintf(ch,"L"); }
        else                                           { SelectObject(hdc,bmp_pinceau_rouge); sprintf(ch,"l"); }
        Rectangle(hdc,x,y,x+17,y+17); EasyTextOut(x+2,y,ch);
    }

    if(action==DEBUG_MOUSE)
    {
        for(i=0;i<5;i++)
        {
            x=210+20*i; y=560;
            if(x_mouse>x && x_mouse<(x+17) && y_mouse>=y && y_mouse<=(y+17))
            {
                cfg_can_inv[selected_card][i]^=1;
            }
            x=210+20*i; y=580;
            if(x_mouse>x && x_mouse<(x+17) && y_mouse>=y && y_mouse<=(y+17))
            {
                if(selected_can_and_card==(100*selected_card+i))
                {
                    //for(j=0;j<4;j++) for(k=0;k<16;k++) if(rs232_debug_link[j][k]==(100*selected_card+i)) rs232_debug_link[j][k]=-1;
                    selected_can_and_card=-1;
                }
                else
                {
                    selected_can_and_card=100*selected_card+i;
                }
            }
        }
    }

    // aff det & pot

    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));
    for(j=0;j<4;j++) for(i=0;i<4;i++)
    {
        x=620-100*j+60+20;
        if(vio_det[selected_card][4*j+i]) SelectObject(hdc,bmp_pinceau_vert);
        else                              SelectObject(hdc,bmp_pinceau_rouge);
        Rectangle(hdc,x-20*i,255,x-20*i+17,255+17);
        sprintf(ch,"%d",4*j+i);
        if((4*j+i)<10) EasyTextOut(x-20*i+5,255,ch);
        else           EasyTextOut(x-20*i+0,255,ch);

        SelectObject(hdc,bmp_pinceau_gris);
        Rectangle(hdc,x-20*i,290,x-20*i+17,290+255);

        if(serial_debug_select_canton_vit[selected_card][4*j+i]) val=serial_debug_canton_vit[selected_card][4*j+i];
        else val=vio_canton_vit[selected_card][4*j+i];
        SelectObject(hdc,bmp_pinceau_rouge);
        if(selected_pot==(4*j+i)) if(serial_debug_select_canton_vit[selected_card][4*j+i]) SelectObject(hdc,bmp_pinceau_vert);
        Rectangle(hdc,x-20*i,290+128-2*val-2,x-20*i+17,290+128-2*val+2);

        if(val<0) {EasyTextOut(x-20*i+5,500,"-"); val=-val;}
        else       EasyTextOut(x-20*i+5,500,"+");
        if(val>=10 ) {sprintf(ch,"%d",val/10);EasyTextOut(x-20*i+5,515,ch);}
        sprintf(ch,"%d",val%10);EasyTextOut(x-20*i+5,530,ch);

        if(serial_debug_select_canton_vit[selected_card][4*j+i]==0)
        {
                EasyLine(x-20*i,290   ,x-20*i+16,290+20);
                EasyLine(x-20*i,290+20,x-20*i+16,290   );
        }

        y=560;
        if(cfg_canton_inv[selected_card][4*j+i]==0) { SelectObject(hdc,bmp_pinceau_vert);  sprintf(ch,"D"); }
        else                                        { SelectObject(hdc,bmp_pinceau_rouge); sprintf(ch,"I"); }
        Rectangle(hdc,x-20*i,y,x-20*i+17,y+17); EasyTextOut(x-20*i+2,y,ch);

        y=580;
        if(serial_debug_select_canton_vit[selected_card][4*j+i]==0) rs232_debug_link[selected_card][4*j+i]=-1;
        val=rs232_debug_link[selected_card][4*j+i];
        if(val!=-1) { SelectObject(hdc,bmp_pinceau_vert);  sprintf(ch,"%d%d",val/100,val%100); }
        else        { SelectObject(hdc,bmp_pinceau_rouge); sprintf(ch,"l"); }
        Rectangle(hdc,x-20*i,y,x-20*i+17,y+17);
        if(strlen(ch)==1) EasyTextOut(x-20*i+7,y,ch); else EasyTextOut(x-20*i+0,y,ch);
    }

    SelectObject(hdc,bmp_pinceau_jaune);     //erase outside cursors
    SelectObject(hdc,bmp_stylo_jaune);
    Rectangle(hdc,230,290-1-3,800,290-1);
    Rectangle(hdc,230,290+255+1,800,290+255+1+5);

    if(action==DEBUG_MOUSE)
    {
        selected_pot=-1;
        for(j=0;j<4;j++) for(i=0;i<4;i++)
        {
            x=620-100*j+60+20;

            if(serial_debug_select_canton_vit[selected_card][4*j+i])
            if(x_mouse>(x-20*i) && x_mouse<(x-20*i+17) && y_mouse>=290 && y_mouse<=(290+255))
            {
                if(serial_debug_select_canton_vit[selected_card][4*j+i])
                    serial_debug_canton_vit[selected_card][4*j+i]=-(y_mouse-(290+128))/2;
                selected_pot=4*j+i;
            }

            if(x_mouse>(x-20*i) && x_mouse<(x-20*i+17) && y_mouse>=560 && y_mouse<=(560+17))
            {
                cfg_canton_inv[selected_card][4*j+i]^=1;
            }

            if(x_mouse>(x-20*i) && x_mouse<(x-20*i+17) && y_mouse>=580 && y_mouse<=(580+17))
            {
                if(rs232_debug_link[selected_card][4*j+i]!=-1) rs232_debug_link[selected_card][4*j+i]=-1;
                else if(selected_can_and_card!=-1)
                {
                    rs232_debug_link[selected_card][4*j+i]=selected_can_and_card;
                }
            }

        }
    }

    if(action==DEBUG_MOUSE_RIGHT)
    {
        for(j=0;j<4;j++) for(i=0;i<4;i++)
        {
            x=620-100*j+60+20;

            if(x_mouse>(x-20*i) && x_mouse<(x-20*i+17) && y_mouse>290 && y_mouse<(290+255))
            {
                serial_debug_select_canton_vit[selected_card][4*j+i]^=1;
                if(serial_debug_select_canton_vit[selected_card][4*j+i]==1) serial_debug_canton_vit[selected_card][4*j+i]=vio_canton_vit[selected_card][4*j+i];
            }
        }
    }

    if(action==DEBUG_KEY) if(selected_pot!=-1)
    {
        if(touche_char=='+') serial_debug_canton_vit[selected_card][selected_pot]++;
        if(touche_char=='-') serial_debug_canton_vit[selected_card][selected_pot]--;
        if(touche_char=='*') serial_debug_canton_vit[selected_card][selected_pot]+=10;
        if(touche_char=='/') serial_debug_canton_vit[selected_card][selected_pot]+=10;
        if(touche_char=='0') serial_debug_canton_vit[selected_card][selected_pot]=0;
        if(serial_debug_canton_vit[selected_card][selected_pot]>64 ) serial_debug_canton_vit[selected_card][selected_pot]=64;
        if(serial_debug_canton_vit[selected_card][selected_pot]<-64) serial_debug_canton_vit[selected_card][selected_pot]=-64;

    }

    // aff in

    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));
    for(j=0;j<9;j++) for(i=0;i<4;i++)
    {
        x=55+20*i;
        y=290+20*j;
        if(vio_in[selected_card][4*j+i]) SelectObject(hdc,bmp_pinceau_vert);
        else                             SelectObject(hdc,bmp_pinceau_rouge);
        Rectangle(hdc,x,y,x+17,y+17);
        sprintf(ch,"%d",4*j+i);
        if((4*j+i)<10) EasyTextOut(x+5,y,ch);
        else           EasyTextOut(x+0,y,ch);
    }

    x=40;
    y=290;
    EasyTextOut(x,y    ,"A");
    EasyTextOut(x,y+ 20,"B");
    EasyTextOut(x,y+ 40,"C");
    EasyTextOut(x,y+ 60,"D");
    EasyTextOut(x,y+ 80,"E");
    EasyTextOut(x,y+100,"F");
    EasyTextOut(x,y+120,"G");
    EasyTextOut(x,y+140,"H");
    EasyTextOut(x,y+160,"I");

    EasyTextOut( 60,255,"0");
    EasyTextOut( 80,255,"1");
    EasyTextOut(100,255,"2");
    EasyTextOut(120,255,"3");

    // aff debug serial error

    SelectObject(hdc,bmp_pinceau_jaune);
    SelectObject(hdc,bmp_stylo_jaune);
    SetTextColor(hdc,RGB(0,0,0));
    Rectangle(hdc,25,500,150,550+5*20);
    sprintf(ch,"Err RS232: %d",serial_error); EasyTextOut(25,500,ch);
    sprintf(ch,"En leds:  ");                 EasyTextOut(25,520,ch);
    sprintf(ch,"En servo0:");                 EasyTextOut(25,540,ch);
    sprintf(ch,"En servo1:");                 EasyTextOut(25,560,ch);
    sprintf(ch,"Tic nb   : %d",debug_tic_nb); EasyTextOut(25,580,ch);

    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));

    x=105; y=520;
    if(cfg_enable_leds[selected_card]) { SelectObject(hdc,bmp_pinceau_vert);  Rectangle(hdc,x,y,x+25,y+17); EasyTextOut(x+2,y,"On" ); }
    else                               { SelectObject(hdc,bmp_pinceau_rouge); Rectangle(hdc,x,y,x+25,y+17); EasyTextOut(x+2,y,"Off"); }

    x=105; y=540;
    Rectangle(hdc,x,y,x+20,y+17);
    if(cfg_enable_servos[selected_card][0]==0) { SelectObject(hdc,bmp_pinceau_rouge); Rectangle(hdc,x,y,x+25,y+17); EasyTextOut(x+2,y,"Off"); }
    else
    {
        SelectObject(hdc,bmp_pinceau_vert);  Rectangle(hdc,x,y,x+25,y+17); EasyTextOut(x+2,y,"On");
        x=x+30;
        SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,x,y,x+30,y+17);
        if(serial_debug_select_srv[selected_card][0]) val=serial_debug_srv[selected_card][0]; else val=vio_srv[selected_card][0];
        sprintf(ch,"%d",val); EasyTextOut(x+2,y,ch);
        if(serial_debug_select_srv[selected_card][0]==0)
        {
            EasyLine(x   ,y,x+30,y+17);
            EasyLine(x+30,y,x   ,y+17);
        }
    }

    x=105; y=560;
    if(cfg_enable_servos[selected_card][1]==0) { SelectObject(hdc,bmp_pinceau_rouge); Rectangle(hdc,x,y,x+25,y+17); EasyTextOut(x+2,y,"Off"); }
    else
    {
        SelectObject(hdc,bmp_pinceau_vert);  Rectangle(hdc,x,y,x+25,y+17); EasyTextOut(x+2,y,"On");
        x=x+30;
        SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,x,y,x+30,y+17);
        if(serial_debug_select_srv[selected_card][1]) val=serial_debug_srv[selected_card][1]; else val=vio_srv[selected_card][1];
        sprintf(ch,"%d",val); EasyTextOut(x+2,y,ch);
        if(serial_debug_select_srv[selected_card][1]==0)
        {
            EasyLine(x   ,y,x+30,y+17);
            EasyLine(x+30,y,x   ,y+17);
        }
    }

    if(action==DEBUG_MOUSE)
    {
        x=105;
        y=520; if(x_mouse>x && x_mouse<(x+25) && y_mouse>y && y_mouse<(y+17)) { cfg_enable_leds[selected_card]^=1;      redraw=1; }
        y=540; if(x_mouse>x && x_mouse<(x+25) && y_mouse>y && y_mouse<(y+17)) { cfg_enable_servos[selected_card][0]^=1; redraw=1; }
        y=560; if(x_mouse>x && x_mouse<(x+25) && y_mouse>y && y_mouse<(y+17)) { cfg_enable_servos[selected_card][1]^=1; redraw=1; }
    }

    if(action==DEBUG_MOUSE_RIGHT)
    {
        x=110+25;
        y=540;
        if(x_mouse>x && x_mouse<(x+30) && y_mouse>y && y_mouse<(y+17))
        {
            serial_debug_select_srv[selected_card][0]^=1;
            if(serial_debug_select_srv[selected_card][0]) serial_debug_srv[selected_card][0]=vio_srv[selected_card][0];
        }
        y=560;
        if(x_mouse>x && x_mouse<(x+30) && y_mouse>y && y_mouse<(y+17))
        {
            serial_debug_select_srv[selected_card][1]^=1;
            if(serial_debug_select_srv[selected_card][1]) serial_debug_srv[selected_card][1]=vio_srv[selected_card][1];
        }
    }

    // aff liste

    y=120;
    SelectObject(hdc,bmp_stylo_noir);
    SetTextColor(hdc,RGB(0,0,0));

    SelectObject(hdc,bmp_pinceau_cyan);
    Rectangle(hdc,100,y+20,690,y+40);
    EasyLine(200,y+20,200,y+40);
    EasyLine(300,y+20,300,y+40);
    EasyLine(400,y+20,400,y+40);
    EasyLine(500,y+20,500,y+40);
    EasyLine(600,y+20,600,y+40);
    EasyTextOut(100+5,y+20,"adr dec");
    EasyTextOut(200+5,y+20,"adr hex");
    EasyTextOut(300+5,y+20,"dat dec");
    EasyTextOut(400+5,y+20,"dat hex");
    EasyTextOut(500+5,y+20,"dat bin");
    EasyTextOut(600+5,y+20,"actions");
    EasyLine(190,y+20,200,y+30);
    EasyLine(290,y+20,300,y+30);
    EasyLine(390,y+20,400,y+30);
    EasyLine(490,y+20,500,y+30);
    EasyLine(680,y+40,690,y+30);

    for(i=0;i<4;i++)
    {
        SelectObject(hdc,bmp_pinceau_blanc);
        Rectangle(hdc,100,y+40+20*i,690,y+60+20*i);
        EasyLine(200,y+40+20*i,200,y+60+20*i);
        EasyLine(300,y+40+20*i,300,y+60+20*i);
        EasyLine(400,y+40+20*i,400,y+60+20*i);
        EasyLine(500,y+40+20*i,500,y+60+20*i);
        EasyLine(600,y+40+20*i,600,y+60+20*i);
        EasyLine(630,y+40+20*i,630,y+60+20*i);
        EasyLine(660,y+40+20*i,660,y+60+20*i);
        sprintf(ch,"%d",serial_tab_adresse[selected_card][i]); EasyTextOut(100+5,y+40+20*i,ch);
        sprintf(ch,"%x",serial_tab_adresse[selected_card][i]); EasyTextOut(200+5,y+40+20*i,ch);
        sprintf(ch,"%d",serial_tab_data[selected_card][i]);    EasyTextOut(300+5,y+40+20*i,ch);
        sprintf(ch,"%x",serial_tab_data[selected_card][i]);    EasyTextOut(400+5,y+40+20*i,ch);
        for(j=1,k=7;j<=0x80;j=j*2,k--) {if(serial_tab_data[selected_card][i]&j) ch[k]='1'; else ch[k]='0';}
        ch[8]='\0';                             EasyTextOut(500+5,y+40+20*i,ch);
                                                EasyTextOut(600+5,y+40+20*i,"W");
                                                EasyTextOut(630+5,y+40+20*i,"R");
        if(tab_auto_read[selected_card][i])     EasyTextOut(660+5,y+40+20*i,"X");
        else                                    EasyTextOut(660+5,y+40+20*i,"A");
    }

    if(action==DEBUG_MOUSE)
    {
        strcpy(tab_cmd_ch,"000");
        tab_cmd_colone=-1;
        srv_debug_cmd=-1;

        if(x_mouse>100 && x_mouse<500) if(y_mouse>(y+40) && y_mouse<(y+40+4*20))
        {
              tab_cmd_colone=(x_mouse-100)/100;
              tab_cmd_ligne =((y_mouse-y-40)/20);
        }

        if(x_mouse>600 && x_mouse<690) if(y_mouse>(y+40) && y_mouse<(y+40+4*20))
        {
              tab_cmd_colone=(x_mouse-600)/30;
              tab_cmd_ligne =((y_mouse-y-40)/20);
              if(tab_cmd_colone==0) serial_tab_cmd[selected_card][tab_cmd_ligne]='w';
              if(tab_cmd_colone==1) serial_tab_cmd[selected_card][tab_cmd_ligne]='r';
              if(tab_cmd_colone==2)
              {
                  tab_auto_read[selected_card][tab_cmd_ligne]^=1;
                  if(tab_auto_read[selected_card][tab_cmd_ligne]) serial_tab_cmd[selected_card][tab_cmd_ligne]='a';
                  else                                            serial_tab_cmd[selected_card][tab_cmd_ligne]='x';
              }
              tab_cmd_colone=-1;
        }

        if(x_mouse>135 && x_mouse<(135+30)) if(y_mouse>540 && y_mouse<(540+17)) srv_debug_cmd=0;
        if(x_mouse>135 && x_mouse<(135+30)) if(y_mouse>560 && y_mouse<(560+17)) srv_debug_cmd=1;
    }

    if(action==DEBUG_KEY)
    {
        if(touche_char!=0xd) //'\n'==0x10 !!!!
        {
            tab_cmd_ch[0]=tab_cmd_ch[1];
            tab_cmd_ch[1]=tab_cmd_ch[2];
            tab_cmd_ch[2]=touche_char;
        }
        else
        {
            if(tab_cmd_colone==0) serial_tab_adresse[selected_card][tab_cmd_ligne]=atoi(tab_cmd_ch);
            if(tab_cmd_colone==1) serial_tab_adresse[selected_card][tab_cmd_ligne]=atoh(tab_cmd_ch);
            if(tab_cmd_colone==2) serial_tab_data   [selected_card][tab_cmd_ligne]=atoi(tab_cmd_ch);
            if(tab_cmd_colone==3) serial_tab_data   [selected_card][tab_cmd_ligne]=atoh(tab_cmd_ch);
            if(srv_debug_cmd==0) { if(serial_debug_select_srv[selected_card][0]) serial_debug_srv[selected_card][0]=atoi(tab_cmd_ch); }
            if(srv_debug_cmd==1) { if(serial_debug_select_srv[selected_card][1]) serial_debug_srv[selected_card][1]=atoi(tab_cmd_ch); }
            strcpy(tab_cmd_ch,"000");
        }
    }


}


/*****************************************************************************/
/* FIN DEBUG BOARD SCREEN                                                    */
/*****************************************************************************/





/*****************************************************************************/
/* IR (+clav)                                                                */
/*****************************************************************************/

/*
    Le module IR peut etre pilote par girder avec les codes suivants:

    aiguillages:
    20           aig inverse (si non specifie aig change)
    21           aig direct  (si non specifie aig change)
    0-15         selection aiguillage si cfg_aig_digit=1
    0-9 puis 0-9 selection aiguillage si cfg_aig_digit=2

    trains:
    50           Tous les pot virtuels a 0
    30-34        selection pot virtuel 0 a 4
    40           stop (step=0)
    41           step++ (max=3)
    42           step-- (min=-3)
*/

int ir=-1;
int cfg_aig_digit=1;

void ir_maj(void)
{
    int i;
    char szTemp[255];
    static int force_aig_cmd=-1;
    static int pot_sel=0;
    static int digit=0;
    static int num=0;
    static int idle=0;

    if(ir==-1)
    {
        idle++;
        if(idle==20) { digit=0; num=0; }
        return;
    }
    idle=0;

    if(ir>=0 && ir<=11) { num=10*num+ir; digit++; } else num=0;

    //sprintf(szTemp,"code=%d",ir); MessageBox(NULL,szTemp,"ir debug",MB_OK);
    //sprintf(szTemp,"num=%d dig=%d",num,digit); MessageBox(NULL,szTemp,"ir debug",MB_OK);

    if(ir==20) force_aig_cmd=1; // aig inv
    if(ir==21) force_aig_cmd=0; // aig direct

    if(ir>=0 && ir<=11) if(digit==cfg_aig_digit) if(num<64)
    {
        if(vio_aig_res[num]==0)
        {
            if(force_aig_cmd==0)  vio_aig_cmd[num]=0;
            if(force_aig_cmd==1)  vio_aig_cmd[num]=1;
            if(force_aig_cmd==-1) vio_aig_cmd[num]^=1;
        }
        force_aig_cmd=-1;
        digit=0;num=0;
    }

    if(ir==30) pot_sel=0;
    if(ir==31) pot_sel=1;
    if(ir==32) pot_sel=2;
    if(ir==33) pot_sel=3;
    if(ir==34) pot_sel=4;

    if(ir==40) { vio_pot_virtual_step[pot_sel]=0; } // stop
    if(ir==41) { if(vio_pot_virtual_step[pot_sel]>-3) vio_pot_virtual_step[pot_sel]--; } // dec
    if(ir==42) { if(vio_pot_virtual_step[pot_sel]< 3) vio_pot_virtual_step[pot_sel]++; } // inc
    //if(ir>=40 && ir<=42) { sprintf(szTemp,"\nstep=%d",vio_pot_virtual_step[0]); log(szTemp); /*MessageBox(NULL,szTemp,"ir debug",MB_OK);*/ }

    if(ir==50) for(i=0;i<5;i++) vio_pot_virtual_step[i]=0;

    ir=-1;
}

void pot_vir_debug(int action)
{
    int i,j;
    char t;

    t=touche_char;
    if(touche_char>='A' && touche_char<='Z') t=t+'a'-'A'; // met en minuscule

    if(action==DEBUG_KEY)
    {
        for(j=0;j<5;j++) for(i=0;i<3;i++) if(t==vio_pot_virtual_conf[j][i])
        {
            if(i==1) { vio_pot_virtual_step[j]=0; } // stop
            if(i==2) { if(vio_pot_virtual_step[j]>-3) vio_pot_virtual_step[j]--; } // dec
            if(i==0) { if(vio_pot_virtual_step[j]< 3) vio_pot_virtual_step[j]++; } // inc
        }
    }
}


/*****************************************************************************/
/* fin IR (+clav)                                                            */
/*****************************************************************************/





/*****************************************************************************/
/* CONFIG GENERAL                                                            */
/*****************************************************************************/


/*------------------------------------------------------------------------------
NAME  : config_general_exit_if_no_file

DESCR : exit if the configuration file ne peut pas etre trouve

ARG   : char filename[]: nom du fichier de configuration

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void  config_general_exit_if_no_file(char filename[])
{
    FILE* pf;

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,STR_NO_CONFIG_FILE,"Error",MB_OK|MB_ICONERROR);
        exit(1);
    }
    fclose(pf);

}

/*------------------------------------------------------------------------------
NAME  : config_general_init_file

DESCR : permet des initialisations gnerales a partir du fichier de config

ARG   : char filename[]: nom du fichier de configuration

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void config_general_init_file(char filename[])
{
    FILE* pf;
    char ch[100],ch_tab[50][100];
    int  ch_nb,i;
    int  val;


    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,"Impossible d'ouvrir le fichier de configuration general","Error",MB_OK|MB_ICONERROR);
        exit(1);
    }

    // #general
    // [
    //    leds on @ ou off
    // ]

    while(fscanf(pf," %s",ch)!=EOF)
    {
        if(STR_SAME strcmp(ch,"#general"))
        {
            fscanf(pf," %s",ch); //remove [

            while(get_line(pf,ch_tab,&ch_nb))
            {
                if(ch_tab[0][0]==']') break;

                for(i=0;i<ch_nb;i++) if(ch_tab[i][0]=='@') ch_nb=i;  //remove comments

                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"leds_card_0") ) if( STR_SAME stricmp(ch_tab[1],"off") ) cfg_enable_leds[0]=0;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"leds_card_1") ) if( STR_SAME stricmp(ch_tab[1],"off") ) cfg_enable_leds[1]=0;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"leds_card_2") ) if( STR_SAME stricmp(ch_tab[1],"off") ) cfg_enable_leds[2]=0;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"leds_card_3") ) if( STR_SAME stricmp(ch_tab[1],"off") ) cfg_enable_leds[3]=0;

                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"show_cards_found") ) if( ! stricmp(ch_tab[1],"on" ) ) cfg_show_cards_found=1;

                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_000_card_0") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[0][0]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_001_card_0") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[0][1]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_100_card_1") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[1][0]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_101_card_1") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[1][1]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_200_card_2") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[2][0]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_201_card_2") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[2][1]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_300_card_3") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[3][0]=1;
                if((ch_nb)>=2) if( STR_SAME stricmp(ch_tab[0],"servo_301_card_3") ) if( STR_SAME stricmp(ch_tab[1],"on") ) cfg_enable_servos[3][1]=1;

                if((ch_nb)>=2) if( STR_SAME strnicmp(ch_tab[0],"inv_canton_",strlen("inv_canton_")) ) if( STR_SAME stricmp(ch_tab[1],"on") ) { val=atoi(&ch_tab[0][strlen("inv_canton_")]); cfg_canton_inv[val/100][val%100]=1; }
                if((ch_nb)>=2) if( STR_SAME strnicmp(ch_tab[0],"inv_pot_"   ,strlen("inv_pot")    ) ) if( STR_SAME stricmp(ch_tab[1],"on") ) { val=atoi(&ch_tab[0][strlen("inv_pot_")   ]); cfg_can_inv[val/100][val%100]=1;    }

                if((ch_nb)>=2) if( STR_SAME strnicmp(ch_tab[0],"ir_aig_digit",strlen("ir_aig_digit")) ) cfg_aig_digit=atoi(ch_tab[1]);
            }    //fin analyse ligne
        }      //fin #general
    }        //fin file

    fclose(pf);
}

/*****************************************************************************/
/* fin de CONFIG GENERAL                                                     */
/*****************************************************************************/





/*****************************************************************************/
/* WINDOWS                                                                   */
/*****************************************************************************/




cSerial   serial_card0;
cSerial   serial_card1;
cSerial   serial_card2;
cSerial   serial_card3;
cTdv      tdv;
cIti      iti;
//cTrain   train;  // declare plus haut
//cCanton  canton; // declare plus haut
cSelectif selectif;
cDeplacement deplacement;

char szDeconnectee[100]="";




/* Declare Windows procedure */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);




int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)
{
    //HWND hwnd;               /* This is the handle for our window */  //now in gmobal
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    ghinstance=hThisInstance;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "UTS_Train_Class";
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    //wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = "MAINMENU"; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use light-gray as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           "UTS_Train_Class",   /* Classname */
           TITRE,               /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           800 /*700*/,         /* The programs width */
           700 /*420*/,         /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow(hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Translate virtual-key messages into character messages */
           TranslateMessage(&messages);
           /* Send message to WindowProcedure */
           DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}


/* This function is called by the Windows function DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static int en_cours=0;
    char ch[100];
    char szAff[200];
    char szXY[20];
    int i;
    int ret;
    int ok;
    static int first=1;

    hdc=GetDC(hwnd);
    switch (message)                  /* handle the messages */
    {
           case WM_CREATE :
                pio_init();   //pio_define_list();
                config_general_exit_if_no_file("config.txt");
                config_general_init_file("config.txt");
                font_pinceau_stylo_init();
                tdv.init("config.txt");         //tdv.save_conf();
                ThisExe.init("config.txt");     //ThisExe.save_conf();
                vib_init_file("config.txt");
                iti.init("config.txt");         //iti.save_conf();
                horo_init_file("config.txt");   horo_tic_on=0;   //horo_save_conf();
                garage.init("config.txt");
                deplacement.init("config.txt"); //deplacement.verif();
                aig_init_file("config.txt");    //aig_save_conf();
                if(ret=serialPort.init()) sprintf(szDeconnectee,"COM%d",ret);
                else strcpy(szDeconnectee,"Mode Deconecte");
                serial_card0.init(0,serialPort.card0_ok);
                serial_card1.init(1,serialPort.card1_ok);
                serial_card2.init(2,serialPort.card2_ok);
                serial_card3.init(3,serialPort.card3_ok);
                canton.init("config.txt");
                train.init("config.txt");       train.save_conf();
                selectif.init("config.txt");    //selectif.verif();
                init_fonte_pen_brush();
                SetTimer(hwnd,1,250,NULL);
                screen_mode=MD_SCREEN_TCO0;
                cells_config("config_tco.txt");
                break;

           case WM_TIMER:

                if(wParam!=1) break;
                if(en_cours==1) break;
                en_cours=1;

                ir_maj();
                update_copy_canton();
                update_copy_train();

                debug_tic_nb++;
                do_not_redraw=debug_tic_nb%20; // 0 each five seconds

                tdv.tick();

                serial_card0.maj();
                serial_card1.maj();
                serial_card2.maj();
                serial_card3.maj();

                if(vio_srv_cmd[0][0]>vio_srv[0][0]) vio_srv[0][0]++;
                if(vio_srv_cmd[0][0]<vio_srv[0][0]) vio_srv[0][0]--;

                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) cells_draw(screen_mode);

                train.maj();
                selectif.tick();
                deplacement.tick();
                canton.maj();
                horo_maj();
                iti.tick();
                aig_maj();
                vib_maj();
                garage.maj();
                ThisExe.tick();

                ////sprintf(szAff,"%s - %s - %s -%s %d%d:%d%d j%d",TITRE,szDeconnectee,TabSzScreenMode[screen_mode],szXY,horo_h/10,horo_h%10,horo_m/10,horo_m%10,horo_j/*,horo_tic_dec*/);
                ////if(horo_blocked) strcat(szAff," b");
                ////if(horo_tic_on==0) strcat(szAff," off");
                ////if(horo_tic_dec&1) strcat(szAff," .");
		        //SendMessage(hwnd , WM_SETTEXT, 0, (LPARAM) szAff);  //UU 31mar2004 : posait un pb de rafraichissement !
                ////PostMessage(hwnd , WM_SETTEXT, 0, (LPARAM) szAff);

                if(screen_mode==MD_SCREEN_AUTO)     deplacement.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_VIB )     vib_debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_CANTON)   canton.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_ITI)      iti.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_AIG)      aig_debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_SELECTIF) garage.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_TRAIN)    train.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_SERIAL)   serial_debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_HORO)     horo_debug(DEBUG_PAINT);
                serial_debug(DEBUG_TICK);  // every time to manage direct can to debug canton loop

                en_cours=0;

                break;

           case WM_PAINT:
                //fond_set_tco(screen_mode);
                if(screen_mode==MD_SCREEN_VIB )     vib_debug(DEBUG_TOTAL_PAINT);
                if(screen_mode==MD_SCREEN_CANTON)   canton.debug(DEBUG_TOTAL_PAINT);
                if(screen_mode==MD_SCREEN_ITI)      iti.debug(DEBUG_TOTAL_PAINT);
                if(screen_mode==MD_SCREEN_AIG)      aig_debug(DEBUG_TOTAL_PAINT);
                if(screen_mode==MD_SCREEN_SELECTIF) garage.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_TRAIN)    train.debug(DEBUG_PAINT);
                if(screen_mode==MD_SCREEN_SERIAL)   serial_debug(DEBUG_TOTAL_PAINT);
                if(screen_mode==MD_SCREEN_HORO)     horo_debug(DEBUG_TOTAL_PAINT);
                if(screen_mode==MD_SCREEN_AUTO)     deplacement.debug(DEBUG_TOTAL_PAINT);
                break;

           case WM_RBUTTONUP:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) cells_debug(screen_mode,DEBUG_MOUSE_RIGHT_UP);
                break;

           case WM_RBUTTONDOWN:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) cells_debug(screen_mode,DEBUG_MOUSE_RIGHT);
                if(screen_mode==MD_SCREEN_SERIAL)                               serial_debug(DEBUG_MOUSE_RIGHT);
                break;

           case WM_LBUTTONUP:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) cells_debug(screen_mode,DEBUG_MOUSE_UP);
                break;

           case WM_LBUTTONDOWN:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) cells_debug(screen_mode,DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_AUTO)      deplacement.debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_VIB)       vib_debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_ITI)       iti.debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_AIG)       aig_debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_SELECTIF)  garage.debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_TRAIN)     train.debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_SERIAL)    serial_debug(DEBUG_MOUSE);
                if(screen_mode==MD_SCREEN_HORO)      horo_debug(DEBUG_MOUSE);
                break;

           case WM_MOUSEMOVE:
                x_mouse_move=LOWORD(lParam);
                y_mouse_move=HIWORD(lParam);
                break;

           case WM_CHAR:
                touche_char=LOWORD(wParam);
                //if(screen_mode==MD_SCREEN_AUTO)      deplacement.debug(DEBUG_KEY);
                //if(screen_mode==MD_SCREEN_ITI)       iti.debug(DEBUG_KEY);
                //if(screen_mode==MD_SCREEN_AIG)       aig_debug(DEBUG_KEY);
                //if(screen_mode==MD_SCREEN_CANTON)    canton.debug(DEBUG_KEY);
                if(screen_mode==MD_SCREEN_TRAIN)     train.debug(DEBUG_KEY);
                if(screen_mode==MD_SCREEN_SERIAL)    serial_debug(DEBUG_KEY);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) cells_debug(screen_mode,DEBUG_KEY);

                ok=1;
                if(screen_mode==MD_SCREEN_SERIAL) ok=0;
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7 && c_conf_wnd!=' ') ok=0;
                if(screen_mode==MD_SCREEN_TRAIN && train.entry!=-1) ok=0;
                if(ok) pot_vir_debug(DEBUG_KEY);

                //if( touche_char=='z' || touche_char=='Z') vio_srv_cmd[0][0]=16;
                //if( touche_char=='q' || touche_char=='Q') vio_srv_cmd[0][0]=32;
                //if( touche_char=='w' || touche_char=='W') vio_srv_cmd[0][0]=47;
                //if( touche_char=='s' || touche_char=='S') vio_srv_cmd[0][0]=171;
                
                //if( touche_char=='/')

                break;

           case WM_DESTROY:
                cells_save("config_tco.txt");
                PostQuitMessage(0); break;

           case WM_COMMAND:
                if(LOWORD(wParam)>=CM_SCREEN_TCO0 && LOWORD(wParam)<=CM_SCREEN_SPARE3) bmp_fond_default();
                switch(LOWORD(wParam))
                {
                    case 999                : ir=LOWORD(lParam); break;
                    case CM_EXIT            : cells_save("config_tco.txt"); PostQuitMessage(0); break;
                    case CM_SCREEN_TCO0     : screen_mode=MD_SCREEN_TCO0;    break;
                    case CM_SCREEN_TCO1     : screen_mode=MD_SCREEN_TCO1;    break;
                    case CM_SCREEN_TCO2     : screen_mode=MD_SCREEN_TCO2;    break;
                    case CM_SCREEN_TCO3     : screen_mode=MD_SCREEN_TCO3;    break;
                    case CM_SCREEN_TCO4     : screen_mode=MD_SCREEN_TCO4;    break;
                    case CM_SCREEN_TCO5     : screen_mode=MD_SCREEN_TCO5;    break;
                    case CM_SCREEN_TCO6     : screen_mode=MD_SCREEN_TCO6;    break;
                    case CM_SCREEN_TCO7     : screen_mode=MD_SCREEN_TCO7;    break;
                    case CM_SCREEN_HORO     : screen_mode=MD_SCREEN_HORO;    break;
                    case CM_SCREEN_SERIAL   : screen_mode=MD_SCREEN_SERIAL;  break;
                    case CM_SCREEN_AIG      : screen_mode=MD_SCREEN_AIG;     break;
                    case CM_SCREEN_ITI      : screen_mode=MD_SCREEN_ITI;     break;
                    case CM_SCREEN_SELECTIF : screen_mode=MD_SCREEN_SELECTIF;break;
                    case CM_SCREEN_AUTO     : screen_mode=MD_SCREEN_AUTO;    break;
                    case CM_SCREEN_REG      : screen_mode=MD_SCREEN_TRAIN;   break;
                    case CM_SCREEN_AFFECT   : screen_mode=MD_SCREEN_CANTON;  break;
                    case CM_SCREEN_VIBRATOR : screen_mode=MD_SCREEN_VIB;     break;
                    case CM_SCREEN_SPARE0   : screen_mode=MD_SCREEN_SPARE0;  break;
                    case CM_SCREEN_SPARE1   : screen_mode=MD_SCREEN_SPARE1;  break;
                    case CM_SCREEN_SPARE2   : screen_mode=MD_SCREEN_SPARE2;  break;
                    case CM_SCREEN_SPARE3   : screen_mode=MD_SCREEN_SPARE3;  break;
                    case CM_ABOUT           : MessageBox(NULL,TITRE,"About",MB_OK|MB_ICONINFORMATION);break;
                    case CM_HELP            : MessageBox(NULL,STR_AIDE,"Help",MB_OK|MB_ICONINFORMATION);break;
                    case CM_SCREEN_TCOEDIT  : cells_open_edit();             break;
                    case CM_SCREEN_TCORENDER: cells_open_render();           break;
                    case CM_SCREEN_TCOSAVE  : cells_save("config_tco.txt");  break;
                    case CM_CONFIG_EDIT     : MessageBox(NULL,SZ_INFO_OPEN_CONFIG,"info",MB_OK|MB_ICONWARNING);
                                              ShellExecute(NULL,"open","config.txt", NULL, NULL, SW_SHOWNORMAL);
                                              break;
                    case CM_CONFIG_RELOAD   : MessageBox(NULL,SZ_INFO_RELOAD_CONFIG,"info",MB_OK|MB_ICONWARNING);
                                              tdv.init("config.txt");         //tdv.save_conf();
                                              ThisExe.init("config.txt");     //ThisExe.save_conf();
                                              vib_init_file("config.txt");
                                              iti.init("config.txt");         //iti.save_conf();
                                              horo_init_file("config.txt");   horo_tic_on=0; //horo_save_conf();
                                              deplacement.init("config.txt"); //deplacement.verif();
                                              break;
                    default                 : break;
                }
                PostMessage(hwnd,WM_PAINT,0,0);
                break;

           default:         break;
    }
    ReleaseDC(hwnd,hdc);
    return DefWindowProc(hwnd, message, wParam, lParam);
}
















/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

                O L D   C O D E   L I N E S   :   N O   M O R E   U S E D   B U T    U S E F U L L   F O R  I D E A S

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */











